//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by Measurement Studio.
//     Runtime Version:2.0.50727.832
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

namespace NationalInstruments.ModularInstruments.Interop

{
    using System;
    using System.Runtime.InteropServices;


    public class niFgen : object, System.IDisposable
    {

        private System.IntPtr _handle;

        private bool _disposed = true;

        ~niFgen() { Dispose(false); }
 	
 	public struct nicomplexnumber
        {
        	public long real;
        	public long imaginary;
        }
        
        public struct nicomplexI16
        {
                public short real;
                public short imaginary;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_init
        /// 
        /// ViStatus niFgen_init (ViRsrc resourceName, ViBoolean idQuery, ViBoolean resetDevice, ViSession* vi);
        /// 
        /// Purpose
        /// 
        /// Performs the following initialization actions:
        /// 
        /// Creates a new IVI instrument driver session.
        /// 
        /// Opens a session to the specified device using the interface and address that you specify for the resourceName parameter.
        /// 
        /// If the IDQuery parameter is set to VI_TRUE, this function queries the device ID and checks that the ID is valid for NI-FGEN.
        /// 
        /// If the resetDevice parameter is set to VI_TRUE, this function resets the device to a known state.
        /// 
        /// Sends initialization commands to set the device to the state necessary for the operation of NI-FGEN.
        /// 
        /// Returns a session handle that you can use to identify the device in all subsequent NI-FGEN function calls.
        /// 
        /// </summary>
        /// <param name="Resource_Name">
        /// 
        /// 
        /// resourceName
        /// ViRsrc
        /// Specifies the resource name of the device to initialize.
        /// 
        /// 
        /// 
        ///                                                 Example #
        ///                 Device Type
        ///                 Syntax
        ///                 Variable
        ///             
        ///                             1
        ///                 Traditional NI-DAQ device
        ///                 DAQ::1
        ///                 (1 = device number)
        ///             
        ///                             2
        ///                 NI-DAQmx device
        ///                 myDAQmxDevice
        ///                 (myDAQmxDevice = device name)
        ///             
        ///                             3
        ///                 NI-DAQmx device
        ///                 DAQ::myDAQmxDevice
        ///                 (myDAQmxDevice = device name)
        ///             
        ///                             4
        ///                 NI-DAQmx device
        ///                 DAQ::2
        ///                 (2 = device name)
        ///             
        ///                             5
        ///                 IVI logical name or IVI virtual name
        ///                 myLogicalName
        ///                 (myLogicalName = name)
        ///             
        ///         
        /// 
        /// For Traditional NI-DAQ devices, the syntax is DAQ::n, where n is the device number assigned by MAX, as shown in Example 1. 
        /// 
        /// For NI-DAQmx devices, the syntax is just the device name specified in MAX, as shown in Example 2. Typical default names for NI-DAQmx devices in MAX are Dev1 or PXI1Slot1. You can rename an NI-DAQmx device by right-clicking on the name in MAX and entering a new name.
        /// 
        /// An alternate syntax for NI-DAQmx devices consists of DAQ::NI-DAQmx device name, as shown in Example 3. This naming convention allows for the use of an NI-DAQmx device in an application that was originally designed for a Traditional NI-DAQ device. For example, if the application expects DAQ::1, you can rename the NI-DAQmx device to 1 in MAX and pass in DAQ::1 for the resource name, as shown in Example 4. 
        /// 
        /// If you use the DAQ::n syntax and an NI-DAQmx device name already exists with that same name, the NI-DAQmx device is matched first. 
        /// 
        /// You can also pass in the name of an IVI logical name or an IVI virtual name configured with the IVI Configuration utility, as shown in Example 5. A logical name identifies a particular virtual instrument. A virtual name identifies a specific device and specifies the initial settings for the session. 
        /// 
        /// 
        /// Caution  Traditional NI-DAQ and NI-DAQmx device names are not case-sensitive. However, all IVI names, such as logical names, are case-sensitive. If you use logical names, driver session names, or virtual names in your program, you must ensure that the name you use matches the name in the IVI Configuration Store file exactly, without any variations in the case of the characters.
        /// 
        ///  
        /// </param>
        /// <param name="ID_Query">
        /// 
        /// 
        /// idQuery
        /// ViBoolean
        /// Specifies whether you want NI-FGEN to perform an ID query.
        ///             
        ///             When you set this parameter to VI_TRUE, NI-FGEN verifies that the device that you initialize is supported.
        /// 
        /// Circumstances can arise where sending an ID query to the device is undesirable. When you set this parameter to VI_FALSE, the function initializes the device without performing an ID query.
        /// 
        /// Defined Values
        /// 
        /// VI_TRUEPerform ID query
        /// VI_FALSESkip ID query
        /// 
        /// Default Value: VI_TRUE
        ///  
        /// </param>
        /// <param name="Reset_Device">
        /// 
        /// 
        /// resetDevice
        /// ViBoolean
        /// Specifies whether you want to reset the device during the initialization procedure.
        /// 
        /// Defined Values
        /// 
        ///  VI_TRUEReset device
        /// VI_FALSEDo not reset device
        /// 
        /// Default Value: VI_TRUE
        ///  
        /// </param>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession*
        /// Returns a session handle that you can use to identify the device in all subsequent NI-FGEN function calls.
        ///  
        /// </param>
        public niFgen(string Resource_Name, bool ID_Query, bool Reset_Device)
        {
            int pInvokeResult = PInvoke.init(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Device), out this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            this._disposed = false;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_InitWithOptions
        /// 
        /// ViStatus niFgen_InitWithOptions (ViRsrc resourceName, ViBoolean idQuery, ViBoolean resetDevice, ViString optionString, ViSession *vi);
        /// 
        /// Purpose
        /// 
        /// Performs the following initialization actions:
        /// 
        /// Creates a new IVI instrument session and optionally sets the initial state of the following session attributes: RangeCheck, QueryInstrStatus, Cache, Simulate, and RecordCoersions.
        /// Opens a session to the specified device using the interface and address that you specify for resourceName.
        /// If IDQuery is set to VI_TRUE, this function queries the device ID and checks that it is valid for NI-FGEN.
        /// If resetDevice is set to VI_TRUE, this function resets the device to a known state.
        /// Sends initialization commands to set the instrument to the state necessary for NI-FGEN operation.
        /// Returns a session handle that you can use to identify the device in all subsequent NI-FGEN function calls.
        /// 
        /// </summary>
        /// <param name="Resource_Name">
        /// 
        /// 
        /// resourceName
        /// ViRsrc
        /// Specifies the resource name of the device to initialize.
        /// 
        /// 
        /// 
        ///                                                 Example #
        ///                 Device Type
        ///                 Syntax
        ///                 Variable
        ///             
        ///                             1
        ///                 Traditional NI-DAQ device
        ///                 DAQ::1
        ///                 (1 = device number)
        ///             
        ///                             2
        ///                 NI-DAQmx device
        ///                 myDAQmxDevice
        ///                 (myDAQmxDevice = device name)
        ///             
        ///                             3
        ///                 NI-DAQmx device
        ///                 DAQ::myDAQmxDevice
        ///                 (myDAQmxDevice = device name)
        ///             
        ///                             4
        ///                 NI-DAQmx device
        ///                 DAQ::2
        ///                 (2 = device name)
        ///             
        ///                             5
        ///                 IVI logical name or IVI virtual name
        ///                 myLogicalName
        ///                 (myLogicalName = name)
        ///             
        ///         
        /// 
        /// For Traditional NI-DAQ devices, the syntax is DAQ::n, where n is the device number assigned by MAX, as shown in Example 1. 
        /// 
        /// For NI-DAQmx devices, the syntax is just the device name specified in MAX, as shown in Example 2. Typical default names for NI-DAQmx devices in MAX are Dev1 or PXI1Slot1. You can rename an NI-DAQmx device by right-clicking on the name in MAX and entering a new name.
        /// 
        /// An alternate syntax for NI-DAQmx devices consists of DAQ::NI-DAQmx device name, as shown in Example 3. This naming convention allows for the use of an NI-DAQmx device in an application that was originally designed for a Traditional NI-DAQ device. For example, if the application expects DAQ::1, you can rename the NI-DAQmx device to 1 in MAX and pass in DAQ::1 for the resource name, as shown in Example 4. 
        /// 
        /// If you use the DAQ::n syntax and an NI-DAQmx device name already exists with that same name, the NI-DAQmx device is matched first. 
        /// 
        /// You can also pass in the name of an IVI logical name or an IVI virtual name configured with the IVI Configuration utility, as shown in Example 5. A logical name identifies a particular virtual instrument. A virtual name identifies a specific device and specifies the initial settings for the session. 
        /// 
        /// 
        /// Caution  Traditional NI-DAQ and NI-DAQmx device names are not case-sensitive. However, all IVI names, such as logical names, are case-sensitive. If you use logical names, driver session names, or virtual names in your program, you must ensure that the name you use matches the name in the IVI Configuration Store file exactly, without any variations in the case of the characters.
        /// 
        ///  
        /// </param>
        /// <param name="ID_Query">
        /// 
        /// 
        /// idQuery
        /// ViBoolean
        /// Specify whether you want NI-FGEN to perform an ID query.
        ///             
        ///             When you set this parameter to VI_TRUE, NI-FGEN verifies that the device that you initialize is a type that it supports.
        /// 
        /// Circumstances can arise where sending an ID query to the device is undesirable. When you set this parameter to VI_FALSE, the function initializes the device without performing an ID query.
        /// 
        /// Defined Values
        /// 
        /// VI_TRUEPerform ID query
        /// VI_FALSESkip ID query
        /// 
        /// Default Value: VI_TRUE
        ///  
        /// </param>
        /// <param name="Reset_Device">
        /// 
        /// 
        /// resetDevice
        /// ViBoolean
        /// Specifies whether you want to reset the device during the initialization procedure.
        /// 
        /// Defined Values
        /// 
        ///  VI_TRUEReset device
        /// VI_FALSEDo not reset device
        /// 
        /// Default Value: VI_TRUE
        ///  
        /// </param>
        /// <param name="Option_String">
        /// 
        /// 
        /// optionString
        /// ViString
        ///            Sets the initial value of certain session attributes.
        /// 
        /// The syntax for optionString is
        /// 
        ///             &#60;attributeName&gt; = &#60;value&gt;
        ///             
        ///             where
        ///             
        ///             attributeName is the name of the attribute and value is the value to which the attribute is set
        /// 
        ///             To set multiple attributes, separate them with a comma.
        /// 
        /// If you pass NULL or an empty string for this parameter, the session uses the default values for these attributes. You can override the default values by assigning a value explicitly in a string that you pass for this parameter.
        /// 
        /// You do not have to specify all of the attributes and may leave any of them out. However, if you do not specify one of the attributes, its default value is used.
        /// 
        /// If simulation is enabled (Simulate=1), you may specify the device that you want to simulate. To specify a device, enter the following syntax in optionString.
        /// 
        /// DriverSetup=Model:&#60;driver model number&gt;;Channels:&#60;channel names&gt;;BoardType:&#60;module type&gt;;MemorySize:&#60;size of onboard memory in bytes&gt;
        /// 
        ///             
        /// Syntax Examples
        /// 
        ///     Device
        ///     optionString Syntax
        ///     NI PXI-5404
        ///     DriverSetup=Model:5404;BoardType:PXI
        ///     NI PCI-5411
        ///     DriverSetup=Model:5411;BoardType:PCI;MemorySize:8000000
        /// NI PXIe-5450
        ///     DriverSetup=Model:5450;Channels:0-1;BoardType:PXIe;MemorySize:8000000
        /// 
        /// Attributes and Defined Values
        ///       
        ///     Attribute Name
        ///     Attribute
        ///     Values
        ///     
        ///     RangeCheck
        ///     NIFGEN_ATTR_RANGE_CHECK
        ///     VI_TRUE, VI_FALSE
        ///     
        ///     QueryInstrStatus
        ///     NIFGEN_ATTR_QUERY_INSTRUMENT_STATUS
        ///     VI_TRUE, VI_FALSE
        ///     
        ///     Cache
        ///     NIFGEN_ATTR_CACHE
        ///     VI_TRUE, VI_FALSE
        ///     
        ///     Simulate
        ///     NIFGEN_ATTR_SIMULATE
        ///     VI_TRUE, VI_FALSE
        /// 
        /// Default Values: &#34;Simulate=0,RangeCheck=1,QueryInstrStatus=1,Cache=1&#34;
        ///  
        /// 
        /// 
        /// </param>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Returns a session handle that you can use to identify the device in all subsequent NI-FGEN function calls.
        ///  
        /// </param>
        public niFgen(string Resource_Name, bool ID_Query, bool Reset_Device, string Option_String)
        {
            int pInvokeResult = PInvoke.InitWithOptions(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Device), Option_String, out this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            this._disposed = false;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_InitExtCal
        /// 
        /// ViStatus niFgen_InitExtCal (ViRsrc resourceName, ViConstString password, ViSession* vi);
        /// 
        /// Purpose
        /// 
        /// Creates and initializes a special NI-FGEN external calibration session.  The ViSession returned is an NI-FGEN session that can be used to configure the device using normal attributes and functions.  However, flags have been set that allow you to program an external calibration procedure using the special calibration attributes and functions.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="Resource_Name">
        /// 
        /// 
        /// resourceName
        /// ViRsrc
        /// Specifies the resource name of the device to initialize.
        /// 
        /// 
        /// 
        ///                                                 Example #
        ///                 Device Type
        ///                 Syntax
        ///                 Variable
        ///             
        ///                             1
        ///                 Traditional NI-DAQ device
        ///                 DAQ::1
        ///                 (1 = device number)
        ///             
        ///                             2
        ///                 NI-DAQmx device
        ///                 myDAQmxDevice
        ///                 (myDAQmxDevice = device name)
        ///             
        ///                             3
        ///                 NI-DAQmx device
        ///                 DAQ::myDAQmxDevice
        ///                 (myDAQmxDevice = device name)
        ///             
        ///                             4
        ///                 NI-DAQmx device
        ///                 DAQ::2
        ///                 (2 = device name)
        ///             
        ///                             5
        ///                 IVI logical name or IVI virtual name
        ///                 myLogicalName
        ///                 (myLogicalName = name)
        ///             
        ///         
        /// 
        /// For Traditional NI-DAQ devices, the syntax is DAQ::n, where n is the device number assigned by MAX, as shown in Example 1. 
        /// 
        /// For NI-DAQmx devices, the syntax is just the device name specified in MAX, as shown in Example 2. Typical default names for NI-DAQmx devices in MAX are Dev1 or PXI1Slot1. You can rename an NI-DAQmx device by right-clicking on the name in MAX and entering a new name.
        /// 
        /// An alternate syntax for NI-DAQmx devices consists of DAQ::NI-DAQmx device name, as shown in Example 3. This naming convention allows for the use of an NI-DAQmx device in an application that was originally designed for a Traditional NI-DAQ device. For example, if the application expects DAQ::1, you can rename the NI-DAQmx device to 1 in MAX and pass in DAQ::1 for the resource name, as shown in Example 4. 
        /// 
        /// If you use the DAQ::n syntax and an NI-DAQmx device name already exists with that same name, the NI-DAQmx device is matched first. 
        /// 
        /// You can also pass in the name of an IVI logical name or an IVI virtual name configured with the IVI Configuration utility, as shown in Example 5. A logical name identifies a particular virtual instrument. A virtual name identifies a specific device and specifies the initial settings for the session. 
        /// 
        /// 
        /// Caution  Traditional NI-DAQ and NI-DAQmx device names are not case-sensitive. However, all IVI names, such as logical names, are case-sensitive. If you use logical names, driver session names, or virtual names in your program, you must ensure that the name you use matches the name in the IVI Configuration Store file exactly, without any variations in the case of the characters.
        /// 
        ///  
        /// </param>
        /// <param name="Password">
        /// 
        /// 
        /// password
        /// ViConstString
        /// The calibration password required to open an external calibration session to the device.
        ///  
        /// </param>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Returns a session handle that you can use to identify the device in all subsequent NI-FGEN function calls.
        ///  
        /// </param>
        public niFgen(string Resource_Name, string Password)
        {
            int pInvokeResult = PInvoke.InitExtCal(Resource_Name, Password, out this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            this._disposed = false;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_Commit
        /// 
        /// ViStatus niFgen_Commit (ViSession vi);
        /// 
        /// Purpose
        /// 
        /// Causes a transition to the Committed state. This function verifies attribute values, reserves the device, and commits the attribute values to the device. If the attributes values are all valid, the device configuration matches the session configuration.
        /// 
        /// In the Committed state, you can load waveforms, scripts, and sequences into memory. If any attributes are changed, NI-FGEN implicitly transitions back to the Idle state, where you can program all session properties before applying them to the device. This function has no effect if the device is already in the Committed state, and returns a successful status value. This function returns an error if it is called in the Generating state.
        /// 
        /// Using this function has the following benefits:
        /// 
        /// The niFgen_InitiateGeneration function occurs faster because the device is configured.
        /// Routes are committed, so signals are exported or imported.
        /// The PLL and all DCMs are locked.
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int Commit()
        {
            int pInvokeResult = PInvoke.Commit(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_reset
        /// 
        /// ViStatus niFgen_Reset (ViSession vi);
        /// 
        /// Purpose
        /// 
        /// Resets the instrument to a known state. This function aborts the generation, clears all 
        /// routes, and resets session attributes to the default values. This function does not, 
        /// however, commit the session properties or configure the device hardware to its default 
        /// state.
        /// <!-- Link to Additional VI/Function Information -->
        /// 
        /// 
        /// Note  For the NI 5401/5404/5411/5431, this function exhibits the 
        /// same behavior as the niFgen_ResetDevice function.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int reset()
        {
            int pInvokeResult = PInvoke.reset(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureOperationMode
        /// 
        /// ViStatus niFgen_ConfigureOperationMode (ViSession vi, ViConstString channelName, ViInt32 operationMode);
        /// 
        /// Purpose
        /// 
        /// Determines how the signal generator produces waveforms. NI signal generators support only Continuous operation mode. To control trigger mode, use the niFgen_ConfigureTriggerMode function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to configure the operation mode.
        /// 
        /// Defined Value: "0"
        /// 
        ///  
        /// </param>
        /// <param name="Operation_Mode">
        /// 
        /// 
        /// operationMode
        /// ViInt32
        /// Specifies the operation mode you want the signal generator to use.  NI-FGEN sets the NIFGEN_ATTR_OPERATION_MODE attribute to this value. Only one value is supported.
        /// 
        /// Defined Value:  NIFGEN_VAL_OPERATE_CONTINUOUS
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureOperationMode(string Channel_Name, int Operation_Mode)
        {
            int pInvokeResult = PInvoke.ConfigureOperationMode(this._handle, Channel_Name, Operation_Mode);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureOutputMode
        /// 
        /// ViStatus niFgen_ConfigureOutputMode (ViSession vi, ViInt32 outputMode);
        /// 
        /// Purpose
        /// 
        /// Configures the output mode of the signal generator. The output mode determines the type of waveforms the signal generator produces.
        /// 
        /// For example, you can choose to generate a standard waveform, an arbitrary waveform, or a sequence of arbitrary waveforms.  
        /// 
        /// 
        /// Note   The signal generator must not be in the Generating state when you call this function.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Output_Mode">
        /// 
        /// 
        /// outputMode
        /// ViInt32
        /// Specifies the output mode that you want the signal generator to use.  The value you specify determines which functions and attributes you can use to configure the waveform the signal generator produces.
        /// 
        /// 
        /// 
        /// Refer to the NIFGEN_ATTR_OUTPUT_MODE attribute for more information on setting this parameter. 
        /// 
        /// 
        /// 
        /// Defined Values
        /// 
        /// 
        ///      
        /// NIFGEN_VAL_OUTPUT_FUNC
        /// Standard Function mode&#8212; Generates standard function waveforms such as sine, square, triangle, and so on.
        ///      
        /// NIFGEN_VAL_OUTPUT_FREQ_LIST
        /// Frequency List mode&#8212;Generates a standard function using a list of frequencies you define.
        ///        
        /// NIFGEN_VAL_OUTPUT_ARB
        /// Arbitrary waveform mode&#8212;Generates waveforms from user-created/provided waveform arrays of numeric data
        ///        
        /// NIFGEN_VAL_OUTPUT_SEQ
        /// Arbitrary sequence mode &#8212;Generates downloaded waveforms in an order your specify.
        /// 
        /// NIFGEN_VAL_OUTPUT_SCRIPT
        /// Script mode&#8212;Allows you to use scripting to link and loop multiple waveforms in complex combinations
        /// 
        /// 
        /// 
        /// 
        /// Default Value: NIFGEN_VAL_OUTPUT_FUNC
        /// 
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureOutputMode(int Output_Mode)
        {
            int pInvokeResult = PInvoke.ConfigureOutputMode(this._handle, Output_Mode);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureChannels
        /// 
        /// ViStatus niFgen_ConfigureChannels (ViSession vi, ViConstString channels);
        /// 
        /// Purpose
        /// 
        /// Configures the channels to use with the instrument specified in the vi parameter.  If you call this function, you must call it immediately after initializing your session and before configuring attributes or writing data.
        /// 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channels">
        /// 
        /// 
        /// 
        /// channels
        /// ViConstString
        /// 
        /// Specifies the channel on which all subsequent channel-based attributes  in the session are set.   Valid values are non-negative integers. For example, 0 is the only valid value on devices with one channel, while devices with two channels support values of 0 and 1. You can specify more than one channel by inserting  commas between values (for example, &#34;0,1&#34;).
        /// 
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureChannels(string Channels)
        {
            int pInvokeResult = PInvoke.ConfigureChannels(this._handle, Channels);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureOutputEnabled
        /// 
        /// ViStatus niFgen_ConfigureOutputEnabled (ViSession vi, ViConstString channelName, ViBoolean enabled);
        /// 
        /// Purpose
        /// 
        /// Enables or disables the signal generator output.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to enable the output.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Enabled">
        /// 
        /// 
        /// enabled
        /// ViBoolean
        /// Specifies whether you want to enable or disable the output. NI-FGEN uses this value to set the NIFGEN_ATTR_OUTPUT_ENABLED attribute.
        /// 
        /// Defined Values
        /// 
        /// VI_TRUE
        /// Enable the output
        /// 
        /// VI_FALSE
        /// Disable the output
        /// 
        /// Default Value: VI_TRUE
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureOutputEnabled(string Channel_Name, bool Enabled)
        {
            int pInvokeResult = PInvoke.ConfigureOutputEnabled(this._handle, Channel_Name, System.Convert.ToUInt16(Enabled));
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureOutputImpedance
        /// 
        /// ViStatus niFgen_ConfigureOutputImpedance (ViSession vi, ViConstString channelName, ViReal64 impedance);
        /// 
        /// Purpose
        /// 
        /// Configures the output impedance for the channel you specify.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to set the output impedance.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Impedance">
        /// 
        /// 
        /// impedance
        /// ViReal64
        /// Specifies the impedance value that you want the signal generator to use.  NI-FGEN sets the NIFGEN_ATTR_OUTPUT_IMPEDANCE attribute to this value. 
        /// 
        /// Units: &#8486; (ohms)
        /// 
        /// Defined Values:
        /// 
        /// NIFGEN_VAL_50_OHMS50 &#8486; of impedance
        /// NIFGEN_VAL_75_OHMS75 &#8486; of impedance
        /// 
        /// 
        /// Default Value: NIFGEN_VAL_50_OHMS
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureOutputImpedance(string Channel_Name, double Impedance)
        {
            int pInvokeResult = PInvoke.ConfigureOutputImpedance(this._handle, Channel_Name, Impedance);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_EnableAnalogFilter
        /// 
        /// ViStatus niFgen_EnableAnalogFilter (ViSession vi, ViConstString channelName, ViReal64 filterCorrectionFrequency);
        /// 
        /// Purpose
        /// 
        /// Enables the analog filter. You can also specify the filter correction frequency of the analog filter. This sets the NIFGEN_ATTR_ANALOG_FILTER_ENABLED attribute to VI_TRUE. This function is valid in Arbitrary Waveform, Arbitrary Sequence, and Script output modes. This function can also be used in Standard Function and Frequency List output modes for user-defined waveforms.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to enable the analog filter.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Filter_Correction_Frequency">
        /// 
        /// 
        /// filterCorrectionFrequency
        /// ViReal64
        /// Specifies the filter correction frequency of the analog filter. On the NI 5411 and NI 5431, 
        /// NI-FGEN adjusts signal amplitude to compensate for the filter attenuation at that 
        /// frequency. To disable amplitude correction, set filterCorrectionFrequency to 0. For 
        /// Standard function output mode, the filter correction frequency typically should  be set to
        /// the same value  as the frequency of the standard waveform. 
        /// Units: hertz
        /// 
        /// Default Value: 0
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int EnableAnalogFilter(string Channel_Name, double Filter_Correction_Frequency)
        {
            int pInvokeResult = PInvoke.EnableAnalogFilter(this._handle, Channel_Name, Filter_Correction_Frequency);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_DisableAnalogFilter
        /// 
        /// ViStatus niFgen_DisableAnalogFilter (ViSession vi, ViConstString channelName);
        /// 
        /// Purpose
        /// 
        /// Disables the analog filter. This function sets the NIFGEN_ATTR_ANALOG_FILTER_ENABLED attribute to VI_FALSE. This function is valid in Arbitrary Waveform, Arbitrary Sequence, and Script output modes. This function can also be used in Standard Function and Frequency List output modes for user-defined waveforms.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to disable the analog filter.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int DisableAnalogFilter(string Channel_Name)
        {
            int pInvokeResult = PInvoke.DisableAnalogFilter(this._handle, Channel_Name);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_EnableDigitalFilter
        /// 
        /// ViStatus niFgen_EnableDigitalFilter (ViSession vi, ViConstString channelName);
        /// 
        /// Purpose
        /// 
        /// Enables the digital filter by setting the NIFGEN_ATTR_DIGITAL_FILTER_ENABLED attribute to VI_TRUE. This function is valid in Arbitrary Waveform, Arbitrary Sequence, and Script output modes. This function can also be used in Standard Function and Frequency List output modes for user-defined waveforms.
        /// 
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to enable the digital filter.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int EnableDigitalFilter(string Channel_Name)
        {
            int pInvokeResult = PInvoke.EnableDigitalFilter(this._handle, Channel_Name);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_DisableDigitalFilter
        /// 
        /// ViStatus niFgen_DisableDigitalFilter (ViSession vi, ViConstString channelName);
        /// 
        /// Purpose
        /// 
        /// Disables the digital filter. This function sets the NIFGEN_ATTR_DIGITAL_FILTER_ENABLED attribute to VI_FALSE. This function is valid in Arbitrary Waveform, Arbitrary Sequence, and Script output modes. This function can also be used in Standard Function and Frequency List output modes for user-defined waveforms.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to disable the digital filter. 
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int DisableDigitalFilter(string Channel_Name)
        {
            int pInvokeResult = PInvoke.DisableDigitalFilter(this._handle, Channel_Name);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_EnableDigitalPatterning
        /// 
        /// ViStatus niFgen_EnableDigitalPatterning (ViSession vi, ViConstString channelName);
        /// 
        /// Purpose
        /// 
        /// Enables digital patterning on the signal generator. This function sets the NIFGEN_ATTR_DIGITAL_PATTERN_ENABLED attribute to VI_TRUE.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to enable the digital patterning.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int EnableDigitalPatterning(string Channel_Name)
        {
            int pInvokeResult = PInvoke.EnableDigitalPatterning(this._handle, Channel_Name);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_DisableDigitalPatterning
        /// 
        /// ViStatus niFgen_DisableDigitalPatterning (ViSession vi, ViConstString channelName);
        /// 
        /// Purpose
        /// 
        /// Disables digital patterning on the signal generator. This function sets the NIFGEN_ATTR_DIGITAL_PATTERN_ENABLED attribute to VI_FALSE.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to disable digital patterning.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int DisableDigitalPatterning(string Channel_Name)
        {
            int pInvokeResult = PInvoke.DisableDigitalPatterning(this._handle, Channel_Name);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureStandardWaveform
        /// 
        /// ViStatus niFgen_ConfigureStandardWaveform (ViSession vi, ViConstString channelName, ViInt32 waveform, ViReal64 amplitude, ViReal64 dcOffset, ViReal64 frequency, ViReal64 startPhase);
        /// 
        /// Purpose
        /// 
        /// Configures the attributes of the signal generator that affect standard waveform generation (the
        /// 
        ///   NIFGEN_ATTR_FUNC_WAVEFORM, 
        /// 
        ///   NIFGEN_ATTR_FUNC_AMPLITUDE, 
        /// 
        ///   NIFGEN_ATTR_FUNC_DC_OFFSET, 
        /// 
        ///   NIFGEN_ATTR_FUNC_FREQUENCY, 
        /// 
        /// and   NIFGEN_ATTR_FUNC_START_PHASE attributes).
        /// 
        /// 
        /// 
        /// Note  You must use the 
        /// 
        ///   niFgen_ConfigureOutputMode function with the outputMode parameter set to NIFGEN_VAL_OUTPUT_FUNC before calling this function.
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to configure a standard waveform.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Waveform">
        /// 
        /// 
        /// waveform
        /// ViInt32
        /// Specifies the standard waveform that you want the signal generator to produce. NI-FGEN sets the NIFGEN_ATTR_FUNC_WAVEFORM attribute to this value.
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_WFM_SINE
        /// Sinusoidal waveform
        /// 
        /// NIFGEN_VAL_WFM_SQUARE
        /// Square waveform
        /// 
        /// NIFGEN_VAL_WFM_TRIANGLE
        /// Triangular waveform
        /// 
        /// NIFGEN_VAL_WFM_RAMP_UP
        /// Positive ramp waveform
        /// 
        /// NIFGEN_VAL_WFM_RAMP_DOWN
        /// Negative ramp waveform
        /// 
        /// NIFGEN_VAL_WFM_DC
        /// Constant voltage
        /// 
        /// NIFGEN_VAL_WFM_NOISE
        /// White noise
        /// 
        /// NIFGEN_VAL_WFM_USER
        /// User-defined waveform as defined with the niFgen_DefineUserStandardWaveform function
        /// 
        /// Default Value: NIFGEN_VAL_WFM_SINE
        /// 
        ///  
        /// </param>
        /// <param name="Amplitude">
        /// 
        /// 
        /// amplitude
        /// ViReal64
        /// Specifies the amplitude of the standard waveform that you want the signal generator to produce. This value is the amplitude at the output terminal. NI-FGEN sets the NIFGEN_ATTR_FUNC_AMPLITUDE attribute to this value. 
        /// 
        /// For example, to produce a waveform ranging from &#8211;5.00 to +5.00 V, set the amplitude to 10.00 V.
        /// 
        /// 
        /// 
        /// Note   This parameter does not affect signal generator behavior when you set the waveform parameter of the niFgen_ConfigureStandardWaveform function to NIFGEN_VAL_WFM_DC.
        /// 
        /// Units: peak-to-peak voltage
        /// 
        /// Default Value: None
        /// 
        ///  
        /// </param>
        /// <param name="DC_Offset">
        /// 
        /// 
        /// dcOffset
        /// ViReal64
        /// Specifies the DC offset of the standard waveform that you want the signal generator to produce. This value is the offset at the output terminal (the offset is from ground to the center of the waveform).  NI-FGEN sets the NIFGEN_ATTR_FUNC_DC_OFFSET attribute to this value.  
        /// 
        /// For example, to configure a waveform with an amplitude of 10.00 V to range from 0.00 to +10.00 V, set the DC Offset to 5.00 V.
        /// 
        /// Units: volts
        /// 
        /// Default Value: None
        ///  
        /// </param>
        /// <param name="Frequency">
        /// 
        /// 
        /// frequency
        /// ViReal64
        /// Specifies the frequency of the standard waveform that you want the signal generator to produce. NI-FGEN sets the NIFGEN_ATTR_FUNC_FREQUENCY attribute to this value.
        /// 
        /// 
        /// 
        /// 
        /// Notes  This parameter does not affect signal generator behavior when you set the waveform parameter of the niFgen_ConfigureStandardWaveform function to NIFGEN_VAL_WFM_DC.
        /// 
        /// Frequency ranges vary from device to device. For information about the frequencies supported on your device, refer to the Features supported topic for your device.
        /// 
        /// 
        /// Units: hertz
        /// Default Value: None
        ///  
        /// </param>
        /// <param name="Start_Phase">
        /// 
        /// 
        /// startPhase
        /// ViReal64
        /// Specifies the horizontal offset of the standard waveform you want the  signal generator to produce. Specify this attribute in degrees of one waveform cycle. NI-FGEN sets the NIFGEN_ATTR_FUNC_START_PHASE attribute to this value. A start phase of 180 degrees means output generation begins halfway through the waveform. A start phase of 360 degrees offsets the output by an entire waveform cycle, which is identical to a start phase of 0 degrees.
        /// 
        /// 
        /// Note   This parameter does not affect signal generator behavior when you set the waveform parameter to NIFGEN_VAL_WFM_DC.
        /// 
        /// Units: degrees of one cycle
        /// 
        /// Default Value: 0.00
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureStandardWaveform(string Channel_Name, int Waveform, double Amplitude, double DC_Offset, double Frequency, double Start_Phase)
        {
            int pInvokeResult = PInvoke.ConfigureStandardWaveform(this._handle, Channel_Name, Waveform, Amplitude, DC_Offset, Frequency, Start_Phase);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_DefineUserStandardWaveform
        /// 
        /// ViStatus niFgen_DefineUserStandardWaveform (ViSession vi, ViConstString channelName, ViInt32 waveformSize, ViReal64[] waveformDataArray);
        /// 
        /// Purpose
        /// 
        /// Defines a user waveform for use in either Standard Function output mode or Frequency List output mode.  
        /// 
        /// To select the waveform, set the waveform parameter to 
        /// NIFGEN_VAL_WFM_USER with either the niFgen_ConfigureStandardWaveform or the niFgen_CreateFreqList function.
        /// 
        /// The waveform data must be scaled between -1.0 and 1.0. Use the 
        /// amplitude parameter to generate different output voltages.
        /// 
        /// 
        /// Note  You must set outputMode to
        /// NIFGEN_VAL_OUTPUT_FUNC or
        /// NIFGEN_VAL_OUTPUT_FREQ_LIST using the niFgen_ConfigureOutputMode function 
        /// before calling this function. 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to define a user standard waveform.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Waveform_Size">
        /// 
        /// 
        /// waveformSize
        /// ViInt32
        /// Specifies the size of the arbitrary waveform you want to create.
        /// 
        /// Default Value: 16384
        ///  
        /// </param>
        /// <param name="Waveform_Data_Array">
        /// 
        /// 
        /// waveformDataArray
        /// ViReal64[]
        /// Specifies the array of data you want to use for the new arbitrary waveform. The array must have at least as many elements as the value that you specify in waveformSize.
        /// 
        /// You must normalize the data points in the array to be between &#8211;1.00 and +1.00.
        /// 
        /// Default Value: None
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int DefineUserStandardWaveform(string Channel_Name, int Waveform_Size, double[] Waveform_Data_Array)
        {
            int pInvokeResult = PInvoke.DefineUserStandardWaveform(this._handle, Channel_Name, Waveform_Size, Waveform_Data_Array);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ClearUserStandardWaveform
        /// 
        /// ViStatus niFgen_ClearUserStandardWaveform (ViSession vi, ViConstString channelName);
        /// 
        /// Purpose
        /// 
        /// Clears the user-defined waveform created by the niFgen_DefineUserStandardWaveform function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name from which you want to clear a user standard waveform.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ClearUserStandardWaveform(string Channel_Name)
        {
            int pInvokeResult = PInvoke.ClearUserStandardWaveform(this._handle, Channel_Name);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureFrequency
        /// 
        /// ViStatus niFgen_ConfigureFrequency (ViSession vi, ViConstString channelName, ViReal64 frequency);
        /// 
        /// Purpose
        /// 
        /// Configures the frequency of the standard waveform that you want the signal generator to produce.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to configure a standard waveform.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Frequency">
        /// 
        /// 
        /// frequency
        /// ViReal64
        /// Specifies the frequency of the standard waveform that you want the signal generator to produce. NI-FGEN sets the NIFGEN_ATTR_FUNC_FREQUENCY attribute to this value.
        /// 
        /// 
        /// 
        /// 
        /// Notes  This parameter does not affect signal generator behavior when you set the waveform parameter of the niFgen_ConfigureStandardWaveform function to NIFGEN_VAL_WFM_DC.
        /// 
        /// Frequency ranges vary from device to device. For information about the frequencies supported on your device, refer to the Features supported topic for your device.
        /// 
        /// 
        /// Units: hertz
        /// Default Value: None
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureFrequency(string Channel_Name, double Frequency)
        {
            int pInvokeResult = PInvoke.ConfigureFrequency(this._handle, Channel_Name, Frequency);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureAmplitude
        /// 
        /// ViStatus niFgen_ConfigureAmplitude (ViSession vi, ViConstString channelName, ViReal64 amplitude);
        /// 
        /// Purpose
        /// 
        /// Configures the amplitude of the standard waveform that you want the signal generator to produce.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to configure a standard waveform.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Amplitude">
        /// 
        /// 
        /// amplitude
        /// ViReal64
        /// Specifies the amplitude of the standard waveform that you want the signal generator to produce. This value is the amplitude at the output terminal. NI-FGEN sets the NIFGEN_ATTR_FUNC_AMPLITUDE attribute to this value. 
        /// 
        /// For example, to produce a waveform ranging from &#8211;5.00 to +5.00 V, set the amplitude to 10.00 V.
        /// 
        /// 
        /// 
        /// Note   This parameter does not affect signal generator behavior when you set the waveform parameter of the niFgen_ConfigureStandardWaveform function to NIFGEN_VAL_WFM_DC.
        /// 
        /// Units: peak-to-peak voltage
        /// 
        /// Default Value: None
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureAmplitude(string Channel_Name, double Amplitude)
        {
            int pInvokeResult = PInvoke.ConfigureAmplitude(this._handle, Channel_Name, Amplitude);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_CreateFreqList
        /// 
        /// ViStatus niFgen_CreateFreqList (ViSession vi, ViInt32 waveform, ViInt32 frequencyListLength, ViReal64[] frequencyArray, ViReal64[] durationArray, ViInt32* frequencyListHandle);
        /// 
        /// Purpose
        /// 
        /// Creates a frequency list from an array of frequencies (frequencyArray) and an array of durations (durationArray). The arrays must be the same size, and this must also be the size of the the frequencyListLength. The signal generator generates each frequency for the given amount of time and then proceeds to the next frequency. When the end of the list is reached, the signal generator starts over at the beginning of the list. The function returns a handle that identifies the frequency list (the frequencyListHandle). You can pass this handle to niFgen_ConfigureFreqList to specify what frequency list you want the signal generator to produce.
        /// 
        /// 
        /// Notes  The signal generator must not be in the Generating state when you call this function.
        /// You must call the niFgen_ConfigureOutputMode function to set the output mode to NIFGEN_VAL_OUTPUT_FREQ_LIST before calling this function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Waveform">
        /// 
        /// 
        /// waveform
        /// ViInt32
        /// Specifies the standard waveform that you want the signal generator to produce. NI-FGEN sets the NIFGEN_ATTR_FUNC_WAVEFORM attribute to this value.
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_WFM_SINE
        /// Sinusoidal waveform
        /// 
        /// NIFGEN_VAL_WFM_SQUARE
        /// Square waveform
        /// 
        /// NIFGEN_VAL_WFM_TRIANGLE
        /// Triangular waveform
        /// 
        /// NIFGEN_VAL_WFM_RAMP_UP
        /// Positive ramp waveform
        /// 
        /// NIFGEN_VAL_WFM_RAMP_DOWN
        /// Negative ramp waveform
        /// 
        /// NIFGEN_VAL_WFM_DC
        /// Constant voltage
        /// 
        /// NIFGEN_VAL_WFM_NOISE
        /// White noise
        /// 
        /// NIFGEN_VAL_WFM_USER
        /// User-defined waveform as defined with the niFgen_DefineUserStandardWaveform function
        /// 
        /// Default Value: NIFGEN_VAL_WFM_SINE
        /// 
        ///  
        /// </param>
        /// <param name="Frequency_List_Length">
        /// 
        /// 
        /// frequencyListLength
        /// ViInt32
        /// Specifies the number of steps in the frequency list you want to create. The value must be between the minimum and maximum frequency list lengths that the signal generator allows. You can obtain the minimum and maximum frequency list lengths from the minimumFrequencyListLength and maximumFrequencyListLength parameters in the niFgen_QueryFreqListCapabilities functions.
        /// 
        /// frequency and duration must each be at least as long as this frequency list length.
        /// 
        /// Default Value: None
        ///  
        /// </param>
        /// <param name="Frequency_Array">
        /// 
        /// 
        /// frequencyArray
        /// ViReal64[]
        /// Specifies the array of frequencies to form the frequency list. The array must have at least as many elements as the value you specify in frequencyListLength. Each frequencyArray element has a corresponding durationArray element that indicates how long that frequency is repeated.  
        /// 
        /// Units: hertz
        /// 
        /// Default Value: None
        ///  
        /// </param>
        /// <param name="Duration_Array">
        /// 
        /// 
        /// durationArray
        /// ViReal64[]
        /// Specifies the array of durations to form the frequency list. The array must have at least as many elements as the value that you specify in frequencyListLength. Each durationArray element has a corresponding frequencyArray element and indicates how long in seconds to generate the corresponding frequency.  
        /// 
        /// Units: seconds
        /// 
        /// Default Value: None
        ///  
        /// </param>
        /// <param name="Frequency_List_Handle">
        /// 
        /// 
        /// frequencyListHandle
        /// ViInt32*
        /// Returns the handle that identifies the new frequency list. You can pass this handle to niFgen_ConfigureFreqList to generate the arbitrary sequence.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int CreateFreqList(int Waveform, int Frequency_List_Length, double[] Frequency_Array, double[] Duration_Array, out int Frequency_List_Handle)
        {
            int pInvokeResult = PInvoke.CreateFreqList(this._handle, Waveform, Frequency_List_Length, Frequency_Array, Duration_Array, out Frequency_List_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureFreqList
        /// 
        /// ViStatus niFgen_ConfigureFreqList (ViSession vi, ViConstString channelName, ViInt32 frequencyListHandle, ViReal64 amplitude, ViReal64 dcOffset, ViReal64 startPhase);
        /// 
        /// Purpose
        /// 
        /// Configures the attributes of the signal generator that affect frequency list generation 
        /// (the NIFGEN_ATTR_FREQ_LIST_HANDLE, 
        /// NIFGEN_ATTR_FUNC_AMPLITUDE, 
        /// NIFGEN_ATTR_FUNC_DC_OFFSET, 
        /// and NIFGEN_ATTR_FUNC_START_PHASE attributes).
        /// 
        /// 
        /// Notes  The signal generator must not be in the Generating state when you call this function.
        /// You must call the niFgen_ConfigureOutputMode function to set the output mode to NIFGEN_VAL_OUTPUT_FREQ_LIST before calling this function.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to configure the frequency list.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Frequency_List_Handle">
        /// 
        /// 
        /// frequencyListHandle
        /// ViInt32
        /// Specifies the handle of the frequency list that you want the signal generator to produce. NI-FGEN sets the NIFGEN_ATTR_FREQ_LIST_HANDLE attribute to this value. You can create a frequency list using the niFgen_CreateFreqList function. The niFgen_CreateFreqList function returns a handle that you use to identify the list.
        /// 
        /// Default Value: None
        /// 
        ///  
        /// </param>
        /// <param name="Amplitude">
        /// 
        /// 
        /// amplitude
        /// ViReal64
        /// Specifies the amplitude of the standard waveform that you want the signal generator to produce. This value is the amplitude at the output terminal. NI-FGEN sets the NIFGEN_ATTR_FUNC_AMPLITUDE attribute to this value. 
        /// 
        /// For example, to produce a waveform ranging from &#8211;5.00 to +5.00 V, set the amplitude to 10.00 V.
        /// 
        /// 
        /// 
        /// Note   This parameter does not affect signal generator behavior when you set the waveform parameter of the niFgen_ConfigureStandardWaveform function to NIFGEN_VAL_WFM_DC.
        /// 
        /// Units: peak-to-peak voltage
        /// 
        /// Default Value: None
        /// 
        ///  
        /// </param>
        /// <param name="DC_Offset">
        /// 
        /// 
        /// dcOffset
        /// ViReal64
        /// Specifies the DC offset of the standard waveform that you want the signal generator to produce. This value is the offset at the output terminal (the offset is from ground to the center of the waveform).  NI-FGEN sets the NIFGEN_ATTR_FUNC_DC_OFFSET attribute to this value.  
        /// 
        /// For example, to configure a waveform with an amplitude of 10.00 V to range from 0.00 to +10.00 V, set the DC Offset to 5.00 V.
        /// 
        /// Units: volts
        /// 
        /// Default Value: None
        ///  
        /// </param>
        /// <param name="Start_Phase">
        /// 
        /// 
        /// startPhase
        /// ViReal64
        /// Specifies the horizontal offset of the standard waveform you want the  signal generator to produce. Specify this attribute in degrees of one waveform cycle. NI-FGEN sets the NIFGEN_ATTR_FUNC_START_PHASE attribute to this value. A start phase of 180 degrees means output generation begins halfway through the waveform. A start phase of 360 degrees offsets the output by an entire waveform cycle, which is identical to a start phase of 0 degrees.
        /// 
        /// 
        /// Note   This parameter does not affect signal generator behavior when you set the waveform parameter to  NIFGEN_VAL_WFM_DC.
        /// 
        /// Units: degrees of one cycle
        /// 
        /// Default Value: None degrees
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureFreqList(string Channel_Name, int Frequency_List_Handle, double Amplitude, double DC_Offset, double Start_Phase)
        {
            int pInvokeResult = PInvoke.ConfigureFreqList(this._handle, Channel_Name, Frequency_List_Handle, Amplitude, DC_Offset, Start_Phase);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ClearFreqList
        /// 
        /// ViStatus niFgen_ClearFreqList (ViSession vi, ViInt32 frequencyListHandle);
        /// 
        /// Purpose
        /// 
        /// Removes a previously created frequency list from the signal generator memory and invalidates the frequency list handle.
        /// 
        /// 
        /// Note   The signal generator must not be in the Generating state when you call this function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Frequency_List_Handle">
        /// 
        /// 
        /// frequencyListHandle
        /// ViInt32
        /// Specifies the handle of the frequency list that you want the signal generator to produce. NI-FGEN sets the NIFGEN_ATTR_FREQ_LIST_HANDLE attribute to this value. You can create a frequency list using the niFgen_CreateFreqList function. The niFgen_CreateFreqList function returns a handle that you use to identify the list.
        /// 
        /// Default Value: None
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ClearFreqList(int Frequency_List_Handle)
        {
            int pInvokeResult = PInvoke.ClearFreqList(this._handle, Frequency_List_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_QueryFreqListCapabilities
        /// 
        /// ViStatus niFgen_QueryFreqListCapabilities (ViSession vi, ViInt32* maximumNumberOfFreqLists, ViInt32* minimumFrequencyListLength, ViInt32* maximumFrequencyListLength, ViReal64* minimumFrequencyListDuration, ViReal64* maximumFrequencyListDuration, ViReal64* frequencyListDurationQuantum);
        /// 
        /// Purpose
        /// 
        /// Returns the attributes of the signal generator that are related to creating frequency lists.  These attributes are NIFGEN_ATTR_MAX_NUM_FREQ_LISTS,
        /// 
        /// NIFGEN_ATTR_MIN_FREQ_LIST_LENGTH, 
        /// 
        /// NIFGEN_ATTR_MAX_FREQ_LIST_LENGTH, 
        /// 
        /// NIFGEN_ATTR_MIN_FREQ_LIST_DURATION, 
        /// 
        /// NIFGEN_ATTR_MAX_FREQ_LIST_DURATION, 
        /// 
        /// and NIFGEN_ATTR_FREQ_LIST_DURATION_QUANTUM.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Maximum_Number_Of_Freq_Lists">
        /// 
        /// 
        /// maximumNumberOfFreqLists
        /// ViInt32
        /// Returns the maximum number of frequency lists that the signal generator allows. NI-FGEN obtains this value from the NIFGEN_ATTR_MAX_NUM_FREQ_LISTS attribute.
        ///  
        /// </param>
        /// <param name="Minimum_Frequency_List_Length">
        /// 
        /// 
        /// minimumFrequencyListLength
        /// ViInt32
        /// Returns the minimum number of steps that the signal generator allows in a frequency list. NI-FGEN obtains this value from the NIFGEN_ATTR_MIN_FREQ_LIST_LENGTH attribute.
        ///  
        /// </param>
        /// <param name="Maximum_Frequency_List_Length">
        /// 
        /// 
        /// maximumFrequencyListLength
        /// ViInt32
        /// Returns the maximum number of steps that the signal generator allows in a frequency list. NI-FGEN obtains this value from the NIFGEN_ATTR_MAX_FREQ_LIST_LENGTH attribute.
        ///  
        /// </param>
        /// <param name="Minimum_Frequency_List_Duration">
        /// 
        /// 
        /// minimumFrequencyListDuration
        /// ViReal64
        /// Returns the minimum duration that the signal generator allows in a step of a frequency list. NI-FGEN obtains this value from the NIFGEN_ATTR_MIN_FREQ_LIST_DURATION attribute.
        ///  
        /// </param>
        /// <param name="Maximum_Frequency_List_Duration">
        /// 
        /// 
        /// maximumFrequencyListDuration
        /// ViReal64
        /// Returns the maximum duration that the signal generator allows in a step of a frequency list. NI-FGEN obtains this value from the NIFGEN_ATTR_MAX_FREQ_LIST_DURATION attribute.
        ///  
        /// </param>
        /// <param name="Frequency_List_Duration_Quantum">
        /// 
        /// 
        /// frequencyListDurationQuantum
        /// ViReal64
        /// Returns the quantum of which all durations must be a multiple in a frequency list. NI-FGEN obtains this value from the NIFGEN_ATTR_FREQ_LIST_DURATION_QUANTUM attribute.
        /// 
        ///
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int QueryFreqListCapabilities(out int Maximum_Number_Of_Freq_Lists, out int Minimum_Frequency_List_Length, out int Maximum_Frequency_List_Length, out double Minimum_Frequency_List_Duration, out double Maximum_Frequency_List_Duration, out double Frequency_List_Duration_Quantum)
        {
            int pInvokeResult = PInvoke.QueryFreqListCapabilities(this._handle, out Maximum_Number_Of_Freq_Lists, out Minimum_Frequency_List_Length, out Maximum_Frequency_List_Length, out Minimum_Frequency_List_Duration, out Maximum_Frequency_List_Duration, out Frequency_List_Duration_Quantum);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureGain
        /// 
        /// ViStatus niFgen_ConfigureGain (ViSession vi, ViConstString channelName, ViReal64 gain);
        /// 
        /// Purpose
        /// 
        /// Configures the amount of gain to apply to the waveform.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to configure the gain.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Gain">
        /// 
        /// 
        /// gain
        /// ViReal64
        /// Specifies the factor by which the signal generator scales the arbitrary waveform data. When you create arbitrary waveforms, you must first normalize the data points to a range of &#8211;1.00 to +1.00 V.  You can use this parameter to scale the arbitrary waveform to other ranges. NI-FGEN sets the NIFGEN_ATTR_ARB_GAIN attribute to this value.
        /// 
        /// For example, to configure the output signal to range from &#8211;2.00 to +2.00 V, set the gain to 2.00.
        /// 
        /// Units: volts
        /// 
        /// Default Value: None
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureGain(string Channel_Name, double Gain)
        {
            int pInvokeResult = PInvoke.ConfigureGain(this._handle, Channel_Name, Gain);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureSampleRate
        /// 
        /// ViStatus niFgen_ConfigureSampleRate (ViSession vi, ViReal64 sampleRate);
        /// 
        /// Purpose
        /// 
        /// Configures the sample rate attribute, which determines the rate at which the signal generator produces arbitrary waveforms.  When you configure the signal generator to produce an arbitrary sequence, this value is the sample rate for all arbitrary waveforms in the sequence.
        /// 
        /// 
        /// Notes  The signal generator must not be in the Generating state when you call this function.
        /// You must call the   niFgen_ConfigureOutputMode function to set the output mode to NIFGEN_VAL_OUTPUT_ARB, NIFGEN_VAL_OUTPUT_SEQ, or NIFGEN_VAL_OUTPUT_SCRIPT before calling this function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Sample_Rate">
        /// 
        /// 
        /// sampleRate
        /// ViReal64
        /// Specifies the sample rate at which you want the signal generator to generate arbitrary waveforms. NI-FGEN sets the NIFGEN_ATTR_ARB_SAMPLE_RATE attribute to this value. 
        /// 
        /// Units: samples/s
        /// 
        /// Default Value: None
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureSampleRate(double Sample_Rate)
        {
            int pInvokeResult = PInvoke.ConfigureSampleRate(this._handle, Sample_Rate);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_QueryArbWfmCapabilities
        /// 
        /// ViStatus niFgen_QueryArbWfmCapabilities (ViSession vi, ViInt32* maximumNumberofWaveforms, ViInt32* waveformQuantum, ViInt32* minimumWaveformSize, ViInt32* maximumWaveformSize);
        /// 
        /// Purpose
        /// 
        /// Returns the attributes of the signal generator that are related to creating arbitrary waveforms. These attributes are the maximum number of waveforms, waveform quantum, minimum waveform size, and maximum waveform size.
        /// 
        /// 
        /// Note   If you do not want to obtain the waveform quantum, pass a value of VI_NULL for this parameter.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Maximum_Number_of_Waveforms">
        /// 
        /// 
        /// maximumNumberofWaveforms
        /// ViInt32*
        /// Returns the maximum number of arbitrary waveforms that the signal generator allows. NI-FGEN obtains this value from the NIFGEN_ATTR_MAX_NUM_WAVEFORMS attribute.
        ///  
        /// </param>
        /// <param name="Waveform_Quantum">
        /// 
        /// 
        /// waveformQuantum
        /// ViInt32*
        /// The size (number of points) of each waveform must be a multiple of a constant quantum value. This parameter obtains the quantum value that the signal generator uses. NI-FGEN returns this value from the NIFGEN_ATTR_WAVEFORM_QUANTUM attribute.
        /// 
        /// For example, when this attribute returns a value of 8, all waveform sizes must be a multiple of 8.
        ///  
        /// </param>
        /// <param name="Minimum_Waveform_Size">
        /// 
        /// 
        /// minimumWaveformSize
        /// ViInt32*
        /// Returns the minimum number of points that the signal generator allows in a waveform. NI-FGEN obtains this value from the NIFGEN_ATTR_MIN_WAVEFORM_SIZE attribute.
        ///  
        /// </param>
        /// <param name="Maximum_Waveform_Size">
        /// 
        /// 
        /// maximumWaveformSize
        /// ViInt32*
        /// Returns the maximum number of points that the signal generator allows in a waveform. NI-FGEN obtains this value from the NIFGEN_ATTR_MAX_WAVEFORM_SIZE attribute.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int QueryArbWfmCapabilities(out int Maximum_Number_of_Waveforms, out int Waveform_Quantum, out int Minimum_Waveform_Size, out int Maximum_Waveform_Size)
        {
            int pInvokeResult = PInvoke.QueryArbWfmCapabilities(this._handle, out Maximum_Number_of_Waveforms, out Waveform_Quantum, out Minimum_Waveform_Size, out Maximum_Waveform_Size);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_CreateWaveformF64
        /// 
        /// ViStatus niFgen_CreateWaveformF64 (ViSession vi, ViConstString channelName, ViInt32 waveformSize, ViReal64[] waveformDataArray, ViInt32* waveformHandle);
        /// 
        /// Purpose
        /// 
        /// Creates an onboard waveform from binary F64 (floating point double) data for use in Arbitrary Waveform output mode or Arbitrary Sequence output mode.  The waveformHandle returned  can later be used for setting the active waveform, changing the data in the waveform, building sequences of waveforms, or deleting the waveform when it is no longer needed.
        /// 
        /// 
        /// Note   You must call the niFgen_ConfigureOutputMode function to set the outputMode parameter to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ before calling this function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to create the waveform.
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Waveform_Size">
        /// 
        /// 
        /// waveformSize
        /// ViInt32
        /// Specifies the size of the arbitrary waveform that you want created.
        /// 
        /// 
        /// The size must meet the following restrictions:
        /// 
        ///  The size must be less than or equal to the maximum waveform size that the device allows.
        /// The size must be greater than or equal to the minimum waveform size that the device allows.
        ///  The size must be an integer multiple of the device waveform quantum.
        /// You can obtain these values from the maximumWaveformSize, minimumWaveformSize, and waveformQuantum parameters in the niFgen_QueryArbWfmCapabilities function.Default Value: None
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Waveform_Data_Array">
        /// 
        /// 
        /// waveformDataArray
        /// ViReal64[]
        /// Specifies the array of data you want to use for the new arbitrary waveform. The array must have at least as many elements as the value that you specify in waveformSize.
        /// 
        /// You must normalize the data points in the array to be between &#8211;1.00 and +1.00.
        /// 
        /// Default Value: None
        ///  
        /// </param>
        /// <param name="Waveform_Handle">
        /// 
        /// 
        /// waveformHandle
        /// ViInt32*
        /// The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
        /// 
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int CreateWaveformF64(string Channel_Name, int Waveform_Size, double[] Waveform_Data_Array, out int Waveform_Handle)
        {
            int pInvokeResult = PInvoke.CreateWaveformF64(this._handle, Channel_Name, Waveform_Size, Waveform_Data_Array, out Waveform_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_CreateWaveformI16
        /// 
        /// ViStatus niFgen_CreateWaveformI16 (ViSession vi, ViConstString channelName, ViInt32 waveformSize, ViInt16[] waveformDataArray, ViInt32* waveformHandle);
        /// 
        /// Purpose
        /// 
        /// Creates an onboard waveform from binary I16 data for use in Arbitrary Waveform or Arbitrary Sequence output mode.  The waveformHandle returned  can later be used for setting the active waveform, changing the data in the waveform, building sequences of waveforms, or deleting the waveform when it is no longer needed.
        /// 
        /// 
        /// Note   You must call the niFgen_ConfigureOutputMode function to set the outputMode parameter to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ before calling this function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to create the waveform.
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Waveform_Size">
        /// 
        /// 
        /// waveformSize
        /// ViInt32
        /// Specifies the size of the arbitrary waveform that you want created.
        /// 
        /// The size must meet the following restrictions:
        ///  The size must be less than or equal to the maximum waveform size that the device allows.
        ///  The size must be greater than or equal to the minimum waveform size that the device allows.
        ///  The size must be an integer multiple of the device waveform quantum.
        /// You can obtain these values from the maximumWaveformSize, minimumWaveformSize, and waveformQuantum parameters in the niFgen_QueryArbWfmCapabilities function.
        /// Default Value: None
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Waveform_Data_Array">
        /// 
        /// 
        /// waveformDataArray
        /// ViReal64[]
        /// Specifies the array of data you want to use for the new arbitrary waveform. The array must have at least as many elements as the value that you specify in waveformSize.
        /// 
        /// You must normalize the data points in the array to be between &#8211;1.00 and +1.00.
        /// 
        /// Default Value: None
        ///  
        /// </param>
        /// <param name="Waveform_Handle">
        /// 
        /// 
        /// waveformHandle
        /// ViInt32*
        /// The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
        /// 
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int CreateWaveformI16(string Channel_Name, int Waveform_Size, short[] Waveform_Data_Array, out int Waveform_Handle)
        {
            int pInvokeResult = PInvoke.CreateWaveformI16(this._handle, Channel_Name, Waveform_Size, Waveform_Data_Array, out Waveform_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_CreateWaveformComplexF64
        /// 
        /// ViStatus niFgen_CreateWaveformComplexF64 (ViSession vi, ViConstString channelName, ViInt32 numberofSamples, niFgen_ComplexF64[] waveformDataArray, ViInt32* waveformHandle);
        /// 
        /// Purpose
        /// 
        /// Creates an onboard waveform from complex double-precision floating-point data for use with the NIFGEN_ATTR_OUTPUT_MODE attribute set to Arbitrary Waveform or Arbitrary Sequence output mode on devices with the NIFGEN_ATTR_OUTPUT_ENABLED attribute set to VI_TRUE and the NIFGEN_ATTR_OSP_DATA_PROCESSING_MODE attribute set to NIFGEN_VAL_OSP_COMPLEX. The waveformHandle returned by the function can be used later for setting the active waveform, changing the data in the waveform, building sequences of waveforms, or deleting the waveform when it is no longer needed.
        /// 
        /// 
        /// Note   You must call the niFgen_ConfigureOutputMode function to set the outputMode parameter to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ before calling this function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to create the waveform.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Number_of_Samples">
        /// 
        /// 
        /// numberofSamples
        /// ViInt32
        /// Specifies the size of the arbitrary waveform that you want created.The size must meet the following restrictions:
        /// 
        ///  The size must be less than or equal to the maximum waveform size that the device allows.
        ///  The size must be greater than or equal to the minimum waveform size that the device allows.
        /// The size must be an integer multiple of the device waveform quantum.
        /// 
        /// You can obtain these values from the maximumWaveformSize, minimumWaveformSize, and waveformQuantum parameters in niFgen_QueryArbWfmCapabilities.
        /// Default Value: None
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Waveform_Data_Array">
        /// 
        /// 
        /// waveformDataArray
        /// ViReal64[]
        /// Specifies the array of data you want to use for the new arbitrary waveform. The array must have at least as many elements as the value that you specify in waveformSize.
        /// 
        /// You must normalize the data points in the array to be between &#8211;1.00 and +1.00.
        /// 
        /// Default Value: None
        ///  
        /// </param>
        /// <param name="Waveform_Handle">
        /// 
        /// 
        /// waveformHandle
        /// ViInt32*
        /// The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
        /// 
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int CreateWaveformComplexF64(string Channel_Name, int Number_of_Samples, int Waveform_Data_Array, out int Waveform_Handle)
        {
            int pInvokeResult = PInvoke.CreateWaveformComplexF64(this._handle, Channel_Name, Number_of_Samples, Waveform_Data_Array, out Waveform_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_CreateWaveformFromFileI16
        /// 
        /// ViStatus niFgen_CreateWaveformFromFileI16 (ViSession vi, ViConstString channelName, ViConstString filename, ViInt32 byteOrder, ViInt32* waveformHandle);
        /// 
        /// Purpose
        /// 
        /// Takes the binary I16 data from the specified file and creates an onboard waveform for use in Arbitrary Waveform or Arbitrary Sequence output mode.  The waveformHandle returned  can later be used for setting the active waveform, changing the data in the waveform, building sequences of waveforms, or deleting the waveform when it is no longer needed.
        /// 
        /// 
        /// Notes   The i16 data (values between -32768 and +32767) is assumed to represent -1 to +1 V.  Use the NIFGEN_ATTR_DIGITAL_GAIN attribute to generate different voltage outputs.
        /// 
        /// You must call the niFgen_ConfigureOutputMode function to set the outputMode parameter to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ before calling this function.
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to create the waveform.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="FileName">
        /// 
        /// 
        /// fileName
        /// ViConstString
        /// The full path and name of the file where the waveform data resides.
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Byte_Order">
        /// 
        /// 
        /// byteOrder
        /// ViInt32
        /// Specifies the byte order of the data in the file.
        /// 
        /// 
        /// Note  Data written by most applications in Windows (including LabWindows/CVI) is in Little Endian format.  Data written to a file from LabVIEW is in Big Endian format by default on all platforms.  (Big Endian and Little Endian refer to the way data is stored in memory, which can differ on different processors.)
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_LITTLE_ENDIAN Little Endian Data&#8212;the least significant bit is stored at the lowest address, followed by the other bits, in order of increasing significance.
        /// NIFGEN_VAL_BIG_ENDIAN Big Endian Data&#8212;the most significant bit is stored at the lowest address, followed by the other bits, in order of decreasing significance.
        /// 
        /// 
        /// 
        /// 
        /// Default Value: NIFGEN_VAL_LITTLE_ENDIAN
        ///  
        /// </param>
        /// <param name="Waveform_Handle">
        /// 
        /// 
        /// waveformHandle
        /// ViInt32*
        /// The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
        /// 
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int CreateWaveformFromFileI16(string Channel_Name, string FileName, int Byte_Order, out int Waveform_Handle)
        {
            int pInvokeResult = PInvoke.CreateWaveformFromFileI16(this._handle, Channel_Name, FileName, Byte_Order, out Waveform_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_CreateWaveformFromFileF64
        /// 
        /// ViStatus niFgen_CreateWaveformFromFileF64 (ViSession vi, ViConstString channelName, ViConstString filename, ViInt32 byteOrder, ViInt32* waveformHandle);
        /// 
        /// Purpose
        /// 
        /// This function takes the F64 (floating point double) data from the specified file and creates an onboard waveform for use in Arbitrary Waveform or Arbitrary Sequence output mode.  The waveformHandle returned  can later be used  for setting the active waveform, changing the data in the waveform, building sequences of waveforms, or deleting the waveform when it is no longer needed.
        /// 
        /// 
        /// 
        /// Notes   The F64 data must be between -1.0 and +1.0 V.  Use the NIFGEN_ATTR_DIGITAL_GAIN attribute to generate different voltage outputs. 
        ///  You must call the niFgen_ConfigureOutputMode function to set the outputMode parameter to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ before calling this function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to create the waveform.
        /// 
        /// Defined Value: &#34;0&#34;
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="FileName">
        /// 
        /// 
        /// fileName
        /// ViConstString
        /// The full path and name of the file where the waveform data resides.
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Byte_Order">
        /// 
        /// 
        /// byteOrder
        /// ViInt32
        /// Specifies the byte order of the data in the file.
        /// 
        /// 
        /// Note  Data written by most applications in Windows (including LabWindows/CVI) is in Little Endian format.  Data written to a file from LabVIEW is in Big Endian format by default on all platforms.  (Big Endian and Little Endian refer to the way data is stored in memory, which can differ on different processors.)
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_LITTLE_ENDIAN Little Endian Data&#8212;the least significant bit is stored at the lowest address, followed by the other bits, in order of increasing significance.
        /// NIFGEN_VAL_BIG_ENDIAN Big Endian Data&#8212;the most significant bit is stored at the lowest address, followed by the other bits, in order of decreasing significance.
        /// 
        /// 
        /// 
        /// 
        /// Default Value: NIFGEN_VAL_LITTLE_ENDIAN
        ///  
        /// </param>
        /// <param name="Waveform_Handle">
        /// 
        /// 
        /// waveformHandle
        /// ViInt32*
        /// The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
        /// 
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int CreateWaveformFromFileF64(string Channel_Name, string FileName, int Byte_Order, out int Waveform_Handle)
        {
            int pInvokeResult = PInvoke.CreateWaveformFromFileF64(this._handle, Channel_Name, FileName, Byte_Order, out Waveform_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// 
        /// 
        /// 
        /// niFgen_CreateWaveformFromFileHWS
        /// 
        /// ViStatus niFgen_CreateWaveformFromFileHWS (ViSession vi, ViConstString channelName, ViConstString filename, ViBoolean useRateFromWaveform, ViBoolean useGain&amp;OffsetFromWaveform, ViInt32* waveformHandle);
        /// 
        /// Purpose
        /// 
        /// Takes the waveform data from the specified HWS (Hierarchical Waveform Storage) file and creates an onboard  waveform for use in Arbitrary Waveform or Arbitrary Sequence output mode.  The waveformHandle returned by the function can be used later for setting the active waveform, changing the data in the waveform, building sequences of waveforms, or deleting the waveform when it is no longer needed.
        /// 
        /// 
        /// When the Analog Waveform Editor saves data in an HWS file, it also stores the rate, gain and offset with the data.  If the useRateFromWaveform and useGain&amp;OffsetFromWaveform inputs are set to VI_TRUE, this function also sets those properties on NI-FGEN. 
        /// 
        /// 
        /// 
        /// 
        /// Notes  If you choose to have this function set the gain and offset properties for you, you should not use the niFgen_ConfigureArbWaveform or niFgen_ConfigureArbSequence functions, as they also set the gain and offset, thereby overriding the values set by this function.  Instead, use the NIFGEN_ATTR_ARB_WAVEFORM_HANDLE or NIFGEN_ATTR_ARB_SEQUENCE_HANDLE attributes.
        /// 
        /// 
        ///  HWS files may contain I16 or DBL data (depending on how it was saved).  This function automatically adapts to either data type.  If the file contains DBL data, it must be between -1.0 and +1.0.  Check the &#34;Scale Data to +/- 1V&#34; option in the Analog Waveform Editor to ensure your data is between -1.0 and +1.0.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to create the waveform.
        /// 
        /// Defined Value: &#34;0&#34;
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="FileName">
        /// 
        /// 
        /// fileName
        /// ViConstString
        /// The full path and name of the file where the waveform data resides.
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Use_Rate_From_Waveform">
        /// 
        /// 
        /// useRateFromWaveform
        /// ViBoolean
        /// If you set this parameter input to VI_TRUE and if onboard signal processing (OSP) is enabled, the 'rate' from the waveform is interpreted as the data rate, and FGEN sets the data rate attribute for you. In all other cases, it is interpreted as the sample rate, and FGEN sets the sample rate attribute for you.
        /// 
        /// 
        /// Defined Values
        /// 
        /// VI_TRUEUse rate from waveform.
        /// VI_FALSE Do not use rate from waveform.
        /// 
        /// 
        /// 
        /// Default Value: VI_TRUE
        /// 
        ///  
        ///  
        /// </param>
        /// <param name="Use_Gain___Offset_From_Waveform">
        /// 
        /// 
        /// useGain&amp;OffsetFromWaveform
        /// ViBoolean
        /// If this input is set to VI_TRUE, NI-FGEN retrieves the gain and offset values from the specified HWS file and applies them to the NI-FGEN driver.
        /// 
        /// 
        /// Defined Values
        /// 
        /// VI_TRUEUse gain and offset from waveform.
        /// VI_FALSE Do not use gain and offset from waveform.
        /// 
        /// Default Value: VI_TRUE
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Waveform_Handle">
        /// 
        /// 
        /// waveformHandle
        /// ViInt32*
        /// The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
        /// 
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int CreateWaveformFromFileHWS(string Channel_Name, string FileName, bool Use_Rate_From_Waveform, bool Use_Gain___Offset_From_Waveform, out int Waveform_Handle)
        {
            int pInvokeResult = PInvoke.CreateWaveformFromFileHWS(this._handle, Channel_Name, FileName, System.Convert.ToUInt16(Use_Rate_From_Waveform), System.Convert.ToUInt16(Use_Gain___Offset_From_Waveform), out Waveform_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureArbWaveform
        /// 
        /// ViStatus niFgen_ConfigureArbWaveform (ViSession vi, ViConstString channelName, ViInt32 waveformHandle, ViReal64 gain, ViReal64 offset);
        /// 
        /// Purpose
        /// 
        /// Configures the attributes of the signal generator that affect arbitrary waveform generation (the NIFGEN_ATTR_ARB_WAVEFORM_HANDLE, NIFGEN_ATTR_ARB_GAIN, and NIFGEN_ATTR_ARB_OFFSET attributes).
        /// 
        /// 
        /// Notes  The signal generator must not be in the Generating state when you call this function.
        /// 
        ///  You must call the niFgen_ConfigureOutputMode function to set the output mode to NIFGEN_VAL_OUTPUT_ARB before calling this function.
        /// 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to configure an arbitrary waveform.
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Waveform_Handle">
        /// 
        /// 
        /// waveformHandle
        /// ViInt32
        /// 
        /// Specifies the handle of the arbitrary waveform you want the signal generator to produce. 
        /// NI-FGEN sets the NIFGEN_ATTR_ARB_WAVEFORM_HANDLE attribute 
        /// to this value. You can create an arbitrary waveform using one of the following niFgen Create Waveform functions:
        /// 
        /// niFgen_CreateWaveformF64
        /// 
        /// 
        /// niFgen_CreateWaveformI16
        /// 
        /// 
        /// niFgen_CreateWaveformFromFileI16
        /// 
        /// 
        /// niFgen_CreateWaveformFromFileF64
        /// 
        /// 
        /// niFgen_CreateWaveformFromFileHWS
        /// 
        /// 
        /// 
        /// These functions return a handle that you use to identify the waveform.
        /// 
        /// Default Value: None
        /// 
        ///  
        /// </param>
        /// <param name="Gain">
        /// 
        /// 
        /// gain
        /// ViReal64
        /// Specifies the factor by which the signal generator scales the arbitrary waveform data. When you create arbitrary waveforms, you must first normalize the data points to a range of &#8211;1.00 to +1.00 V.  You can use this parameter to scale the arbitrary waveform to other ranges. NI-FGEN sets the NIFGEN_ATTR_ARB_GAIN attribute to this value.
        /// 
        /// For example, to configure the output signal to range from &#8211;2.00 to +2.00 V, set the gain to 2.00.
        /// 
        /// Units: volts
        /// 
        /// Default Value: None
        ///  
        /// </param>
        /// <param name="Offset">
        /// 
        /// 
        /// offset
        /// ViReal64
        /// Specifies the value the signal generator adds to the arbitrary waveform data. When you create arbitrary waveforms, you must first normalize the data points to a range of &#8211;1.00 to +1.00 V. You can use this parameter to shift the range of the arbitrary waveform. NI-FGEN sets the NIFGEN_ATTR_ARB_OFFSET attribute to this value.
        /// 
        /// For example, to configure the output signal to range from 0.00 to 2.00 V instead of &#8211;1.00 to 1.00 V, set the offset to 1.00.
        /// 
        /// Units: volts
        /// 
        /// Default Value: None
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureArbWaveform(string Channel_Name, int Waveform_Handle, double Gain, double Offset)
        {
            int pInvokeResult = PInvoke.ConfigureArbWaveform(this._handle, Channel_Name, Waveform_Handle, Gain, Offset);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ClearArbWaveform
        /// 
        /// ViStatus niFgen_ClearArbWaveform (ViSession vi, ViInt32 waveformHandle);
        /// 
        /// Purpose
        /// 
        /// Removes a previously created arbitrary waveform from the signal generator memory and invalidates the waveform handle.
        /// 
        /// 
        /// Note   The signal generator must not be in the Generating state when you call this function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Waveform_Handle">
        /// 
        /// 
        /// waveformHandle
        /// ViInt32
        /// Specifies the handle of the arbitrary waveform that you want the signal generator to remove. 
        /// You can create multiple arbitrary waveforms using one of the following niFgen Create 
        /// Waveform functions:
        /// 
        /// niFgen_CreateWaveformF64
        /// niFgen_CreateWaveformI16
        /// niFgen_CreateWaveformFromFileI16
        /// niFgen_CreateWaveformFromFileF64
        /// niFgen_CreateWaveformFromFileHWS
        /// 
        /// 
        /// Defined Value:
        /// 
        /// NIFGEN_VAL_ALL_WAVEFORMS&#8212;Remove all waveforms from the signal generator.
        /// 
        /// Default Value: None
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ClearArbWaveform(int Waveform_Handle)
        {
            int pInvokeResult = PInvoke.ClearArbWaveform(this._handle, Waveform_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_QueryArbSeqCapabilities
        /// 
        /// ViStatus niFgen_QueryArbSeqCapabilities (ViSession vi, ViInt32* maximumNumberofSequences, ViInt32* minimumSequenceLength, ViInt32* maximumSequenceLength, ViInt32* maximumLoopCount);
        /// 
        /// Purpose
        /// 
        /// Returns the attributes of the signal generator that are related to creating arbitrary sequences (the NIFGEN_ATTR_MAX_NUM_SEQUENCES, NIFGEN_ATTR_MIN_SEQUENCE_LENGTH, NIFGEN_ATTR_MAX_SEQUENCE_LENGTH, and NIFGEN_ATTR_MAX_LOOP_COUNT attributes).
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Maximum_Number_of_Sequences">
        /// 
        /// 
        /// maximumNumberofSequences
        /// ViInt32*
        /// Returns the maximum number of arbitrary waveform sequences that the signal generator allows.  NI-FGEN obtains this value from the NIFGEN_ATTR_MAX_NUM_SEQUENCES attribute.
        ///  
        /// </param>
        /// <param name="Minimum_Sequence_Length">
        /// 
        /// 
        /// minimumSequenceLength
        /// ViInt32*
        /// Returns the minimum number of arbitrary waveforms the signal generator allows in a sequence.  NI-FGEN obtains this value from the NIFGEN_ATTR_MIN_SEQUENCE_LENGTH attribute.
        ///  
        /// </param>
        /// <param name="Maximum_Sequence_Length">
        /// 
        /// 
        /// maximumSequenceLength
        /// ViInt32*
        /// Returns the maximum number of arbitrary waveforms the signal generator allows in a sequence.  NI-FGEN obtains this value from the NIFGEN_ATTR_MAX_SEQUENCE_LENGTH attribute.
        ///  
        /// </param>
        /// <param name="Maximum_Loop_Count">
        /// 
        /// 
        /// maximumLoopCount
        /// ViInt32*
        /// Returns the maximum number of times the signal generator can repeat an arbitrary waveform in a sequence.  NI-FGEN obtains this value from the NIFGEN_ATTR_MAX_LOOP_COUNT attribute.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int QueryArbSeqCapabilities(out int Maximum_Number_of_Sequences, out int Minimum_Sequence_Length, out int Maximum_Sequence_Length, out int Maximum_Loop_Count)
        {
            int pInvokeResult = PInvoke.QueryArbSeqCapabilities(this._handle, out Maximum_Number_of_Sequences, out Minimum_Sequence_Length, out Maximum_Sequence_Length, out Maximum_Loop_Count);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_CreateArbSequence
        /// 
        /// ViStatus niFgen_CreateArbSequence (ViSession vi, ViInt32 sequenceLength, ViInt32[] waveformHandlesArray, ViInt32[] loopCountsArray, ViInt32* sequenceHandle);
        /// 
        /// Purpose
        /// 
        /// 
        /// Creates an arbitrary sequence from an array of waveform handles and an array of corresponding loop counts. An arbitrary sequence consists of multiple waveforms. For each waveform, you can specify the number of times that the signal generator produces the waveform before proceeding to the next waveform. The number of times to repeat a specific waveform is called the loop count. 
        /// The function returns a handle that identifies the sequence. You pass this handle to the niFgen_ConfigureArbSequence function to specify what arbitrary sequence you want the signal generator to produce.
        /// 
        /// 
        /// Note  You must call the niFgen_ConfigureOutputMode function to set the output mode to NIFGEN_VAL_OUTPUT_SEQ before calling this function.
        /// 
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Sequence_Length">
        /// 
        /// 
        /// sequenceLength
        /// ViInt32
        /// Specifies the number of waveforms in the new arbitrary sequence that you want to create. The value you pass must be between the minimum and maximum sequence lengths that the signal generator allows. You can obtain the minimum and maximum sequence lengths from minimumSequenceLength and maximumSequenceLength in the niFgen_QueryArbSeqCapabilities function.
        /// 
        /// Default Value: None
        ///  
        /// </param>
        /// <param name="Waveform_Handles_Array">
        /// 
        /// 
        /// waveformHandlesArray
        /// ViInt32[]
        /// Specifies the array of waveform handles from which you want to create a new arbitrary 
        /// sequence. The array must have at least as many elements as the value that you specify in 
        /// sequenceLength. Each waveformHandlesArray element has a 
        /// corresponding loopCountsArray element that indicates how many times that 
        /// waveform is repeated. You obtain waveform handles when you create arbitrary waveforms with the niFgen_AllocateWaveform function or one of the following niFgen CreateWaveform functions:
        /// 
        /// niFgen_CreateWaveformF64
        /// niFgen_CreateWaveformI16
        /// niFgen_CreateWaveformFromFileI16
        /// niFgen_CreateWaveformFromFileF64
        /// niFgen_CreateWaveformFromFileHWS
        /// 
        /// Default Value: None
        /// 
        ///  
        /// </param>
        /// <param name="Loop_Counts_Array">
        /// 
        /// 
        /// loopCountsArray
        /// ViInt32[]
        /// Specifies the array of loop counts you want to use to create a new arbitrary sequence. The array must have at least as many elements as the value that you specify in the sequenceLength parameter. Each loopCountsArray element corresponds to a waveformHandlesArray element and indicates how many times to repeat that waveform. Each element of the loopCountsArray must be less than or equal to the maximum number of loop counts that the signal generator allows. You can obtain the maximum loop count from maximumLoopCount in the niFgen_QueryArbSeqCapabilities function.
        /// 
        /// Default Value: None
        /// 
        ///  
        /// </param>
        /// <param name="Sequence_Handle">
        /// 
        /// 
        /// sequenceHandle
        /// ViInt32*
        /// Returns the handle that identifies the new arbitrary sequence.  You can pass this handle to niFgen_ConfigureArbSequence to generate the arbitrary sequence.
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int CreateArbSequence(int Sequence_Length, int[] Waveform_Handles_Array, int[] Loop_Counts_Array, out int Sequence_Handle)
        {
            int pInvokeResult = PInvoke.CreateArbSequence(this._handle, Sequence_Length, Waveform_Handles_Array, Loop_Counts_Array, out Sequence_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_CreateAdvancedArbSequence
        /// 
        /// ViStatus niFgen_CreateAdvancedArbSequence (ViSession vi, ViInt32 sequenceLength, ViInt32[] waveformHandlesArray, ViInt32[] loopCountsArray, 
        /// ViInt32[] sampleCountsArray, 
        /// ViInt32[] markerLocationArray, 
        /// ViInt32[] coercedMarkersArray, 
        /// ViInt32* sequenceHandle);
        /// 
        /// Purpose
        /// 
        /// 
        /// Creates an arbitrary sequence from an array of waveform handles and an array of corresponding loop counts. An arbitrary sequence consists of multiple waveforms. For each waveform, you specify the number of times the signal generator produces the waveform before proceeding to the next waveform. The number of times to repeat a specific waveform is called the loop count.
        ///  The function returns a handle that identifies the sequence. You pass this handle to the niFgen_ConfigureArbSequence function to specify what arbitrary sequence you want the signal generator to produce.
        /// 
        /// The niFgen_CreateAdvancedArbSequence function extends on niFgen_CreateArbSequence by adding the ability to set the number of samples in each sequence step and to set marker locations.
        /// 
        /// 
        /// 
        /// Note  You must call the niFgen_ConfigureOutputMode function to set the output mode to NIFGEN_VAL_OUTPUT_SEQ before calling this function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Sequence_Length">
        /// 
        /// 
        /// sequenceLength
        /// ViInt32
        /// Specifies the number of waveforms in the new arbitrary sequence that you want to create. The value you pass must be between the minimum and maximum sequence lengths that the signal generator allows. You can obtain the minimum and maximum sequence lengths from minimumSequenceLength and maximumSequenceLength in the niFgen_QueryArbSeqCapabilities function.
        /// 
        /// Default Value: None
        ///  
        /// </param>
        /// <param name="Waveform_Handles_Array">
        /// 
        /// 
        /// waveformHandlesArray
        /// ViInt32[]
        /// Specifies the array of waveform handles from which you want to create a new arbitrary 
        /// sequence. The array must have at least as many elements as the value that you specify in 
        /// sequenceLength. Each waveformHandlesArray element has a 
        /// corresponding loopCountsArray element that indicates how many times that 
        /// waveform is repeated. You obtain waveform handles when you create arbitrary waveforms with the niFgen_AllocateWaveform function or one of the following niFgen CreateWaveform functions:
        /// 
        /// niFgen_CreateWaveformF64
        /// niFgen_CreateWaveformI16
        /// niFgen_CreateWaveformFromFileI16
        /// niFgen_CreateWaveformFromFileF64
        /// niFgen_CreateWaveformFromFileHWS
        /// 
        /// Default Value: None
        /// 
        ///  
        /// </param>
        /// <param name="Loop_Counts_Array">
        /// 
        /// 
        /// loopCountsArray
        /// ViInt32[]
        /// Specifies the array of loop counts you want to use to create a new arbitrary sequence. The array must have at least as many elements as the value that you specify in the sequenceLength parameter. Each loopCountsArray element corresponds to a waveformHandlesArray element and indicates how many times to repeat that waveform. Each element of the loopCountsArray must be less than or equal to the maximum number of loop counts that the signal generator allows. You can obtain the maximum loop count from maximumLoopCount in the niFgen_QueryArbSeqCapabilities function.
        /// 
        /// Default Value: None
        /// 
        ///  
        /// </param>
        /// <param name="Sample_Counts_Array">
        /// 
        /// 
        /// sampleCountsArray
        /// ViInt32[]
        /// Specifies the array of sample counts that you want to use to create a new arbitrary sequence.  The array must have at least as many elements as the value you specify in the sequenceLength parameter.  Each sampleCountsArray element corresponds to a waveformHandlesArray element and indicates the subset, in samples, of the given waveform to generate.  Each element of the sampleCountsArray must be larger than the minimum waveform size, a multiple of the waveform quantum and no larger than the number of samples in the corresponding waveform.  You can obtain these values by calling the niFgen_QueryArbWfmCapabilities function. 
        /// 
        /// Default Value: None
        ///  
        /// </param>
        /// <param name="Marker_Location_Array">
        /// 
        /// 
        /// markerLocationArray
        /// ViInt32[]
        /// Specifies the array of marker locations to where you want a marker to be generated in the sequence.  The array must have at least as many elements as the value you specify in the sequenceLength parameter.  Each markerLocationArray element corresponds to a waveformHandlesArray element and indicates where in the waveform a marker is to generate.  The marker location must be less than the size of the waveform the marker is in.  The markers are coerced to the nearest marker quantum and the coerced values are returned in the coercedMarkersArray parameter.
        /// 
        /// If you do not want a marker generated for a particular sequence stage, set the marker to NIFGEN_VAL_NO_MARKER.
        /// 
        /// Defined Value: NIFGEN_VAL_NO_MARKER
        /// 
        /// Default Value: None
        ///  
        /// </param>
        /// <param name="Coerced_Markers_Array">
        /// 
        /// 
        /// coercedMarkersArray
        /// ViInt32[]
        /// Returns an array of all given markers that are coerced (rounded) to the nearest marker quantum. Not all devices coerce markers. 
        /// Default Value: None
        ///  
        /// </param>
        /// <param name="Sequence_Handle">
        /// 
        /// 
        /// sequenceHandle
        /// ViInt32*
        /// Returns the handle that identifies the new arbitrary sequence.  You can pass this handle to niFgen_ConfigureArbSequence to generate the arbitrary sequence.
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int CreateAdvancedArbSequence(int Sequence_Length, int[] Waveform_Handles_Array, int[] Loop_Counts_Array, int[] Sample_Counts_Array, int[] Marker_Location_Array, int[] Coerced_Markers_Array, out int Sequence_Handle)
        {
            int pInvokeResult = PInvoke.CreateAdvancedArbSequence(this._handle, Sequence_Length, Waveform_Handles_Array, Loop_Counts_Array, Sample_Counts_Array, Marker_Location_Array, Coerced_Markers_Array, out Sequence_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureArbSequence
        /// 
        /// ViStatus niFgen_ConfigureArbSequence (ViSession vi, VViConstString channelName,
        /// ViInt32 sequenceHandle, ViReal64 gain, ViReal64 offset;
        /// 
        /// 
        /// 
        /// Purpose
        /// 
        /// Configures the signal generator attributes that affect arbitrary sequence generation. These attributes are the NIFGEN_ATTR_ARB_SEQUENCE_HANDLE, NIFGEN_ATTR_ARB_GAIN, and NIFGEN_ATTR_ARB_OFFSET
        /// 
        /// 
        /// 
        /// Notes  The signal generator must not be in the Generating state when you call this function.
        /// 
        /// You must call the niFgen_ConfigureOutputMode function to set the output mode to NIFGEN_VAL_OUTPUT_SEQ before calling this function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name from which you want to configure an arbitrary sequence.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Sequence_Handle">
        /// 
        /// 
        /// sequenceHandle
        /// ViInt32
        /// 
        /// Specifies the handle of the arbitrary sequence that you want the signal generator to produce. NI-FGEN sets the NIFGEN_ATTR_ARB_SEQUENCE_HANDLE attribute to this value. You can create an arbitrary sequence using the niFgen_CreateArbSequence function. The niFgen_CreateArbSequence function returns a handle that you use to identify the sequence.
        /// 
        /// Default Value: None
        /// 
        ///  
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Gain">
        /// 
        /// 
        /// gain
        /// ViReal64
        /// Specifies the factor by which the signal generator scales the arbitrary waveform data. When you create arbitrary waveforms, you must first normalize the data points to a range of &#8211;1.00 to +1.00 V.  You can use this parameter to scale the arbitrary waveform to other ranges. NI-FGEN sets the NIFGEN_ATTR_ARB_GAIN attribute to this value.
        /// 
        /// For example, to configure the output signal to range from &#8211;2.00 to +2.00 V, set the gain to 2.00.
        /// 
        /// Units: volts
        /// 
        /// Default Value: None
        ///  
        /// </param>
        /// <param name="Offset">
        /// 
        /// 
        /// offset
        /// ViReal64
        /// Specifies the value the signal generator adds to the arbitrary waveform data. When you create arbitrary waveforms, you must first normalize the data points to a range of &#8211;1.00 to +1.00 V. You can use this parameter to shift the range of the arbitrary waveform. NI-FGEN sets the NIFGEN_ATTR_ARB_OFFSET attribute to this value.
        /// 
        /// For example, to configure the output signal to range from 0.00 to 2.00 V instead of &#8211;1.00 to 1.00 V, set the offset to 1.00.
        /// 
        /// Units: volts
        /// 
        /// Default Value: None
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureArbSequence(string Channel_Name, int Sequence_Handle, double Gain, double Offset)
        {
            int pInvokeResult = PInvoke.ConfigureArbSequence(this._handle, Channel_Name, Sequence_Handle, Gain, Offset);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ClearArbSequence
        /// 
        /// ViStatus niFgen_ClearArbSequence (ViSession vi, ViInt32 sequenceHandle);
        /// 
        /// Purpose
        /// 
        /// Removes a previously created arbitrary sequence from the signal generator memory and invalidates the sequence handle.
        /// 
        /// 
        /// Note    The signal generator must not be in the Generating state when you call this function.
        /// 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Sequence_Handle">
        /// 
        /// 
        /// sequenceHandle
        /// ViInt32
        /// 
        /// 
        /// 
        /// 
        /// Specifies the handle of the arbitrary sequence that you want the signal generator to remove.  You can create an arbitrary sequence using the niFgen_CreateArbSequence function. The niFgen_CreateArbSequence function returns a handle that you use to identify the sequence.
        /// 
        /// Defined Value:
        /// NIFGEN_VAL_ALL_SEQUENCES&#8212;Remove all sequences from the signal generator
        /// 
        /// Default Value: None
        /// 
        ///  
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ClearArbSequence(int Sequence_Handle)
        {
            int pInvokeResult = PInvoke.ClearArbSequence(this._handle, Sequence_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ClearArbMemory
        /// 
        /// ViStatus niFgen_ClearArbMemory (ViSession vi);
        /// 
        /// Purpose
        /// 
        /// Removes all previously created arbitrary waveforms, sequences, and scripts from the signal generator memory, and invalidates all waveform handles, sequence handles, and waveform names.
        /// 
        /// 
        /// Note    The signal generator must not be in the Generating state when you call this function.
        /// 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ClearArbMemory()
        {
            int pInvokeResult = PInvoke.ClearArbMemory(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_AllocateWaveform
        /// 
        /// ViStatus niFgen_AllocateWaveform (ViSession vi, ViConstString channelName, ViInt32 waveformSize, ViInt32* waveformHandle);
        /// 
        /// Purpose
        /// 
        /// Specifies the size of a waveform so that it can be allocated in onboard memory before loading the associated data.  Data can then be loaded in smaller chunks with the Write (Binary16)Waveform functions.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to allocate the waveform.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Waveform_Size">
        /// 
        /// 
        /// waveformSize
        /// ViInt32
        /// Specifies, in samples, the size of the waveform to allocate.
        ///  
        /// </param>
        /// <param name="Waveform_Handle">
        /// 
        /// 
        /// waveformHandle
        /// ViInt32*
        /// The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
        /// 
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int AllocateWaveform(string Channel_Name, int Waveform_Size, out int Waveform_Handle)
        {
            int pInvokeResult = PInvoke.AllocateWaveform(this._handle, Channel_Name, Waveform_Size, out Waveform_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_SetWaveformNextWritePosition
        /// 
        /// ViStatus niFgen_SetWaveformNextWritePosition (ViSession vi, ViConstString channelName, ViInt32 waveformHandle, ViInt32 relativeto, ViInt32 offset);
        /// 
        /// Purpose
        /// 
        /// Sets the position in the waveform at which the next waveform data is written. 
        /// This function allows you to write to arbitrary locations within the waveform. These settings 
        /// apply only to the next write to the waveform specified by the waveformHandle 
        /// parameter. Subsequent writes to that waveform begin where the last write left off, unless 
        /// this function is called again. The waveformHandle passed in must have been created by a call 
        /// to the niFgen_AllocateWaveform function or one of the following
        /// niFgen CreateWaveform functions:
        /// 
        /// 
        /// niFgen_CreateWaveformF64
        /// niFgen_CreateWaveformI16
        /// niFgen_CreateWaveformFromFileI16
        /// niFgen_CreateWaveformFromFileF64
        /// niFgen_CreateWaveformFromFileHWS
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel on which to the waveform data should be loaded.
        /// 
        /// Default Value: 0
        ///  
        /// </param>
        /// <param name="Waveform_Handle">
        /// 
        /// 
        /// waveformHandle
        /// ViInt32
        /// Specifies the handle of the arbitrary waveform previously allocated with the 
        /// niFgen_AllocateWaveform function. 
        ///  
        /// </param>
        /// <param name="relativeTo">
        /// 
        /// 
        /// relativeTo
        /// ViInt32
        /// Specifies the reference position in the waveform. The position and offset together determine where to start loading data into the waveform.
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_WAVEFORM_POSITION_START (0)  
        /// Use the start of the waveform as the reference position.
        /// NIFGEN_VAL_WAVEFORM_POSITION_CURRENT (1) 
        /// Use the current position within the waveform as the reference position. 
        ///  
        /// </param>
        /// <param name="offset">
        /// 
        /// 
        /// offset
        /// ViInt32
        /// Specifies the offset from relativeTo at which to start loading the data into the waveform.
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int SetWaveformNextWritePosition(string Channel_Name, int Waveform_Handle, int relativeTo, int offset)
        {
            int pInvokeResult = PInvoke.SetWaveformNextWritePosition(this._handle, Channel_Name, Waveform_Handle, relativeTo, offset);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_WriteWaveform
        /// 
        /// ViStatus niFgen_WriteWaveform (ViSession vi, ViConstString channelName, ViInt32 waveformHandle, ViInt32 size, ViReal64[] data);
        /// 
        /// Purpose
        /// 
        /// Writes floating-point data to the waveform in onboard memory. 
        /// The waveform handle passed in must have been created by a call to the 
        /// niFgen_AllocateWaveform function or one of the following 
        /// niFgen CreateWaveform functions:
        /// niFgen_CreateWaveformF64
        /// niFgen_CreateWaveformI16
        /// niFgen_CreateWaveformFromFileI16
        /// niFgen_CreateWaveformFromFileF64
        /// niFgen_CreateWaveformFromFileHWS
        /// The write position and offset can be set by calling the niFgen_SetWaveformNextWritePosition function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// The channel onto which the waveform data should be loaded. 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Waveform_Handle">
        /// 
        /// 
        /// waveformHandle
        /// ViInt32
        /// Specifies the handle of the arbitrary waveform previously allocated with the
        /// niFgen_AllocateWaveform function. 
        ///  
        /// 
        /// </param>
        /// <param name="Size">
        /// 
        /// 
        /// size
        /// ViInt32
        /// Specifies the number of samples to load into the waveform.
        /// 
        /// Default Value: 0
        ///  
        /// 
        /// 
        /// </param>
        /// <param name="Data">
        /// 
        /// 
        /// data
        /// ViInt64[]
        /// Specifies the array of data to load into the waveform. The array must have at least as many elements as the value in size.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int WriteWaveform(string Channel_Name, int Waveform_Handle, int Size, double[] Data)
        {
            int pInvokeResult = PInvoke.WriteWaveform(this._handle, Channel_Name, Waveform_Handle, Size, Data);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_WriteWaveformComplexF64
        /// 
        /// ViStatus niFgen_WriteWaveformComplexF64 (ViSession vi, ViConstString channelName, ViInt32 numberofSamples, niFgen_ComplexF64[] data, ViInt32 waveformHandle);
        /// 
        /// Purpose
        /// 
        /// Writes complex data to the waveform in onboard memory on devices with the NIFGEN_ATTR_OUTPUT_ENABLED attribute set to VI_TRUE and the NIFGEN_ATTR_OSP_DATA_PROCESSING_MODE attribute set to NIFGEN_VAL_OSP_COMPLEX. The waveform handle passed in must have been created by a call to the niFgen_AllocateWaveform function or to one of the following niFgen Create Waveform functions:
        /// 
        /// niFgen_CreateWaveformF64
        /// 
        /// niFgen_CreateWaveformI16
        /// 
        ///  niFgen_CreateWaveformFromFileI16
        /// 
        /// niFgen_CreateWaveformFromFileF64
        /// 
        /// niFgen_CreateWaveformFromFileHWS
        /// 
        /// 
        /// The write position and offset can be set by calling the niFgen_SetWaveformNextWritePosition function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel onto which the waveform data should be loaded. 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Number_of_Samples">
        /// 
        /// 
        /// numberofSamples
        /// ViInt32
        /// Specifies the number of samples to load into the waveform.
        /// 
        /// Default Value: 0
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Data">
        /// 
        /// 
        /// data
        /// niFgen_ComplexF64[]
        /// Specifies the array of data to load into the waveform. You must normalize the data points in the array to be between -1.00 and +1.00. The array must have at least as many elements as the value in the numberOfSamples parameter.
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Waveform_Handle">
        /// 
        /// 
        /// waveformHandle
        /// ViInt32
        /// Specifies the handle of the arbitrary waveform previously allocated with 
        /// niFgen_AllocateWaveform. 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int WriteWaveformComplexF64(string Channel_Name, int Number_of_Samples, int Data, int Waveform_Handle)
        {
            int pInvokeResult = PInvoke.WriteWaveformComplexF64(this._handle, Channel_Name, Number_of_Samples, Data, Waveform_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_WriteBinary16Waveform
        /// 
        /// ViStatus niFgen_WriteBinary16Waveform (ViSession vi, ViConstString channelName, ViInt32 waveformHandle, ViInt32 size, ViInt16[] data);
        /// 
        /// Purpose
        /// 
        /// Writes binary data to the waveform in onboard memory. The waveform handle 
        /// passed in must have been created by a call to the niFgen_AllocateWaveform
        /// or the niFgen_CreateWaveformI16 function.
        /// The write position and offset can be set by calling the niFgen_SetWaveformNextWritePosition function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel on which to the waveform data should be loaded.  
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Waveform_Handle">
        /// 
        /// 
        /// waveformHandle
        /// ViInt32
        /// Specifies the handle of the arbitrary waveform previously allocated with the 
        /// niFgen_AllocateWaveform function.  
        ///  
        /// </param>
        /// <param name="Size">
        /// 
        /// 
        /// size
        /// ViInt32
        /// Specifies the number of samples to load into the waveform.
        /// 
        /// Default Value: 0
        ///  
        /// 
        /// 
        /// </param>
        /// <param name="Data">
        /// 
        /// 
        /// data
        /// ViInt16 []
        /// Specifies the array of data to load into the waveform. The array must have at least as many elements as the value in size. The binary data is left-justified.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int WriteBinary16Waveform(string Channel_Name, int Waveform_Handle, int Size, short[] Data)
        {
            int pInvokeResult = PInvoke.WriteBinary16Waveform(this._handle, Channel_Name, Waveform_Handle, Size, Data);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_WriteComplexBinary16Waveform
        /// 
        /// ViStatus niFgen_WriteComplexBinary16Waveform (ViSession vi, ViConstString channelName, ViInt32 waveformHandle, ViInt32 size, NIComplexI16[] data);
        /// 
        /// Purpose
        /// 
        /// Writes binary data to the waveform in onboard memory. The waveform handle passed in must have been created by a call to the niFgen_AllocateWaveform or the niFgen_CreateWaveformI16 function.
        /// 
        /// The write position and offset can be set by calling the niFgen_SetWaveformNextWritePosition function.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies channel on which to the waveform data should be loaded.  
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Waveform_Handle">
        /// 
        /// 
        /// waveformHandle
        /// ViInt32
        /// Specifies the handle of the arbitrary waveform previously allocated with the 
        /// niFgen_AllocateWaveform function. 
        ///  
        /// </param>
        /// <param name="Size">
        /// 
        /// 
        /// size
        /// ViInt32
        /// Specifies the number of samples to load into the waveform.
        /// 
        /// Default Value: 0
        ///  
        /// 
        /// 
        /// </param>
        /// <param name="Data">
        /// 
        /// 
        /// data
        /// NIComplexI16 []
        /// Specifies the array of data to load into the waveform. The array must have at least as many elements as the value in size. The binary data is left-justified.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int WriteComplexBinary16Waveform(string Channel_Name, int Waveform_Handle, int Size, nicomplexI16 Data)
        {
            int pInvokeResult = PInvoke.WriteComplexBinary16Waveform(this._handle, Channel_Name, Waveform_Handle, Size, Data);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureReferenceClock
        /// 
        /// ViStatus niFgen_ConfigureReferenceClock (ViSession vi, ViConstString referenceClockSource, ViReal64 referenceClockFrequency);
        /// 
        /// Purpose
        /// 
        /// Configures the signal generator Reference clock source and frequency. 
        /// 
        /// The signal generator uses the Reference clock to tune the Sample clock timebase of the signal generator so that the frequency stability and accuracy of the Sample clock timebase matches that of the Reference clock.
        /// 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Reference_Clock_Source">
        /// 
        /// 
        /// referenceClockSource
        /// ViConstString
        /// Specifies the source for the Reference clock.
        /// 
        /// 
        /// 
        /// For example, when you set this parameter to &#34;ClkIn,&#34; the signal generator uses the signal it receives at its Clk In front panel connector as the Reference clock. The Reference clock phase-locks with the signal generator Sample clock timebase to allow the frequency stability and accuracy of the sample clock timebase to match that of the Reference clock.
        /// 
        /// 
        /// 
        /// Note   The following Defined Values are examples of possible reference clock sources. For a complete list of the reference clock sources available on your device, refer to the Device Routes tab in MAX.
        /// 
        /// 
        /// 
        /// Defined Values
        /// 
        /// &#34;None&#34;No Reference clock
        /// 
        /// &#34;PXI_Clk10&#34;10 MHz PCI backplane reference clock
        /// 
        /// &#34;ClkIn&#34;Clk In Front panel connector
        /// 
        /// &#34;OnboardRefClk&#34;
        /// Onboard reference clock
        /// 
        /// &#34;RTSI7&#34;RTSI line 7
        /// 
        /// &#34;RefIn&#34;Ref In front panel connector
        /// 
        /// 
        /// 
        /// Default Value: &#34;None&#34;
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Reference_Clock_Frequency">
        /// 
        /// 
        /// referenceClockFrequency
        /// ViReal64
        /// The reference clock frequency in hertz.
        /// Default Value: 10000000
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureReferenceClock(string Reference_Clock_Source, double Reference_Clock_Frequency)
        {
            int pInvokeResult = PInvoke.ConfigureReferenceClock(this._handle, Reference_Clock_Source, Reference_Clock_Frequency);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureSampleClockSource
        /// 
        /// ViStatus niFgen_ConfigureSampleClockSource (ViSession vi, ViConstString sampleClockSource);
        /// 
        /// Purpose
        /// 
        /// Sets the source of the Sample clock of the signal generator. Samples are generated based on the the Sample clock cycles. The Sample clock source can be internal or external.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Sample_Clock_Source">
        /// 
        /// 
        /// sampleClockSource
        /// ViConstString
        /// Specifies the Sample clock source that you want the signal generator to use. 
        /// 
        /// 
        /// 
        /// 
        /// 
        /// Note   The following Defined Values are examples of possible Sample clock sources. For a complete list of the Sample clock sources available on your device, refer to the Device Routes tab in MAX.
        /// 
        /// 
        /// Defined Values
        /// 
        /// &#34;OnboardClock&#34;Onboard clock
        /// 
        /// 
        /// &#34;ClkIn&#34;Clk In front panel connector
        /// 
        /// &#34;PXI_Star&#34;PXI star trigger line
        /// 
        /// &#34;PXI_Trig0&#34;
        /// PXI trigger line 0 or RTSI line 0
        /// 
        /// &#34;PXI_Trig1&#34;
        /// PXI trigger line 1 or RTSI line 1
        /// 
        /// &#34;PXI_Trig2&#34;
        /// PXI trigger line 2 or RTSI line 2
        /// 
        /// &#34;PXI_Trig3&#34;
        /// PXI trigger line 3 or RTSI line 3
        /// 
        /// &#34;PXI_Trig4&#34;
        /// PXI trigger line 4 or RTSI line 4
        /// 
        /// &#34;PXI_Trig5&#34;
        /// PXI trigger line 5 or RTSI line 5
        /// 
        /// &#34;PXI_Trig6&#34;
        /// PXI trigger line 6 or RTSI line 6
        /// 
        /// &#34;PXI_Trig7&#34;
        /// PXI trigger line 7 or RTSI line 7
        /// 
        /// &#34;DDC_ClkIn&#34;
        /// Sample clock from DDC connector
        /// 
        /// 
        /// 
        /// Default Value: &#34;OnboardClock&#34;
        /// 
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureSampleClockSource(string Sample_Clock_Source)
        {
            int pInvokeResult = PInvoke.ConfigureSampleClockSource(this._handle, Sample_Clock_Source);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureClockMode
        /// 
        /// ViStatus niFgen_ConfigureClockMode (ViSession vi, ViInt32 clockMode);
        /// 
        /// Purpose
        /// 
        /// Selects the clock mode for the signal generator.  
        /// 
        /// For signal generators that support it, this function allows you to switch the Sample clock to High-Resolution Sampling mode.
        /// 
        /// When in Divide-Down Sampling mode, you can only set the sample rate to certain frequencies, based on dividing down the update clock. However, in High-Resolution Sampling mode, you can set the sample rate to any value. 
        /// 
        /// 
        /// Note  The signal generator must not be in the Generating state when you call this function.
        /// 
        /// 
        /// Note  You must call the niFgen_ConfigureOutputMode function to set the output mode to NIFGEN_VAL_OUTPUT_SEQ, NIFGEN_VAL_OUTPUT_ARB, or NIFGEN_VAL_OUTPUT_SCRIPT before calling this function.
        /// 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Clock_Mode">
        /// 
        /// 
        /// clockMode
        /// ViInt32
        /// Sets the clock mode of the signal generator. 
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_DIVIDE_DOWNDivide down sampling&#8212;Sample rates are generated by dividing the source frequency.
        /// NIFGEN_VAL_HIGH_RESOLUTIONHigh resolution sampling&#8212;Sample rate is generated by a high resolution clock source.
        /// NIFGEN_VAL_AUTOMATICAutomatic Selection&#8212;NI-FGEN selects between the divide-down and high-resolution clocking modes.
        /// 
        /// Default Value: Depends on the device
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureClockMode(int Clock_Mode)
        {
            int pInvokeResult = PInvoke.ConfigureClockMode(this._handle, Clock_Mode);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_AdjustSampleClockRelativeDelay
        /// 
        /// ViStatus niFgen_AdjustSampleClockRelativeDelay (ViSession vi, ViReal64 adjustmentTime);
        /// 
        /// Purpose
        /// 
        /// Delays (or phase shifts) the Sample clock, which delays the generated signal.  Delaying the Sample clock can be useful when synchronizing the output of multiple modules or when intentionally phase shifting the output relative to a fixed reference, such as the PLL Reference clock.  
        /// Adjustment time can be positive or negative, but it must be less than or equal to the Sample clock period.  The delay takes effect immediately after this function is called.  To delay an external Sample clock, use the 
        /// NIFGEN_ATTR_SAMPLE_CLOCK_ABSOLUTE_DELAY attribute.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Adjustment_Time">
        /// 
        /// 
        /// adjustmentTime
        /// ViReal64
        /// Specifies the amount of time to adjust the sample clock delay in seconds.
        /// 
        /// Default Value: 0
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int AdjustSampleClockRelativeDelay(double Adjustment_Time)
        {
            int pInvokeResult = PInvoke.AdjustSampleClockRelativeDelay(this._handle, Adjustment_Time);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureDigitalEdgeStartTrigger
        /// 
        /// ViStatus niFgen_ConfigureDigitalEdgeStartTrigger (ViSession vi, ViConstString source, ViInt32 edge);
        /// 
        /// Purpose
        /// 
        /// Configures the Start trigger for digital edge triggering.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Source">
        /// 
        /// 
        /// source
        /// ViConstString
        /// Specifies which trigger source the signal generator uses.
        ///  
        /// </param>
        /// <param name="Edge">
        /// 
        /// 
        /// edge
        /// ViInt32
        /// Specifies the edge to detect. 
        /// 
        /// Defined Values
        /// NIFGEN_VAL_RISING_EDGEOccurs when the signal transitions from low level to high level.
        /// NIFGEN_VAL_FALLING_EDGEOccurs when the signal transitions from high level to low level.
        /// Default Value:
        /// NIFGEN_VAL_RISING_EDGE
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureDigitalEdgeStartTrigger(string Source, int Edge)
        {
            int pInvokeResult = PInvoke.ConfigureDigitalEdgeStartTrigger(this._handle, Source, Edge);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureSoftwareEdgeStartTrigger
        /// 
        /// ViStatus niFgen_ConfigureSoftwareEdgeStartTrigger (ViSession vi);
        /// 
        /// Purpose
        /// 
        /// Configures the Start trigger for software edge triggering.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureSoftwareEdgeStartTrigger()
        {
            int pInvokeResult = PInvoke.ConfigureSoftwareEdgeStartTrigger(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_DisableStartTrigger
        /// 
        /// ViStatus niFgen_DisableStartTrigger (ViSession vi);
        /// 
        /// Purpose
        /// 
        /// Disables the Start trigger.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int DisableStartTrigger()
        {
            int pInvokeResult = PInvoke.DisableStartTrigger(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureDigitalEdgeScriptTrigger
        /// 
        /// ViStatus niFgen_ConfigureDigitalEdgeScriptTrigger (ViSession vi, ViConstString triggerID, ViConstString source, ViInt32 edge);
        /// 
        /// Purpose
        /// 
        /// Configures the specified Script trigger for digital edge triggering.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Trigger_ID">
        /// 
        /// 
        /// triggerID
        /// ViConstString
        /// Specifies the Script trigger used for triggering.
        ///  
        /// </param>
        /// <param name="Source">
        /// 
        /// 
        /// source
        /// ViConstString
        /// Specifies which trigger source the signal generator uses.
        ///  
        /// </param>
        /// <param name="Edge">
        /// 
        /// 
        /// edge
        /// ViInt32
        /// Specifies the edge to detect. 
        /// 
        /// Defined Values
        /// NIFGEN_VAL_RISING_EDGEOccurs when the signal transitions from low level to high level.
        /// NIFGEN_VAL_FALLING_EDGEOccurs when the signal transitions from high level to low level.
        /// Default Value:
        /// NIFGEN_VAL_RISING_EDGE
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureDigitalEdgeScriptTrigger(string Trigger_ID, string Source, int Edge)
        {
            int pInvokeResult = PInvoke.ConfigureDigitalEdgeScriptTrigger(this._handle, Trigger_ID, Source, Edge);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureDigitalLevelScriptTrigger
        /// 
        /// ViStatus niFgen_ConfigureDigitalLevelScriptTrigger (ViSession vi, ViConstString triggerID, ViConstString source, ViInt32 triggerWhen);
        /// 
        /// Purpose
        /// 
        /// Configures the specified Script trigger for digital level triggering.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Trigger_ID">
        /// 
        /// 
        /// triggerID
        /// ViConstString
        /// Specifies the Script trigger used for triggering.
        ///  
        /// </param>
        /// <param name="Source">
        /// 
        /// 
        /// source
        /// ViConstString
        /// Specifies which trigger source the signal generator uses.
        ///  
        /// </param>
        /// <param name="Trigger_When">
        /// 
        /// 
        /// triggerWhen
        /// ViInt32
        /// Configures the specified Script trigger for digital level triggering.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureDigitalLevelScriptTrigger(string Trigger_ID, string Source, int Trigger_When)
        {
            int pInvokeResult = PInvoke.ConfigureDigitalLevelScriptTrigger(this._handle, Trigger_ID, Source, Trigger_When);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureSoftwareEdgeScriptTrigger
        /// 
        /// ViStatus niFgen_ConfigureSoftwareEdgeScriptTrigger (ViSession vi, ViConstString triggerID);
        /// 
        /// Purpose
        /// 
        /// Configures the specified Script trigger for software edge triggering.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Trigger_ID">
        /// 
        /// 
        /// triggerID
        /// ViConstString
        /// Specifies the Script trigger used for triggering.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureSoftwareEdgeScriptTrigger(string Trigger_ID)
        {
            int pInvokeResult = PInvoke.ConfigureSoftwareEdgeScriptTrigger(this._handle, Trigger_ID);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_DisableScriptTrigger
        /// 
        /// ViStatus niFgen_DisableScriptTrigger (ViSession vi, ViConstString triggerID);
        /// 
        /// Purpose
        /// 
        /// Disables the specified Script trigger.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Trigger_ID">
        /// 
        /// 
        /// triggerID
        /// ViConstString
        /// Specifies the Script trigger used for triggering.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int DisableScriptTrigger(string Trigger_ID)
        {
            int pInvokeResult = PInvoke.DisableScriptTrigger(this._handle, Trigger_ID);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureTriggerMode
        /// 
        /// ViStatus niFgen_ConfigureTriggerMode (ViSession vi, ViConstString channelName, ViInt32 triggerMode);
        /// 
        /// Purpose
        /// 
        /// Sets the trigger mode for the signal generator.
        /// 
        /// Supported trigger modes are Single Trigger, Continuous Trigger, Stepped Trigger, and Burst Trigger. Refer to Devices>> <your device> >>Triggering>>Trigger Modes in the NI Signal Generators Help for descriptions of the signal generator's specific behavior for supported trigger modes.
        /// 
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to configure the trigger mode.
        /// 
        /// 
        /// Default Value: 0
        ///  
        /// </param>
        /// <param name="Trigger_Mode">
        /// 
        /// 
        /// triggerMode
        /// ViInt32
        /// Sets the trigger mode.
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_SINGLE
        /// The waveform that you describe in the sequence list generates only once by going through the entire staging list. Only one trigger is required to start the waveform generation. You can use single trigger mode with the output mode in any mode.  After a trigger is received, the waveform generation starts from the first stage and continues through to the last stage.
        /// 
        /// NIFGEN_VAL_CONTINUOUS 
        /// The waveform that you describe in the staging list generates infinitely by repeatedly cycling through the staging list. After a trigger is received, the waveform generation starts from the first stage and continues through to the last stage. After the last stage is completed, the waveform generation loops back to the start of the first stage and continues until it is stopped. Only one trigger is required to start the waveform generation.
        /// 
        /// NIFGEN_VAL_STEPPED
        /// After a start trigger is received, the waveform described by the first stage generates. Then, the device waits for the next trigger signal. On the next trigger, the waveform described by the second stage generates, and so on. Once the staging list is exhausted, the waveform generation returns to the first stage and continues to repeat the cycle.
        /// 
        /// NIFGEN_VAL_BURST
        ///   After a start trigger is received, the waveform described by the first stage generates until another trigger is received. At the next trigger, the buffer of the previous stage completes, and then the waveform described by the second stage generates. Once the staging list is exhausted, the waveform generation returns to the first stage and continues to repeat the cycle.  In Frequency List mode, the duration instruction is ignored, and the trigger switches the frequency to the next frequency in the list.
        /// 
        /// 
        /// Default Value: NIFGEN_VAL_CONTINUOUS
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureTriggerMode(string Channel_Name, int Trigger_Mode)
        {
            int pInvokeResult = PInvoke.ConfigureTriggerMode(this._handle, Channel_Name, Trigger_Mode);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_SendSoftwareEdgeTrigger
        /// 
        /// ViStatus niFgen_SendSoftwareEdgeTrigger (ViSession vi, viInt32 trigger, viConstString triggerID);
        /// 
        /// Purpose
        /// 
        /// Sends a software edge to the specified trigger.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Trigger">
        /// 
        /// 
        /// trigger
        /// ViInt32
        /// Specifies the type of trigger to send.
        /// Defined Values
        /// 
        /// NIFGEN_VAL_START_TRIGGER Transitions the device from an Idle state to a Generation state where the device can respond to sample clocks.
        /// NIFGEN_VAL_SCRIPT_TRIGGER Allows you to create sophisticated generation operations that are determined by the generation script.
        /// 
        /// Default Value: NIFGEN_VAL_START_TRIGGER
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Trigger_ID">
        /// 
        /// 
        /// triggerID
        /// ViConstString
        /// Identifies the specific trigger to be used.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int SendSoftwareEdgeTrigger(int Trigger, string Trigger_ID)
        {
            int pInvokeResult = PInvoke.SendSoftwareEdgeTrigger(this._handle, Trigger, Trigger_ID);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureSynchronization
        /// 
        /// ViStatus niFgen_ConfigureSynchronization (ViSession vi, ViConstString channelName, ViInt32 synchronizationSource);
        /// 
        /// Purpose
        /// 
        /// Sets the signal generator to receive a synchronization signal to synchronize two or more NI 5401/5411/5431 signal generators. One signal generator should route a SYNC signal to a RTSI line by calling the niFgen_ExportSignal function (use the niFgen_RouteSignalOut function for the NI 5404), and other signal generators should receive the signal by calling the niFgen_ConfigureSynchronization function.
        /// 
        /// 
        /// Note    The signal generator must not be in the Generating state when you call this function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to configure the synchronization signal.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Synchronization_Source">
        /// 
        /// 
        /// synchronizationSource
        /// ViInt32
        /// Specify the source of the synchronization signal you want to use. 
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_NONE  
        /// No synchronization source
        /// 
        /// NIFGEN_VAL_RTSI_0  
        /// RTSI 0 or PXI_Trig 0
        /// 
        /// NIFGEN_VAL_RTSI_1  
        /// RTSI 1 or PXI_Trig 1
        /// 
        /// NIFGEN_VAL_RTSI_2  
        /// RTSI 2 or PXI_Trig 2
        /// 
        /// NIFGEN_VAL_RTSI_3  
        /// RTSI 3 or PXI_Trig 3
        /// 
        /// NIFGEN_VAL_RTSI_4  
        /// RTSI 4 or PXI_Trig 4
        /// 
        /// NIFGEN_VAL_RTSI_5  
        /// RTSI 5 or PXI_Trig 5
        /// 
        /// NIFGEN_VAL_RTSI_6  
        /// RTSI 6 or PXI_Trig 6
        /// 
        /// NIFGEN_VAL_TTL0  
        /// TTL 0
        /// 
        /// NIFGEN_VAL_TTL1  
        /// TTL 1
        /// 
        /// NIFGEN_VAL_TTL2  
        /// TTL 2
        /// 
        /// NIFGEN_VAL_TTL3  
        /// TTL 3
        /// 
        /// NIFGEN_VAL_TTL4  
        /// TTL 4
        /// 
        /// NIFGEN_VAL_TTL5  
        /// TTL 5
        /// 
        /// NIFGEN_VAL_TTL6  
        /// TTL 6
        /// 
        /// Default Value: NIFGEN_VAL_NONE
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureSynchronization(string Channel_Name, int Synchronization_Source)
        {
            int pInvokeResult = PInvoke.ConfigureSynchronization(this._handle, Channel_Name, Synchronization_Source);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ExportSignal
        /// 
        /// ViStatus niFgen_ExportSignal (ViSession vi, ViInt32 signal, ViConstString signalIdentifier, ViConstString outputTerminal);
        /// 
        /// Purpose
        /// 
        /// Exports various signals, clocks, and events from the signal generator to the RTSI lines, front panel, or other external terminals.  
        /// 
        /// Notes  The signal generator must not be in the Generating state when you call this function.
        /// You can clear a previously routed signal by exporting the signal to &#34;&#34; (empty string).
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Signal">
        /// 
        /// 
        /// signal
        /// ViInt32
        /// Specifies the source of the signal to route.
        /// 
        /// Defined Values
        /// 
        /// 
        /// 
        /// NIFGEN_VAL_ONBOARD_REFERENCE_CLOCKThe onboard 10 MHz synchronization clock (PCI only).
        /// 
        /// NIFGEN_VAL_SYNC_OUTThe SYNC OUT signal that normally is generated on the SYNC OUT front panel connector.
        /// 
        /// NIFGEN_VAL_START_TRIGGERStart trigger.
        /// 
        /// 
        /// NIFGEN_VAL_MARKER_EVENTMarker event.
        /// 
        /// 
        /// NIFGEN_VAL_SAMPLE_CLOCK_TIMEBASEThe clock from which the sample clock is derived.
        /// 
        /// NIFGEN_VAL_SYNCHRONIZATIONA synchronization strobe used to guarantee absolute synchronization between two or more signal generators. (NI 5404, 5411, 5431 only)
        /// 
        /// NIFGEN_VAL_SAMPLE_CLOCKSample clock 
        /// 
        /// NIFGEN_VAL_REFERENCE_CLOCKPLL Reference clock
        /// 
        /// NIFGEN_VAL_SCRIPT_TRIGGERScript trigger
        /// 
        /// NIFGEN_VAL_READY_FOR_START_EVENTReady For Start event
        /// 
        /// NIFGEN_VAL_STARTED_EVENTStarted event
        /// 
        /// NIFGEN_VAL_DONE_EVENTDone event
        /// 
        /// NIFGEN_VAL_DATA_MARKER_EVENTData Marker event
        /// 
        /// 
        /// 
        /// </param>
        /// <param name="Signal_Identifier">
        /// 
        /// 
        /// signalIdentifier
        /// ViConstString
        /// Specifies which instance of the selected signal to export.
        /// 
        /// 
        /// 
        /// 
        /// Defined Values
        /// 
        /// &#34;&#34; (empty string)Default (for non instance-based signals)
        /// 
        /// 
        /// &#34;ScriptTrigger0&#34;Script trigger 0
        /// 
        /// &#34;ScriptTrigger1&#34;Script trigger 1
        /// 
        /// &#34;ScriptTrigger2&#34;Script trigger 2
        /// 
        /// &#34;ScriptTrigger3&#34;Script trigger 3
        /// 
        /// &#34;Marker0&#34;
        /// Marker 0
        /// 
        /// &#34;Marker1&#34;
        /// Marker 1
        /// 
        /// &#34;Marker2&#34;
        /// Marker 2
        /// 
        /// &#34;Marker3&#34;
        /// Marker 3
        /// 
        /// &#34;DataMarker0&#34;
        /// Data Marker 0*
        /// 
        /// &#34;DataMarker1&#34;
        /// Data Marker 1*
        /// 
        /// &#34;DataMarker2&#34;
        /// Data Marker 2*
        /// 
        /// &#34;DataMarker3&#34;
        /// Data Marker 3*
        /// 
        /// * These Data Marker values apply only to single-channel devices or to multichannel devices that are configured for single-channel operation. When using a device that is configured for multichannel operation, specify the channel number along with the signal identifier. For example, to export Data Marker 0 on channel 1 of a device configured for multichannel operation, use the value "1/ DataMarker0." If you do not specify a channel when using a device configured for multichannel generation, DataMarker0  generates on all channels.
        /// 
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Output_Terminal">
        /// 
        /// 
        /// outputTerminal
        /// ViConstString
        /// Specifies the output terminal to export the signal.
        /// 
        /// 
        /// 
        /// 
        /// 
        /// Note   The following Defined Values are examples of possible output terminals. For a complete list of the output terminals available on your device, refer to the Device Routes tab in MAX.
        /// 
        /// 
        /// 
        /// Defined Values
        /// 
        /// &#34;&#34; (empty string)Do not export signal
        /// 
        /// 
        /// &#34;PFI0&#34;PFI line 0
        /// 
        /// &#34;PFI1&#34;PFI line 1
        /// 
        /// &#34;PFI4&#34;PFI line 4
        /// 
        /// &#34;PFI5&#34;PFI line 5
        /// 
        /// &#34;PXI_Trig0&#34;
        /// PXI or RTSI line 0
        /// 
        /// &#34;PXI_Trig1&#34;
        /// PXI or RTSI line 1
        /// 
        /// &#34;PXI_Trig2&#34;
        /// PXI or RTSI line 2
        /// 
        /// &#34;PXI_Trig3&#34;
        /// PXI or RTSI line 3
        /// 
        /// &#34;PXI_Trig4&#34;
        /// PXI or RTSI line 4
        /// 
        /// &#34;PXI_Trig5&#34;
        /// PXI or RTSI line 5
        /// 
        /// &#34;PXI_Trig6&#34;
        /// PXI or RTSI line 6
        /// 
        /// &#34;PXI_Trig7&#34;
        /// PXI or RTSI line 7
        /// 
        /// &#34;DDC_ClkOut&#34;
        /// Clock out from DDC connector
        /// 
        /// &#34;PXI_Star&#34;PXI star trigger line
        /// 
        /// 
        /// 
        /// 
        ///  
        /// 
        /// 
        /// 
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ExportSignal(int Signal, string Signal_Identifier, string Output_Terminal)
        {
            int pInvokeResult = PInvoke.ExportSignal(this._handle, Signal, Signal_Identifier, Output_Terminal);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_RouteSignalOut
        /// 
        /// ViStatus niFgen_RouteSignalOut (ViSession vi, ViConstString channelName, ViInt32 routeSignalFrom, ViInt32 routeSignalTo);
        /// 
        /// Purpose
        /// 
        /// Routes various signals in the signal generator to the RTSI lines and front 
        /// panel terminals. 
        /// 
        /// 
        /// Notes  The signal generator must not be in the Generating state when you call this function.
        /// 
        /// You can clear a previously routed signal by routing NIFGEN_VAL_NONE to the destination terminal.
        /// 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to route a signal.
        /// 
        /// 
        /// 
        /// Default Value: "0"
        ///  
        /// </param>
        /// <param name="Route_Signal_From">
        /// 
        /// 
        /// routeSignalFrom
        /// ViInt32
        /// Various signals can be routed out the RTSI lines.  
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_NONE
        /// Route nothing to the RTSI line. Clears the line.
        /// 
        /// NIFGEN_VAL_MARKER
        /// Marker event
        /// 
        /// NIFGEN_VAL_SYNC_OUT
        /// The SYNC signal that normally appears on the SYNC OUT front panel connector.
        /// 
        /// NIFGEN_VAL_OUT_START_TRIGGER
        /// The trigger generated at the start of the sequence. Call the niFgen_ConfigureTriggerSource function to receive this trigger.
        /// 
        /// NIFGEN_VAL_BOARD_CLOCK
        /// The signal generator board clock, which is 20 MHz for the NI PCI-5401/5411/5431. The NI PXI-5404 has a 20 MHz board clock, and the NI PXI-5421 has integer divisors of 100 MHz. The NI PXI-5401/5411/5431 does not support routing a Board Clock to RTSI lines or front panel connectors.
        /// 
        /// NIFGEN_VAL_SYNCHRONIZATION
        /// A synchronization strobe used to guarantee absolute synchronization between two or more signal generators. Call the niFgen_ConfigureSynchronization function to receive the strobe.
        /// 
        /// NIFGEN_VAL_SOFTWARE_TRIG
        /// Software trigger
        /// 
        /// NIFGEN_VAL_OUT_UPDATE
        /// --
        /// 
        /// NIFGEN_VAL_REF_OUT
        /// Reference clock out front panel connector
        /// 
        /// NIFGEN_VAL_PXI_CLK10
        /// PXI 10 MHz backplane reference clock
        /// 
        /// NIFGEN_VAL_PXI_STAR
        /// PXI star trigger line
        /// 
        /// NIFGEN_VAL_PFI_0
        /// PFI 0
        /// 
        /// NIFGEN_VAL_RTSI_0
        /// RTSI 0 or PXI_Trig 0
        /// 
        /// NIFGEN_VAL_RTSI_1
        /// RTSI 1 or PXI_Trig 1
        /// 
        /// NIFGEN_VAL_RTSI_2
        /// RTSI 2 or PXI_Trig 2
        /// 
        /// NIFGEN_VAL_RTSI_3
        /// RTSI 3 or PXI_Trig 3
        /// 
        /// NIFGEN_VAL_RTSI_4
        /// RTSI 4 or PXI_Trig 4
        /// 
        /// NIFGEN_VAL_RTSI_5
        /// RTSI 5 or PXI_Trig 5
        /// 
        /// NIFGEN_VAL_RTSI_6
        /// RTSI 6 or PXI_Trig 6
        /// 
        /// NIFGEN_VAL_RTSI_7
        /// RTSI 7 or PXI_Trig 7
        /// 
        /// NIFGEN_VAL_REF_CLOCK_RTSI_CLOCK
        /// RTSI clock
        /// 
        /// NIFGEN_VAL_ONBOARD_REFERENCE_CLOCK
        /// Onboard Reference clock
        /// 
        /// NIFGEN_VAL_UPDATE_CLOCK
        /// Sample clock
        /// 
        /// NIFGEN_VAL_PLL_REF_SOURCE
        /// PLL reference clock
        /// 
        ///  
        /// </param>
        /// <param name="Route_Signal_To">
        /// 
        /// 
        /// routeSignalTo
        /// ViInt32
        /// The possible RTSI lines to which you can route a signal.
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_RTSI_0
        /// RTSI 0 or PXI_Trig 0
        /// 
        /// NIFGEN_VAL_RTSI_1
        /// RTSI 1 or PXI_Trig 1
        /// 
        /// NIFGEN_VAL_RTSI_2
        /// RTSI 2 or PXI_Trig 2
        /// 
        /// NIFGEN_VAL_RTSI_3
        /// RTSI 3 or PXI_Trig 3
        /// 
        /// NIFGEN_VAL_RTSI_4
        /// RTSI 4 or PXI_Trig 4
        /// 
        /// NIFGEN_VAL_RTSI_5
        /// RTSI 5 or PXI_Trig 5
        /// 
        /// NIFGEN_VAL_RTSI_6
        /// RTSI 6 or PXI_Trig 6
        /// 
        /// NIFGEN_VAL_RTSI_7
        /// RTSI 7 or PXI_Trig 7
        /// 
        /// NIFGEN_VAL_REF_CLOCK_RTSI_CLOCK
        /// RTSI clock
        /// 
        /// NIFGEN_VAL_REF_OUT
        /// Reference clock out front panel connector
        /// 
        /// NIFGEN_VAL_PFI_0
        /// PFI 0
        /// 
        /// NIFGEN_VAL_PFI_1
        /// PFI 1
        /// 
        /// NIFGEN_VAL_PFI_4
        /// PFI 4
        /// 
        /// NIFGEN_VAL_PFI_5
        /// PFI 5
        ///  
        /// NIFGEN_VAL_PXI_STAR
        /// PXI star trigger line
        /// 
        /// NIFGEN_VAL_PXI_CLK10
        /// PXI 10 MHz backplane reference clock
        /// 
        /// 
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int RouteSignalOut(string Channel_Name, int Route_Signal_From, int Route_Signal_To)
        {
            int pInvokeResult = PInvoke.RouteSignalOut(this._handle, Channel_Name, Route_Signal_From, Route_Signal_To);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_AllocateNamedWaveform
        /// 
        /// ViStatus niFgen_AllocateNamedWaveform (ViSession vi, ViConstString channelName, ViConstString waveformName, ViInt32 waveformSize);
        /// 
        /// Purpose
        /// 
        /// Specifies the size of a named waveform up front so that it can be allocated in onboard memory before loading the associated data. Data can then be loaded in smaller blocks with the niFgen Write (Binary16) Waveform functions.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to allocate the named waveform.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Waveform_Name">
        /// 
        /// 
        /// waveformName
        /// ViConstString
        /// Specifies the name to associate with the allocated waveform.
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Waveform_Size">
        /// 
        /// 
        /// waveformSize
        /// ViInt32
        /// Specifies the size of the waveform to allocate in samples.
        /// 
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int AllocateNamedWaveform(string Channel_Name, string Waveform_Name, int Waveform_Size)
        {
            int pInvokeResult = PInvoke.AllocateNamedWaveform(this._handle, Channel_Name, Waveform_Name, Waveform_Size);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_SetNamedWaveformNextWritePosition
        /// 
        /// ViStatus niFgen_SetNamedWaveformNextWritePosition (ViSession vi, ViConstString channelName, ViConstString waveformName, ViInt32 relativeto, ViInt32 offset);
        /// 
        /// Purpose
        /// 
        /// Sets the position in the waveform to which data is written at the next write. This function allows you to write to arbitrary locations within the waveform. These settings apply only to the next write to the waveform specified by the waveformHandle parameter. Subsequent writes to that waveform begin where the last write left off, unless this function is called again. The waveformHandle passed in must have been created with a call to one of the following functions:
        /// 
        ///  niFgen_AllocateWaveform
        ///  niFgen_CreateWaveformF64
        /// 
        /// niFgen_CreateWaveformI16
        /// 
        ///  niFgen_CreateWaveformFromFileI16
        /// 
        ///  niFgen_CreateWaveformFromFileF64
        /// 
        ///  niFgen_CreateWaveformFromFileHWS
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel onto which the waveform data should be loaded.
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Waveform_Name">
        /// 
        /// 
        /// waveformName
        /// ViConstString
        /// Specifies the name to associate with the allocated waveform.
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="relativeTo">
        /// 
        /// 
        /// relativeTo
        /// ViInt32
        /// Specifies the reference position in the waveform. The position and offset together determine where to start loading data into the waveform.
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_WAVEFORM_POSITION_START (0)  
        /// Use the start of the waveform as the reference position.
        /// NIFGEN_VAL_WAVEFORM_POSITION_CURRENT (1) 
        /// Use the current position within the waveform as the reference position. 
        ///  
        /// </param>
        /// <param name="offset">
        /// html>
        /// 
        /// 
        /// offset
        /// ViInt32
        /// Specifies the offset from the relativeTo parameter at which to start loading the data into the waveform.
        ///  
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int SetNamedWaveformNextWritePosition(string Channel_Name, string Waveform_Name, int relativeTo, int offset)
        {
            int pInvokeResult = PInvoke.SetNamedWaveformNextWritePosition(this._handle, Channel_Name, Waveform_Name, relativeTo, offset);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_WriteNamedWaveformF64
        /// 
        /// ViStatus niFgen_WriteNamedWaveformF64 (ViSession vi, ViConstString channelName, ViConstString waveformName, ViInt32 size, ViReal64[] data);
        /// 
        /// Purpose
        /// 
        /// Writes floating-point data to the waveform in onboard memory.  The waveform handle passed in must have been created by a call to the niFgen_AllocateWaveform function or to one of the following niFgen Create Waveform functions:
        /// 
        ///  niFgen_CreateWaveformF64
        /// 
        ///  niFgen_CreateWaveformI16
        /// 
        ///  niFgen_CreateWaveformFromFileI16
        /// 
        ///  niFgen_CreateWaveformFromFileF64
        /// 
        ///  niFgen_CreateWaveformFromFileHWS
        /// 
        /// The write position and offset can be set by calling niFgen_SetWaveformNextWritePosition.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel onto which the waveform data should be loaded.  
        /// 
        /// Default Value: "0"
        ///  
        /// </param>
        /// <param name="Waveform_Name">
        /// 
        /// 
        /// waveformName
        /// ViConstString
        /// Specifies the name to associate with the allocated waveform.
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Size">
        /// 
        /// 
        /// size
        /// ViInt32
        /// Specifies the number of samples to load into the waveform.
        /// 
        /// Default Value: 0
        ///  
        /// 
        /// 
        /// </param>
        /// <param name="Data">
        /// 
        /// 
        /// data
        /// ViReal64 []
        /// Specifies the array of data to load into the waveform. The array must have at least as many elements as the value in size.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int WriteNamedWaveformF64(string Channel_Name, string Waveform_Name, int Size, double[] Data)
        {
            int pInvokeResult = PInvoke.WriteNamedWaveformF64(this._handle, Channel_Name, Waveform_Name, Size, Data);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_WriteNamedWaveformI16
        /// 
        /// ViStatus niFgen_WriteNamedWaveformI16 (ViSession vi, ViConstString channelName, ViConstString waveformName, ViInt32 size, ViInt16[] data);
        /// 
        /// Purpose
        /// 
        /// Writes binary data to the named waveform in onboard memory.  The waveform handle passed in must have been created by a call to the niFgen_AllocateWaveform function or to one of the following niFgen Create Waveform functions:
        /// 
        ///  niFgen_CreateWaveformF64
        /// 
        ///  niFgen_CreateWaveformI16
        /// 
        ///  niFgen_CreateWaveformFromFileI16
        /// 
        ///  niFgen_CreateWaveformFromFileF64
        /// 
        ///  niFgen_CreateWaveformFromFileHWS
        /// 
        /// The write position and offset can be set by calling the niFgen_SetWaveformNextWritePosition function.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel onto which the waveform data should be loaded.  
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Waveform_Name">
        /// 
        /// 
        /// waveformName
        /// ViConstString
        /// Specifies the name to associate with the allocated waveform.
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Size">
        /// 
        /// 
        /// size
        /// ViInt32
        /// Specifies the number of samples to load into the waveform.
        /// 
        /// Default Value: 0
        ///  
        /// 
        /// 
        /// </param>
        /// <param name="Data">
        /// 
        /// 
        /// data
        /// ViInt16 []
        /// Specifies the array of data to load into the waveform. The array must have at least as many elements as the value in size.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int WriteNamedWaveformI16(string Channel_Name, string Waveform_Name, int Size, short[] Data)
        {
            int pInvokeResult = PInvoke.WriteNamedWaveformI16(this._handle, Channel_Name, Waveform_Name, Size, Data);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_WriteNamedWaveformComplexF64
        /// 
        /// ViStatus niFgen_WriteNamedWaveformComplexF64 (ViSession vi, ViConstString channelName, ViConstString waveformName, ViInt32 size, NIComplexNumber[] data);
        /// 
        /// Purpose
        /// 
        /// Writes complex floating&#8211;point data to the named waveform in onboard memory on devices with the OSP Enabled property set to VI_TRUE and the Data Processing Mode property set to Complex.  The waveform handle passed in must have been created by a call to the niFgen_AllocateWaveform function or to one of the following niFgen Create Waveform functions:
        /// 
        ///  niFgen_CreateWaveformF64
        /// 
        ///  niFgen_CreateWaveformI16
        /// 
        ///  niFgen_CreateWaveformFromFileI16
        /// 
        ///  niFgen_CreateWaveformFromFileF64
        /// 
        ///  niFgen_CreateWaveformFromFileHWS
        /// 
        /// The write position and offset can be set by calling the niFgen_SetWaveformNextWritePosition function.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel onto which the waveform data should be loaded.  
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Waveform_Name">
        /// 
        /// 
        /// waveformName
        /// ViConstString
        /// Specifies the name to associate with the allocated waveform.
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Size">
        /// 
        /// 
        /// size
        /// ViInt32
        /// Specifies the number of samples to load into the waveform.
        /// 
        /// Default Value: 0
        ///  
        /// 
        /// 
        /// </param>
        /// <param name="Data">
        /// 
        /// 
        /// data
        /// NIComplexNumber []
        /// Specifies the array of data to load into the waveform. The array must have at least as many elements as the value in size.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int WriteNamedWaveformComplexF64(string Channel_Name, string Waveform_Name, int Size, nicomplexnumber Data)
        {
            int pInvokeResult = PInvoke.WriteNamedWaveformComplexF64(this._handle, Channel_Name, Waveform_Name, Size, Data);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_WriteNamedComplexWaveformI16
        /// 
        /// ViStatus niFgen_WriteNamedComplexWaveformI16 (ViSession vi, ViConstString channelName, ViConstString waveformName, ViInt32 size, NIComplexI16[] data);
        /// 
        /// Purpose
        /// 
        /// Writes complex binary data to the named waveform in onboard memory on devices with the OSP Enabled property set to VI_TRUE and the Data Processing Mode property set to Complex.   The waveform handle passed in must have been created by a call to the niFgen_AllocateWaveform function or to one of the following niFgen Create Waveform functions:
        /// 
        ///  niFgen_CreateWaveformF64
        /// 
        ///  niFgen_CreateWaveformI16
        /// 
        ///  niFgen_CreateWaveformFromFileI16
        /// 
        ///  niFgen_CreateWaveformFromFileF64
        /// 
        ///  niFgen_CreateWaveformFromFileHWS
        /// 
        /// The write position and offset can be set by calling the niFgen_SetWaveformNextWritePositionfunction.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel onto which the waveform data should be loaded.  
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Waveform_Name">
        /// 
        /// 
        /// waveformName
        /// ViConstString
        /// Specifies the name to associate with the allocated waveform.
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Size">
        /// 
        /// 
        /// size
        /// ViInt32
        /// Specifies the number of samples to load into the waveform.
        /// 
        /// Default Value: 0
        ///  
        /// 
        /// 
        /// </param>
        /// <param name="Data">
        /// 
        /// 
        /// data
        /// NIComplexI16 []
        /// Specifies the array of data to load into the waveform. The array must have at least as many elements as the value in size.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int WriteNamedWaveformComplexI16(string Channel_Name, string Waveform_Name, int Size, nicomplexI16 Data)
        {
            int pInvokeResult = PInvoke.WriteNamedWaveformComplexI16(this._handle, Channel_Name, Waveform_Name, Size, Data);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_DeleteNamedWaveform
        /// 
        /// ViStatus niFgen_DeleteNamedWaveform (ViSession vi, ViConstString channelName, ViConstString waveformName);
        /// 
        /// Purpose
        /// 
        /// Removes a previously created arbitrary waveform from the signal generator memory and invalidates the waveform handle.
        /// 
        /// 
        /// Note  The signal generator must not be in the Generating state when you call this function.
        /// 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel onto which the named waveform is loaded.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Waveform_Name">
        /// 
        /// 
        /// waveformName
        /// ViConstString
        /// Specifies the name to associate with the allocated waveform.
        /// 
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int DeleteNamedWaveform(string Channel_Name, string Waveform_Name)
        {
            int pInvokeResult = PInvoke.DeleteNamedWaveform(this._handle, Channel_Name, Waveform_Name);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_WriteScript
        /// 
        /// ViStatus niFgen_WriteScript (ViSession vi, ViConstString channelName, ViConstString script);
        /// 
        /// Purpose
        /// 
        /// Writes a string containing one or more scripts that govern the generation of waveforms.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel on which the script is loaded. 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Script">
        /// 
        /// 
        /// script
        /// ViConstString
        /// Contains the text of the script you want to use for your generation operation.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int WriteScript(string Channel_Name, string Script)
        {
            int pInvokeResult = PInvoke.WriteScript(this._handle, Channel_Name, Script);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_DeleteScript
        /// 
        /// ViStatus niFgen_DeleteScript (ViSession vi, ViConstString channelName, ViConstString scriptName);
        /// 
        /// Purpose
        /// 
        /// Deletes the specified script from onboard memory.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel onto which the script is loaded.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Script_Name">
        /// 
        /// 
        /// scriptName
        /// ViConstString
        /// Specifies the name of the script you want to delete. The script name appears in the text of the script following the script keyword.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int DeleteScript(string Channel_Name, string Script_Name)
        {
            int pInvokeResult = PInvoke.DeleteScript(this._handle, Channel_Name, Script_Name);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ConfigureCustomFIRFilterCoefficients
        /// 
        /// ViStatus niFgen_ConfigureCustomFIRFilterCoefficients (ViSession vi, ViConstString channelName, ViInt32 numberofCoefficients, ViReal64[] coefficientsArray);
        /// 
        /// Purpose
        /// 
        /// Sets the FIR filter coefficients used by the NI 5441 onboard signal processing block. The values are coerced to the closest settings achievable by the signal generator.
        /// 
        /// Refer to  Devices>>&#60;your device&gt;>>Theory of Operation>>Onboard Signal Processing>>Components>>FIR Filter for more information about FIR filter coefficients.
        /// 
        /// 
        /// Note  The signal generator must not be in the Generating state when you call this function.
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to configure the operation mode.
        /// 
        /// Defined Value: &#34;0&#34;
        /// 
        ///  
        /// </param>
        /// <param name="Number_of_Coefficients">
        /// 
        /// 
        /// numberofCoefficients
        /// ViInt32
        /// Specifies the number of coefficients. The NI 5441 requires 95.
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Coefficients_Array">
        /// 
        /// 
        /// coefficientsArray
        /// ViReal64[]
        /// Specifies the array of data the onboard signal processor uses for the FIR filter coefficients. For the NI 5441, provide a symmetric array of 95 coefficients to this parameter. The array must have at least as many elements as the value that you specify in the numberOfCoefficients parameter in the niFgen_ConfigureCustomFIRFilterCoefficients VI.
        /// 
        /// The coefficients should range between -1.00 and +1.00.
        /// 
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureCustomFIRFilterCoefficients(string Channel_Name, int Number_of_Coefficients, double[] Coefficients_Array)
        {
            int pInvokeResult = PInvoke.ConfigureCustomFIRFilterCoefficients(this._handle, Channel_Name, Number_of_Coefficients, Coefficients_Array);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_GetFIRFilterCoefficients
        /// 
        /// ViStatus niFgen_GetFIRFilterCoefficients (ViSession vi, ViConstString channelName, ViInt32 arraySize, ViReal64[] coefficientsArray, ViInt32* numberofCoefficientsRead);
        /// 
        /// Purpose
        /// 
        /// 
        /// Returns the FIR filter coefficients used by the onboard signal processing block. These coefficients are determined by NI-FGEN and based on the FIR filter type and corresponding attribute (Alpha, Passband, BT) unless you are using the custom filter. If you are using a custom filter, the coefficients returned are those set with the niFgen_ConfigureCustomFIRFilterCoefficients  function coerced to the quantized values used by the device.
        /// 
        /// The coefficients are between &#8211;1.00 and +1.00.
        /// 
        /// 
        /// 
        /// 
        /// To use this function, first call an instance of the niFgen_GetFIRFilterCoefficients function with the coefficientsArray parameter set to VI_NULL. Calling the function in this state returns the current size of the coefficientsArray as the value of the numberOfCoefficientsRead parameter. Create an array of this size, and call the niFgen_GetFIRFilterCoefficients function a second time, passing the new array as the coefficientsArray parameter and the size as the arraySize parameter.  This second function call populate the array with the FIR filter coefficients. 
        /// 
        /// 
        /// 
        /// 
        /// 
        /// Refer to  Devices>>&#60;your device&gt;>>Theory of Operation>>Onboard Signal Processing>>Components>>FIR Filter for more information about FIR filter coefficients.
        /// 
        /// 
        /// 
        /// Default Value: None
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to configure the operation mode.
        /// 
        /// Defined Value: &#34;0&#34;
        /// 
        ///  
        /// </param>
        /// <param name="Array_Size">
        /// 
        /// 
        /// arraySize
        /// ViInt32
        /// Specifies the size of the coefficient array
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Coefficients_Array">
        /// 
        /// 
        /// coefficientsArray
        /// ViReal64[]
        /// Specifies the array of data the onboard signal processor uses for the FIR filter coefficients. For the NI 5441, provide a symmetric array of 95 coefficients to this parameter. The array must have at least as many elements as the value that you specify in the numberOfCoefficients parameter in the niFgen_ConfigureCustomFIRFilterCoefficients VI.
        /// 
        /// The coefficients should range between -1.00 and +1.00.
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Number_of_Coefficients_Read">
        /// 
        /// 
        /// numberofCoefficientsRead
        /// ViInt32[]
        /// Specifies the array of data containing the number of coefficients you want to read.
        /// 
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int GetFIRFilterCoefficients(string Channel_Name, int Array_Size, double[] Coefficients_Array, int[] Number_of_Coefficients_Read)
        {
            int pInvokeResult = PInvoke.GetFIRFilterCoefficients(this._handle, Channel_Name, Array_Size, Coefficients_Array, Number_of_Coefficients_Read);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_InitiateGeneration
        /// 
        /// ViStatus niFgen_InitiateGeneration (ViSession vi);
        /// 
        /// Purpose
        /// 
        /// Initiates signal generation.  If you want to abort signal generation, call the niFgen_AbortGeneration function. Once the signal generation is aborted, you can call the niFgen_InitiateGeneration function to cause the signal generator to produce a signal again.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int InitiateGeneration()
        {
            int pInvokeResult = PInvoke.InitiateGeneration(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_AbortGeneration
        /// 
        /// ViStatus niFgen_AbortGeneration (ViSession vi);
        /// 
        /// Purpose
        /// 
        /// Aborts any previously initiated signal generation. If you want to abort signal generation, call this function. Call the 
        /// niFgen_InitiateGeneration function to cause the signal generator to produce a signal again.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int AbortGeneration()
        {
            int pInvokeResult = PInvoke.AbortGeneration(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_GetHardwareState
        /// 
        /// ViStatus niFgen_GetHardwareState (ViSession vi, ViInt32* state);
        /// 
        /// Purpose
        /// 
        /// Returns the current hardware state of the device and, if the device is in the hardware error state, the current hardware error.  
        /// 
        /// 
        /// Note    Hardware states do not necessarily correspond to NI-FGEN states.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="state">
        /// 
        /// 
        /// state
        /// ViInt32*
        /// Returns the Hardware state of the signal generator.Defined Values
        /// 
        /// NIFGEN_VAL_IDLE
        /// The device is in the Idle state.
        /// 
        /// NIFGEN_VAL_WAITING_FOR_START_TRIGGER
        /// The device is waiting for Start trigger.
        /// 
        /// NIFGEN_VAL_RUNNING
        /// The device is in the Running state.
        /// 
        /// NIFGEN_VAL_DONE
        /// The generation has completed successfully.
        /// 
        /// NIFGEN_VAL_HARDWARE_ERROR
        /// There is a hardware error.
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int GetHardwareState(out int state)
        {
            int pInvokeResult = PInvoke.GetHardwareState(this._handle, out state);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_WaitUntilDone
        /// 
        /// ViStatus niFgen_WaitUntilDone (ViSession vi, ViInt32 maxtime);
        /// 
        /// Purpose
        /// 
        /// Waits until the device is done generating or until the maximum time has expired.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="maxTime">
        /// 
        /// 
        /// maxTime
        /// ViInt32
        /// The timeout value (in milliseconds).
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int WaitUntilDone(int maxTime)
        {
            int pInvokeResult = PInvoke.WaitUntilDone(this._handle, maxTime);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_IsDone
        /// 
        /// ViStatus niFgen_IsDone (ViSession vi, ViBoolean* done);
        /// 
        /// Purpose
        /// 
        /// Determines whether the current generation is complete.  This function sets the done parameter to VI_TRUE if the session is in the Idle or Committed states.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Done">
        /// 
        /// 
        /// done
        /// ViBoolean*
        /// Returns information about the completion of waveform generation.
        /// 
        /// Defined Values
        /// 
        /// VI_TRUEGeneration is complete.
        /// VI_FALSEGeneration is not complete.
        ///  
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int IsDone(out bool Done)
        {
            ushort DoneAsUShort;
            int pInvokeResult = PInvoke.IsDone(this._handle, out DoneAsUShort);
            Done = System.Convert.ToBoolean(DoneAsUShort);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ResetWithDefaults
        /// 
        /// ViStatus niFgen_ResetWithDefaults (ViSession vi);
        /// 
        /// Purpose
        /// 
        /// Resets the instrument and reapplies initial user&#8211;specified settings from the logical name that was used to initialize the session.  If the session was created without a logical name, this function is equivalent to the niFgen_reset function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ResetWithDefaults()
        {
            int pInvokeResult = PInvoke.ResetWithDefaults(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ResetDevice
        /// 
        /// ViStatus niFgen_ResetDevice (ViSession vi);
        /// 
        /// Purpose
        /// 
        /// Performs a hard reset on the device.  Generation is stopped, all routes are released, external bidirectional terminals are tristated, FPGAs are reset, hardware is configured to its default state, and all session attributes are reset to their default states.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ResetDevice()
        {
            int pInvokeResult = PInvoke.ResetDevice(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_GetChannelName
        /// 
        /// ViStatus niFgen_GetChannelName (ViSession vi, ViInt32 index, ViInt32 buffersize, ViChar[] channelName);
        /// 
        /// Purpose
        /// 
        /// The function returns the channel string that is in the channel table at an index you specify.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Index">
        /// 
        /// 
        /// index
        /// ViInt32
        /// Specifies a 1-based index into the channel table.
        ///  
        /// </param>
        /// <param name="BufferSize">
        /// 
        /// 
        /// bufferSize
        /// ViInt32
        /// Specifies the size of the buffer for the channel string.
        ///  
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Returns the channel string that is in the channel table at the index you specify.
        /// 
        /// Do not modify the contents of the channel string.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int GetChannelName(int Index, int BufferSize, System.Text.StringBuilder Channel_Name)
        {
            int pInvokeResult = PInvoke.GetChannelName(this._handle, Index, BufferSize, Channel_Name);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_Disable
        /// 
        /// ViStatus niFgen_Disable (ViSession vi);
        /// 
        /// Purpose
        /// 
        /// Places the instrument in a quiescent state where it has minimal or no impact on the system to which it is connected.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int Disable()
        {
            int pInvokeResult = PInvoke.Disable(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_self_test
        /// 
        /// ViStatus niFgen_self_test (ViSession vi, ViInt16* selfTestResult, ViChar[] selfTestMessage);
        /// 
        /// Purpose
        /// 
        /// Runs the instrument self-test routine and returns the test result(s).
        /// 
        /// 
        /// Note  When used on some signal generators, the device is reset after the niFgen_self_test function runs. If you use the niFgen_self_test function, your device may not be in its previously configured state after the function runs. 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Self_Test_Result">
        /// 
        /// 
        /// selfTestResult
        /// ViInt16
        /// Contains the value returned from the instrument self-test.  Zero means success. 
        /// 
        /// 
        /// 
        /// Self-Test Code    
        /// Description
        /// 
        /// 0              
        /// Passed self-test
        /// 
        /// 1              
        /// Self-test failed
        /// 
        ///  
        /// </param>
        /// <param name="Self_Test_Message">
        /// 
        /// 
        /// selfTestMessage
        /// ViChar[]
        /// Returns the self-test response string from the instrument. 
        /// 
        /// You must pass a ViChar array with at least 256 bytes.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int self_test(out short Self_Test_Result, System.Text.StringBuilder Self_Test_Message)
        {
            int pInvokeResult = PInvoke.self_test(this._handle, out Self_Test_Result, Self_Test_Message);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_revision_query
        /// 
        /// ViStatus niFgen_revision_query (ViSession vi, ViChar[] instrumentDriverRevision, ViChar[] firmwareRevision);
        /// 
        /// Purpose
        /// 
        /// Returns the revision numbers of the NI-FGEN and instrument firmware.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Instrument_Driver_Revision">
        /// 
        /// 
        /// instrumentDriverRevision
        /// ViChar[]
        /// Returns the NI-FGEN software revision numbers in the form of a string.
        /// 
        /// You must pass a ViChar array with at least 256 bytes.
        ///  
        /// </param>
        /// <param name="Firmware_Revision">
        /// 
        /// 
        /// firmwareRevision
        /// ViChar[]
        /// Returns the instrument firmware revision numbers in the form of a string.
        /// 
        /// You must pass a ViChar array with at least 256 bytes.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int revision_query(System.Text.StringBuilder Instrument_Driver_Revision, System.Text.StringBuilder Firmware_Revision)
        {
            int pInvokeResult = PInvoke.revision_query(this._handle, Instrument_Driver_Revision, Firmware_Revision);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_GetNextCoercionRecord
        /// 
        /// ViStatus niFgen_GetNextCoercionRecord (ViSession vi, ViInt32 bufferSize, ViChar[] coercionRecord);
        /// 
        /// Purpose
        /// 
        /// Returns the coercion information associated with the IVI session.  This function retrieves and clears the oldest instance in which the NI-FGEN coerced a value you specified to another value.
        /// 
        /// If you set the NIFGEN_ATTR_RECORD_COERCIONS attribute to VI_TRUE, NI-FGEN keeps a list of all coercions it makes on ViInt32 or ViReal64 values that you pass to NI-FGEN functions.  You use this function to retrieve information from that list.
        /// 
        /// If the next coercion record string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies bufferSize &#8211; 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value.  For example, if the value is &#34;123456&#34; and bufferSize is 4, the function places &#34;123&#34; into the buffer and returns 7.
        /// 
        /// If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
        /// 
        /// If you pass 0, you can pass VI_NULL for the coercionRecord buffer parameter.
        /// 
        /// The function returns an empty string in the coercionRecord parameter if no coercion records remain for the session.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Buffer_Size">
        /// 
        /// 
        /// bufferSize
        /// ViInt32
        /// Specifies the number of bytes in the ViChar array you specify for the coercionRecord parameter.
        /// 
        /// If the next coercion record string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies bufferSize &#8211; 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size that you must pass to get the entire value.  For example, if the value is &#34;123456&#34; and the buffer size is 4, the function places &#34;123&#34; into the buffer and returns 7.
        /// 
        /// If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
        /// 
        /// If you pass 0, you can pass VI_NULL for the coercionRecord buffer parameter.
        /// 
        /// Default Value:  None
        ///  
        /// </param>
        /// <param name="Coercion_Record">
        /// 
        /// 
        /// coercionRecord
        /// ViChar[]
        /// Returns the next coercion record for the IVI session.  If there are no coercion records, the function returns an empty string.
        /// 
        /// The buffer must contain at least as many elements as the value you specify with the bufferSize parameter.  If the next coercion record string, including the terminating NUL byte, contains more bytes than you indicate with the bufferSize parameter, the function copies bufferSize &#8211; 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size that you must pass to get the entire value.  For example, if the value is &#34;123456&#34; and bufferSize is 4, the function places &#34;123&#34; into the buffer and returns 7.
        /// 
        /// This parameter returns an empty string if no coercion records remain for the session.
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call   niFgen_error_message. To obtain additional information about the error condition, call   niFgen_GetError. To clear the error information from NI-FGEN, call   niFgen_ClearError. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int GetNextCoercionRecord(int Buffer_Size, System.Text.StringBuilder Coercion_Record)
        {
            int pInvokeResult = PInvoke.GetNextCoercionRecord(this._handle, Buffer_Size, Coercion_Record);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_error_query
        /// 
        /// ViStatus niFgen_error_query (ViSession vi, ViInt32* errorCode, ViChar[] errorMessage);
        /// 
        /// Purpose
        /// 
        /// Reads an error code and a message from the instrument error queue.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Error_Code">
        /// 
        /// 
        /// errorCode
        /// ViInt32*
        /// Returns the error code read from the instrument error queue.
        ///  
        /// </param>
        /// <param name="Error_Message">
        /// 
        /// 
        /// errorMessage
        /// ViChar[]
        /// Returns the error message string read from the instrument error message queue.
        /// 
        /// You must pass a ViChar array with at least 256 bytes.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int error_query(out int Error_Code, System.Text.StringBuilder Error_Message)
        {
            int pInvokeResult = PInvoke.error_query(this._handle, out Error_Code, Error_Message);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ErrorHandler
        /// 
        /// ViStatus niFgen_ErrorHandler (ViSession vi, ViStatus errorCode, ViChar[] errorMessage);
        /// 
        /// Purpose
        /// 
        /// Converts a status code returned by an NI-FGEN function into a user-readable string and returns any error elaborations.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitWithOptions functions and identifies a
        ///             particular instrument session.  
        /// You can pass VI_NULL for this parameter.  Passing VI_NULL is useful when one of the initialize functions fail.
        /// 
        /// Default Value:  VI_NULL
        /// 
        ///  
        /// </param>
        /// <param name="Error_Code">
        /// 
        /// 
        /// errorCode
        /// ViStatus
        /// Specifies the status parameter that is returned from any of the NI-FGEN functions.
        /// 
        /// Default Value:  0  (VI_SUCCESS)
        /// 
        ///  
        /// </param>
        /// <param name="Error_Message">
        /// 
        /// 
        /// errorMessage
        /// ViChar[]
        /// Returns the error message string read from the instrument error message queue.
        /// 
        /// You must pass a ViChar array with at least 256 bytes.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ErrorHandler(int Error_Code, System.Text.StringBuilder Error_Message)
        {
            int pInvokeResult = PInvoke.ErrorHandler(this._handle, Error_Code, Error_Message);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_GetNextInterchangeWarning
        /// 
        /// ViStatus niFgen_GetNextInterchangeWarning (ViSession vi, ViInt32 bufferSize, ViChar[] interchangeWarning);
        /// 
        /// Purpose
        /// 
        /// Returns the interchangeability warnings associated with the IVI session. It retrieves and clears the oldest instance in which the class driver recorded an interchangeability warning.  Interchangeability warnings indicate that using your application with a different instrument might cause different behavior. Use this function to retrieve interchangeability warnings.
        /// 
        /// NI-FGEN performs interchangeability checking when the NIFGEN_ATTR_INTERCHANGE_CHECK attribute is set to VI_TRUE.
        /// 
        /// The function returns an empty string in the interchangeWarning parameter if no interchangeability warnings remain for the session.
        /// 
        /// In general, NI-FGEN generates interchangeability warnings when an attribute that affects the behavior of the instrument is in a state that you did not specify.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Buffer_Size">
        /// 
        /// 
        /// bufferSize
        /// ViInt32
        /// Specifies the number of bytes in the ViChar array you specify for the interchangeWarning parameter.
        /// 
        /// If the next interchangeability warning string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies bufferSize &#8211; 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size that you must pass to get the entire value. For example, if the value is &#34;123456&#34; and bufferSize is 4, the function places &#34;123&#34; into the buffer and returns 7.
        /// 
        /// If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
        /// 
        /// If you pass 0, you can pass VI_NULL for the interchangeWarning buffer parameter.
        /// 
        /// Default Value:  None
        /// 
        ///  
        /// 
        /// </param>
        /// <param name="Interchange_Warning">
        /// 
        /// 
        /// interchangeWarning
        /// ViChar[]
        /// Returns the next interchange warning for the IVI session. If there are no interchange warnings, the function returns an empty string.
        /// 
        /// The buffer must contain at least as many elements as the value you specify with the bufferSize parameter. If the next interchangeability warning string, including the terminating NUL byte, contains more bytes than you indicate with the bufferSize parameter, the function copies bufferSize &#8211; 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size that you must pass to get the entire value.  For example, if the value is &#34;123456&#34; and bufferSize is 4, the function places &#34;123&#34; into the buffer and returns 7.
        /// 
        /// This parameter returns an empty string if no interchangeability warnings remain for the session.
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call   niFgen_error_message. To obtain additional information about the error condition, call   niFgen_GetError. To clear the error information from NI-FGEN, call   niFgen_ClearError. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int GetNextInterchangeWarning(int Buffer_Size, System.Text.StringBuilder Interchange_Warning)
        {
            int pInvokeResult = PInvoke.GetNextInterchangeWarning(this._handle, Buffer_Size, Interchange_Warning);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ClearInterchangeWarnings
        /// 
        /// ViStatus niFgen_ClearInterchangeWarnings (ViSession vi);
        /// 
        /// Purpose
        /// 
        /// Clears the list of current interchange warnings.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ClearInterchangeWarnings()
        {
            int pInvokeResult = PInvoke.ClearInterchangeWarnings(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ResetInterchangeCheck
        /// 
        /// ViStatus niFgen_ResetInterchangeCheck (ViSession vi);
        /// 
        /// Purpose
        /// 
        /// When developing a complex test system that consists of multiple test modules, it is generally a good idea to design the test modules so that they can run in any order.  To do so requires ensuring that each test module completely configures the state of each instrument it uses.  If a particular test module does not completely configure the state of an instrument, the state of the instrument depends on the configuration from a previously executed test module.  If you execute the test modules in a different order, the behavior of the instrument and therefore the entire test module is likely to change.  This change in behavior is generally instrument specific and represents an interchangeability problem.
        /// 
        /// You can use this function to test for such cases.  After you call this function, the interchangeability checking algorithms in the specific driver ignore all previous configuration operations.  By calling this function at the beginning of a test module, you can determine whether the test module has dependencies on the operation of previously executed test modules.
        /// 
        /// This function does not clear the interchangeability warnings from the list of previously recorded interchangeability warnings.  If you want to guarantee that the niFgen_GetNextInterchangeWarning function only returns those interchangeability warnings that are generated after calling this function, you must clear the list of interchangeability warnings.  You can clear the interchangeability warnings list by repeatedly calling the niFgen_GetNextInterchangeWarning function until no more interchangeability warnings are returned.  If you are not interested in the content of those warnings, you can call the  niFgen_ClearInterchangeWarnings function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ResetInterchangeCheck()
        {
            int pInvokeResult = PInvoke.ResetInterchangeCheck(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_CloseExtCal
        /// 
        /// ViStatus niFgen_CloseExtCal (ViSession vi, ViInt32 action);
        /// 
        /// Purpose
        /// 
        /// Closes an NI-FGEN external calibration session and, if specified, stores the new calibration constants and calibration data, such as time and temperature, in the onboard EEPROM.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Action">
        /// 
        /// 
        /// action
        /// ViInt32
        /// Specifies he action to perform upon closing. 
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_EXT_CAL_ABORT
        /// No changes are made to the calibration constants and data in the EEPROM.
        /// 
        /// NIFGEN_VAL_EXT_CAL_COMMIT
        /// The new calibration constants and data determined during the external calibration session are stored in the onboard EEPROM.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int CloseExtCal(int Action)
        {
            int pInvokeResult = PInvoke.CloseExtCal(this._handle, Action);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_SelfCal
        /// 
        /// ViStatus niFgen_SelfCal (ViSession vi);
        /// 
        /// Purpose
        /// 
        /// Performs a full internal (self-) calibration on the device.  If the calibration is successful, new calibration data and constants are stored in the onboard EEPROM.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int SelfCal()
        {
            int pInvokeResult = PInvoke.SelfCal(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_InitializeAnalogOutputCalibration
        /// 
        /// ViStatus niFgen_InitializeAnalogOutputCalibration (ViSession vi);
        /// 
        /// Purpose
        /// 
        /// This function sets up the device to start the analog output calibration.
        /// 
        /// The session handle should be the handle returned by niFgen_InitExtCal.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int InitializeAnalogOutputCalibration()
        {
            int pInvokeResult = PInvoke.InitializeAnalogOutputCalibration(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_WriteBinary16AnalogStaticValue
        /// 
        /// ViStatus niFgen_WriteBinary16AnalogStaticValue  (ViSession vi, ViConstString channelName, ViInt16 value);
        /// 
        /// Purpose
        /// 
        /// Writes a 16-bit value to the DAC, which can be generated as a DC voltage. This function writes to the DAC only within an external calibration session.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to write the value.  
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Value">
        /// 
        /// 
        /// value
        /// ViInt16
        /// Specifies the value to write.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int WriteBinary16AnalogStaticValue(string Channel_Name, short Value)
        {
            int pInvokeResult = PInvoke.WriteBinary16AnalogStaticValue(this._handle, Channel_Name, Value);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_CalAdjustMainPathPreAmpOffset
        /// 
        /// ViStatus niFgen_CalAdjustMainPathPreAmpOffset (ViSession vi, ViConstString channelName, ViInt32 configuration, ViInt32[] gainDACValues, ViInt32[] offsetDACValues, ViReal64[] measuredOutputs);
        /// 
        /// Purpose
        /// 
        /// Calculates calibration constants pertaining to the preamplifier offset of the main analog path. During external calibration, you can put the device in different configurations; program different gain, offset, and main DAC values; and take measurements of the resulting output voltage. Pass the configuration data, as well as the measurements, to this function to allow NI-FGEN to calculate the appropriate calibration constants and store them in the onboard EEPROM when the calibration session is committed.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the name of the channel being calibrated.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Configuration">
        /// 
        /// 
        /// configuration
        /// ViInt32
        /// Specifies the preamplifier stage configuration.
        ///  
        /// </param>
        /// <param name="Gain_DAC_Values">
        /// 
        /// 
        /// gainDACValues
        /// ViInt32[]
        /// Specifies an array of the values programmed to the gain calibration DAC during this calibration stage.
        ///  
        /// </param>
        /// <param name="Offset_DAC_Values">
        /// 
        /// 
        /// offsetDACValues
        /// ViInt32[]
        /// Specifies an array of the values programmed to the offset calibration DAC during this calibration stage.
        ///  
        /// </param>
        /// <param name="Measured_Outputs">
        /// 
        /// 
        /// measuredOutputs
        /// ViReal64[]
        /// Specifies an array of the analog output voltages measured during this calibration stage.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int CalAdjustMainPathPreAmpOffset(string Channel_Name, int Configuration, int[] Gain_DAC_Values, int[] Offset_DAC_Values, double[] Measured_Outputs)
        {
            int pInvokeResult = PInvoke.CalAdjustMainPathPreAmpOffset(this._handle, Channel_Name, Configuration, Gain_DAC_Values, Offset_DAC_Values, Measured_Outputs);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_CalAdjustMainPathPreAmpGain
        /// 
        /// ViStatus niFgen_CalAdjustMainPathPreAmpGain (ViSession vi, ViConstString channelName, ViInt32 configuration, ViInt32[] mainDACValues, ViInt32[] gainDACValues, ViInt32[] offsetDACValues, ViReal64[] measuredOutputs);
        /// 
        /// Purpose
        /// 
        /// Calculates calibration constants pertaining to the preamplifier gain of the main analog path. During external calibration, you can put the device in different configurations; program different gain, offset, and main DAC values; and take measurements of the resulting output voltage. Pass the configuration data, as well as the measurements to this function to allow NI-FGEN to calculate the appropriate calibration constants and store them in the onboard EEPROM when the calibration session is committed.
        /// 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the name of the channel being calibrated.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Configuration">
        /// 
        /// 
        /// configuration
        /// ViInt32
        /// Specifies the preamplifier stage configuration.
        ///  
        /// </param>
        /// <param name="Main_DAC_Values">
        /// 
        /// 
        /// mainDACValues
        /// ViInt32[]
        /// Specifies an array of the values programmed to the main output DAC during this calibration stage.
        ///  
        /// </param>
        /// <param name="Gain_DAC_Values">
        /// 
        /// 
        /// gainDACValues
        /// ViInt32[]
        /// Specifies an array of the values programmed to the gain calibration DAC during this calibration stage.
        ///  
        /// </param>
        /// <param name="Offset_DAC_Values">
        /// 
        /// 
        /// offsetDACValues
        /// ViInt32[]
        /// Specifies an array of the values programmed to the offset calibration DAC during this calibration stage.
        ///  
        /// </param>
        /// <param name="Measured_Outputs">
        /// 
        /// 
        /// measuredOutputs
        /// ViReal64[]
        /// Specifies an array of the analog output voltages measured during this calibration stage.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int CalAdjustMainPathPreAmpGain(string Channel_Name, int Configuration, int[] Main_DAC_Values, int[] Gain_DAC_Values, int[] Offset_DAC_Values, double[] Measured_Outputs)
        {
            int pInvokeResult = PInvoke.CalAdjustMainPathPreAmpGain(this._handle, Channel_Name, Configuration, Main_DAC_Values, Gain_DAC_Values, Offset_DAC_Values, Measured_Outputs);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_CalAdjustMainPathPostAmpGainAndOffset
        /// 
        /// ViStatus niFgen_CalAdjustMainPathPostAmpGainAndOffset (ViSession vi, ViConstString channelName, ViInt32 configuration, ViInt32[] mainDACValues, ViInt32[] gainDACValues, ViInt32[] offsetDACValues, ViReal64[] measuredOutputs);
        /// 
        /// Purpose
        /// 
        /// Calculates calibration constants pertaining to the postamplifier gain and offset of the main analog path. During external calibration, you can put the device in different configurations; program different gain, offset, and main DAC values; and take measurements of the resulting output voltage.  Pass the configuration data, as well as the measurements to this function to allow NI-FGEN to calculate the appropriate calibration constants and store them in the onboard EEPROM when the calibration session is committed.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the name of the channel being calibrated.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Configuration">
        /// 
        /// 
        /// configuration
        /// ViInt32
        /// Specifies the postamplifier stage configuration.
        ///  
        /// </param>
        /// <param name="Main_DAC_Values">
        /// 
        /// 
        /// mainDACValues
        /// ViInt32[]
        /// Specifies an array of the values programmed to the main output DAC during this calibration stage.
        ///  
        /// </param>
        /// <param name="Gain_DAC_Values">
        /// 
        /// 
        /// gainDACValues
        /// ViInt32[]
        /// Specifies an array of the values programmed to the gain calibration DAC during this calibration stage.
        ///  
        /// </param>
        /// <param name="Offset_DAC_Values">
        /// 
        /// 
        /// offsetDACValues
        /// ViInt32[]
        /// Specifies an array of the values programmed to the offset calibration DAC during this calibration stage.
        ///  
        /// </param>
        /// <param name="Measured_Outputs">
        /// 
        /// 
        /// measuredOutputs
        /// ViReal64[]
        /// Specifies an array of the analog output voltages measured during this calibration stage.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int CalAdjustMainPathPostAmpGainAndOffset(string Channel_Name, int Configuration, int[] Main_DAC_Values, int[] Gain_DAC_Values, int[] Offset_DAC_Values, double[] Measured_Outputs)
        {
            int pInvokeResult = PInvoke.CalAdjustMainPathPostAmpGainAndOffset(this._handle, Channel_Name, Configuration, Main_DAC_Values, Gain_DAC_Values, Offset_DAC_Values, Measured_Outputs);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_CalAdjustDirectPathGain
        /// 
        /// ViStatus niFgen_CalAdjustDirectPathGain (ViSession vi, ViConstString channelName, ViInt32[] mainDACValues, ViInt32[] gainDACValues, ViReal64[] measuredOutputs);
        /// 
        /// Purpose
        /// 
        /// Calculates calibration constants pertaining to the gain of the direct analog path. During external calibration, you can put the device in different configurations; program different gain and main DAC values; and take measurements of the resulting output voltage. Pass the configuration data, as well as the measurements, to this function to allow NI-FGEN to calculate the appropriate calibration constants and store them in the onboard EEPROM when the calibration session is committed.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the name of the channel being calibrated.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Main_DAC_Values">
        /// 
        /// 
        /// mainDACValues
        /// ViInt32[]
        /// Specifies an array of the values programmed to the main output DAC during this calibration stage.
        ///  
        /// </param>
        /// <param name="Gain_DAC_Values">
        /// 
        /// 
        /// gainDACValues
        /// ViInt32[]
        /// Specifies an array of the values programmed to the gain calibration DAC during this calibration stage.
        ///  
        /// </param>
        /// <param name="Measured_Outputs">
        /// 
        /// 
        /// measuredOutputs
        /// ViReal64[]
        /// Specifies an array of the analog output voltages measured during this calibration stage.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int CalAdjustDirectPathGain(string Channel_Name, int[] Main_DAC_Values, int[] Gain_DAC_Values, double[] Measured_Outputs)
        {
            int pInvokeResult = PInvoke.CalAdjustDirectPathGain(this._handle, Channel_Name, Main_DAC_Values, Gain_DAC_Values, Measured_Outputs);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_CalAdjustMainPathOutputImpedance
        /// 
        /// ViStatus niFgen_CalAdjustMainPathOutputImpedance (ViSession vi, ViConstString channelName, ViInt32 configuration, ViReal64 loadImpedance, ViReal64 measuredSourceVoltage, ViReal64 measuredVoltageAcrossLoad);
        /// 
        /// Purpose
        /// 
        /// Calculates calibration constants pertaining to main analog path output impedance.  During external calibration, you can put the device in different configurations and take measurements of the resulting output voltage across different loads.  Pass the configuration data, as well as the measurements, to this function to allow NI-FGEN to calculate the appropriate calibration constants and store them in the onboard EEPROM when the calibration session is committed.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the name of the channel being calibrated.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Configuration">
        /// 
        /// 
        /// configuration
        /// ViInt32
        /// Specifies the main path output impedance configuration.
        ///  
        /// </param>
        /// <param name="Load_Impedance">
        /// 
        /// 
        /// loadImpedance
        /// ViReal64
        /// Specifies the impedance of the load across which the measurement passed in as measuredVoltageAcrossLoad is taken.
        ///  
        /// </param>
        /// <param name="Measured_Source_Voltage">
        /// 
        /// 
        /// measuredSourceVoltage
        /// ViReal64
        /// Specifies the analog output voltage measured across a very high-impedance load.
        ///  
        /// </param>
        /// <param name="Measured_Voltage_Across_Load">
        /// 
        /// 
        /// measuredVoltageAcrossLoad
        /// ViReal64
        /// Specifies the analog output voltage measured across the load impedance specified in the loadImpedance parameter.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int CalAdjustMainPathOutputImpedance(string Channel_Name, int Configuration, double Load_Impedance, double Measured_Source_Voltage, double Measured_Voltage_Across_Load)
        {
            int pInvokeResult = PInvoke.CalAdjustMainPathOutputImpedance(this._handle, Channel_Name, Configuration, Load_Impedance, Measured_Source_Voltage, Measured_Voltage_Across_Load);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_CalAdjustDirectPathOutputImpedance
        /// 
        /// ViStatus niFgen_CalAdjustDirectPathOutputImpedance (ViSession vi, ViConstString channelName, ViInt32 configuration, ViReal64 loadImpedance, ViReal64 measuredSourceVoltage, ViReal64 measuredVoltageAcrossLoad);
        /// 
        /// Purpose
        /// 
        /// Calculates calibration constants pertaining to direct analog path output impedance. During external calibration, you can put the device in different configurations and take measurements of the resulting output voltage across different loads. Pass the configuration data, as well as the measurements, to this function to allow NI-FGEN to calculate the appropriate calibration constants and store them in the onboard EEPROM when the calibration session is committed.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the name of the channel being calibrated.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Configuration">
        /// 
        /// 
        /// configuration
        /// ViInt32
        /// Specifies the direct path output impedance configuration.
        ///  
        /// </param>
        /// <param name="Load_Impedance">
        /// 
        /// 
        /// loadImpedance
        /// ViReal64
        /// Specifies the impedance of the load across which the measurement passed in as measuredVoltageAcrossLoad is taken.
        ///  
        /// </param>
        /// <param name="Measured_Source_Voltage">
        /// 
        /// 
        /// measuredSourceVoltage
        /// ViReal64
        /// Specifies the analog output voltage measured across a very high-impedance load.
        ///  
        /// </param>
        /// <param name="Measured_Voltage_Across_Load">
        /// 
        /// 
        /// measuredVoltageAcrossLoad
        /// ViReal64
        /// Specifies the analog output voltage measured across the load impedance specified in the loadImpedance parameter.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int CalAdjustDirectPathOutputImpedance(string Channel_Name, int Configuration, double Load_Impedance, double Measured_Source_Voltage, double Measured_Voltage_Across_Load)
        {
            int pInvokeResult = PInvoke.CalAdjustDirectPathOutputImpedance(this._handle, Channel_Name, Configuration, Load_Impedance, Measured_Source_Voltage, Measured_Voltage_Across_Load);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_InitializeOscillatorFrequencyCalibration
        /// 
        /// ViStatus niFgen_InitializeOscillatorFrequencyCalibration (ViSession vi);
        /// 
        /// Purpose
        /// 
        /// Sets up the device to start the VCXO calibration.
        /// 
        /// The session handle should be the handle returned by the niFgen_InitExtCal function.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int InitializeOscillatorFrequencyCalibration()
        {
            int pInvokeResult = PInvoke.InitializeOscillatorFrequencyCalibration(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_CalAdjustOscillatorFrequency
        /// 
        /// ViStatus niFgen_CalAdjustOscillatorFrequency (ViSession vi, ViReal64 desiredFrequency, ViReal64 measuredFrequency);
        /// 
        /// Purpose
        /// 
        /// Calculates calibration constants pertaining to the VCXO.  During external calibration, you can generate sine waves and take measurements of the resulting output frequency.  Pass the desired and measured frequencies to this function to allow NI-FGEN to calculate the appropriate calibration constants and store them in the onboard EEPROM when the calibration session is committed.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Desired_Frequency">
        /// 
        /// 
        /// desiredFrequency
        /// ViReal64
        /// Specifies the expected frequency of the output waveform.
        ///  
        /// </param>
        /// <param name="Measured_Frequency">
        /// 
        /// 
        /// measuredFrequency
        /// ViReal64
        /// Specifies the actual (measured) frequency of the output waveform.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int CalAdjustOscillatorFrequency(double Desired_Frequency, double Measured_Frequency)
        {
            int pInvokeResult = PInvoke.CalAdjustOscillatorFrequency(this._handle, Desired_Frequency, Measured_Frequency);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_InitializeCalADCCalibration
        /// 
        /// ViStatus niFgen_InitializeCalADCCalibration (ViSession vi);
        /// 
        /// Purpose
        /// 
        /// Initializes an external calibration session for ADC calibration.  For the NI 5421/5422/5441, calibration ADC calibration involves characterizing the gain and offset of the onboard calibration ADC.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int InitializeCalADCCalibration()
        {
            int pInvokeResult = PInvoke.InitializeCalADCCalibration(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_CalAdjustCalADC
        /// 
        /// ViStatus niFgen_calAdjustCalADC (ViSession vi, ViReal64[] voltagesMeasuredExternally, ViReal64[] voltagesMeasuredWithCalADC);
        /// 
        /// Purpose
        /// 
        /// Calculates calibration constants pertaining to the gain and offset of the onboard calibration ADC.  During external calibration, you can generate voltages and measure them both externally and with the calibration ADC.  Pass the measured voltages to this function to allow NI-FGEN to calculate the appropriate calibration constants and store them in the onboard EEPROM when the calibration session is committed.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Voltages_Measured_Externally">
        /// 
        /// 
        /// voltagesMeasuredExternally
        /// ViReal64[]
        /// Specifies an array of analog output voltages measured with an external instrument.
        ///  
        /// </param>
        /// <param name="Voltages_Measured_With_CalADC">
        /// 
        /// 
        /// voltagesMeasuredWithCalADC
        /// ViReal64[]
        /// Specifies an array of analog output voltages measured with the onboard calibration ADC.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int CalAdjustCalADC(double[] Voltages_Measured_Externally, double[] Voltages_Measured_With_CalADC)
        {
            int pInvokeResult = PInvoke.CalAdjustCalADC(this._handle, Voltages_Measured_Externally, Voltages_Measured_With_CalADC);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ReadCalADC
        /// 
        /// ViStatus niFgen_ReadCalADC (ViSession vi, ViInt32 numberofReadstoAverage, ViBoolean returnCalibratedValue, ViReal64* calADCValue);
        /// 
        /// Purpose
        /// 
        /// Takes one or more voltage measurements from the onboard calibration ADC and returns the value or the average value. The signal that the ADC actually measures can be specified using the NIFGEN_ATTR_CAL_ADC_INPUT attribute. The ADC has some inherent gain and offset. These values can be determined during an external calibration session and stored in the calibration EEPROM.
        /// 
        /// If the returnCalibratedValue parameter is VI_TRUE, NI-FGEN adjusts the value that is returned to account for the gain and offset of the ADC. Otherwise, the raw voltage value reported by the ADC is returned.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Number_of_Reads_to_Average">
        /// 
        /// 
        /// numberofReadstoAverage
        /// ViInt32
        /// Specifies the number of measurements to be taken and averaged to determine the return value.
        ///  
        /// </param>
        /// <param name="Return_Calibrated_Value">
        /// 
        /// 
        /// returnCalibratedValue
        /// ViBoolean
        /// Specifies whether the voltage returned from the ADC should be adjusted to account for the gain and offset of the ADC.
        ///  
        /// </param>
        /// <param name="Cal_ADC_Value">
        /// 
        /// 
        /// calADCValue
        /// ViReal64*
        /// Specifies the average of the voltage measurements taken from the onboard calibration ADC.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ReadCalADC(int Number_of_Reads_to_Average, bool Return_Calibrated_Value, out double Cal_ADC_Value)
        {
            int pInvokeResult = PInvoke.ReadCalADC(this._handle, Number_of_Reads_to_Average, System.Convert.ToUInt16(Return_Calibrated_Value), out Cal_ADC_Value);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_InitializeFlatnessCalibration
        /// 
        /// ViStatus niFgen_InitializeFlatnessCalibration (ViSession vi);
        /// 
        /// Purpose
        /// 
        /// Initializes an external calibration session to calibrate flatness.
        /// 
        /// The session handle should be the handle returned by the niFgen_InitExtCal function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the  niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int InitializeFlatnessCalibration()
        {
            int pInvokeResult = PInvoke.InitializeFlatnessCalibration(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_CalAdjustFlatness
        /// 
        /// ViStatus niFgen_CalAdjustFlatness (ViSession vi, ViConstString channelName, ViInt32 configuration, ViReal64 requestedAmplitude, ViReal64[] frequencies, ViReal64[] measuredAmplitudes, ViInt32 numberOfMeasurements);
        /// 
        /// Purpose
        /// 
        /// Calculates calibration constants pertaining to the VCXO.  During external calibration, you can generate sine waves and take measurements of the resulting output frequency.  The desired and measured frequencies are passed to this function so that NI-FGEN can calculate the appropriate calibration constants and, when the calibration session is committed, store them in the onboard EEPROM.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the name of the channel being calibrated.
        /// 
        /// 
        /// Default Value: &#34;0&#34;
        ///  
        /// </param>
        /// <param name="Configuration">
        /// 
        /// 
        /// configuration
        /// ViInt32
        /// Specifies the main path configuration.
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Requested_Amplitude">
        /// 
        /// 
        /// requestedAmplitude
        /// ViReal64
        /// Specifies the desired amplitude of the output waveform.
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Frequencies">
        /// 
        /// 
        /// frequencies
        /// ViReal64[]
        /// Specifies the frequencies of the output waveform.
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Measured_Amplitudes">
        /// 
        /// 
        /// measuredAmplitudes
        /// ViReal64[]
        /// Specifies the actual (measured) amplitudes of the output waveform.
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Number_Of_Measurements">
        /// 
        /// 
        /// numberofMeasurements
        /// ViInt32
        /// Specifies the number of measurements to take.
        /// 
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int CalAdjustFlatness(string Channel_Name, int Configuration, double Requested_Amplitude, double[] Frequencies, double[] Measured_Amplitudes, int Number_Of_Measurements)
        {
            int pInvokeResult = PInvoke.CalAdjustFlatness(this._handle, Channel_Name, Configuration, Requested_Amplitude, Frequencies, Measured_Amplitudes, Number_Of_Measurements);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_GetSelfCalSupported
        /// 
        /// ViStatus niFgen_GetSelfCalSupported (ViSession vi, ViBoolean* selfCalSupported);
        /// 
        /// Purpose
        /// 
        /// Returns whether the device supports self&#8211;calibration.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitWithOptions  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Self_Cal_Supported">
        /// 
        /// 
        /// selfCalSupported
        /// ViBoolean*
        /// Returns whether the device supports self-calibration. 
        /// 
        /// Defined Values
        /// VI_TRUE Self&#8211;calibration is supported.  VI_FALSESelf&#8211;calibration is not supported.
        ///  
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int GetSelfCalSupported(out bool Self_Cal_Supported)
        {
            ushort Self_Cal_SupportedAsUShort;
            int pInvokeResult = PInvoke.GetSelfCalSupported(this._handle, out Self_Cal_SupportedAsUShort);
            Self_Cal_Supported = System.Convert.ToBoolean(Self_Cal_SupportedAsUShort);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_GetSelfCalLastDateAndTime
        /// 
        /// ViStatus niFgen_GetSelfCalLastDateAndTime  (ViSession vi, ViInt32* year, ViInt32* month, ViInt32* day, ViInt32* hour, ViInt32* minute);
        /// 
        /// Purpose
        /// 
        /// Returns the date and time of the last successful self-calibration.  The time returned is 24-hour (military) local time; for example, if the device was calibrated at 2:30 PM, this function returns 14 for the hours parameter and 30 for the minutes parameter.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Year">
        /// 
        /// 
        /// year
        /// ViInt32*
        /// Specifies the year of the last successful calibration.
        ///  
        /// </param>
        /// <param name="Month">
        /// 
        /// 
        /// month
        /// ViInt32*
        /// Specifies the month of the last successful calibration.
        ///  
        /// </param>
        /// <param name="Day">
        /// 
        /// 
        /// day
        /// ViInt32*
        /// Specifies the day of the last successful calibration.
        ///  
        /// </param>
        /// <param name="Hour">
        /// 
        /// 
        /// hour
        /// ViInt32*
        /// Specifies the hour of the last successful calibration.
        ///  
        /// </param>
        /// <param name="Minute">
        /// 
        /// 
        /// minute
        /// ViInt32*
        /// Specifies the minute of the last successful calibration.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int GetSelfCalLastDateAndTime(out int Year, out int Month, out int Day, out int Hour, out int Minute)
        {
            int pInvokeResult = PInvoke.GetSelfCalLastDateAndTime(this._handle, out Year, out Month, out Day, out Hour, out Minute);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_GetExtCalLastDateAndTime
        /// 
        /// ViStatus niFgen_GetExtCalLastDateAndTime (ViSession vi, ViInt32* year, ViInt32* month, ViInt32* day, ViInt32* hour, ViInt32* minute);
        /// 
        /// Purpose
        /// 
        /// Returns the date and time of the last successful external calibration.  The time returned is 24-hour (military) local time; for example, if the device was calibrated at 2:30 PM, this function returns 14 for the hours parameter and 30 for the minutes parameter.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Year">
        /// 
        /// 
        /// year
        /// ViInt32*
        /// Specifies the year of the last successful calibration.
        ///  
        /// </param>
        /// <param name="Month">
        /// 
        /// 
        /// month
        /// ViInt32*
        /// Specifies the month of the last successful calibration.
        ///  
        /// </param>
        /// <param name="Day">
        /// 
        /// 
        /// day
        /// ViInt32*
        /// Specifies the day of the last successful calibration.
        ///  
        /// </param>
        /// <param name="Hour">
        /// 
        /// 
        /// hour
        /// ViInt32*
        /// Specifies the hour of the last successful calibration.
        ///  
        /// </param>
        /// <param name="Minute">
        /// 
        /// 
        /// minute
        /// ViInt32*
        /// Specifies the minute of the last successful calibration.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int GetExtCalLastDateAndTime(out int Year, out int Month, out int Day, out int Hour, out int Minute)
        {
            int pInvokeResult = PInvoke.GetExtCalLastDateAndTime(this._handle, out Year, out Month, out Day, out Hour, out Minute);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_GetSelfCalLastTemp
        /// 
        /// ViStatus niFgen_GetSelfCalLastTemp (ViSession vi, ViReal64* temperature);
        /// 
        /// Purpose
        /// 
        /// Returns the temperature at the last successful self-calibration.  The temperature is returned in degrees Celsius.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Temperature">
        /// 
        /// 
        /// temperature
        /// ViReal64*
        /// Specifies the temperature at the last successful calibration.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int GetSelfCalLastTemp(out double Temperature)
        {
            int pInvokeResult = PInvoke.GetSelfCalLastTemp(this._handle, out Temperature);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_GetExtCalLastTemp
        /// 
        /// ViStatus niFgen_GetExtCalLastTemp (ViSession vi, ViReal64* temperature);
        /// 
        /// Purpose
        /// 
        /// Returns the temperature at the last successful external calibration.  The temperature is returned in degrees Celsius.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Temperature">
        /// 
        /// 
        /// temperature
        /// ViReal64*
        /// Specifies the temperature at the last successful calibration.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int GetExtCalLastTemp(out double Temperature)
        {
            int pInvokeResult = PInvoke.GetExtCalLastTemp(this._handle, out Temperature);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_GetExtCalRecommendedInterval
        /// 
        /// ViStatus niFgen_GetExtCalRecommendedInterval (ViSession vi, ViInt32* months);
        /// 
        /// Purpose
        /// 
        /// Returns the recommended interval between external calibrations in months.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Months">
        /// 
        /// 
        /// months
        /// ViInt32*
        /// Specifies the recommended interval between external calibrations in months.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int GetExtCalRecommendedInterval(out int Months)
        {
            int pInvokeResult = PInvoke.GetExtCalRecommendedInterval(this._handle, out Months);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ChangeExtCalPassword
        /// 
        /// ViStatus niFgen_ChangeExtCalPassword (ViSession vi, ViConstString oldPassword, ViConstString newPassword);
        /// 
        /// Purpose
        /// 
        /// Changes the password that is required to initialize an external calibration session.  The password may be up to four characters long.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Old_Password">
        /// 
        /// 
        /// oldPassword
        /// ViConstString
        /// Specifies the old (current) external calibration password.
        ///  
        /// </param>
        /// <param name="New_Password">
        /// 
        /// 
        /// newPassword
        /// ViConstString
        /// Specifies the new (desired) external calibration password.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ChangeExtCalPassword(string Old_Password, string New_Password)
        {
            int pInvokeResult = PInvoke.ChangeExtCalPassword(this._handle, Old_Password, New_Password);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_SetCalUserDefinedInfo
        /// 
        /// ViStatus niFgen_SetCalUserDefinedInfo (ViSession vi, ViConstString info);
        /// 
        /// Purpose
        /// 
        /// Stores user-defined information in the onboard EEPROM.  Call the niFgen_GetCalUserDefinedInfoMaxSize function to determine the number of characters that can be stored.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Info">
        /// 
        /// 
        /// info
        /// ViConstString
        /// Specifies the information string that should be stored in the EEPROM.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int SetCalUserDefinedInfo(string Info)
        {
            int pInvokeResult = PInvoke.SetCalUserDefinedInfo(this._handle, Info);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_GetCalUserDefinedInfo
        /// 
        /// ViStatus niFgen_GetCalUserDefinedInfo (ViSession vi, ViString info);
        /// 
        /// Purpose
        /// 
        /// Retrieves user-defined information from the onboard EEPROM.  Call the niFgen_GetCalUserDefinedInfoMaxSize  function to determine the number of characters that can be retrieved.  The buffer you provide should be the size of the maximum number of characters stored plus one termination character.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Info">
        /// 
        /// 
        /// info
        /// ViString
        /// Specifies a string into which the user information is copied.  This parameter must point to a character buffer large enough to hold the information string.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int GetCalUserDefinedInfo(string Info)
        {
            int pInvokeResult = PInvoke.GetCalUserDefinedInfo(this._handle, Info);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_GetCalUserDefinedInfoMaxSize
        /// 
        /// ViStatus niFgen_GetCalUserDefinedInfoMaxSize (ViSession vi, ViInt32* infoSize);
        /// 
        /// Purpose
        /// 
        /// Returns the maximum number of characters (excluding the termination character) of user-defined information that can be stored in the onboard EEPROM.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Info_Size">
        /// 
        /// 
        /// infoSize
        /// ViInt32*
        /// Specifies the maximum number of characters of user defined info that can be stored in the onboard EEPROM.
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int GetCalUserDefinedInfoMaxSize(out int Info_Size)
        {
            int pInvokeResult = PInvoke.GetCalUserDefinedInfoMaxSize(this._handle, out Info_Size);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_ReadCurrentTemperature
        /// 
        /// ViStatus niFgen_ReadCurrentTemperature (ViSession vi, ViReal64* temperature);
        /// 
        /// Purpose
        /// 
        /// Reads the current onboard temperature of the device. The temperature is returned in degrees Celsius.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Temperature">
        /// 
        /// 
        /// Temperature
        /// ViReal64*
        /// Returns the current temperature read from onboard temperature sensors (degrees Celsius).
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ReadCurrentTemperature(out double Temperature)
        {
            int pInvokeResult = PInvoke.ReadCurrentTemperature(this._handle, out Temperature);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// niFgen_RestoreLastExtCalConstants
        /// 
        /// ViStatus niFgen_RestoreLastExtCalConstants (ViSession vi);
        /// 
        /// Purpose
        /// 
        /// Overwrites the current calibration constants with those from the last successful external calibration. This action effectively undoes any self-calibrations performed since the last time an external calibration was performed. This function should be used if a self-calibration produced invalid calibration constants.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int RestoreLastExtCalConstants()
        {
            int pInvokeResult = PInvoke.RestoreLastExtCalConstants(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// [OBSOLETE] niFgen_ConfigureTriggerSource
        /// 
        /// ViStatus niFgen_ConfigureTriggerSource (ViSession vi, ViConstString channelName, ViInt32 triggerSource);
        /// 
        /// Purpose
        /// 
        /// Configures the trigger source. The signal generator responds to a trigger depending on the operation mode in which the signal generator is operating.
        /// 
        /// 
        /// Note   The signal generator must not be in the Generating state when you call this function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Channel_Name">
        /// 
        /// 
        /// channelName
        /// ViConstString
        /// Specifies the channel name for which you want to configure the trigger source.
        /// 
        /// Defined Value:&#34;0&#34;
        /// 
        ///  
        /// </param>
        /// <param name="Trigger_Source">
        /// 
        /// 
        /// triggerSource
        /// ViInt32
        /// Controls which trigger source the signal generator uses.
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_IMMEDIATE
        /// Immediate
        /// 
        /// NIFGEN_VAL_EXTERNAL
        /// External (maps to PFI 0)
        /// 
        /// NIFGEN_VAL_SOFTWARE_TRIG
        /// Software trigger
        /// 
        /// NIFGEN_VAL_PXI_STAR
        /// PXI star
        /// 
        /// NIFGEN_VAL_RTSI_0
        /// RTSI 0 or PXI_Trig 0
        /// 
        /// NIFGEN_VAL_RTSI_1
        /// RTSI 1 or PXI_Trig 1
        /// 
        /// NIFGEN_VAL_RTSI_2
        /// RTSI 2 or PXI_Trig 2
        /// 
        /// NIFGEN_VAL_RTSI_3
        /// RTSI 3 or PXI_Trig 3
        /// 
        /// NIFGEN_VAL_RTSI_4
        /// RTSI 4 or PXI_Trig 4
        /// 
        /// NIFGEN_VAL_RTSI_5
        /// RTSI 5 or PXI_Trig 5
        /// 
        /// NIFGEN_VAL_RTSI_6
        /// RTSI 6 or PXI_Trig 6
        /// 
        /// NIFGEN_VAL_RTSI_7
        /// RTSI 7 or PXI_Trig 7
        /// 
        /// NIFGEN_VAL_TTL0
        /// TTL 0
        /// 
        /// NIFGEN_VAL_TTL1
        /// TTL 1
        /// 
        /// NIFGEN_VAL_TTL2
        /// TTL 2
        /// 
        /// NIFGEN_VAL_TTL3
        /// TTL 3
        /// 
        /// NIFGEN_VAL_TTL4
        /// TTL 4
        /// 
        /// NIFGEN_VAL_TTL5
        /// TTL 5
        /// 
        /// NIFGEN_VAL_TTL6
        /// TTL 6
        /// 
        /// NIFGEN_VAL_PFI_0
        /// PFI 0
        /// 
        /// NIFGEN_VAL_PFI_1
        /// PFI 1
        /// 
        /// NIFGEN_VAL_PFI_2
        /// PFI 2
        /// 
        /// NIFGEN_VAL_PFI_3
        /// PFI 3
        /// 
        /// Default Value: NIFGEN_VAL_IMMEDIATE
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureTriggerSource(string Channel_Name, int Trigger_Source)
        {
            int pInvokeResult = PInvoke.ConfigureTriggerSource(this._handle, Channel_Name, Trigger_Source);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// [OBSOLETE] niFgen_CreateArbWaveform
        /// 
        /// ViStatus niFgen_CreateArbWaveform (ViSession vi, ViInt32 waveformSize, ViReal64[] waveformDataArray, ViInt32* waveformHandle);
        /// 
        /// Purpose
        /// 
        /// [OBSOLETE] This function is obsolete.  Use the niFgen_CreateWaveformF64, niFgen_CreateWaveformI16, or niFgen_CreateWaveformComplexF64 function instead of this function.
        /// 
        /// Creates an arbitrary waveform and returns a handle that identifies that waveform. You can pass this handle to the niFgen_ConfigureArbWaveform function to produce that waveform. You can also use the handles this function returns to specify a sequence of arbitrary waveforms with the niFgen_CreateArbSequence function.
        /// 
        /// 
        /// Note  You must set the output mode to NIFGEN_VAL_OUTPUT_ARB before calling this function.
        /// 
        /// 
        /// Note  You must scale the data between &#8211;1.00 and +1.00. Use the arbGain parameter to generate different output voltages.
        /// 
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Waveform_Size">
        /// 
        /// 
        /// waveformSize
        /// ViInt32
        /// Specifies the size of the arbitrary waveform that you want created.
        /// 
        /// The size must meet the following restrictions:
        /// 
        /// 
        /// 
        /// The size must be less than or equal to the maximum waveform size that the device allows.
        /// The size must be greater than or equal to the minimum waveform size that the device allows.
        /// The size must be an integer multiple of the device waveform quantum.
        /// 
        /// 
        /// 
        /// You can obtain these values from the maximumWaveformSize, minimumWaveformSize, and waveformQuantum parameters in the niFgen_QueryArbWfmCapabilities function.
        /// 
        /// Default Value: None
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Waveform_Data_Array">
        /// 
        /// 
        /// waveformDataArray
        /// ViReal64[]
        /// Specifies the array of data you want to use for the new arbitrary waveform. The array must have at least as many elements as the value that you specify in waveformSize.
        /// 
        /// You must normalize the data points in the array to be between &#8211;1.00 and +1.00.
        /// 
        /// Default Value: None
        ///  
        /// </param>
        /// <param name="Waveform_Handle">
        /// 
        /// 
        /// waveformHandle
        /// ViInt32*
        /// The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
        /// 
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int CreateArbWaveform(int Waveform_Size, double[] Waveform_Data_Array, out int Waveform_Handle)
        {
            int pInvokeResult = PInvoke.CreateArbWaveform(this._handle, Waveform_Size, Waveform_Data_Array, out Waveform_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// [OBSOLETE] niFgen_CreateBinary16ArbWaveform
        /// 
        /// ViStatus niFgen_CreateBinary16ArbWaveform (ViSession vi, ViInt32 waveformSize, ViInt16[] waveformDataArray, ViInt32* waveformHandle);
        /// 
        /// Purpose
        /// 
        /// [OBSOLETE] This function is obsolete.  Use the niFgen_CreateWaveformI16 function instead of this function.
        /// 
        /// Creates an arbitrary waveform from binary data and returns a handle that identifies that waveform. You can pass this handle to the niFgen_ConfigureArbWaveform function to produce that waveform. You can also use the handles this function returns to specify a sequence of arbitrary waveforms with the niFgen_CreateArbSequence function.
        /// 
        /// 
        /// Note  You must set the output mode to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ before calling this function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Waveform_Size">
        /// 
        /// 
        /// waveformSize
        /// ViInt32
        /// Specifies the size of the arbitrary waveform that you want created.
        /// 
        /// The size must meet the following restrictions:
        /// 
        ///  The size must be less than or equal to the maximum waveform size that the device allows.
        ///  The size must be greater than or equal to the minimum waveform size that the device allows.
        ///  The size must be an integer multiple of the device waveform quantum.
        /// 
        /// 
        /// 
        /// You can obtain these values from the maximumWaveformSize, minimumWaveformSize, and waveformQuantum parameters in niFgen_QueryArbWfmCapabilities.
        /// 
        /// Default Value: None
        /// 
        /// 
        ///  
        /// </param>
        /// <param name="Waveform_Data_Array">
        /// 
        /// 
        /// waveformDataArray
        /// ViReal64[]
        /// Specifies the array of data you want to use for the new arbitrary waveform. The array must have at least as many elements as the value that you specify in waveformSize.
        /// 
        /// You must normalize the data points in the array to be between &#8211;1.00 and +1.00.
        /// 
        /// Default Value: None
        ///  
        /// </param>
        /// <param name="Waveform_Handle">
        /// 
        /// 
        /// waveformHandle
        /// ViInt32*
        /// The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
        /// 
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int CreateBinary16ArbWaveform(int Waveform_Size, short[] Waveform_Data_Array, out int Waveform_Handle)
        {
            int pInvokeResult = PInvoke.CreateBinary16ArbWaveform(this._handle, Waveform_Size, Waveform_Data_Array, out Waveform_Handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// [OBSOLETE] niFgen_ConfigureRefClockSource
        /// 
        /// ViStatus niFgen_ConfigureRefClockSource (ViSession vi, ViInt32 referenceClockSource);
        /// 
        /// Purpose
        /// 
        /// Configures the signal generator reference clock source. The signal generator uses the reference clock to derive frequencies and sample rates when generating waveforms.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Reference_Clock_Source">
        /// 
        /// 
        /// referenceClockSource
        /// ViInt32
        /// Specifies the reference clock source that you want the signal generator to use. NI-FGEN sets the NIFGEN_ATTR_REF_CLOCK_SOURCE attribute to this value.
        /// 
        /// The signal generator derives the frequencies and sample rates that it uses to generate waveforms from the source you specify.
        /// 
        /// For example, when you set this parameter to NIFGEN_VAL_REF_CLOCK_EXTERNAL, the signal generator uses the signal it receives at its external clock terminal as the reference clock.
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_REF_CLOCK_INTERNAL
        /// Internal clock source
        /// 
        /// NIFGEN_VAL_REF_CLOCK_EXTERNAL
        /// External clock source
        /// 
        /// NIFGEN_VAL_REF_CLOCK_RTSI_CLOCK
        /// RTSI clock
        /// 
        /// NIFGEN_VAL_REF_CLOCK_TTL7
        /// TTL 7
        /// 
        /// NIFGEN_VAL_PXI_CLK10
        /// PXI 10 MHz clock
        /// 
        /// NIFGEN_VAL_REF_IN
        /// External clock source
        /// 
        /// NIFGEN_VAL_RTSI_0
        /// RTSI 0
        /// 
        /// NIFGEN_VAL_RTSI_1
        /// RTSI 1
        /// 
        /// NIFGEN_VAL_RTSI_2
        /// RTSI 2
        /// 
        /// NIFGEN_VAL_RTSI_3
        /// RTSI 3
        /// 
        /// NIFGEN_VAL_RTSI_4
        /// RTSI 4
        /// 
        /// NIFGEN_VAL_RTSI_5
        /// RTSI 5
        /// 
        /// NIFGEN_VAL_RTSI_6
        /// RTSI 6
        /// 
        /// NIFGEN_VAL_RTSI_7
        /// RTSI 7
        /// 
        /// NIFGEN_VAL_CLK_IN
        /// CLK IN front panel connector
        /// 
        /// Default Value: NIFGEN_VAL_REF_CLOCK_INTERNAL
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureRefClockSource(int Reference_Clock_Source)
        {
            int pInvokeResult = PInvoke.ConfigureRefClockSource(this._handle, Reference_Clock_Source);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// [OBSOLETE] niFgen_ConfigureRefClockFrequency
        /// 
        /// ViStatus niFgen_ConfigureRefClockFrequency (ViSession vi, ViReal64 referenceClockFrequency);
        /// 
        /// Purpose
        /// 
        /// Configures the signal generator reference clock frequency.  The signal generator uses the reference clock to derive frequencies and sample rates when generating waveforms.
        /// 
        /// 
        /// Note    The signal generator must not be in the Generating state when you call this function.
        /// 
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Reference_Clock_Frequency">
        /// 
        /// 
        /// referenceClockFrequency
        /// ViReal64
        /// The reference clock frequency in Hz.
        /// 
        /// Default Value: 10000000
        /// 
        ///  
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureRefClockFrequency(double Reference_Clock_Frequency)
        {
            int pInvokeResult = PInvoke.ConfigureRefClockFrequency(this._handle, Reference_Clock_Frequency);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// [OBSOLETE] niFgen_ConfigureUpdateClockSource
        /// 
        /// ViStatus niFgen_ConfigureUpdateClockSource (ViSession vi, ViInt32 updateClockSource);
        /// 
        /// Purpose
        /// 
        /// Sets the source of the update clock of the signal generator.  The source can be internal or external.
        /// 
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <param name="Update_Clock_Source">
        /// 
        /// 
        /// updateClockSource
        /// ViInt32
        /// Specifies the update clock source.
        /// 
        /// Defined Values
        /// 
        /// NIFGEN_VAL_INTERNAL
        /// Internal clock source
        /// 
        /// NIFGEN_VAL_EXTERNAL
        /// External clock source
        /// 
        /// NIFGEN_VAL_PXI_STAR
        /// PXI star
        /// 
        /// NIFGEN_VAL_RTSI_0
        /// RTSI 0 or PXI_Trig 0
        /// 
        /// NIFGEN_VAL_RTSI_1
        /// RTSI 1 or PXI_Trig 1
        /// 
        /// NIFGEN_VAL_RTSI_2
        /// RTSI 2 or PXI_Trig 2
        /// 
        /// NIFGEN_VAL_RTSI_3
        /// RTSI 3 or PXI_Trig 3
        /// 
        /// NIFGEN_VAL_RTSI_4
        /// RTSI 4 or PXI_Trig 4
        /// 
        /// NIFGEN_VAL_RTSI_5
        /// RTSI 5 or PXI_Trig 5
        /// 
        /// NIFGEN_VAL_RTSI_6
        /// RTSI 6 or PXI_Trig 6
        /// 
        /// NIFGEN_VAL_RTSI_7
        /// RTSI 7 or PXI_Trig 7
        /// 
        /// NIFGEN_VAL_CLK_IN
        /// CLK IN front panel connector
        /// 
        /// NIFGEN_VAL_DDC_CLK_IN
        /// Digital Data &amp; Control clock in
        /// 
        /// Default Value: NIFGEN_VAL_INTERNAL
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int ConfigureUpdateClockSource(int Update_Clock_Source)
        {
            int pInvokeResult = PInvoke.ConfigureUpdateClockSource(this._handle, Update_Clock_Source);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        /// <summary>
        /// 
        /// 
        /// 
        /// [OBSOLETE] niFgen_SendSoftwareTrigger
        /// 
        /// ViStatus niFgen_SendSoftwareTrigger (ViSession vi);
        /// 
        /// Purpose
        /// 
        /// Sends a command to trigger the signal generator. 
        /// 
        /// 
        /// Note  This function can act as an override for an external edge trigger. However, the NI 5401/5411/5431 
        /// do not support overriding an external digital edge trigger.
        /// 
        /// </summary>
        /// <param name="vi">
        /// 
        /// 
        /// vi
        /// ViSession
        /// Identifies your instrument session. vi is obtained from the 
        ///    niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
        ///  
        /// 
        /// </param>
        /// <returns>
        /// 
        /// 
        /// Status
        /// ViStatus
        /// Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
        /// 
        /// To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
        /// 
        /// 
        ///  
        /// 
        /// The general meaning of the status code is as follows:
        ///  
        /// 
        /// 
        /// 
        /// Value
        /// Meaning
        /// 0
        /// Success
        /// Positive Values
        /// Warnings
        /// Negative Values
        /// Errors
        /// 
        /// 
        /// 
        /// 
        /// 
        /// </returns>
        public int SendSoftwareTrigger()
        {
            int pInvokeResult = PInvoke.SendSoftwareTrigger(this._handle);
            PInvoke.TestForError(this._handle, pInvokeResult);
            return pInvokeResult;
        }

        public void Dispose()
        {
            this.Dispose(true);
            System.GC.SuppressFinalize(this);
        }

        private void Dispose(bool disposing)
        {
            if ((this._disposed == false))
            {
                PInvoke.close(this._handle);
                this._handle = System.IntPtr.Zero;
            }
            this._disposed = true;
        }

        public void SetInt32(niFgenProperties propertyId, string repeatedCapabilityOrChannel, int val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViInt32(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), val));
        }

        public void SetInt32(niFgenProperties propertyId, int val)
        {
            this.SetInt32(propertyId, "", val);
        }

        public int GetInt32(niFgenProperties propertyId, string repeatedCapabilityOrChannel)
        {
            int val;
            PInvoke.TestForError(this._handle, PInvoke.GetAttributeViInt32(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), out val));
            return val;
        }

        public int GetInt32(niFgenProperties propertyId)
        {
            return this.GetInt32(propertyId, "");
        }

        public void SetDouble(niFgenProperties propertyId, string repeatedCapabilityOrChannel, double val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViReal64(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), val));
        }

        public void SetDouble(niFgenProperties propertyId, double val)
        {
            this.SetDouble(propertyId, "", val);
        }

        public double GetDouble(niFgenProperties propertyId, string repeatedCapabilityOrChannel)
        {
            double val;
            PInvoke.TestForError(this._handle, PInvoke.GetAttributeViReal64(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), out val));
            return val;
        }

        public double GetDouble(niFgenProperties propertyId)
        {
            return this.GetDouble(propertyId, "");
        }

        public void SetBoolean(niFgenProperties propertyId, string repeatedCapabilityOrChannel, bool val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViBoolean(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), System.Convert.ToUInt16(val)));
        }

        public void SetBoolean(niFgenProperties propertyId, bool val)
        {
            this.SetBoolean(propertyId, "", val);
        }

        public bool GetBoolean(niFgenProperties propertyId, string repeatedCapabilityOrChannel)
        {
            ushort val;
            PInvoke.TestForError(this._handle, PInvoke.GetAttributeViBoolean(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), out val));
            return System.Convert.ToBoolean(val);
        }

        public bool GetBoolean(niFgenProperties propertyId)
        {
            return this.GetBoolean(propertyId, "");
        }

        public void SetString(niFgenProperties propertyId, string repeatedCapabilityOrChannel, string val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViString(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), val));
        }

        public void SetString(niFgenProperties propertyId, string val)
        {
            this.SetString(propertyId, "", val);
        }

        public string GetString(niFgenProperties propertyId, string repeatedCapabilityOrChannel)
        {
            System.Text.StringBuilder newVal = new System.Text.StringBuilder(512);
            int size = PInvoke.GetAttributeViString(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), 512, newVal);
            if ((size < 0))
            {
                PInvoke.ThrowError(this._handle, size);
            }
            else
            {
                if ((size > 0))
                {
                    newVal.Capacity = size;
                    PInvoke.TestForError(this._handle, PInvoke.GetAttributeViString(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), size, newVal));
                }
            }
            return newVal.ToString();
        }

        public string GetString(niFgenProperties propertyId)
        {
            return this.GetString(propertyId, "");
        }

        public void SetSession(niFgenProperties propertyId, string repeatedCapabilityOrChannel, System.IntPtr val)
        {
            PInvoke.TestForError(this._handle, PInvoke.SetAttributeViSession(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), val));
        }

        public void SetSession(niFgenProperties propertyId, System.IntPtr val)
        {
            this.SetSession(propertyId, "", val);
        }

        public System.IntPtr GetSession(niFgenProperties propertyId, string repeatedCapabilityOrChannel)
        {
            System.IntPtr val;
            PInvoke.TestForError(this._handle, PInvoke.GetAttributeViSession(this._handle, repeatedCapabilityOrChannel, ((int)(propertyId)), out val));
            return val;
        }

        public System.IntPtr GetSession(niFgenProperties propertyId)
        {
            return this.GetSession(propertyId, "");
        }

        private class PInvoke
        {

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_init", CallingConvention = CallingConvention.StdCall)]
            public static extern int init(string Resource_Name, ushort ID_Query, ushort Reset_Device, out System.IntPtr vi);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_InitWithOptions", CallingConvention = CallingConvention.StdCall)]
            public static extern int InitWithOptions(string Resource_Name, ushort ID_Query, ushort Reset_Device, string Option_String, out System.IntPtr vi);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_InitExtCal", CallingConvention = CallingConvention.StdCall)]
            public static extern int InitExtCal(string Resource_Name, string Password, out System.IntPtr vi);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_Commit", CallingConvention = CallingConvention.StdCall)]
            public static extern int Commit(System.IntPtr vi);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_reset", CallingConvention = CallingConvention.StdCall)]
            public static extern int reset(System.IntPtr vi);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureOperationMode", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureOperationMode(System.IntPtr vi, string Channel_Name, int Operation_Mode);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureOutputMode", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureOutputMode(System.IntPtr vi, int Output_Mode);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureChannels", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureChannels(System.IntPtr vi, string Channels);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureOutputEnabled", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureOutputEnabled(System.IntPtr vi, string Channel_Name, ushort Enabled);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureOutputImpedance", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureOutputImpedance(System.IntPtr vi, string Channel_Name, double Impedance);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_EnableAnalogFilter", CallingConvention = CallingConvention.StdCall)]
            public static extern int EnableAnalogFilter(System.IntPtr vi, string Channel_Name, double Filter_Correction_Frequency);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_DisableAnalogFilter", CallingConvention = CallingConvention.StdCall)]
            public static extern int DisableAnalogFilter(System.IntPtr vi, string Channel_Name);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_EnableDigitalFilter", CallingConvention = CallingConvention.StdCall)]
            public static extern int EnableDigitalFilter(System.IntPtr vi, string Channel_Name);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_DisableDigitalFilter", CallingConvention = CallingConvention.StdCall)]
            public static extern int DisableDigitalFilter(System.IntPtr vi, string Channel_Name);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_EnableDigitalPatterning", CallingConvention = CallingConvention.StdCall)]
            public static extern int EnableDigitalPatterning(System.IntPtr vi, string Channel_Name);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_DisableDigitalPatterning", CallingConvention = CallingConvention.StdCall)]
            public static extern int DisableDigitalPatterning(System.IntPtr vi, string Channel_Name);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureStandardWaveform", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureStandardWaveform(System.IntPtr vi, string Channel_Name, int Waveform, double Amplitude, double DC_Offset, double Frequency, double Start_Phase);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_DefineUserStandardWaveform", CallingConvention = CallingConvention.StdCall)]
            public static extern int DefineUserStandardWaveform(System.IntPtr vi, string Channel_Name, int Waveform_Size, double[] Waveform_Data_Array);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ClearUserStandardWaveform", CallingConvention = CallingConvention.StdCall)]
            public static extern int ClearUserStandardWaveform(System.IntPtr vi, string Channel_Name);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureFrequency", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureFrequency(System.IntPtr vi, string Channel_Name, double Frequency);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureAmplitude", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureAmplitude(System.IntPtr vi, string Channel_Name, double Amplitude);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_CreateFreqList", CallingConvention = CallingConvention.StdCall)]
            public static extern int CreateFreqList(System.IntPtr vi, int Waveform, int Frequency_List_Length, double[] Frequency_Array, double[] Duration_Array, out int Frequency_List_Handle);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureFreqList", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureFreqList(System.IntPtr vi, string Channel_Name, int Frequency_List_Handle, double Amplitude, double DC_Offset, double Start_Phase);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ClearFreqList", CallingConvention = CallingConvention.StdCall)]
            public static extern int ClearFreqList(System.IntPtr vi, int Frequency_List_Handle);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_QueryFreqListCapabilities", CallingConvention = CallingConvention.StdCall)]
            public static extern int QueryFreqListCapabilities(System.IntPtr vi, out int Maximum_Number_Of_Freq_Lists, out int Minimum_Frequency_List_Length, out int Maximum_Frequency_List_Length, out double Minimum_Frequency_List_Duration, out double Maximum_Frequency_List_Duration, out double Frequency_List_Duration_Quantum);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureGain", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureGain(System.IntPtr vi, string Channel_Name, double Gain);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureSampleRate", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureSampleRate(System.IntPtr vi, double Sample_Rate);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_QueryArbWfmCapabilities", CallingConvention = CallingConvention.StdCall)]
            public static extern int QueryArbWfmCapabilities(System.IntPtr vi, out int Maximum_Number_of_Waveforms, out int Waveform_Quantum, out int Minimum_Waveform_Size, out int Maximum_Waveform_Size);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_CreateWaveformF64", CallingConvention = CallingConvention.StdCall)]
            public static extern int CreateWaveformF64(System.IntPtr vi, string Channel_Name, int Waveform_Size, double[] Waveform_Data_Array, out int Waveform_Handle);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_CreateWaveformI16", CallingConvention = CallingConvention.StdCall)]
            public static extern int CreateWaveformI16(System.IntPtr vi, string Channel_Name, int Waveform_Size, short[] Waveform_Data_Array, out int Waveform_Handle);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_CreateWaveformComplexF64", CallingConvention = CallingConvention.StdCall)]
            public static extern int CreateWaveformComplexF64(System.IntPtr vi, string Channel_Name, int Number_of_Samples, int Waveform_Data_Array, out int Waveform_Handle);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_CreateWaveformFromFileI16", CallingConvention = CallingConvention.StdCall)]
            public static extern int CreateWaveformFromFileI16(System.IntPtr vi, string Channel_Name, string FileName, int Byte_Order, out int Waveform_Handle);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_CreateWaveformFromFileF64", CallingConvention = CallingConvention.StdCall)]
            public static extern int CreateWaveformFromFileF64(System.IntPtr vi, string Channel_Name, string FileName, int Byte_Order, out int Waveform_Handle);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_CreateWaveformFromFileHWS", CallingConvention = CallingConvention.StdCall)]
            public static extern int CreateWaveformFromFileHWS(System.IntPtr vi, string Channel_Name, string FileName, ushort Use_Rate_From_Waveform, ushort Use_Gain___Offset_From_Waveform, out int Waveform_Handle);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureArbWaveform", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureArbWaveform(System.IntPtr vi, string Channel_Name, int Waveform_Handle, double Gain, double Offset);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ClearArbWaveform", CallingConvention = CallingConvention.StdCall)]
            public static extern int ClearArbWaveform(System.IntPtr vi, int Waveform_Handle);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_QueryArbSeqCapabilities", CallingConvention = CallingConvention.StdCall)]
            public static extern int QueryArbSeqCapabilities(System.IntPtr vi, out int Maximum_Number_of_Sequences, out int Minimum_Sequence_Length, out int Maximum_Sequence_Length, out int Maximum_Loop_Count);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_CreateArbSequence", CallingConvention = CallingConvention.StdCall)]
            public static extern int CreateArbSequence(System.IntPtr vi, int Sequence_Length, int[] Waveform_Handles_Array, int[] Loop_Counts_Array, out int Sequence_Handle);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_CreateAdvancedArbSequence", CallingConvention = CallingConvention.StdCall)]
            public static extern int CreateAdvancedArbSequence(System.IntPtr vi, int Sequence_Length, int[] Waveform_Handles_Array, int[] Loop_Counts_Array, int[] Sample_Counts_Array, int[] Marker_Location_Array, [In, Out] int[] Coerced_Markers_Array, out int Sequence_Handle);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureArbSequence", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureArbSequence(System.IntPtr vi, string Channel_Name, int Sequence_Handle, double Gain, double Offset);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ClearArbSequence", CallingConvention = CallingConvention.StdCall)]
            public static extern int ClearArbSequence(System.IntPtr vi, int Sequence_Handle);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ClearArbMemory", CallingConvention = CallingConvention.StdCall)]
            public static extern int ClearArbMemory(System.IntPtr vi);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_AllocateWaveform", CallingConvention = CallingConvention.StdCall)]
            public static extern int AllocateWaveform(System.IntPtr vi, string Channel_Name, int Waveform_Size, out int Waveform_Handle);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_SetWaveformNextWritePosition", CallingConvention = CallingConvention.StdCall)]
            public static extern int SetWaveformNextWritePosition(System.IntPtr vi, string Channel_Name, int Waveform_Handle, int relativeTo, int offset);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_WriteWaveform", CallingConvention = CallingConvention.StdCall)]
            public static extern int WriteWaveform(System.IntPtr vi, string Channel_Name, int Waveform_Handle, int Size, double[] Data);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_WriteWaveformComplexF64", CallingConvention = CallingConvention.StdCall)]
            public static extern int WriteWaveformComplexF64(System.IntPtr vi, string Channel_Name, int Number_of_Samples, int Data, int Waveform_Handle);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_WriteBinary16Waveform", CallingConvention = CallingConvention.StdCall)]
            public static extern int WriteBinary16Waveform(System.IntPtr vi, string Channel_Name, int Waveform_Handle, int Size, short[] Data);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_WriteComplexBinary16Waveform", CallingConvention = CallingConvention.StdCall)]
            public static extern int WriteComplexBinary16Waveform(System.IntPtr vi, string Channel_Name, int Waveform_Handle, int Size, nicomplexI16 Data);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureReferenceClock", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureReferenceClock(System.IntPtr vi, string Reference_Clock_Source, double Reference_Clock_Frequency);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureSampleClockSource", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureSampleClockSource(System.IntPtr vi, string Sample_Clock_Source);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureClockMode", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureClockMode(System.IntPtr vi, int Clock_Mode);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_AdjustSampleClockRelativeDelay", CallingConvention = CallingConvention.StdCall)]
            public static extern int AdjustSampleClockRelativeDelay(System.IntPtr vi, double Adjustment_Time);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureDigitalEdgeStartTrigger", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureDigitalEdgeStartTrigger(System.IntPtr vi, string Source, int Edge);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureSoftwareEdgeStartTrigger", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureSoftwareEdgeStartTrigger(System.IntPtr vi);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_DisableStartTrigger", CallingConvention = CallingConvention.StdCall)]
            public static extern int DisableStartTrigger(System.IntPtr vi);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureDigitalEdgeScriptTrigger", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureDigitalEdgeScriptTrigger(System.IntPtr vi, string Trigger_ID, string Source, int Edge);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureDigitalLevelScriptTrigger", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureDigitalLevelScriptTrigger(System.IntPtr vi, string Trigger_ID, string Source, int Trigger_When);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureSoftwareEdgeScriptTrigger", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureSoftwareEdgeScriptTrigger(System.IntPtr vi, string Trigger_ID);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_DisableScriptTrigger", CallingConvention = CallingConvention.StdCall)]
            public static extern int DisableScriptTrigger(System.IntPtr vi, string Trigger_ID);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureTriggerMode", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureTriggerMode(System.IntPtr vi, string Channel_Name, int Trigger_Mode);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_SendSoftwareEdgeTrigger", CallingConvention = CallingConvention.StdCall)]
            public static extern int SendSoftwareEdgeTrigger(System.IntPtr vi, int Trigger, string Trigger_ID);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureSynchronization", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureSynchronization(System.IntPtr vi, string Channel_Name, int Synchronization_Source);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ExportSignal", CallingConvention = CallingConvention.StdCall)]
            public static extern int ExportSignal(System.IntPtr vi, int Signal, string Signal_Identifier, string Output_Terminal);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_RouteSignalOut", CallingConvention = CallingConvention.StdCall)]
            public static extern int RouteSignalOut(System.IntPtr vi, string Channel_Name, int Route_Signal_From, int Route_Signal_To);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_AllocateNamedWaveform", CallingConvention = CallingConvention.StdCall)]
            public static extern int AllocateNamedWaveform(System.IntPtr vi, string Channel_Name, string Waveform_Name, int Waveform_Size);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_SetNamedWaveformNextWritePosition", CallingConvention = CallingConvention.StdCall)]
            public static extern int SetNamedWaveformNextWritePosition(System.IntPtr vi, string Channel_Name, string Waveform_Name, int relativeTo, int offset);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_WriteNamedWaveformF64", CallingConvention = CallingConvention.StdCall)]
            public static extern int WriteNamedWaveformF64(System.IntPtr vi, string Channel_Name, string Waveform_Name, int Size, double[] Data);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_WriteNamedWaveformI16", CallingConvention = CallingConvention.StdCall)]
            public static extern int WriteNamedWaveformI16(System.IntPtr vi, string Channel_Name, string Waveform_Name, int Size, short[] Data);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_WriteNamedWaveformComplexF64", CallingConvention = CallingConvention.StdCall)]
            public static extern int WriteNamedWaveformComplexF64(System.IntPtr vi, string Channel_Name, string Waveform_Name, int Size, nicomplexnumber Data);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_WriteNamedWaveformComplexI16", CallingConvention = CallingConvention.StdCall)]
            public static extern int WriteNamedWaveformComplexI16(System.IntPtr vi, string Channel_Name, string Waveform_Name, int Size, nicomplexI16 Data);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_DeleteNamedWaveform", CallingConvention = CallingConvention.StdCall)]
            public static extern int DeleteNamedWaveform(System.IntPtr vi, string Channel_Name, string Waveform_Name);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_WriteScript", CallingConvention = CallingConvention.StdCall)]
            public static extern int WriteScript(System.IntPtr vi, string Channel_Name, string Script);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_DeleteScript", CallingConvention = CallingConvention.StdCall)]
            public static extern int DeleteScript(System.IntPtr vi, string Channel_Name, string Script_Name);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureCustomFIRFilterCoefficients", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureCustomFIRFilterCoefficients(System.IntPtr vi, string Channel_Name, int Number_of_Coefficients, double[] Coefficients_Array);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_GetFIRFilterCoefficients", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetFIRFilterCoefficients(System.IntPtr vi, string Channel_Name, int Array_Size, double[] Coefficients_Array, int[] Number_of_Coefficients_Read);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_InitiateGeneration", CallingConvention = CallingConvention.StdCall)]
            public static extern int InitiateGeneration(System.IntPtr vi);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_AbortGeneration", CallingConvention = CallingConvention.StdCall)]
            public static extern int AbortGeneration(System.IntPtr vi);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_GetHardwareState", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetHardwareState(System.IntPtr vi, out int state);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_WaitUntilDone", CallingConvention = CallingConvention.StdCall)]
            public static extern int WaitUntilDone(System.IntPtr vi, int maxTime);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_IsDone", CallingConvention = CallingConvention.StdCall)]
            public static extern int IsDone(System.IntPtr vi, out ushort Done);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ResetWithDefaults", CallingConvention = CallingConvention.StdCall)]
            public static extern int ResetWithDefaults(System.IntPtr vi);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ResetDevice", CallingConvention = CallingConvention.StdCall)]
            public static extern int ResetDevice(System.IntPtr vi);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_GetChannelName", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetChannelName(System.IntPtr vi, int Index, int BufferSize, System.Text.StringBuilder Channel_Name);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_Disable", CallingConvention = CallingConvention.StdCall)]
            public static extern int Disable(System.IntPtr vi);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_self_test", CallingConvention = CallingConvention.StdCall)]
            public static extern int self_test(System.IntPtr vi, out short Self_Test_Result, System.Text.StringBuilder Self_Test_Message);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_revision_query", CallingConvention = CallingConvention.StdCall)]
            public static extern int revision_query(System.IntPtr vi, System.Text.StringBuilder Instrument_Driver_Revision, System.Text.StringBuilder Firmware_Revision);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_GetNextCoercionRecord", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetNextCoercionRecord(System.IntPtr vi, int Buffer_Size, System.Text.StringBuilder Coercion_Record);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_error_query", CallingConvention = CallingConvention.StdCall)]
            public static extern int error_query(System.IntPtr vi, out int Error_Code, System.Text.StringBuilder Error_Message);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ErrorHandler", CallingConvention = CallingConvention.StdCall)]
            public static extern int ErrorHandler(System.IntPtr vi, int Error_Code, System.Text.StringBuilder Error_Message);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_GetNextInterchangeWarning", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetNextInterchangeWarning(System.IntPtr vi, int Buffer_Size, System.Text.StringBuilder Interchange_Warning);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ClearInterchangeWarnings", CallingConvention = CallingConvention.StdCall)]
            public static extern int ClearInterchangeWarnings(System.IntPtr vi);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ResetInterchangeCheck", CallingConvention = CallingConvention.StdCall)]
            public static extern int ResetInterchangeCheck(System.IntPtr vi);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_CloseExtCal", CallingConvention = CallingConvention.StdCall)]
            public static extern int CloseExtCal(System.IntPtr vi, int Action);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_SelfCal", CallingConvention = CallingConvention.StdCall)]
            public static extern int SelfCal(System.IntPtr vi);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_InitializeAnalogOutputCalibration", CallingConvention = CallingConvention.StdCall)]
            public static extern int InitializeAnalogOutputCalibration(System.IntPtr vi);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_WriteBinary16AnalogStaticValue", CallingConvention = CallingConvention.StdCall)]
            public static extern int WriteBinary16AnalogStaticValue(System.IntPtr vi, string Channel_Name, short Value);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_CalAdjustMainPathPreAmpOffset", CallingConvention = CallingConvention.StdCall)]
            public static extern int CalAdjustMainPathPreAmpOffset(System.IntPtr vi, string Channel_Name, int Configuration, int[] Gain_DAC_Values, int[] Offset_DAC_Values, double[] Measured_Outputs);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_CalAdjustMainPathPreAmpGain", CallingConvention = CallingConvention.StdCall)]
            public static extern int CalAdjustMainPathPreAmpGain(System.IntPtr vi, string Channel_Name, int Configuration, int[] Main_DAC_Values, int[] Gain_DAC_Values, int[] Offset_DAC_Values, double[] Measured_Outputs);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_CalAdjustMainPathPostAmpGainAndOffset", CallingConvention = CallingConvention.StdCall)]
            public static extern int CalAdjustMainPathPostAmpGainAndOffset(System.IntPtr vi, string Channel_Name, int Configuration, int[] Main_DAC_Values, int[] Gain_DAC_Values, int[] Offset_DAC_Values, double[] Measured_Outputs);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_CalAdjustDirectPathGain", CallingConvention = CallingConvention.StdCall)]
            public static extern int CalAdjustDirectPathGain(System.IntPtr vi, string Channel_Name, int[] Main_DAC_Values, int[] Gain_DAC_Values, double[] Measured_Outputs);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_CalAdjustMainPathOutputImpedance", CallingConvention = CallingConvention.StdCall)]
            public static extern int CalAdjustMainPathOutputImpedance(System.IntPtr vi, string Channel_Name, int Configuration, double Load_Impedance, double Measured_Source_Voltage, double Measured_Voltage_Across_Load);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_CalAdjustDirectPathOutputImpedance", CallingConvention = CallingConvention.StdCall)]
            public static extern int CalAdjustDirectPathOutputImpedance(System.IntPtr vi, string Channel_Name, int Configuration, double Load_Impedance, double Measured_Source_Voltage, double Measured_Voltage_Across_Load);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_InitializeOscillatorFrequencyCalibration", CallingConvention = CallingConvention.StdCall)]
            public static extern int InitializeOscillatorFrequencyCalibration(System.IntPtr vi);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_CalAdjustOscillatorFrequency", CallingConvention = CallingConvention.StdCall)]
            public static extern int CalAdjustOscillatorFrequency(System.IntPtr vi, double Desired_Frequency, double Measured_Frequency);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_InitializeCalADCCalibration", CallingConvention = CallingConvention.StdCall)]
            public static extern int InitializeCalADCCalibration(System.IntPtr vi);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_CalAdjustCalADC", CallingConvention = CallingConvention.StdCall)]
            public static extern int CalAdjustCalADC(System.IntPtr vi, double[] Voltages_Measured_Externally, double[] Voltages_Measured_With_CalADC);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ReadCalADC", CallingConvention = CallingConvention.StdCall)]
            public static extern int ReadCalADC(System.IntPtr vi, int Number_of_Reads_to_Average, ushort Return_Calibrated_Value, out double Cal_ADC_Value);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_InitializeFlatnessCalibration", CallingConvention = CallingConvention.StdCall)]
            public static extern int InitializeFlatnessCalibration(System.IntPtr vi);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_CalAdjustFlatness", CallingConvention = CallingConvention.StdCall)]
            public static extern int CalAdjustFlatness(System.IntPtr vi, string Channel_Name, int Configuration, double Requested_Amplitude, double[] Frequencies, double[] Measured_Amplitudes, int Number_Of_Measurements);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_GetSelfCalSupported", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetSelfCalSupported(System.IntPtr vi, out ushort Self_Cal_Supported);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_GetSelfCalLastDateAndTime", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetSelfCalLastDateAndTime(System.IntPtr vi, out int Year, out int Month, out int Day, out int Hour, out int Minute);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_GetExtCalLastDateAndTime", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetExtCalLastDateAndTime(System.IntPtr vi, out int Year, out int Month, out int Day, out int Hour, out int Minute);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_GetSelfCalLastTemp", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetSelfCalLastTemp(System.IntPtr vi, out double Temperature);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_GetExtCalLastTemp", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetExtCalLastTemp(System.IntPtr vi, out double Temperature);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_GetExtCalRecommendedInterval", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetExtCalRecommendedInterval(System.IntPtr vi, out int Months);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ChangeExtCalPassword", CallingConvention = CallingConvention.StdCall)]
            public static extern int ChangeExtCalPassword(System.IntPtr vi, string Old_Password, string New_Password);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_SetCalUserDefinedInfo", CallingConvention = CallingConvention.StdCall)]
            public static extern int SetCalUserDefinedInfo(System.IntPtr vi, string Info);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_GetCalUserDefinedInfo", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetCalUserDefinedInfo(System.IntPtr vi, string Info);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_GetCalUserDefinedInfoMaxSize", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetCalUserDefinedInfoMaxSize(System.IntPtr vi, out int Info_Size);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ReadCurrentTemperature", CallingConvention = CallingConvention.StdCall)]
            public static extern int ReadCurrentTemperature(System.IntPtr vi, out double Temperature);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_RestoreLastExtCalConstants", CallingConvention = CallingConvention.StdCall)]
            public static extern int RestoreLastExtCalConstants(System.IntPtr vi);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureTriggerSource", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureTriggerSource(System.IntPtr vi, string Channel_Name, int Trigger_Source);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_CreateArbWaveform", CallingConvention = CallingConvention.StdCall)]
            public static extern int CreateArbWaveform(System.IntPtr vi, int Waveform_Size, double[] Waveform_Data_Array, out int Waveform_Handle);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_CreateBinary16ArbWaveform", CallingConvention = CallingConvention.StdCall)]
            public static extern int CreateBinary16ArbWaveform(System.IntPtr vi, int Waveform_Size, short[] Waveform_Data_Array, out int Waveform_Handle);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureRefClockSource", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureRefClockSource(System.IntPtr vi, int Reference_Clock_Source);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureRefClockFrequency", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureRefClockFrequency(System.IntPtr vi, double Reference_Clock_Frequency);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_ConfigureUpdateClockSource", CallingConvention = CallingConvention.StdCall)]
            public static extern int ConfigureUpdateClockSource(System.IntPtr vi, int Update_Clock_Source);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_SendSoftwareTrigger", CallingConvention = CallingConvention.StdCall)]
            public static extern int SendSoftwareTrigger(System.IntPtr vi);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_close", CallingConvention = CallingConvention.StdCall)]
            public static extern int close(System.IntPtr vi);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_error_message", CallingConvention = CallingConvention.StdCall)]
            public static extern int error_message(System.IntPtr vi, int Error_Code, System.Text.StringBuilder Error_Message_2);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_GetAttributeViInt32", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetAttributeViInt32(System.IntPtr vi, string Channel_Name, int Attribute_ID, out int Attribute_Value);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_GetAttributeViReal64", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetAttributeViReal64(System.IntPtr vi, string Channel_Name, int Attribute_ID, out double Attribute_Value);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_GetAttributeViString", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetAttributeViString(System.IntPtr vi, string Channel_Name, int Attribute_ID, int Array_Size, System.Text.StringBuilder Attribute_Value);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_GetAttributeViBoolean", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetAttributeViBoolean(System.IntPtr vi, string Channel_Name, int Attribute_ID, out ushort Attribute_Value);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_GetAttributeViSession", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetAttributeViSession(System.IntPtr vi, string Channel_Name, int Attribute_ID, out System.IntPtr Attribute_Value);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_SetAttributeViInt32", CallingConvention = CallingConvention.StdCall)]
            public static extern int SetAttributeViInt32(System.IntPtr vi, string Channel_Name, int Attribute_ID, int Attribute_Value);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_SetAttributeViReal64", CallingConvention = CallingConvention.StdCall)]
            public static extern int SetAttributeViReal64(System.IntPtr vi, string Channel_Name, int Attribute_ID, double Attribute_Value);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_SetAttributeViString", CallingConvention = CallingConvention.StdCall)]
            public static extern int SetAttributeViString(System.IntPtr vi, string Channel_Name, int Attribute_ID, string Attribute_Value);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_SetAttributeViBoolean", CallingConvention = CallingConvention.StdCall)]
            public static extern int SetAttributeViBoolean(System.IntPtr vi, string Channel_Name, int Attribute_ID, ushort Attribute_Value);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_SetAttributeViSession", CallingConvention = CallingConvention.StdCall)]
            public static extern int SetAttributeViSession(System.IntPtr vi, string Channel_Name, int Attribute_ID, System.IntPtr Attribute_Value);

            [DllImport("niFgen_32.dll", EntryPoint = "niFgen_GetError", CallingConvention = CallingConvention.StdCall)]
            public static extern int GetError(System.IntPtr vi, out int Error_Code, int Error_Description_Buffer_Size, System.Text.StringBuilder Error_Description);


            public static int TestForError(System.IntPtr handle, int status)
            {
                if ((status < 0))
                {
                    PInvoke.ThrowError(handle, status);
                }
                return status;
            }

            public static int ThrowError(System.IntPtr handle, int code)
            {
                int status;
                int size = PInvoke.GetError(handle, out status, 0, null);
                System.Text.StringBuilder msg = new System.Text.StringBuilder();
                if ((size >= 0))
                {
                    msg.Capacity = size;
                    PInvoke.GetError(handle, out status, size, msg);
                }
                throw new System.Runtime.InteropServices.ExternalException(msg.ToString(), code);
            }
        }
    }

    public class niFgenConstants
    {

        public const int OperateContinuous = 0;

        public const int OutputFunc = 0;

        public const int OutputFreqList = 101;

        public const int OutputArb = 1;

        public const int OutputSeq = 2;

        public const int OutputScript = 102;

        public const int WfmSine = 1;

        public const int WfmSquare = 2;

        public const int WfmTriangle = 3;

        public const int WfmRampUp = 4;

        public const int WfmRampDown = 5;

        public const int WfmDc = 6;

        public const int WfmUser = 102;

        public const int LittleEndian = 0;

        public const int BigEndian = 1;

        public const int WaveformPositionStart = 0;

        public const int WaveformPositionCurrent = 1;

        public const int DivideDown = 1;

        public const int HighResolution = 0;

        public const int Automatic = 2;

        public const int RisingEdge = 101;

        public const int FallingEdge = 102;

        public const int ActiveHigh = 101;

        public const int ActiveLow = 102;

        public const int Single = 1;

        public const int Continuous = 2;

        public const int Stepped = 3;

        public const int Burst = 4;

        public const int StartTrigger = 1004;

        public const int ScriptTrigger = 103;

        public const int None = 1000;

        public const int Ttl0 = 111;

        public const int Ttl1 = 112;

        public const int Ttl2 = 113;

        public const int Ttl3 = 114;

        public const int Ttl4 = 115;

        public const int Ttl5 = 116;

        public const int Ttl6 = 117;

        public const int Rtsi0 = 141;

        public const int Rtsi1 = 142;

        public const int Rtsi2 = 143;

        public const int Rtsi3 = 144;

        public const int Rtsi4 = 145;

        public const int Rtsi5 = 146;

        public const int Rtsi6 = 147;

        public const int SampleClock = 101;

        public const int ReferenceClock = 102;

        public const int OnboardReferenceClock = 1019;

        public const int SyncOut = 1002;

        public const int MarkerEvent = 1001;

        public const int DataMarkerEvent = 108;

        public const int ReadyForStartEvent = 105;

        public const int StartedEvent = 106;

        public const int DoneEvent = 107;

        public const int Synchronization = 1007;

        public const int Marker = 1001;

        public const int PllRefSource = 1003;

        public const int UpdateClock = 1017;

        public const int OutStartTrigger = 1004;

        public const int BoardClock = 1006;

        public const int SoftwareTrig = 2;

        public const int RefOut = 1008;

        public const int PxiClk10 = 1201;

        public const int Pfi0 = 1011;

        public const int Rtsi7 = 1010;

        public const int RefClockRtsiClock = 101;

        public const int ClockOut = 1009;

        public const int PxiStar = 131;

        public const int ExtCalAbort = 0;

        public const int ExtCalCommit = 1;

        public const int CalConfigMainPathFilterOff0db = 0;

        public const int CalConfigMainPathFilterOff3db = 1;

        public const int CalConfigMainPathFilterOff6db = 2;

        public const int CalConfigMainPathFilterOff9db = 3;

        public const int CalConfigMainPathFilterOff12db = 4;

        public const int CalConfigMainPathFilterOn0db = 5;

        public const int CalConfigMainPathFilterOn3db = 6;

        public const int CalConfigMainPathFilterOn6db = 7;

        public const int CalConfigMainPathFilterOn9db = 8;

        public const int CalConfigMainPathFilterOn12db = 9;

        public const int CalConfigMainPathLowGain0db = 0;

        public const int CalConfigMainPathLowGain12db = 1;

        public const int CalConfigMainPathLowGain24db = 2;

        public const int CalConfigMainPathLowGain36db = 3;

        public const int CalConfigMainPathHighGain0db = 4;

        public const int CalConfigMainPathHighGain12db = 5;

        public const int CalConfigMainPathHighGain24db = 6;

        public const int CalConfigMainPathHighGain36db = 7;

        public const int CalConfigMainPathLowGain0db50ohms = 0;

        public const int CalConfigMainPathLowGain0db75ohms = 1;

        public const int CalConfigMainPathLowGain12db50ohms = 2;

        public const int CalConfigMainPathLowGain12db75ohms = 3;

        public const int CalConfigMainPathLowGain24db50ohms = 4;

        public const int CalConfigMainPathLowGain24db75ohms = 5;

        public const int CalConfigMainPathLowGain36db50ohms = 6;

        public const int CalConfigMainPathLowGain36db75ohms = 7;

        public const int CalConfigMainPathHighGain0db50ohms = 8;

        public const int CalConfigMainPathHighGain0db75ohms = 9;

        public const int CalConfigMainPathHighGain12db50ohms = 10;

        public const int CalConfigMainPathHighGain12db75ohms = 11;

        public const int CalConfigMainPathHighGain24db50ohms = 12;

        public const int CalConfigMainPathHighGain24db75ohms = 13;

        public const int CalConfigMainPathHighGain36db50ohms = 14;

        public const int CalConfigMainPathHighGain36db75ohms = 15;

        public const int CalConfigDirectPath50ohms = 0;

        public const int CalConfigDirectPath75ohms = 1;

        public const int CalConfigLowGainPathPreAmp0db = 0;

        public const int CalConfigLowGainPathPreAmp3db = 1;

        public const int CalConfigLowGainPathPreAmp6db = 2;

        public const int CalConfigLowGainPathPreAmp9db = 3;

        public const int CalConfigLowGainPathPreAmp12db = 4;

        public const int CalConfigHighGainPathPreAmp0db = 5;

        public const int CalConfigHighGainPathPreAmp3db = 6;

        public const int CalConfigHighGainPathPreAmp6db = 7;

        public const int CalConfigHighGainPathPreAmp9db = 8;

        public const int CalConfigHighGainPathPreAmp12db = 9;

        public const int External = 1;

        public const int Immediate = 0;

        public const int Pfi1 = 1012;

        public const int Pfi2 = 1013;

        public const int Pfi3 = 1014;

        public const int Ttl7 = 118;

        public const int RefClockInternal = 0;

        public const int RefClockExternal = 1;

        public const int RefClockTtl7 = 118;

        public const int RefIn = 1200;

        public const int ClkIn = 1202;

        public const int DdcClkIn = 1203;

        public const int Internal = 0;

        public const int MainAnalogPath = 0;

        public const int DirectAnalogPath = 1;

        public const int FixedLowGainAnalogPath = 2;

        public const int FixedHighGainAnalogPath = 3;

        public const double _50Ohms = 50;

        public const double _75Ohms = 75;

        public const int SingleEnded = 300;

        public const int Differential = 301;

        public const int HoldLastValue = 400;

        public const int JumpToValue = 401;

        public const int OspReal = 0;

        public const int OspComplex = 1;

        public const int OspIf = 0;

        public const int OspBaseband = 1;

        public const int OspFlat = 0;

        public const int OspRaisedCosine = 1;

        public const int OspRootRaisedCosine = 2;

        public const int OspGaussian = 3;

        public const int OspCustom = 4;

        public const int ErrorReportingError = 0;

        public const int ErrorReportingDisabled = 2;

        public const int OspOverflowNone = 0;

        public const int OspOverflowPreFilterGainI = 1;

        public const int OspOverflowPreFilterGainQ = 2;

        public const int OspOverflowPreFilterOffsetI = 4;

        public const int OspOverflowPreFilterOffsetQ = 8;

        public const int OspOverflowFirFilterI = 16;

        public const int OspOverflowFirFilterQ = 32;

        public const int OspOverflowCicFilterI = 64;

        public const int OspOverflowCicFilterQ = 128;

        public const int OspOverflowComplexData = 256;

        public const int WfmNoise = 101;

        public const int Pulse = 101;

        public const int Level = 102;

        public const int SampleClockPeriods = 101;

        public const int Seconds = 102;

        public const int High = 101;

        public const int Low = 102;

        public const int TrigNone = 101;

        public const int DigitalEdge = 102;

        public const int SoftwareEdge = 104;

        public const int DigitalLevel = 103;

        public const int BusInvalid = 0;

        public const int BusAt = 1;

        public const int BusPci = 2;

        public const int BusPxi = 3;

        public const int BusVxi = 4;

        public const int BusPcmcia = 5;

        public const int AnalogOutput = 0;

        public const int InternalVoltageReference = 1;

        public const int Ground = 2;

        public const int AnalogOutputDifferential = 3;

        public const int AnalogOutputPlus = 4;

        public const int AnalogOutputMinus = 5;

        public const int AnalogOutputIdle = 6;

        public const int PalB = 0;

        public const int PalD = 1;

        public const int PalG = 2;

        public const int PalH = 3;

        public const int PalI = 4;

        public const int PalM = 5;

        public const int PalN = 6;

        public const int NtscM = 7;
    }

    public enum niFgenProperties
    {

        /// <summary>
        /// System.Int32
        /// </summary>
        OutputMode = 1250001,

        /// <summary>
        /// System.Boolean
        /// </summary>
        OutputEnabled = 1250003,

        /// <summary>
        /// System.Double
        /// </summary>
        DigitalGain = 1150254,

        /// <summary>
        /// System.Int32
        /// </summary>
        AnalogPath = 1150222,

        /// <summary>
        /// System.Double
        /// </summary>
        LoadImpedance = 1150220,

        /// <summary>
        /// System.Double
        /// </summary>
        OutputImpedance = 1250004,

        /// <summary>
        /// System.Int32
        /// </summary>
        TerminalConfiguration = 1150365,

        /// <summary>
        /// System.Double
        /// </summary>
        CommonModeOffset = 1150366,

        /// <summary>
        /// System.Double
        /// </summary>
        ChannelDelay = 1150369,

        /// <summary>
        /// System.Boolean
        /// </summary>
        AnalogFilterEnabled = 1150103,

        /// <summary>
        /// System.Boolean
        /// </summary>
        DigitalFilterEnabled = 1150102,

        /// <summary>
        /// System.Int32
        /// </summary>
        DigitalFilterInterpolationFactor = 1150218,

        /// <summary>
        /// System.Boolean
        /// </summary>
        FlatnessCorrectionEnabled = 1150323,

        /// <summary>
        /// System.Int32
        /// </summary>
        AnalogDataMask = 1150234,

        /// <summary>
        /// System.Int32
        /// </summary>
        AnalogStaticValue = 1150235,

        /// <summary>
        /// System.Int32
        /// </summary>
        DigitalDataMask = 1150236,

        /// <summary>
        /// System.Int32
        /// </summary>
        DigitalStaticValue = 1150237,

        /// <summary>
        /// System.Boolean
        /// </summary>
        DigitalPatternEnabled = 1150101,

        /// <summary>
        /// System.Int32
        /// </summary>
        IdleBehavior = 1150377,

        /// <summary>
        /// System.Int32
        /// </summary>
        IdleValue = 1150378,

        /// <summary>
        /// System.Int32
        /// </summary>
        WaitBehavior = 1150379,

        /// <summary>
        /// System.Int32
        /// </summary>
        WaitValue = 1150380,

        /// <summary>
        /// System.Double
        /// </summary>
        ArbGain = 1250202,

        /// <summary>
        /// System.Double
        /// </summary>
        ArbOffset = 1250203,

        /// <summary>
        /// System.Int32
        /// </summary>
        ArbWaveformHandle = 1250201,

        /// <summary>
        /// System.Int32
        /// </summary>
        ArbMarkerPosition = 1150327,

        /// <summary>
        /// System.Int32
        /// </summary>
        ArbRepeatCount = 1150328,

        /// <summary>
        /// System.Int32
        /// </summary>
        ArbSequenceHandle = 1250211,

        /// <summary>
        /// System.Int32
        /// </summary>
        MaxNumSequences = 1250212,

        /// <summary>
        /// System.Int32
        /// </summary>
        MaxSequenceLength = 1250214,

        /// <summary>
        /// System.Int32
        /// </summary>
        MinSequenceLength = 1250213,

        /// <summary>
        /// System.Int32
        /// </summary>
        MaxLoopCount = 1250215,

        /// <summary>
        /// System.String
        /// </summary>
        ScriptToGenerate = 1150270,

        /// <summary>
        /// System.Int32
        /// </summary>
        WaveformQuantum = 1250206,

        /// <summary>
        /// System.Int32
        /// </summary>
        MaxNumWaveforms = 1250205,

        /// <summary>
        /// System.Int32
        /// </summary>
        MinWaveformSize = 1250207,

        /// <summary>
        /// System.Int32
        /// </summary>
        MaxWaveformSize = 1250208,

        /// <summary>
        /// System.Int32
        /// </summary>
        DataTransferBlockSize = 1150241,

        /// <summary>
        /// System.Int32
        /// </summary>
        FileTransferBlockSize = 1150240,

        /// <summary>
        /// System.Double
        /// </summary>
        DataTransferMaximumBandwidth = 1150373,

        /// <summary>
        /// System.Boolean
        /// </summary>
        DirectDmaEnabled = 1150244,

        /// <summary>
        /// System.Int32
        /// </summary>
        DirectDmaWindowAddress = 1150274,

        /// <summary>
        /// System.Int32
        /// </summary>
        DirectDmaWindowSize = 1150245,

        /// <summary>
        /// System.String
        /// </summary>
        StreamingWaveformName = 1150326,

        /// <summary>
        /// System.Int32
        /// </summary>
        StreamingWaveformHandle = 1150324,

        /// <summary>
        /// System.Int32
        /// </summary>
        StreamingSpaceAvailableInWaveform = 1150325,

        /// <summary>
        /// System.Int32
        /// </summary>
        DataTransferMaximumInFlightReads = 1150375,

        /// <summary>
        /// System.Boolean
        /// </summary>
        PciDmaOptimizationsEnabled = 1150362,

        /// <summary>
        /// System.Int32
        /// </summary>
        DataTransferPreferredPacketSize = 1150374,

        /// <summary>
        /// System.Boolean
        /// </summary>
        OspEnabled = 1150246,

        /// <summary>
        /// System.Double
        /// </summary>
        OspIqRate = 1150248,

        /// <summary>
        /// System.Int32
        /// </summary>
        OspDataProcessingMode = 1150247,

        /// <summary>
        /// System.Int32
        /// </summary>
        OspMode = 1150370,

        /// <summary>
        /// System.Boolean
        /// </summary>
        OspCarrierEnabled = 1150249,

        /// <summary>
        /// System.Double
        /// </summary>
        OspCarrierFrequency = 1150250,

        /// <summary>
        /// System.Double
        /// </summary>
        OspFrequencyShift = 1150371,

        /// <summary>
        /// System.Int32
        /// </summary>
        OspFirFilterType = 1150253,

        /// <summary>
        /// System.Double
        /// </summary>
        OspFirFilterFlatPassband = 1150261,

        /// <summary>
        /// System.Double
        /// </summary>
        OspFirFilterRaisedCosineAlpha = 1150260,

        /// <summary>
        /// System.Double
        /// </summary>
        OspFirFilterRootRaisedCosineAlpha = 1150259,

        /// <summary>
        /// System.Double
        /// </summary>
        OspFirFilterGaussianBt = 1150262,

        /// <summary>
        /// System.Double
        /// </summary>
        OspCarrierPhaseI = 1150251,

        /// <summary>
        /// System.Double
        /// </summary>
        OspCarrierPhaseQ = 1150252,

        /// <summary>
        /// System.Double
        /// </summary>
        OspPreFilterGainI = 1150264,

        /// <summary>
        /// System.Double
        /// </summary>
        OspPreFilterGainQ = 1150265,

        /// <summary>
        /// System.Double
        /// </summary>
        OspPreFilterOffsetI = 1150266,

        /// <summary>
        /// System.Double
        /// </summary>
        OspPreFilterOffsetQ = 1150267,

        /// <summary>
        /// System.Boolean
        /// </summary>
        OspFirFilterEnabled = 1150255,

        /// <summary>
        /// System.Double
        /// </summary>
        OspFirFilterInterpolation = 1150256,

        /// <summary>
        /// System.Boolean
        /// </summary>
        OspCicFilterEnabled = 1150257,

        /// <summary>
        /// System.Double
        /// </summary>
        OspCicFilterGain = 1150263,

        /// <summary>
        /// System.Double
        /// </summary>
        OspCicFilterInterpolation = 1150258,

        /// <summary>
        /// System.Int32
        /// </summary>
        OspOverflowErrorReporting = 1150268,

        /// <summary>
        /// System.Int32
        /// </summary>
        OspOverflowStatus = 1150269,

        /// <summary>
        /// System.Int32
        /// </summary>
        FuncWaveform = 1250101,

        /// <summary>
        /// System.Double
        /// </summary>
        FuncAmplitude = 1250102,

        /// <summary>
        /// System.Double
        /// </summary>
        FuncDcOffset = 1250103,

        /// <summary>
        /// System.Double
        /// </summary>
        FuncStartPhase = 1250105,

        /// <summary>
        /// System.Double
        /// </summary>
        FuncDutyCycleHigh = 1250106,

        /// <summary>
        /// System.Double
        /// </summary>
        SyncDutyCycleHigh = 1150105,

        /// <summary>
        /// System.String
        /// </summary>
        SyncOutOutputTerminal = 1150330,

        /// <summary>
        /// System.Double
        /// </summary>
        FuncFrequency = 1250104,

        /// <summary>
        /// System.Int32
        /// </summary>
        FuncBufferSize = 1150238,

        /// <summary>
        /// System.Int32
        /// </summary>
        FuncMaxBufferSize = 1150239,

        /// <summary>
        /// System.Int32
        /// </summary>
        FreqListHandle = 1150208,

        /// <summary>
        /// System.Int32
        /// </summary>
        MaxNumFreqLists = 1150209,

        /// <summary>
        /// System.Int32
        /// </summary>
        MaxFreqListLength = 1150211,

        /// <summary>
        /// System.Int32
        /// </summary>
        MinFreqListLength = 1150210,

        /// <summary>
        /// System.Double
        /// </summary>
        FreqListDurationQuantum = 1150214,

        /// <summary>
        /// System.Double
        /// </summary>
        MaxFreqListDuration = 1150213,

        /// <summary>
        /// System.Double
        /// </summary>
        MinFreqListDuration = 1150212,

        /// <summary>
        /// System.Double
        /// </summary>
        RefClockFrequency = 1150107,

        /// <summary>
        /// System.String
        /// </summary>
        ReferenceClockSource = 1150113,

        /// <summary>
        /// System.String
        /// </summary>
        ExportedReferenceClockOutputTerminal = 1150321,

        /// <summary>
        /// System.String
        /// </summary>
        ExportedOnboardReferenceClockOutputTerminal = 1150322,

        /// <summary>
        /// System.Double
        /// </summary>
        ArbSampleRate = 1250204,

        /// <summary>
        /// System.Int32
        /// </summary>
        ClockMode = 1150110,

        /// <summary>
        /// System.String
        /// </summary>
        SampleClockSource = 1150112,

        /// <summary>
        /// System.String
        /// </summary>
        ExportedSampleClockOutputTerminal = 1150320,

        /// <summary>
        /// System.Int32
        /// </summary>
        ExportedSampleClockDivisor = 1150219,

        /// <summary>
        /// System.String
        /// </summary>
        SampleClockTimebaseSource = 1150367,

        /// <summary>
        /// System.Double
        /// </summary>
        SampleClockTimebaseRate = 1150368,

        /// <summary>
        /// System.String
        /// </summary>
        ExportedSampleClockTimebaseOutputTerminal = 1150329,

        /// <summary>
        /// System.Int32
        /// </summary>
        ExportedSampleClockTimebaseDivisor = 1150230,

        /// <summary>
        /// System.Double
        /// </summary>
        ExternalSampleClockMultiplier = 1150376,

        /// <summary>
        /// System.Double
        /// </summary>
        SampleClockAbsoluteDelay = 1150231,

        /// <summary>
        /// System.Int32
        /// </summary>
        ExternalClockDelayBinaryValue = 1150233,

        /// <summary>
        /// System.Int32
        /// </summary>
        OscillatorPhaseDacValue = 1150232,

        /// <summary>
        /// System.String
        /// </summary>
        MarkerEventOutputTerminal = 1150312,

        /// <summary>
        /// System.Int32
        /// </summary>
        MarkerEventOutputBehavior = 1150342,

        /// <summary>
        /// System.Int32
        /// </summary>
        MarkerEventPulsePolarity = 1150313,

        /// <summary>
        /// System.Int32
        /// </summary>
        MarkerEventPulseWidthUnits = 1150341,

        /// <summary>
        /// System.Double
        /// </summary>
        MarkerEventPulseWidth = 1150340,

        /// <summary>
        /// System.Int32
        /// </summary>
        MarkerEventToggleInitialState = 1150343,

        /// <summary>
        /// System.Int32
        /// </summary>
        MarkerEventDelayUnits = 1150355,

        /// <summary>
        /// System.Double
        /// </summary>
        MarkerEventDelay = 1150354,

        /// <summary>
        /// System.Boolean
        /// </summary>
        MarkerEventLatchedStatus = 1150350,

        /// <summary>
        /// System.Int32
        /// </summary>
        AllMarkerEventsLatchedStatus = 1150349,

        /// <summary>
        /// System.Boolean
        /// </summary>
        MarkerEventLiveStatus = 1150345,

        /// <summary>
        /// System.Int32
        /// </summary>
        AllMarkerEventsLiveStatus = 1150344,

        /// <summary>
        /// System.String
        /// </summary>
        DataMarkerEventOutputTerminal = 1150339,

        /// <summary>
        /// System.Int32
        /// </summary>
        DataMarkerEventDataBitNumber = 1150337,

        /// <summary>
        /// System.Int32
        /// </summary>
        DataMarkerEventLevelPolarity = 1150338,

        /// <summary>
        /// System.String
        /// </summary>
        ReadyForStartEventOutputTerminal = 1150310,

        /// <summary>
        /// System.Int32
        /// </summary>
        ReadyForStartEventLevelActiveLevel = 1150311,

        /// <summary>
        /// System.Boolean
        /// </summary>
        ReadyForStartEventLiveStatus = 1150348,

        /// <summary>
        /// System.String
        /// </summary>
        StartedEventOutputTerminal = 1150314,

        /// <summary>
        /// System.Int32
        /// </summary>
        StartedEventOutputBehavior = 1150331,

        /// <summary>
        /// System.Int32
        /// </summary>
        StartedEventPulsePolarity = 1150318,

        /// <summary>
        /// System.Int32
        /// </summary>
        StartedEventPulseWidthUnits = 1150333,

        /// <summary>
        /// System.Double
        /// </summary>
        StartedEventPulseWidth = 1150335,

        /// <summary>
        /// System.Int32
        /// </summary>
        StartedEventLevelActiveLevel = 1150316,

        /// <summary>
        /// System.Double
        /// </summary>
        StartedEventDelay = 1150356,

        /// <summary>
        /// System.Int32
        /// </summary>
        StartedEventDelayUnits = 1150357,

        /// <summary>
        /// System.Boolean
        /// </summary>
        StartedEventLatchedStatus = 1150352,

        /// <summary>
        /// System.String
        /// </summary>
        DoneEventOutputTerminal = 1150315,

        /// <summary>
        /// System.Int32
        /// </summary>
        DoneEventOutputBehavior = 1150332,

        /// <summary>
        /// System.Int32
        /// </summary>
        DoneEventPulsePolarity = 1150319,

        /// <summary>
        /// System.Int32
        /// </summary>
        DoneEventPulseWidthUnits = 1150334,

        /// <summary>
        /// System.Double
        /// </summary>
        DoneEventPulseWidth = 1150336,

        /// <summary>
        /// System.Int32
        /// </summary>
        DoneEventLevelActiveLevel = 1150317,

        /// <summary>
        /// System.Double
        /// </summary>
        DoneEventDelay = 1150358,

        /// <summary>
        /// System.Int32
        /// </summary>
        DoneEventDelayUnits = 1150359,

        /// <summary>
        /// System.Boolean
        /// </summary>
        DoneEventLatchedStatus = 1150351,

        /// <summary>
        /// System.Int32
        /// </summary>
        TriggerMode = 1150108,

        /// <summary>
        /// System.Int32
        /// </summary>
        StartTriggerType = 1150280,

        /// <summary>
        /// System.String
        /// </summary>
        ExportedStartTriggerOutputTerminal = 1150283,

        /// <summary>
        /// System.String
        /// </summary>
        DigitalEdgeStartTriggerSource = 1150281,

        /// <summary>
        /// System.Int32
        /// </summary>
        DigitalEdgeStartTriggerEdge = 1150282,

        /// <summary>
        /// System.Int32
        /// </summary>
        ScriptTriggerType = 1150290,

        /// <summary>
        /// System.String
        /// </summary>
        ExportedScriptTriggerOutputTerminal = 1150295,

        /// <summary>
        /// System.String
        /// </summary>
        DigitalEdgeScriptTriggerSource = 1150291,

        /// <summary>
        /// System.Int32
        /// </summary>
        DigitalEdgeScriptTriggerEdge = 1150292,

        /// <summary>
        /// System.String
        /// </summary>
        DigitalLevelScriptTriggerSource = 1150293,

        /// <summary>
        /// System.Int32
        /// </summary>
        DigitalLevelScriptTriggerActiveLevel = 1150294,

        /// <summary>
        /// System.Int32
        /// </summary>
        BusType = 1150215,

        /// <summary>
        /// System.Int32
        /// </summary>
        MemorySize = 1150242,

        /// <summary>
        /// System.String
        /// </summary>
        SerialNumber = 1150243,

        /// <summary>
        /// System.Int32
        /// </summary>
        MarkerEventsCount = 1150271,

        /// <summary>
        /// System.Int32
        /// </summary>
        DataMarkerEventsCount = 1150273,

        /// <summary>
        /// System.Int32
        /// </summary>
        ScriptTriggersCount = 1150272,

        /// <summary>
        /// System.Int32
        /// </summary>
        CalAdcInput = 1150227,

        /// <summary>
        /// System.Int32
        /// </summary>
        GainDacValue = 1150223,

        /// <summary>
        /// System.Int32
        /// </summary>
        OffsetDacValue = 1150224,

        /// <summary>
        /// System.Int32
        /// </summary>
        OscillatorFreqDacValue = 1150225,

        /// <summary>
        /// System.Double
        /// </summary>
        PreAmplifierAttenuation = 1150228,

        /// <summary>
        /// System.Double
        /// </summary>
        PostAmplifierAttenuation = 1150229,

        /// <summary>
        /// System.String
        /// </summary>
        DriverSetup = 1050007,

        /// <summary>
        /// System.String
        /// </summary>
        LogicalName = 1050305,

        /// <summary>
        /// System.String
        /// </summary>
        IoResourceDescriptor = 1050304,

        /// <summary>
        /// System.Int32
        /// </summary>
        ChannelCount = 1050203,

        /// <summary>
        /// System.String
        /// </summary>
        GroupCapabilities = 1050401,

        /// <summary>
        /// System.String
        /// </summary>
        SupportedInstrumentModels = 1050327,

        /// <summary>
        /// System.Int32
        /// </summary>
        SpecificDriverClassSpecMajorVersion = 1050515,

        /// <summary>
        /// System.Int32
        /// </summary>
        SpecificDriverClassSpecMinorVersion = 1050516,

        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverDescription = 1050514,

        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverPrefix = 1050302,

        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverVendor = 1050513,

        /// <summary>
        /// System.String
        /// </summary>
        SpecificDriverRevision = 1050551,

        /// <summary>
        /// System.String
        /// </summary>
        IdQueryResponse = 1150001,

        /// <summary>
        /// System.String
        /// </summary>
        InstrumentFirmwareRevision = 1050510,

        /// <summary>
        /// System.String
        /// </summary>
        InstrumentManufacturer = 1050511,

        /// <summary>
        /// System.String
        /// </summary>
        InstrumentModel = 1050512,

        /// <summary>
        /// System.Boolean
        /// </summary>
        Cache = 1050004,

        /// <summary>
        /// System.Boolean
        /// </summary>
        InterchangeCheck = 1050021,

        /// <summary>
        /// System.Boolean
        /// </summary>
        QueryInstrumentStatus = 1050003,

        /// <summary>
        /// System.Boolean
        /// </summary>
        RangeCheck = 1050002,

        /// <summary>
        /// System.Boolean
        /// </summary>
        RecordCoercions = 1050006,

        /// <summary>
        /// System.Boolean
        /// </summary>
        Simulate = 1050005,

        /// <summary>
        /// System.Double
        /// </summary>
        FilterCorrectionFrequency = 1150104,

        /// <summary>
        /// System.Int32
        /// </summary>
        TriggerSource = 1250302,

        /// <summary>
        /// System.Int32
        /// </summary>
        Synchronization = 1150111,

        /// <summary>
        /// System.Int32
        /// </summary>
        VideoWaveformType = 1150216,

        /// <summary>
        /// System.String
        /// </summary>
        ErrorElaboration = 1050103,

        /// <summary>
        /// System.Int32
        /// </summary>
        PrimaryError = 1050101,

        /// <summary>
        /// System.Int32
        /// </summary>
        SecondaryError = 1050102,

        /// <summary>
        /// System.Int32
        /// </summary>
        OperationMode = 1250005,

        /// <summary>
        /// System.Int32
        /// </summary>
        RefClockSource = 1250002,

        /// <summary>
        /// System.Int32
        /// </summary>
        UpdateClockSource = 1150106,

        /// <summary>
        /// System.Int32
        /// </summary>
        CycleCount = 1250350,

        /// <summary>
        /// System.IntPtr
        /// </summary>
        IoSession = 1050322,

        /// <summary>
        /// System.Int32
        /// </summary>
        NumChannels = 1050203,

        /// <summary>
        /// System.Int32
        /// </summary>
        BurstCount = 1250350,

        /// <summary>
        /// System.Double
        /// </summary>
        ActualArbSampleRate = 1150109,

        /// <summary>
        /// System.Int32
        /// </summary>
        DaqmxTask = 1150221,
    }
}
