'------------------------------------------------------------------------------
' <auto-generated>
'     This code was generated by Measurement Studio.
'     Runtime Version:2.0.50727.832
'
'     Changes to this file may cause incorrect behavior and will be lost if
'     the code is regenerated.
' </auto-generated>
'------------------------------------------------------------------------------

Option Strict Off
Option Explicit On

Imports System
Imports System.Runtime.InteropServices

Namespace NationalInstruments.ModularInstruments.Interop

Public Class niFgen
    Inherits Object
    Implements System.IDisposable
    
    Private _handle As System.IntPtr
    
    Private _disposed As Boolean = true
    
    Public Structure nicomplexnumber
    Public real as System.Int64
    Public imaginary as System.Int64
    End Structure
    
    Public Structure nicomplexI16
    Public real as short
    Public imaginary as short
    End Structure 
        
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_init
    '''''
    '''''ViStatus niFgen_init&#160;(ViRsrc&#160;resourceName, ViBoolean&#160;idQuery, ViBoolean&#160;resetDevice, ViSession* vi);
    '''''
    '''''Purpose
    '''''
    '''''Performs the following initialization actions:
    '''''
    '''''Creates a new IVI instrument driver session.
    '''''
    '''''Opens a session to the specified device using the interface and address that you specify for the resourceName parameter.
    '''''
    '''''If the IDQuery parameter is set to VI_TRUE, this function queries the device ID and checks that the ID is valid for NI-FGEN.
    '''''
    '''''If the resetDevice parameter is set to VI_TRUE, this function resets the device to a known state.
    '''''
    '''''Sends initialization commands to set the device to the state necessary for the operation of NI-FGEN.
    '''''
    '''''Returns a session handle that you can use to identify the device in all subsequent NI-FGEN function calls.
    '''''
    '''''</summary>
    '''''<param name="Resource_Name">
    '''''
    '''''
    '''''resourceName
    '''''ViRsrc
    '''''Specifies the resource name of the device to initialize.
    '''''
    '''''
    '''''
    '''''                                                Example&#160;#
    '''''                Device Type
    '''''                Syntax
    '''''                Variable
    '''''            
    '''''                            1
    '''''                Traditional NI-DAQ device
    '''''                DAQ::1
    '''''                (1 = device number)
    '''''            
    '''''                            2
    '''''                NI-DAQmx device
    '''''                myDAQmxDevice
    '''''                (myDAQmxDevice = device name)
    '''''            
    '''''                            3
    '''''                NI-DAQmx device
    '''''                DAQ::myDAQmxDevice
    '''''                (myDAQmxDevice = device name)
    '''''            
    '''''                            4
    '''''                NI-DAQmx device
    '''''                DAQ::2
    '''''                (2 = device name)
    '''''            
    '''''                            5
    '''''                IVI logical name or IVI virtual name
    '''''                myLogicalName
    '''''                (myLogicalName = name)
    '''''            
    '''''        
    '''''
    '''''For Traditional NI-DAQ devices, the syntax is DAQ::n, where n is the device number assigned by MAX, as shown in Example 1. 
    '''''
    '''''For NI-DAQmx devices, the syntax is just the device name specified in MAX, as shown in Example 2. Typical default names for NI-DAQmx devices in MAX are Dev1 or PXI1Slot1. You can rename an NI-DAQmx device by right-clicking on the name in MAX and entering a new name.
    '''''
    '''''An alternate syntax for NI-DAQmx devices consists of DAQ::NI-DAQmx device name, as shown in Example 3. This naming convention allows for the use of an NI-DAQmx device in an application that was originally designed for a Traditional NI-DAQ device. For example, if the application expects DAQ::1, you can rename the NI-DAQmx device to 1 in MAX and pass in DAQ::1 for the resource name, as shown in Example 4. 
    '''''
    '''''If you use the DAQ::n syntax and an NI-DAQmx device name already exists with that same name, the NI-DAQmx device is matched first. 
    '''''
    '''''You can also pass in the name of an IVI logical name or an IVI virtual name configured with the IVI Configuration utility, as shown in Example 5. A logical name identifies a particular virtual instrument. A virtual name identifies a specific device and specifies the initial settings for the session. 
    '''''
    '''''
    '''''Caution&#160;&#160;Traditional NI-DAQ and NI-DAQmx device names are not case-sensitive. However, all IVI names, such as logical names, are case-sensitive. If you use logical names, driver session names, or virtual names in your program, you must ensure that the name you use matches the name in the IVI Configuration Store file exactly, without any variations in the case of the characters.
    '''''
    ''''' 
    '''''</param>
    '''''<param name="ID_Query">
    '''''
    '''''
    '''''idQuery
    '''''ViBoolean
    '''''Specifies whether you want NI-FGEN to perform an ID query.
    '''''            
    '''''            When you set this parameter to VI_TRUE, NI-FGEN verifies that the device that you initialize is supported.
    '''''
    '''''Circumstances can arise where sending an ID query to the device is undesirable. When you set this parameter to VI_FALSE, the function initializes the device without performing an ID query.
    '''''
    '''''Defined Values
    '''''
    '''''VI_TRUEPerform ID query
    '''''VI_FALSESkip ID query
    '''''
    '''''Default Value: VI_TRUE
    ''''' 
    '''''</param>
    '''''<param name="Reset_Device">
    '''''
    '''''
    '''''resetDevice
    '''''ViBoolean
    '''''Specifies whether you want to reset the device during the initialization procedure.
    '''''
    '''''Defined Values
    '''''
    ''''' VI_TRUEReset device
    '''''VI_FALSEDo not reset device
    '''''
    '''''Default Value: VI_TRUE
    ''''' 
    '''''</param>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession*
    '''''Returns a session handle that you can use to identify the device in all subsequent NI-FGEN function calls.
    ''''' 
    '''''</param>
    Public Sub New(ByVal Resource_Name As String, ByVal ID_Query As Boolean, ByVal Reset_Device As Boolean)
        MyBase.New
        Dim pInvokeResult As Integer = PInvoke.init(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Device), Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Me._disposed = false
    End Sub
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_InitWithOptions
    '''''
    '''''ViStatus niFgen_InitWithOptions&#160;(ViRsrc&#160;resourceName, ViBoolean&#160;idQuery, ViBoolean&#160;resetDevice, ViString&#160;optionString, ViSession&#160;*vi);
    '''''
    '''''Purpose
    '''''
    '''''Performs the following initialization actions:
    '''''
    '''''Creates a new IVI instrument session and optionally sets the initial state of the following session attributes: RangeCheck, QueryInstrStatus, Cache, Simulate, and RecordCoersions.
    '''''Opens a session to the specified device using the interface and address that you specify for resourceName.
    '''''If IDQuery is set to VI_TRUE, this function queries the device ID and checks that it is valid for NI-FGEN.
    '''''If resetDevice is set to VI_TRUE, this function resets the device to a known state.
    '''''Sends initialization commands to set the instrument to the state necessary for NI-FGEN operation.
    '''''Returns a session handle that you can use to identify the device in all subsequent NI-FGEN function calls.
    '''''
    '''''</summary>
    '''''<param name="Resource_Name">
    '''''
    '''''
    '''''resourceName
    '''''ViRsrc
    '''''Specifies the resource name of the device to initialize.
    '''''
    '''''
    '''''
    '''''                                                Example&#160;#
    '''''                Device Type
    '''''                Syntax
    '''''                Variable
    '''''            
    '''''                            1
    '''''                Traditional NI-DAQ device
    '''''                DAQ::1
    '''''                (1 = device number)
    '''''            
    '''''                            2
    '''''                NI-DAQmx device
    '''''                myDAQmxDevice
    '''''                (myDAQmxDevice = device name)
    '''''            
    '''''                            3
    '''''                NI-DAQmx device
    '''''                DAQ::myDAQmxDevice
    '''''                (myDAQmxDevice = device name)
    '''''            
    '''''                            4
    '''''                NI-DAQmx device
    '''''                DAQ::2
    '''''                (2 = device name)
    '''''            
    '''''                            5
    '''''                IVI logical name or IVI virtual name
    '''''                myLogicalName
    '''''                (myLogicalName = name)
    '''''            
    '''''        
    '''''
    '''''For Traditional NI-DAQ devices, the syntax is DAQ::n, where n is the device number assigned by MAX, as shown in Example 1. 
    '''''
    '''''For NI-DAQmx devices, the syntax is just the device name specified in MAX, as shown in Example 2. Typical default names for NI-DAQmx devices in MAX are Dev1 or PXI1Slot1. You can rename an NI-DAQmx device by right-clicking on the name in MAX and entering a new name.
    '''''
    '''''An alternate syntax for NI-DAQmx devices consists of DAQ::NI-DAQmx device name, as shown in Example 3. This naming convention allows for the use of an NI-DAQmx device in an application that was originally designed for a Traditional NI-DAQ device. For example, if the application expects DAQ::1, you can rename the NI-DAQmx device to 1 in MAX and pass in DAQ::1 for the resource name, as shown in Example 4. 
    '''''
    '''''If you use the DAQ::n syntax and an NI-DAQmx device name already exists with that same name, the NI-DAQmx device is matched first. 
    '''''
    '''''You can also pass in the name of an IVI logical name or an IVI virtual name configured with the IVI Configuration utility, as shown in Example 5. A logical name identifies a particular virtual instrument. A virtual name identifies a specific device and specifies the initial settings for the session. 
    '''''
    '''''
    '''''Caution&#160;&#160;Traditional NI-DAQ and NI-DAQmx device names are not case-sensitive. However, all IVI names, such as logical names, are case-sensitive. If you use logical names, driver session names, or virtual names in your program, you must ensure that the name you use matches the name in the IVI Configuration Store file exactly, without any variations in the case of the characters.
    '''''
    ''''' 
    '''''</param>
    '''''<param name="ID_Query">
    '''''
    '''''
    '''''idQuery
    '''''ViBoolean
    '''''Specify whether you want NI-FGEN to perform an ID query.
    '''''            
    '''''            When you set this parameter to VI_TRUE, NI-FGEN verifies that the device that you initialize is a type that it supports.
    '''''
    '''''Circumstances can arise where sending an ID query to the device is undesirable. When you set this parameter to VI_FALSE, the function initializes the device without performing an ID query.
    '''''
    '''''Defined Values
    '''''
    '''''VI_TRUEPerform ID query
    '''''VI_FALSESkip ID query
    '''''
    '''''Default Value: VI_TRUE
    ''''' 
    '''''</param>
    '''''<param name="Reset_Device">
    '''''
    '''''
    '''''resetDevice
    '''''ViBoolean
    '''''Specifies whether you want to reset the device during the initialization procedure.
    '''''
    '''''Defined Values
    '''''
    ''''' VI_TRUEReset device
    '''''VI_FALSEDo not reset device
    '''''
    '''''Default Value: VI_TRUE
    ''''' 
    '''''</param>
    '''''<param name="Option_String">
    '''''
    '''''
    '''''optionString
    '''''ViString
    '''''           Sets the initial value of certain session attributes.
    '''''
    '''''The syntax for optionString is
    '''''
    '''''            &lt;attributeName&gt;&#160;=&#160;&lt;value&gt;
    '''''            
    '''''            where
    '''''            
    '''''            attributeName is the name of the attribute and value is the value to which the attribute is set
    '''''
    '''''            To set multiple attributes, separate them with a comma.
    '''''
    '''''If you pass NULL or an empty string for this parameter, the session uses the default values for these attributes. You can override the default values by assigning a value explicitly in a string that you pass for this parameter.
    '''''
    '''''You do not have to specify all of the attributes and may leave any of them out. However, if you do not specify one of the attributes, its default value is used.
    '''''
    '''''If simulation is enabled (Simulate=1), you may specify the device that you want to simulate. To specify a device, enter the following syntax in optionString.
    '''''
    '''''DriverSetup=Model:&lt;driver model number&gt;;Channels:&lt;channel names&gt;;BoardType:&lt;module type&gt;;MemorySize:&lt;size of onboard memory in bytes&gt;
    '''''
    '''''            
    '''''Syntax Examples
    '''''
    '''''    Device
    '''''    optionString Syntax
    '''''    NI PXI-5404
    '''''    DriverSetup=Model:5404;BoardType:PXI
    '''''    NI PCI-5411
    '''''    DriverSetup=Model:5411;BoardType:PCI;MemorySize:8000000
    '''''NI PXIe-5450
    '''''    DriverSetup=Model:5450;Channels:0-1;BoardType:PXIe;MemorySize:8000000
    '''''
    '''''Attributes and Defined Values
    '''''      
    '''''    Attribute Name
    '''''    Attribute
    '''''    Values
    '''''    
    '''''    RangeCheck
    '''''    NIFGEN_ATTR_RANGE_CHECK
    '''''    VI_TRUE, VI_FALSE
    '''''    
    '''''    QueryInstrStatus
    '''''    NIFGEN_ATTR_QUERY_INSTRUMENT_STATUS
    '''''    VI_TRUE, VI_FALSE
    '''''    
    '''''    Cache
    '''''    NIFGEN_ATTR_CACHE
    '''''    VI_TRUE, VI_FALSE
    '''''    
    '''''    Simulate
    '''''    NIFGEN_ATTR_SIMULATE
    '''''    VI_TRUE, VI_FALSE
    '''''
    '''''Default Values: &quot;Simulate=0,RangeCheck=1,QueryInstrStatus=1,Cache=1&quot;
    ''''' 
    '''''
    '''''
    '''''</param>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Returns a session handle that you can use to identify the device in all subsequent NI-FGEN function calls.
    ''''' 
    '''''</param>
    Public Sub New(ByVal Resource_Name As String, ByVal ID_Query As Boolean, ByVal Reset_Device As Boolean, ByVal Option_String As String)
        MyBase.New
        Dim pInvokeResult As Integer = PInvoke.InitWithOptions(Resource_Name, System.Convert.ToUInt16(ID_Query), System.Convert.ToUInt16(Reset_Device), Option_String, Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Me._disposed = false
    End Sub
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_InitExtCal
    '''''
    '''''ViStatus niFgen_InitExtCal&#160;(ViRsrc&#160;resourceName, ViConstString&#160;password, ViSession*&#160;vi);
    '''''
    '''''Purpose
    '''''
    '''''Creates and initializes a special NI-FGEN external calibration session.  The ViSession returned is an NI-FGEN session that can be used to configure the device using normal attributes and functions.  However, flags have been set that allow you to program an external calibration procedure using the special calibration attributes and functions.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="Resource_Name">
    '''''
    '''''
    '''''resourceName
    '''''ViRsrc
    '''''Specifies the resource name of the device to initialize.
    '''''
    '''''
    '''''
    '''''                                                Example&#160;#
    '''''                Device Type
    '''''                Syntax
    '''''                Variable
    '''''            
    '''''                            1
    '''''                Traditional NI-DAQ device
    '''''                DAQ::1
    '''''                (1 = device number)
    '''''            
    '''''                            2
    '''''                NI-DAQmx device
    '''''                myDAQmxDevice
    '''''                (myDAQmxDevice = device name)
    '''''            
    '''''                            3
    '''''                NI-DAQmx device
    '''''                DAQ::myDAQmxDevice
    '''''                (myDAQmxDevice = device name)
    '''''            
    '''''                            4
    '''''                NI-DAQmx device
    '''''                DAQ::2
    '''''                (2 = device name)
    '''''            
    '''''                            5
    '''''                IVI logical name or IVI virtual name
    '''''                myLogicalName
    '''''                (myLogicalName = name)
    '''''            
    '''''        
    '''''
    '''''For Traditional NI-DAQ devices, the syntax is DAQ::n, where n is the device number assigned by MAX, as shown in Example 1. 
    '''''
    '''''For NI-DAQmx devices, the syntax is just the device name specified in MAX, as shown in Example 2. Typical default names for NI-DAQmx devices in MAX are Dev1 or PXI1Slot1. You can rename an NI-DAQmx device by right-clicking on the name in MAX and entering a new name.
    '''''
    '''''An alternate syntax for NI-DAQmx devices consists of DAQ::NI-DAQmx device name, as shown in Example 3. This naming convention allows for the use of an NI-DAQmx device in an application that was originally designed for a Traditional NI-DAQ device. For example, if the application expects DAQ::1, you can rename the NI-DAQmx device to 1 in MAX and pass in DAQ::1 for the resource name, as shown in Example 4. 
    '''''
    '''''If you use the DAQ::n syntax and an NI-DAQmx device name already exists with that same name, the NI-DAQmx device is matched first. 
    '''''
    '''''You can also pass in the name of an IVI logical name or an IVI virtual name configured with the IVI Configuration utility, as shown in Example 5. A logical name identifies a particular virtual instrument. A virtual name identifies a specific device and specifies the initial settings for the session. 
    '''''
    '''''
    '''''Caution&#160;&#160;Traditional NI-DAQ and NI-DAQmx device names are not case-sensitive. However, all IVI names, such as logical names, are case-sensitive. If you use logical names, driver session names, or virtual names in your program, you must ensure that the name you use matches the name in the IVI Configuration Store file exactly, without any variations in the case of the characters.
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Password">
    '''''
    '''''
    '''''password
    '''''ViConstString
    '''''The calibration password required to open an external calibration session to the device.
    ''''' 
    '''''</param>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Returns a session handle that you can use to identify the device in all subsequent NI-FGEN function calls.
    ''''' 
    '''''</param>
    Public Sub New(ByVal Resource_Name As String, ByVal Password As String)
        MyBase.New
        Dim pInvokeResult As Integer = PInvoke.InitExtCal(Resource_Name, Password, Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Me._disposed = false
    End Sub
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_Commit
    '''''
    '''''ViStatus niFgen_Commit&#160;(ViSession vi);
    '''''
    '''''Purpose
    '''''
    '''''Causes a transition to the Committed state. This function verifies attribute values, reserves the device, and commits the attribute values to the device. If the attributes values are all valid, the device configuration matches the session configuration.
    '''''
    '''''In the Committed state, you can load waveforms, scripts, and sequences into memory. If any attributes are changed, NI-FGEN implicitly transitions back to the Idle state, where you can program all session properties before applying them to the device. This function has no effect if the device is already in the Committed state, and returns a successful status value. This function returns an error if it is called in the Generating state.
    '''''
    '''''Using this function has the following benefits:
    '''''
    '''''The niFgen_InitiateGeneration function occurs faster because the device is configured.
    '''''Routes are committed, so signals are exported or imported.
    '''''The PLL and all DCMs are locked.
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function Commit() As Integer
        Dim pInvokeResult As Integer = PInvoke.Commit(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_reset
    '''''
    '''''ViStatus niFgen_Reset&#160;(ViSession&#160;vi);
    '''''
    '''''Purpose
    '''''
    '''''Resets the instrument to a known state. This function aborts the generation, clears all 
    '''''routes, and resets session attributes to the default values. This function does not, 
    '''''however, commit the session properties or configure the device hardware to its default 
    '''''state.
    '''''<!-- Link to Additional VI/Function Information -->
    '''''
    '''''
    '''''Note&#160;&#160;For the NI 5401/5404/5411/5431, this function exhibits the 
    '''''same behavior as the niFgen_ResetDevice function.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function reset() As Integer
        Dim pInvokeResult As Integer = PInvoke.reset(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureOperationMode
    '''''
    '''''ViStatus niFgen_ConfigureOperationMode&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;operationMode);
    '''''
    '''''Purpose
    '''''
    '''''Determines how the signal generator produces waveforms. NI signal generators support only Continuous operation mode. To control trigger mode, use the niFgen_ConfigureTriggerMode function.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to configure the operation mode.
    '''''
    '''''Defined Value: &quot;0&quot;
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Operation_Mode">
    '''''
    '''''
    '''''operationMode
    '''''ViInt32
    '''''Specifies the operation mode you want the signal generator to use.  NI-FGEN sets the NIFGEN_ATTR_OPERATION_MODE attribute to this value. Only one value is supported.
    '''''
    '''''Defined Value:  NIFGEN_VAL_OPERATE_CONTINUOUS
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureOperationMode(ByVal Channel_Name As String, ByVal Operation_Mode As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureOperationMode(Me._handle, Channel_Name, Operation_Mode)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureOutputMode
    '''''
    '''''ViStatus niFgen_ConfigureOutputMode&#160;(ViSession&#160;vi, ViInt32&#160;outputMode);
    '''''
    '''''Purpose
    '''''
    '''''Configures the output mode of the signal generator. The output mode determines the type of waveforms the signal generator produces.
    '''''
    '''''For example, you can choose to generate a standard waveform, an arbitrary waveform, or a sequence of arbitrary waveforms.  
    '''''
    '''''
    '''''Note&#160;&#160; The signal generator must not be in the Generating state when you call this function.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Output_Mode">
    '''''
    '''''
    '''''outputMode
    '''''ViInt32
    '''''Specifies the output mode that you want the signal generator to use.  The value you specify determines which functions and attributes you can use to configure the waveform the signal generator produces.
    '''''
    '''''
    '''''
    '''''Refer to the NIFGEN_ATTR_OUTPUT_MODE attribute for more information on setting this parameter. 
    '''''
    '''''
    '''''
    '''''Defined Values
    '''''
    '''''
    '''''     
    '''''NIFGEN_VAL_OUTPUT_FUNC
    '''''Standard Function mode&#8212; Generates standard function waveforms such as sine, square, triangle, and so on.
    '''''     
    '''''NIFGEN_VAL_OUTPUT_FREQ_LIST
    '''''Frequency List mode&#8212;Generates a standard function using a list of frequencies you define.
    '''''       
    '''''NIFGEN_VAL_OUTPUT_ARB
    '''''Arbitrary waveform mode&#8212;Generates waveforms from user-created/provided waveform arrays of numeric data
    '''''       
    '''''NIFGEN_VAL_OUTPUT_SEQ
    '''''Arbitrary sequence mode &#8212;Generates downloaded waveforms in an order your specify.
    '''''
    '''''NIFGEN_VAL_OUTPUT_SCRIPT
    '''''Script mode&#8212;Allows you to use scripting to link and loop multiple waveforms in complex combinations
    '''''
    '''''
    '''''
    '''''
    '''''Default Value: NIFGEN_VAL_OUTPUT_FUNC
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureOutputMode(ByVal Output_Mode As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureOutputMode(Me._handle, Output_Mode)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureChannels
    '''''
    '''''ViStatus niFgen_ConfigureChannels&#160;(ViSession&#160;vi, ViConstString&#160;channels);
    '''''
    '''''Purpose
    '''''
    '''''Configures the channels to use with the instrument specified in the vi parameter.  If you call this function, you must call it immediately after initializing your session and before configuring attributes or writing data.
    '''''
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channels">
    '''''
    '''''
    '''''
    '''''channels
    '''''ViConstString
    '''''
    '''''Specifies the channel on which all subsequent channel-based attributes  in the session are set.   Valid values are non-negative integers. For example, 0 is the only valid value on devices with one channel, while devices with two channels support values of 0 and 1. You can specify more than one channel by inserting  commas between values (for example, &quot;0,1&quot;).
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureChannels(ByVal Channels As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureChannels(Me._handle, Channels)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureOutputEnabled
    '''''
    '''''ViStatus niFgen_ConfigureOutputEnabled&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViBoolean&#160;enabled);
    '''''
    '''''Purpose
    '''''
    '''''Enables or disables the signal generator output.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to enable the output.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Enabled">
    '''''
    '''''
    '''''enabled
    '''''ViBoolean
    '''''Specifies whether you want to enable or disable the output. NI-FGEN uses this value to set the NIFGEN_ATTR_OUTPUT_ENABLED attribute.
    '''''
    '''''Defined Values
    '''''
    '''''VI_TRUE
    '''''Enable the output
    '''''
    '''''VI_FALSE
    '''''Disable the output
    '''''
    '''''Default Value: VI_TRUE
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureOutputEnabled(ByVal Channel_Name As String, ByVal Enabled As Boolean) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureOutputEnabled(Me._handle, Channel_Name, System.Convert.ToUInt16(Enabled))
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureOutputImpedance
    '''''
    '''''ViStatus niFgen_ConfigureOutputImpedance&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViReal64&#160;impedance);
    '''''
    '''''Purpose
    '''''
    '''''Configures the output impedance for the channel you specify.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to set the output impedance.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Impedance">
    '''''
    '''''
    '''''impedance
    '''''ViReal64
    '''''Specifies the impedance value that you want the signal generator to use.  NI-FGEN sets the NIFGEN_ATTR_OUTPUT_IMPEDANCE attribute to this value. 
    '''''
    '''''Units: &#8486; (ohms)
    '''''
    '''''Defined Values:
    '''''
    '''''NIFGEN_VAL_50_OHMS50 &#8486; of impedance
    '''''NIFGEN_VAL_75_OHMS75 &#8486; of impedance
    '''''
    '''''
    '''''Default Value: NIFGEN_VAL_50_OHMS
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureOutputImpedance(ByVal Channel_Name As String, ByVal Impedance As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureOutputImpedance(Me._handle, Channel_Name, Impedance)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_EnableAnalogFilter
    '''''
    '''''ViStatus niFgen_EnableAnalogFilter&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViReal64&#160;filterCorrectionFrequency);
    '''''
    '''''Purpose
    '''''
    '''''Enables the analog filter. You can also specify the filter correction frequency of the analog filter. This sets the NIFGEN_ATTR_ANALOG_FILTER_ENABLED attribute to VI_TRUE. This function is valid in Arbitrary Waveform, Arbitrary Sequence, and Script output modes. This function can also be used in Standard Function and Frequency List output modes for user-defined waveforms.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to enable the analog filter.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Filter_Correction_Frequency">
    '''''
    '''''
    '''''filterCorrectionFrequency
    '''''ViReal64
    '''''Specifies the filter correction frequency of the analog filter. On the NI&#160;5411 and NI&#160;5431, 
    '''''NI-FGEN adjusts signal amplitude to compensate for the filter attenuation at that 
    '''''frequency. To disable amplitude correction, set filterCorrectionFrequency to 0. For 
    '''''Standard function output mode, the filter correction frequency typically should  be set to
    '''''the same value  as the frequency of the standard waveform. 
    '''''Units: hertz
    '''''
    '''''Default Value: 0
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function EnableAnalogFilter(ByVal Channel_Name As String, ByVal Filter_Correction_Frequency As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.EnableAnalogFilter(Me._handle, Channel_Name, Filter_Correction_Frequency)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_DisableAnalogFilter
    '''''
    '''''ViStatus niFgen_DisableAnalogFilter&#160;(ViSession&#160;vi, ViConstString&#160;channelName);
    '''''
    '''''Purpose
    '''''
    '''''Disables the analog filter. This function sets the NIFGEN_ATTR_ANALOG_FILTER_ENABLED attribute to VI_FALSE. This function is valid in Arbitrary Waveform, Arbitrary Sequence, and Script output modes. This function can also be used in Standard Function and Frequency List output modes for user-defined waveforms.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to disable the analog filter.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function DisableAnalogFilter(ByVal Channel_Name As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.DisableAnalogFilter(Me._handle, Channel_Name)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_EnableDigitalFilter
    '''''
    '''''ViStatus niFgen_EnableDigitalFilter&#160;(ViSession&#160;vi, ViConstString&#160;channelName);
    '''''
    '''''Purpose
    '''''
    '''''Enables the digital filter by setting the NIFGEN_ATTR_DIGITAL_FILTER_ENABLED attribute to VI_TRUE. This function is valid in Arbitrary Waveform, Arbitrary Sequence, and Script output modes. This function can also be used in Standard Function and Frequency List output modes for user-defined waveforms.
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to enable the digital filter.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function EnableDigitalFilter(ByVal Channel_Name As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.EnableDigitalFilter(Me._handle, Channel_Name)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_DisableDigitalFilter
    '''''
    '''''ViStatus niFgen_DisableDigitalFilter&#160;(ViSession&#160;vi, ViConstString&#160;channelName);
    '''''
    '''''Purpose
    '''''
    '''''Disables the digital filter. This function sets the NIFGEN_ATTR_DIGITAL_FILTER_ENABLED attribute to VI_FALSE. This function is valid in Arbitrary Waveform, Arbitrary Sequence, and Script output modes. This function can also be used in Standard Function and Frequency List output modes for user-defined waveforms.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to disable the digital filter. 
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function DisableDigitalFilter(ByVal Channel_Name As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.DisableDigitalFilter(Me._handle, Channel_Name)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_EnableDigitalPatterning
    '''''
    '''''ViStatus niFgen_EnableDigitalPatterning&#160;(ViSession&#160;vi, ViConstString&#160;channelName);
    '''''
    '''''Purpose
    '''''
    '''''Enables digital patterning on the signal generator. This function sets the NIFGEN_ATTR_DIGITAL_PATTERN_ENABLED attribute to VI_TRUE.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to enable the digital patterning.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function EnableDigitalPatterning(ByVal Channel_Name As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.EnableDigitalPatterning(Me._handle, Channel_Name)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_DisableDigitalPatterning
    '''''
    '''''ViStatus niFgen_DisableDigitalPatterning&#160;(ViSession&#160;vi, ViConstString&#160;channelName);
    '''''
    '''''Purpose
    '''''
    '''''Disables digital patterning on the signal generator. This function sets the NIFGEN_ATTR_DIGITAL_PATTERN_ENABLED attribute to VI_FALSE.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to disable digital patterning.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function DisableDigitalPatterning(ByVal Channel_Name As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.DisableDigitalPatterning(Me._handle, Channel_Name)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureStandardWaveform
    '''''
    '''''ViStatus niFgen_ConfigureStandardWaveform&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;waveform, ViReal64&#160;amplitude, ViReal64&#160;dcOffset, ViReal64&#160;frequency, ViReal64&#160;startPhase);
    '''''
    '''''Purpose
    '''''
    '''''Configures the attributes of the signal generator that affect standard waveform generation (the
    '''''
    '''''  NIFGEN_ATTR_FUNC_WAVEFORM, 
    '''''
    '''''  NIFGEN_ATTR_FUNC_AMPLITUDE, 
    '''''
    '''''  NIFGEN_ATTR_FUNC_DC_OFFSET, 
    '''''
    '''''  NIFGEN_ATTR_FUNC_FREQUENCY, 
    '''''
    '''''and   NIFGEN_ATTR_FUNC_START_PHASE attributes).
    '''''
    '''''
    '''''
    '''''Note&#160;&#160;You must use the 
    '''''
    '''''  niFgen_ConfigureOutputMode function with the outputMode parameter set to NIFGEN_VAL_OUTPUT_FUNC before calling this function.
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to configure a standard waveform.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Waveform">
    '''''
    '''''
    '''''waveform
    '''''ViInt32
    '''''Specifies the standard waveform that you want the signal generator to produce. NI-FGEN sets the NIFGEN_ATTR_FUNC_WAVEFORM attribute to this value.
    '''''
    '''''Defined Values
    '''''
    '''''NIFGEN_VAL_WFM_SINE
    '''''Sinusoidal waveform
    '''''
    '''''NIFGEN_VAL_WFM_SQUARE
    '''''Square waveform
    '''''
    '''''NIFGEN_VAL_WFM_TRIANGLE
    '''''Triangular waveform
    '''''
    '''''NIFGEN_VAL_WFM_RAMP_UP
    '''''Positive ramp waveform
    '''''
    '''''NIFGEN_VAL_WFM_RAMP_DOWN
    '''''Negative ramp waveform
    '''''
    '''''NIFGEN_VAL_WFM_DC
    '''''Constant voltage
    '''''
    '''''NIFGEN_VAL_WFM_NOISE
    '''''White noise
    '''''
    '''''NIFGEN_VAL_WFM_USER
    '''''User-defined waveform as defined with the niFgen_DefineUserStandardWaveform function
    '''''
    '''''Default Value: NIFGEN_VAL_WFM_SINE
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Amplitude">
    '''''
    '''''
    '''''amplitude
    '''''ViReal64
    '''''Specifies the amplitude of the standard waveform that you want the signal generator to produce. This value is the amplitude at the output terminal. NI-FGEN sets the NIFGEN_ATTR_FUNC_AMPLITUDE attribute to this value. 
    '''''
    '''''For example, to produce a waveform ranging from &#8211;5.00 to +5.00&#160;V, set the amplitude to 10.00&#160;V.
    '''''
    '''''
    '''''
    '''''Note&#160;&#160; This parameter does not affect signal generator behavior when you set the waveform parameter of the niFgen_ConfigureStandardWaveform function to NIFGEN_VAL_WFM_DC.
    '''''
    '''''Units: peak-to-peak voltage
    '''''
    '''''Default Value: None
    '''''
    ''''' 
    '''''</param>
    '''''<param name="DC_Offset">
    '''''
    '''''
    '''''dcOffset
    '''''ViReal64
    '''''Specifies the DC offset of the standard waveform that you want the signal generator to produce. This value is the offset at the output terminal (the offset is from ground to the center of the waveform).  NI-FGEN sets the NIFGEN_ATTR_FUNC_DC_OFFSET attribute to this value.  
    '''''
    '''''For example, to configure a waveform with an amplitude of 10.00&#160;V to range from 0.00 to +10.00&#160;V, set the DC Offset to 5.00&#160;V.
    '''''
    '''''Units: volts
    '''''
    '''''Default Value: None
    ''''' 
    '''''</param>
    '''''<param name="Frequency">
    '''''
    '''''
    '''''frequency
    '''''ViReal64
    '''''Specifies the frequency of the standard waveform that you want the signal generator to produce. NI-FGEN sets the NIFGEN_ATTR_FUNC_FREQUENCY attribute to this value.
    '''''
    '''''
    '''''
    '''''
    '''''Notes&#160;&#160;This parameter does not affect signal generator behavior when you set the waveform parameter of the niFgen_ConfigureStandardWaveform function to NIFGEN_VAL_WFM_DC.
    '''''
    '''''Frequency ranges vary from device to device. For information about the frequencies supported on your device, refer to the Features supported topic for your device.
    '''''
    '''''
    '''''Units: hertz
    '''''Default Value: None
    ''''' 
    '''''</param>
    '''''<param name="Start_Phase">
    '''''
    '''''
    '''''startPhase
    '''''ViReal64
    '''''Specifies the horizontal offset of the standard waveform you want the  signal generator to produce. Specify this attribute in degrees of one waveform cycle. NI-FGEN sets the NIFGEN_ATTR_FUNC_START_PHASE attribute to this value. A start phase of 180 degrees means output generation begins halfway through the waveform. A start phase of 360 degrees offsets the output by an entire waveform cycle, which is identical to a start phase of 0 degrees.
    '''''
    '''''
    '''''Note&#160;&#160; This parameter does not affect signal generator behavior when you set the waveform parameter to NIFGEN_VAL_WFM_DC.
    '''''
    '''''Units: degrees of one cycle
    '''''
    '''''Default Value: 0.00
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureStandardWaveform(ByVal Channel_Name As String, ByVal Waveform As Integer, ByVal Amplitude As Double, ByVal DC_Offset As Double, ByVal Frequency As Double, ByVal Start_Phase As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureStandardWaveform(Me._handle, Channel_Name, Waveform, Amplitude, DC_Offset, Frequency, Start_Phase)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_DefineUserStandardWaveform
    '''''
    '''''ViStatus niFgen_DefineUserStandardWaveform&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;waveformSize, ViReal64[]&#160;waveformDataArray);
    '''''
    '''''Purpose
    '''''
    '''''Defines a user waveform for use in either Standard Function output mode or Frequency List output mode.  
    '''''
    '''''To select the waveform, set the waveform parameter to 
    '''''NIFGEN_VAL_WFM_USER with either the niFgen_ConfigureStandardWaveform or the niFgen_CreateFreqList function.
    '''''
    '''''The waveform data must be scaled between -1.0 and 1.0. Use the 
    '''''amplitude parameter to generate different output voltages.
    '''''
    '''''
    '''''Note&#160;&#160;You must set outputMode to
    '''''NIFGEN_VAL_OUTPUT_FUNC or
    '''''NIFGEN_VAL_OUTPUT_FREQ_LIST using the niFgen_ConfigureOutputMode function 
    '''''before calling this function. 
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to define a user standard waveform.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Size">
    '''''
    '''''
    '''''waveformSize
    '''''ViInt32
    '''''Specifies the size of the arbitrary waveform you want to create.
    '''''
    '''''Default Value: 16384
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Data_Array">
    '''''
    '''''
    '''''waveformDataArray
    '''''ViReal64[]
    '''''Specifies the array of data you want to use for the new arbitrary waveform. The array must have at least as many elements as the value that you specify in waveformSize.
    '''''
    '''''You must normalize the data points in the array to be between &#8211;1.00 and +1.00.
    '''''
    '''''Default Value: None
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function DefineUserStandardWaveform(ByVal Channel_Name As String, ByVal Waveform_Size As Integer, ByVal Waveform_Data_Array() As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.DefineUserStandardWaveform(Me._handle, Channel_Name, Waveform_Size, Waveform_Data_Array)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ClearUserStandardWaveform
    '''''
    '''''ViStatus niFgen_ClearUserStandardWaveform&#160;(ViSession&#160;vi, ViConstString&#160;channelName);
    '''''
    '''''Purpose
    '''''
    '''''Clears the user-defined waveform created by the niFgen_DefineUserStandardWaveform function.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name from which you want to clear a user standard waveform.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ClearUserStandardWaveform(ByVal Channel_Name As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.ClearUserStandardWaveform(Me._handle, Channel_Name)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureFrequency
    '''''
    '''''ViStatus niFgen_ConfigureFrequency&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViReal64&#160;frequency);
    '''''
    '''''Purpose
    '''''
    '''''Configures the frequency of the standard waveform that you want the signal generator to produce.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to configure a standard waveform.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Frequency">
    '''''
    '''''
    '''''frequency
    '''''ViReal64
    '''''Specifies the frequency of the standard waveform that you want the signal generator to produce. NI-FGEN sets the NIFGEN_ATTR_FUNC_FREQUENCY attribute to this value.
    '''''
    '''''
    '''''
    '''''
    '''''Notes&#160;&#160;This parameter does not affect signal generator behavior when you set the waveform parameter of the niFgen_ConfigureStandardWaveform function to NIFGEN_VAL_WFM_DC.
    '''''
    '''''Frequency ranges vary from device to device. For information about the frequencies supported on your device, refer to the Features supported topic for your device.
    '''''
    '''''
    '''''Units: hertz
    '''''Default Value: None
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureFrequency(ByVal Channel_Name As String, ByVal Frequency As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureFrequency(Me._handle, Channel_Name, Frequency)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureAmplitude
    '''''
    '''''ViStatus niFgen_ConfigureAmplitude&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViReal64&#160;amplitude);
    '''''
    '''''Purpose
    '''''
    '''''Configures the amplitude of the standard waveform that you want the signal generator to produce.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to configure a standard waveform.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Amplitude">
    '''''
    '''''
    '''''amplitude
    '''''ViReal64
    '''''Specifies the amplitude of the standard waveform that you want the signal generator to produce. This value is the amplitude at the output terminal. NI-FGEN sets the NIFGEN_ATTR_FUNC_AMPLITUDE attribute to this value. 
    '''''
    '''''For example, to produce a waveform ranging from &#8211;5.00 to +5.00&#160;V, set the amplitude to 10.00&#160;V.
    '''''
    '''''
    '''''
    '''''Note&#160;&#160; This parameter does not affect signal generator behavior when you set the waveform parameter of the niFgen_ConfigureStandardWaveform function to NIFGEN_VAL_WFM_DC.
    '''''
    '''''Units: peak-to-peak voltage
    '''''
    '''''Default Value: None
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureAmplitude(ByVal Channel_Name As String, ByVal Amplitude As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureAmplitude(Me._handle, Channel_Name, Amplitude)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_CreateFreqList
    '''''
    '''''ViStatus niFgen_CreateFreqList&#160;(ViSession&#160;vi, ViInt32&#160;waveform, ViInt32&#160;frequencyListLength, ViReal64[]&#160;frequencyArray, ViReal64[]&#160;durationArray, ViInt32*&#160;frequencyListHandle);
    '''''
    '''''Purpose
    '''''
    '''''Creates a frequency list from an array of frequencies (frequencyArray) and an array of durations (durationArray). The arrays must be the same size, and this must also be the size of the the frequencyListLength. The signal generator generates each frequency for the given amount of time and then proceeds to the next frequency. When the end of the list is reached, the signal generator starts over at the beginning of the list. The function returns a handle that identifies the frequency list (the frequencyListHandle). You can pass this handle to niFgen_ConfigureFreqList to specify what frequency list you want the signal generator to produce.
    '''''
    '''''
    '''''Notes&#160;&#160;The signal generator must not be in the Generating state when you call this function.
    '''''You must call the niFgen_ConfigureOutputMode function to set the output mode to NIFGEN_VAL_OUTPUT_FREQ_LIST before calling this function.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Waveform">
    '''''
    '''''
    '''''waveform
    '''''ViInt32
    '''''Specifies the standard waveform that you want the signal generator to produce. NI-FGEN sets the NIFGEN_ATTR_FUNC_WAVEFORM attribute to this value.
    '''''
    '''''Defined Values
    '''''
    '''''NIFGEN_VAL_WFM_SINE
    '''''Sinusoidal waveform
    '''''
    '''''NIFGEN_VAL_WFM_SQUARE
    '''''Square waveform
    '''''
    '''''NIFGEN_VAL_WFM_TRIANGLE
    '''''Triangular waveform
    '''''
    '''''NIFGEN_VAL_WFM_RAMP_UP
    '''''Positive ramp waveform
    '''''
    '''''NIFGEN_VAL_WFM_RAMP_DOWN
    '''''Negative ramp waveform
    '''''
    '''''NIFGEN_VAL_WFM_DC
    '''''Constant voltage
    '''''
    '''''NIFGEN_VAL_WFM_NOISE
    '''''White noise
    '''''
    '''''NIFGEN_VAL_WFM_USER
    '''''User-defined waveform as defined with the niFgen_DefineUserStandardWaveform function
    '''''
    '''''Default Value: NIFGEN_VAL_WFM_SINE
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Frequency_List_Length">
    '''''
    '''''
    '''''frequencyListLength
    '''''ViInt32
    '''''Specifies the number of steps in the frequency list you want to create. The value must be between the minimum and maximum frequency list lengths that the signal generator allows. You can obtain the minimum and maximum frequency list lengths from the minimumFrequencyListLength and maximumFrequencyListLength parameters in the niFgen_QueryFreqListCapabilities functions.
    '''''
    '''''frequency and duration must each be at least as long as this frequency list length.
    '''''
    '''''Default Value: None
    ''''' 
    '''''</param>
    '''''<param name="Frequency_Array">
    '''''
    '''''
    '''''frequencyArray
    '''''ViReal64[]
    '''''Specifies the array of frequencies to form the frequency list. The array must have at least as many elements as the value you specify in frequencyListLength. Each frequencyArray element has a corresponding durationArray element that indicates how long that frequency is repeated.  
    '''''
    '''''Units: hertz
    '''''
    '''''Default Value: None
    ''''' 
    '''''</param>
    '''''<param name="Duration_Array">
    '''''
    '''''
    '''''durationArray
    '''''ViReal64[]
    '''''Specifies the array of durations to form the frequency list. The array must have at least as many elements as the value that you specify in frequencyListLength. Each durationArray element has a corresponding frequencyArray element and indicates how long in seconds to generate the corresponding frequency.  
    '''''
    '''''Units: seconds
    '''''
    '''''Default Value: None
    ''''' 
    '''''</param>
    '''''<param name="Frequency_List_Handle">
    '''''
    '''''
    '''''frequencyListHandle
    '''''ViInt32*
    '''''Returns the handle that identifies the new frequency list. You can pass this handle to niFgen_ConfigureFreqList to generate the arbitrary sequence.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function CreateFreqList(ByVal Waveform As Integer, ByVal Frequency_List_Length As Integer, ByVal Frequency_Array() As Double, ByVal Duration_Array() As Double, ByRef Frequency_List_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CreateFreqList(Me._handle, Waveform, Frequency_List_Length, Frequency_Array, Duration_Array, Frequency_List_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureFreqList
    '''''
    '''''ViStatus niFgen_ConfigureFreqList&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;frequencyListHandle, ViReal64&#160;amplitude, ViReal64&#160;dcOffset, ViReal64&#160;startPhase);
    '''''
    '''''Purpose
    '''''
    '''''Configures the attributes of the signal generator that affect frequency list generation 
    '''''(the NIFGEN_ATTR_FREQ_LIST_HANDLE, 
    '''''NIFGEN_ATTR_FUNC_AMPLITUDE, 
    '''''NIFGEN_ATTR_FUNC_DC_OFFSET, 
    '''''and NIFGEN_ATTR_FUNC_START_PHASE attributes).
    '''''
    '''''
    '''''Notes&#160;&#160;The signal generator must not be in the Generating state when you call this function.
    '''''You must call the niFgen_ConfigureOutputMode function to set the output mode to NIFGEN_VAL_OUTPUT_FREQ_LIST before calling this function.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to configure the frequency list.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Frequency_List_Handle">
    '''''
    '''''
    '''''frequencyListHandle
    '''''ViInt32
    '''''Specifies the handle of the frequency list that you want the signal generator to produce. NI-FGEN sets the NIFGEN_ATTR_FREQ_LIST_HANDLE attribute to this value. You can create a frequency list using the niFgen_CreateFreqList function. The niFgen_CreateFreqList function returns a handle that you use to identify the list.
    '''''
    '''''Default Value: None
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Amplitude">
    '''''
    '''''
    '''''amplitude
    '''''ViReal64
    '''''Specifies the amplitude of the standard waveform that you want the signal generator to produce. This value is the amplitude at the output terminal. NI-FGEN sets the NIFGEN_ATTR_FUNC_AMPLITUDE attribute to this value. 
    '''''
    '''''For example, to produce a waveform ranging from &#8211;5.00 to +5.00&#160;V, set the amplitude to 10.00&#160;V.
    '''''
    '''''
    '''''
    '''''Note&#160;&#160; This parameter does not affect signal generator behavior when you set the waveform parameter of the niFgen_ConfigureStandardWaveform function to NIFGEN_VAL_WFM_DC.
    '''''
    '''''Units: peak-to-peak voltage
    '''''
    '''''Default Value: None
    '''''
    ''''' 
    '''''</param>
    '''''<param name="DC_Offset">
    '''''
    '''''
    '''''dcOffset
    '''''ViReal64
    '''''Specifies the DC offset of the standard waveform that you want the signal generator to produce. This value is the offset at the output terminal (the offset is from ground to the center of the waveform).  NI-FGEN sets the NIFGEN_ATTR_FUNC_DC_OFFSET attribute to this value.  
    '''''
    '''''For example, to configure a waveform with an amplitude of 10.00&#160;V to range from 0.00 to +10.00&#160;V, set the DC Offset to 5.00&#160;V.
    '''''
    '''''Units: volts
    '''''
    '''''Default Value: None
    ''''' 
    '''''</param>
    '''''<param name="Start_Phase">
    '''''
    '''''
    '''''startPhase
    '''''ViReal64
    '''''Specifies the horizontal offset of the standard waveform you want the  signal generator to produce. Specify this attribute in degrees of one waveform cycle. NI-FGEN sets the NIFGEN_ATTR_FUNC_START_PHASE attribute to this value. A start phase of 180 degrees means output generation begins halfway through the waveform. A start phase of 360 degrees offsets the output by an entire waveform cycle, which is identical to a start phase of 0 degrees.
    '''''
    '''''
    '''''Note&#160;&#160; This parameter does not affect signal generator behavior when you set the waveform parameter to  NIFGEN_VAL_WFM_DC.
    '''''
    '''''Units: degrees of one cycle
    '''''
    '''''Default Value: None degrees
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureFreqList(ByVal Channel_Name As String, ByVal Frequency_List_Handle As Integer, ByVal Amplitude As Double, ByVal DC_Offset As Double, ByVal Start_Phase As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureFreqList(Me._handle, Channel_Name, Frequency_List_Handle, Amplitude, DC_Offset, Start_Phase)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ClearFreqList
    '''''
    '''''ViStatus niFgen_ClearFreqList&#160;(ViSession&#160;vi, ViInt32&#160;frequencyListHandle);
    '''''
    '''''Purpose
    '''''
    '''''Removes a previously created frequency list from the signal generator memory and invalidates the frequency list handle.
    '''''
    '''''
    '''''Note&#160;&#160; The signal generator must not be in the Generating state when you call this function.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Frequency_List_Handle">
    '''''
    '''''
    '''''frequencyListHandle
    '''''ViInt32
    '''''Specifies the handle of the frequency list that you want the signal generator to produce. NI-FGEN sets the NIFGEN_ATTR_FREQ_LIST_HANDLE attribute to this value. You can create a frequency list using the niFgen_CreateFreqList function. The niFgen_CreateFreqList function returns a handle that you use to identify the list.
    '''''
    '''''Default Value: None
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ClearFreqList(ByVal Frequency_List_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ClearFreqList(Me._handle, Frequency_List_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_QueryFreqListCapabilities
    '''''
    '''''ViStatus niFgen_QueryFreqListCapabilities&#160;(ViSession&#160;vi, ViInt32*&#160;maximumNumberOfFreqLists, ViInt32*&#160;minimumFrequencyListLength, ViInt32*&#160;maximumFrequencyListLength, ViReal64*&#160;minimumFrequencyListDuration, ViReal64*&#160;maximumFrequencyListDuration, ViReal64*&#160;frequencyListDurationQuantum);
    '''''
    '''''Purpose
    '''''
    '''''Returns the attributes of the signal generator that are related to creating frequency lists.  These attributes are NIFGEN_ATTR_MAX_NUM_FREQ_LISTS,
    '''''
    '''''NIFGEN_ATTR_MIN_FREQ_LIST_LENGTH, 
    '''''
    '''''NIFGEN_ATTR_MAX_FREQ_LIST_LENGTH, 
    '''''
    '''''NIFGEN_ATTR_MIN_FREQ_LIST_DURATION, 
    '''''
    '''''NIFGEN_ATTR_MAX_FREQ_LIST_DURATION, 
    '''''
    '''''and NIFGEN_ATTR_FREQ_LIST_DURATION_QUANTUM.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Maximum_Number_Of_Freq_Lists">
    '''''
    '''''
    '''''maximumNumberOfFreqLists
    '''''ViInt32
    '''''Returns the maximum number of frequency lists that the signal generator allows. NI-FGEN obtains this value from the NIFGEN_ATTR_MAX_NUM_FREQ_LISTS attribute.
    ''''' 
    '''''</param>
    '''''<param name="Minimum_Frequency_List_Length">
    '''''
    '''''
    '''''minimumFrequencyListLength
    '''''ViInt32
    '''''Returns the minimum number of steps that the signal generator allows in a frequency list. NI-FGEN obtains this value from the NIFGEN_ATTR_MIN_FREQ_LIST_LENGTH attribute.
    ''''' 
    '''''</param>
    '''''<param name="Maximum_Frequency_List_Length">
    '''''
    '''''
    '''''maximumFrequencyListLength
    '''''ViInt32
    '''''Returns the maximum number of steps that the signal generator allows in a frequency list. NI-FGEN obtains this value from the NIFGEN_ATTR_MAX_FREQ_LIST_LENGTH attribute.
    ''''' 
    '''''</param>
    '''''<param name="Minimum_Frequency_List_Duration">
    '''''
    '''''
    '''''minimumFrequencyListDuration
    '''''ViReal64
    '''''Returns the minimum duration that the signal generator allows in a step of a frequency list. NI-FGEN obtains this value from the NIFGEN_ATTR_MIN_FREQ_LIST_DURATION attribute.
    ''''' 
    '''''</param>
    '''''<param name="Maximum_Frequency_List_Duration">
    '''''
    '''''
    '''''maximumFrequencyListDuration
    '''''ViReal64
    '''''Returns the maximum duration that the signal generator allows in a step of a frequency list. NI-FGEN obtains this value from the NIFGEN_ATTR_MAX_FREQ_LIST_DURATION attribute.
    ''''' 
    '''''</param>
    '''''<param name="Frequency_List_Duration_Quantum">
    '''''
    '''''
    '''''frequencyListDurationQuantum
    '''''ViReal64
    '''''Returns the quantum of which all durations must be a multiple in a frequency list. NI-FGEN obtains this value from the NIFGEN_ATTR_FREQ_LIST_DURATION_QUANTUM attribute.
    '''''
    ''''' </tr></table>
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function QueryFreqListCapabilities(ByRef Maximum_Number_Of_Freq_Lists As Integer, ByRef Minimum_Frequency_List_Length As Integer, ByRef Maximum_Frequency_List_Length As Integer, ByRef Minimum_Frequency_List_Duration As Double, ByRef Maximum_Frequency_List_Duration As Double, ByRef Frequency_List_Duration_Quantum As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.QueryFreqListCapabilities(Me._handle, Maximum_Number_Of_Freq_Lists, Minimum_Frequency_List_Length, Maximum_Frequency_List_Length, Minimum_Frequency_List_Duration, Maximum_Frequency_List_Duration, Frequency_List_Duration_Quantum)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureGain
    '''''
    '''''ViStatus niFgen_ConfigureGain&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViReal64&#160;gain);
    '''''
    '''''Purpose
    '''''
    '''''Configures the amount of gain to apply to the waveform.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to configure the gain.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Gain">
    '''''
    '''''
    '''''gain
    '''''ViReal64
    '''''Specifies the factor by which the signal generator scales the arbitrary waveform data. When you create arbitrary waveforms, you must first normalize the data points to a range of &#8211;1.00 to +1.00&#160;V.  You can use this parameter to scale the arbitrary waveform to other ranges. NI-FGEN sets the NIFGEN_ATTR_ARB_GAIN attribute to this value.
    '''''
    '''''For example, to configure the output signal to range from &#8211;2.00 to +2.00&#160;V, set the gain to 2.00.
    '''''
    '''''Units: volts
    '''''
    '''''Default Value: None
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureGain(ByVal Channel_Name As String, ByVal Gain As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureGain(Me._handle, Channel_Name, Gain)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureSampleRate
    '''''
    '''''ViStatus niFgen_ConfigureSampleRate&#160;(ViSession&#160;vi, ViReal64&#160;sampleRate);
    '''''
    '''''Purpose
    '''''
    '''''Configures the sample rate attribute, which determines the rate at which the signal generator produces arbitrary waveforms.  When you configure the signal generator to produce an arbitrary sequence, this value is the sample rate for all arbitrary waveforms in the sequence.
    '''''
    '''''
    '''''Notes&#160;&#160;The signal generator must not be in the Generating state when you call this function.
    '''''You must call the   niFgen_ConfigureOutputMode function to set the output mode to NIFGEN_VAL_OUTPUT_ARB, NIFGEN_VAL_OUTPUT_SEQ, or NIFGEN_VAL_OUTPUT_SCRIPT before calling this function.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Sample_Rate">
    '''''
    '''''
    '''''sampleRate
    '''''ViReal64
    '''''Specifies the sample rate at which you want the signal generator to generate arbitrary waveforms. NI-FGEN sets the NIFGEN_ATTR_ARB_SAMPLE_RATE attribute to this value. 
    '''''
    '''''Units: samples/s
    '''''
    '''''Default Value: None
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureSampleRate(ByVal Sample_Rate As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureSampleRate(Me._handle, Sample_Rate)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_QueryArbWfmCapabilities
    '''''
    '''''ViStatus niFgen_QueryArbWfmCapabilities&#160;(ViSession&#160;vi, ViInt32*&#160;maximumNumberofWaveforms, ViInt32*&#160;waveformQuantum, ViInt32*&#160;minimumWaveformSize, ViInt32*&#160;maximumWaveformSize);
    '''''
    '''''Purpose
    '''''
    '''''Returns the attributes of the signal generator that are related to creating arbitrary waveforms. These attributes are the maximum number of waveforms, waveform quantum, minimum waveform size, and maximum waveform size.
    '''''
    '''''
    '''''Note&#160;&#160; If you do not want to obtain the waveform quantum, pass a value of VI_NULL for this parameter.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Maximum_Number_of_Waveforms">
    '''''
    '''''
    '''''maximumNumberofWaveforms
    '''''ViInt32*
    '''''Returns the maximum number of arbitrary waveforms that the signal generator allows. NI-FGEN obtains this value from the NIFGEN_ATTR_MAX_NUM_WAVEFORMS attribute.
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Quantum">
    '''''
    '''''
    '''''waveformQuantum
    '''''ViInt32*
    '''''The size (number of points) of each waveform must be a multiple of a constant quantum value. This parameter obtains the quantum value that the signal generator uses. NI-FGEN returns this value from the NIFGEN_ATTR_WAVEFORM_QUANTUM attribute.
    '''''
    '''''For example, when this attribute returns a value of 8, all waveform sizes must be a multiple of 8.
    ''''' 
    '''''</param>
    '''''<param name="Minimum_Waveform_Size">
    '''''
    '''''
    '''''minimumWaveformSize
    '''''ViInt32*
    '''''Returns the minimum number of points that the signal generator allows in a waveform. NI-FGEN obtains this value from the NIFGEN_ATTR_MIN_WAVEFORM_SIZE attribute.
    ''''' 
    '''''</param>
    '''''<param name="Maximum_Waveform_Size">
    '''''
    '''''
    '''''maximumWaveformSize
    '''''ViInt32*
    '''''Returns the maximum number of points that the signal generator allows in a waveform. NI-FGEN obtains this value from the NIFGEN_ATTR_MAX_WAVEFORM_SIZE attribute.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function QueryArbWfmCapabilities(ByRef Maximum_Number_of_Waveforms As Integer, ByRef Waveform_Quantum As Integer, ByRef Minimum_Waveform_Size As Integer, ByRef Maximum_Waveform_Size As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.QueryArbWfmCapabilities(Me._handle, Maximum_Number_of_Waveforms, Waveform_Quantum, Minimum_Waveform_Size, Maximum_Waveform_Size)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_CreateWaveformF64
    '''''
    '''''ViStatus niFgen_CreateWaveformF64&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;waveformSize, ViReal64[]&#160;waveformDataArray, ViInt32*&#160;waveformHandle);
    '''''
    '''''Purpose
    '''''
    '''''Creates an onboard waveform from binary F64 (floating point double) data for use in Arbitrary Waveform output mode or Arbitrary Sequence output mode.  The waveformHandle returned  can later be used for setting the active waveform, changing the data in the waveform, building sequences of waveforms, or deleting the waveform when it is no longer needed.
    '''''
    '''''
    '''''Note&#160;&#160; You must call the niFgen_ConfigureOutputMode function to set the outputMode parameter to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ before calling this function.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to create the waveform.
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Size">
    '''''
    '''''
    '''''waveformSize
    '''''ViInt32
    '''''Specifies the size of the arbitrary waveform that you want created.
    '''''
    '''''
    '''''The size must meet the following restrictions:
    '''''
    ''''' The size must be less than or equal to the maximum waveform size that the device allows.
    '''''The size must be greater than or equal to the minimum waveform size that the device allows.
    ''''' The size must be an integer multiple of the device waveform quantum.
    '''''You can obtain these values from the maximumWaveformSize, minimumWaveformSize, and waveformQuantum parameters in the niFgen_QueryArbWfmCapabilities function.Default Value: None
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Data_Array">
    '''''
    '''''
    '''''waveformDataArray
    '''''ViReal64[]
    '''''Specifies the array of data you want to use for the new arbitrary waveform. The array must have at least as many elements as the value that you specify in waveformSize.
    '''''
    '''''You must normalize the data points in the array to be between &#8211;1.00 and +1.00.
    '''''
    '''''Default Value: None
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Handle">
    '''''
    '''''
    '''''waveformHandle
    '''''ViInt32*
    '''''The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function CreateWaveformF64(ByVal Channel_Name As String, ByVal Waveform_Size As Integer, ByVal Waveform_Data_Array() As Double, ByRef Waveform_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CreateWaveformF64(Me._handle, Channel_Name, Waveform_Size, Waveform_Data_Array, Waveform_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_CreateWaveformI16
    '''''
    '''''ViStatus niFgen_CreateWaveformI16&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;waveformSize, ViInt16[]&#160;waveformDataArray, ViInt32*&#160;waveformHandle);
    '''''
    '''''Purpose
    '''''
    '''''Creates an onboard waveform from binary I16 data for use in Arbitrary Waveform or Arbitrary Sequence output mode.  The waveformHandle returned  can later be used for setting the active waveform, changing the data in the waveform, building sequences of waveforms, or deleting the waveform when it is no longer needed.
    '''''
    '''''
    '''''Note&#160;&#160; You must call the niFgen_ConfigureOutputMode function to set the outputMode parameter to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ before calling this function.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to create the waveform.
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Size">
    '''''
    '''''
    '''''waveformSize
    '''''ViInt32
    '''''Specifies the size of the arbitrary waveform that you want created.
    '''''
    '''''The size must meet the following restrictions:
    ''''' The size must be less than or equal to the maximum waveform size that the device allows.
    ''''' The size must be greater than or equal to the minimum waveform size that the device allows.
    ''''' The size must be an integer multiple of the device waveform quantum.
    '''''You can obtain these values from the maximumWaveformSize, minimumWaveformSize, and waveformQuantum parameters in the niFgen_QueryArbWfmCapabilities function.
    '''''Default Value: None
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Data_Array">
    '''''
    '''''
    '''''waveformDataArray
    '''''ViReal64[]
    '''''Specifies the array of data you want to use for the new arbitrary waveform. The array must have at least as many elements as the value that you specify in waveformSize.
    '''''
    '''''You must normalize the data points in the array to be between &#8211;1.00 and +1.00.
    '''''
    '''''Default Value: None
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Handle">
    '''''
    '''''
    '''''waveformHandle
    '''''ViInt32*
    '''''The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function CreateWaveformI16(ByVal Channel_Name As String, ByVal Waveform_Size As Integer, ByVal Waveform_Data_Array() As Short, ByRef Waveform_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CreateWaveformI16(Me._handle, Channel_Name, Waveform_Size, Waveform_Data_Array, Waveform_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_CreateWaveformComplexF64
    '''''
    '''''ViStatus niFgen_CreateWaveformComplexF64&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;numberofSamples, niFgen_ComplexF64[]&#160;waveformDataArray, ViInt32*&#160;waveformHandle);
    '''''
    '''''Purpose
    '''''
    '''''Creates an onboard waveform from complex double-precision floating-point data for use with the NIFGEN_ATTR_OUTPUT_MODE attribute set to Arbitrary Waveform or Arbitrary Sequence output mode on devices with the NIFGEN_ATTR_OUTPUT_ENABLED attribute set to VI_TRUE and the NIFGEN_ATTR_OSP_DATA_PROCESSING_MODE attribute set to NIFGEN_VAL_OSP_COMPLEX. The waveformHandle returned by the function can be used later for setting the active waveform, changing the data in the waveform, building sequences of waveforms, or deleting the waveform when it is no longer needed.
    '''''
    '''''
    '''''Note&#160;&#160; You must call the niFgen_ConfigureOutputMode function to set the outputMode parameter to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ before calling this function.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to create the waveform.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Number_of_Samples">
    '''''
    '''''
    '''''numberofSamples
    '''''ViInt32
    '''''Specifies the size of the arbitrary waveform that you want created.The size must meet the following restrictions:
    '''''
    ''''' The size must be less than or equal to the maximum waveform size that the device allows.
    ''''' The size must be greater than or equal to the minimum waveform size that the device allows.
    '''''The size must be an integer multiple of the device waveform quantum.
    '''''
    '''''You can obtain these values from the maximumWaveformSize, minimumWaveformSize, and waveformQuantum parameters in niFgen_QueryArbWfmCapabilities.
    '''''Default Value: None
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Data_Array">
    '''''
    '''''
    '''''waveformDataArray
    '''''ViReal64[]
    '''''Specifies the array of data you want to use for the new arbitrary waveform. The array must have at least as many elements as the value that you specify in waveformSize.
    '''''
    '''''You must normalize the data points in the array to be between &#8211;1.00 and +1.00.
    '''''
    '''''Default Value: None
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Handle">
    '''''
    '''''
    '''''waveformHandle
    '''''ViInt32*
    '''''The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function CreateWaveformComplexF64(ByVal Channel_Name As String, ByVal Number_of_Samples As Integer, ByVal Waveform_Data_Array As Integer, ByRef Waveform_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CreateWaveformComplexF64(Me._handle, Channel_Name, Number_of_Samples, Waveform_Data_Array, Waveform_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_CreateWaveformFromFileI16
    '''''
    '''''ViStatus niFgen_CreateWaveformFromFileI16&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViConstString&#160;filename, ViInt32&#160;byteOrder, ViInt32*&#160;waveformHandle);
    '''''
    '''''Purpose
    '''''
    '''''Takes the binary I16 data from the specified file and creates an onboard waveform for use in Arbitrary Waveform or Arbitrary Sequence output mode.  The waveformHandle returned  can later be used for setting the active waveform, changing the data in the waveform, building sequences of waveforms, or deleting the waveform when it is no longer needed.
    '''''
    '''''
    '''''Notes&#160;&#160; The i16 data (values between -32768 and +32767) is assumed to represent -1 to +1 V.  Use the NIFGEN_ATTR_DIGITAL_GAIN attribute to generate different voltage outputs.
    '''''
    '''''You must call the niFgen_ConfigureOutputMode function to set the outputMode parameter to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ before calling this function.
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to create the waveform.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="FileName">
    '''''
    '''''
    '''''fileName
    '''''ViConstString
    '''''The full path and name of the file where the waveform data resides.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Byte_Order">
    '''''
    '''''
    '''''byteOrder
    '''''ViInt32
    '''''Specifies the byte order of the data in the file.
    '''''
    '''''
    '''''Note&#160;&#160;Data written by most applications in Windows (including LabWindows/CVI) is in Little Endian format.  Data written to a file from LabVIEW is in Big Endian format by default on all platforms.  (Big Endian and Little Endian refer to the way data is stored in memory, which can differ on different processors.)
    '''''
    '''''Defined Values
    '''''
    '''''NIFGEN_VAL_LITTLE_ENDIAN Little Endian Data&#8212;the least significant bit is stored at the lowest address, followed by the other bits, in order of increasing significance.
    '''''NIFGEN_VAL_BIG_ENDIAN Big Endian Data&#8212;the most significant bit is stored at the lowest address, followed by the other bits, in order of decreasing significance.
    '''''
    '''''
    '''''
    '''''
    '''''Default Value: NIFGEN_VAL_LITTLE_ENDIAN
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Handle">
    '''''
    '''''
    '''''waveformHandle
    '''''ViInt32*
    '''''The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function CreateWaveformFromFileI16(ByVal Channel_Name As String, ByVal FileName As String, ByVal Byte_Order As Integer, ByRef Waveform_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CreateWaveformFromFileI16(Me._handle, Channel_Name, FileName, Byte_Order, Waveform_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_CreateWaveformFromFileF64
    '''''
    '''''ViStatus niFgen_CreateWaveformFromFileF64&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViConstString&#160;filename, ViInt32&#160;byteOrder, ViInt32*&#160;waveformHandle);
    '''''
    '''''Purpose
    '''''
    '''''This function takes the F64 (floating point double) data from the specified file and creates an onboard waveform for use in Arbitrary Waveform or Arbitrary Sequence output mode.  The waveformHandle returned  can later be used  for setting the active waveform, changing the data in the waveform, building sequences of waveforms, or deleting the waveform when it is no longer needed.
    '''''
    '''''
    '''''
    '''''Notes&#160;&#160; The F64 data must be between -1.0 and +1.0 V.  Use the NIFGEN_ATTR_DIGITAL_GAIN attribute to generate different voltage outputs. 
    ''''' You must call the niFgen_ConfigureOutputMode function to set the outputMode parameter to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ before calling this function.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to create the waveform.
    '''''
    '''''Defined Value: &quot;0&quot;
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="FileName">
    '''''
    '''''
    '''''fileName
    '''''ViConstString
    '''''The full path and name of the file where the waveform data resides.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Byte_Order">
    '''''
    '''''
    '''''byteOrder
    '''''ViInt32
    '''''Specifies the byte order of the data in the file.
    '''''
    '''''
    '''''Note&#160;&#160;Data written by most applications in Windows (including LabWindows/CVI) is in Little Endian format.  Data written to a file from LabVIEW is in Big Endian format by default on all platforms.  (Big Endian and Little Endian refer to the way data is stored in memory, which can differ on different processors.)
    '''''
    '''''Defined Values
    '''''
    '''''NIFGEN_VAL_LITTLE_ENDIAN Little Endian Data&#8212;the least significant bit is stored at the lowest address, followed by the other bits, in order of increasing significance.
    '''''NIFGEN_VAL_BIG_ENDIAN Big Endian Data&#8212;the most significant bit is stored at the lowest address, followed by the other bits, in order of decreasing significance.
    '''''
    '''''
    '''''
    '''''
    '''''Default Value: NIFGEN_VAL_LITTLE_ENDIAN
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Handle">
    '''''
    '''''
    '''''waveformHandle
    '''''ViInt32*
    '''''The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function CreateWaveformFromFileF64(ByVal Channel_Name As String, ByVal FileName As String, ByVal Byte_Order As Integer, ByRef Waveform_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CreateWaveformFromFileF64(Me._handle, Channel_Name, FileName, Byte_Order, Waveform_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''niFgen_CreateWaveformFromFileHWS
    '''''
    '''''ViStatus niFgen_CreateWaveformFromFileHWS&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViConstString&#160;filename, ViBoolean&#160;useRateFromWaveform, ViBoolean&#160;useGain&amp;OffsetFromWaveform, ViInt32*&#160;waveformHandle);
    '''''
    '''''Purpose
    '''''
    '''''Takes the waveform data from the specified HWS (Hierarchical Waveform Storage) file and creates an onboard  waveform for use in Arbitrary Waveform or Arbitrary Sequence output mode.  The waveformHandle returned by the function can be used later for setting the active waveform, changing the data in the waveform, building sequences of waveforms, or deleting the waveform when it is no longer needed.
    '''''
    '''''
    '''''When the Analog Waveform Editor saves data in an HWS file, it also stores the rate, gain and offset with the data.  If the useRateFromWaveform and useGain&amp;OffsetFromWaveform inputs are set to VI_TRUE, this function also sets those properties on NI-FGEN. 
    '''''
    '''''
    '''''
    '''''
    '''''Notes&#160;&#160;If you choose to have this function set the gain and offset properties for you, you should not use the niFgen_ConfigureArbWaveform or niFgen_ConfigureArbSequence functions, as they also set the gain and offset, thereby overriding the values set by this function.  Instead, use the NIFGEN_ATTR_ARB_WAVEFORM_HANDLE or NIFGEN_ATTR_ARB_SEQUENCE_HANDLE attributes.
    '''''
    '''''
    ''''' HWS files may contain I16 or DBL data (depending on how it was saved).  This function automatically adapts to either data type.  If the file contains DBL data, it must be between -1.0 and +1.0.  Check the &quot;Scale Data to +/- 1V&quot; option in the Analog Waveform Editor to ensure your data is between -1.0 and +1.0.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to create the waveform.
    '''''
    '''''Defined Value: &quot;0&quot;
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="FileName">
    '''''
    '''''
    '''''fileName
    '''''ViConstString
    '''''The full path and name of the file where the waveform data resides.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Use_Rate_From_Waveform">
    '''''
    '''''
    '''''useRateFromWaveform
    '''''ViBoolean
    '''''If you set this parameter input to VI_TRUE and if onboard signal processing (OSP) is enabled, the 'rate' from the waveform is interpreted as the data rate, and FGEN sets the data rate attribute for you. In all other cases, it is interpreted as the sample rate, and FGEN sets the sample rate attribute for you.
    '''''
    '''''
    '''''Defined Values
    '''''
    '''''VI_TRUEUse rate from waveform.
    '''''VI_FALSE Do not use rate from waveform.
    '''''
    '''''
    '''''
    '''''Default Value: VI_TRUE
    '''''
    ''''' 
    ''''' 
    '''''</param>
    '''''<param name="Use_Gain___Offset_From_Waveform">
    '''''
    '''''
    '''''useGain&amp;OffsetFromWaveform
    '''''ViBoolean
    '''''If this input is set to VI_TRUE, NI-FGEN retrieves the gain and offset values from the specified HWS file and applies them to the NI-FGEN driver.
    '''''
    '''''
    '''''Defined Values
    '''''
    '''''VI_TRUEUse gain and offset from waveform.
    '''''VI_FALSE Do not use gain and offset from waveform.
    '''''
    '''''Default Value: VI_TRUE
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Handle">
    '''''
    '''''
    '''''waveformHandle
    '''''ViInt32*
    '''''The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function CreateWaveformFromFileHWS(ByVal Channel_Name As String, ByVal FileName As String, ByVal Use_Rate_From_Waveform As Boolean, ByVal Use_Gain___Offset_From_Waveform As Boolean, ByRef Waveform_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CreateWaveformFromFileHWS(Me._handle, Channel_Name, FileName, System.Convert.ToUInt16(Use_Rate_From_Waveform), System.Convert.ToUInt16(Use_Gain___Offset_From_Waveform), Waveform_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureArbWaveform
    '''''
    '''''ViStatus niFgen_ConfigureArbWaveform&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;waveformHandle, ViReal64&#160;gain, ViReal64&#160;offset);
    '''''
    '''''Purpose
    '''''
    '''''Configures the attributes of the signal generator that affect arbitrary waveform generation (the NIFGEN_ATTR_ARB_WAVEFORM_HANDLE, NIFGEN_ATTR_ARB_GAIN, and NIFGEN_ATTR_ARB_OFFSET attributes).
    '''''
    '''''
    '''''Notes&#160;&#160;The signal generator must not be in the Generating state when you call this function.
    '''''
    ''''' You must call the niFgen_ConfigureOutputMode function to set the output mode to NIFGEN_VAL_OUTPUT_ARB before calling this function.
    '''''
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to configure an arbitrary waveform.
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Handle">
    '''''
    '''''
    '''''waveformHandle
    '''''ViInt32
    '''''
    '''''Specifies the handle of the arbitrary waveform you want the signal generator to produce. 
    '''''NI-FGEN sets the NIFGEN_ATTR_ARB_WAVEFORM_HANDLE attribute 
    '''''to this value. You can create an arbitrary waveform using one of the following niFgen Create Waveform functions:
    '''''
    '''''niFgen_CreateWaveformF64
    '''''
    '''''
    '''''niFgen_CreateWaveformI16
    '''''
    '''''
    '''''niFgen_CreateWaveformFromFileI16
    '''''
    '''''
    '''''niFgen_CreateWaveformFromFileF64
    '''''
    '''''
    '''''niFgen_CreateWaveformFromFileHWS
    '''''
    '''''
    '''''
    '''''These functions return a handle that you use to identify the waveform.
    '''''
    '''''Default Value: None
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Gain">
    '''''
    '''''
    '''''gain
    '''''ViReal64
    '''''Specifies the factor by which the signal generator scales the arbitrary waveform data. When you create arbitrary waveforms, you must first normalize the data points to a range of &#8211;1.00 to +1.00&#160;V.  You can use this parameter to scale the arbitrary waveform to other ranges. NI-FGEN sets the NIFGEN_ATTR_ARB_GAIN attribute to this value.
    '''''
    '''''For example, to configure the output signal to range from &#8211;2.00 to +2.00&#160;V, set the gain to 2.00.
    '''''
    '''''Units: volts
    '''''
    '''''Default Value: None
    ''''' 
    '''''</param>
    '''''<param name="Offset">
    '''''
    '''''
    '''''offset
    '''''ViReal64
    '''''Specifies the value the signal generator adds to the arbitrary waveform data. When you create arbitrary waveforms, you must first normalize the data points to a range of &#8211;1.00 to +1.00&#160;V. You can use this parameter to shift the range of the arbitrary waveform. NI-FGEN sets the NIFGEN_ATTR_ARB_OFFSET attribute to this value.
    '''''
    '''''For example, to configure the output signal to range from 0.00 to 2.00&#160;V instead of &#8211;1.00 to 1.00&#160;V, set the offset to 1.00.
    '''''
    '''''Units: volts
    '''''
    '''''Default Value: None
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureArbWaveform(ByVal Channel_Name As String, ByVal Waveform_Handle As Integer, ByVal Gain As Double, ByVal Offset As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureArbWaveform(Me._handle, Channel_Name, Waveform_Handle, Gain, Offset)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ClearArbWaveform
    '''''
    '''''ViStatus niFgen_ClearArbWaveform&#160;(ViSession&#160;vi, ViInt32&#160;waveformHandle);
    '''''
    '''''Purpose
    '''''
    '''''Removes a previously created arbitrary waveform from the signal generator memory and invalidates the waveform handle.
    '''''
    '''''
    '''''Note&#160;&#160; The signal generator must not be in the Generating state when you call this function.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Waveform_Handle">
    '''''
    '''''
    '''''waveformHandle
    '''''ViInt32
    '''''Specifies the handle of the arbitrary waveform that you want the signal generator to remove. 
    '''''You can create multiple arbitrary waveforms using one of the following niFgen Create 
    '''''Waveform functions:
    '''''
    '''''niFgen_CreateWaveformF64
    '''''niFgen_CreateWaveformI16
    '''''niFgen_CreateWaveformFromFileI16
    '''''niFgen_CreateWaveformFromFileF64
    '''''niFgen_CreateWaveformFromFileHWS
    '''''
    '''''
    '''''Defined Value:
    '''''
    '''''NIFGEN_VAL_ALL_WAVEFORMS&#8212;Remove all waveforms from the signal generator.
    '''''
    '''''Default Value: None
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ClearArbWaveform(ByVal Waveform_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ClearArbWaveform(Me._handle, Waveform_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_QueryArbSeqCapabilities
    '''''
    '''''ViStatus niFgen_QueryArbSeqCapabilities&#160;(ViSession&#160;vi, ViInt32*&#160;maximumNumberofSequences, ViInt32*&#160;minimumSequenceLength, ViInt32*&#160;maximumSequenceLength, ViInt32*&#160;maximumLoopCount);
    '''''
    '''''Purpose
    '''''
    '''''Returns the attributes of the signal generator that are related to creating arbitrary sequences (the NIFGEN_ATTR_MAX_NUM_SEQUENCES, NIFGEN_ATTR_MIN_SEQUENCE_LENGTH, NIFGEN_ATTR_MAX_SEQUENCE_LENGTH, and NIFGEN_ATTR_MAX_LOOP_COUNT attributes).
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Maximum_Number_of_Sequences">
    '''''
    '''''
    '''''maximumNumberofSequences
    '''''ViInt32*
    '''''Returns the maximum number of arbitrary waveform sequences that the signal generator allows.  NI-FGEN obtains this value from the NIFGEN_ATTR_MAX_NUM_SEQUENCES attribute.
    ''''' 
    '''''</param>
    '''''<param name="Minimum_Sequence_Length">
    '''''
    '''''
    '''''minimumSequenceLength
    '''''ViInt32*
    '''''Returns the minimum number of arbitrary waveforms the signal generator allows in a sequence.  NI-FGEN obtains this value from the NIFGEN_ATTR_MIN_SEQUENCE_LENGTH attribute.
    ''''' 
    '''''</param>
    '''''<param name="Maximum_Sequence_Length">
    '''''
    '''''
    '''''maximumSequenceLength
    '''''ViInt32*
    '''''Returns the maximum number of arbitrary waveforms the signal generator allows in a sequence.  NI-FGEN obtains this value from the NIFGEN_ATTR_MAX_SEQUENCE_LENGTH attribute.
    ''''' 
    '''''</param>
    '''''<param name="Maximum_Loop_Count">
    '''''
    '''''
    '''''maximumLoopCount
    '''''ViInt32*
    '''''Returns the maximum number of times the signal generator can repeat an arbitrary waveform in a sequence.  NI-FGEN obtains this value from the NIFGEN_ATTR_MAX_LOOP_COUNT attribute.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function QueryArbSeqCapabilities(ByRef Maximum_Number_of_Sequences As Integer, ByRef Minimum_Sequence_Length As Integer, ByRef Maximum_Sequence_Length As Integer, ByRef Maximum_Loop_Count As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.QueryArbSeqCapabilities(Me._handle, Maximum_Number_of_Sequences, Minimum_Sequence_Length, Maximum_Sequence_Length, Maximum_Loop_Count)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_CreateArbSequence
    '''''
    '''''ViStatus niFgen_CreateArbSequence&#160;(ViSession&#160;vi, ViInt32&#160;sequenceLength, ViInt32[]&#160;waveformHandlesArray, ViInt32[]&#160;loopCountsArray, ViInt32*&#160;sequenceHandle);
    '''''
    '''''Purpose
    '''''
    '''''
    '''''Creates an arbitrary sequence from an array of waveform handles and an array of corresponding loop counts. An arbitrary sequence consists of multiple waveforms. For each waveform, you can specify the number of times that the signal generator produces the waveform before proceeding to the next waveform. The number of times to repeat a specific waveform is called the loop count. 
    '''''The function returns a handle that identifies the sequence. You pass this handle to the niFgen_ConfigureArbSequence function to specify what arbitrary sequence you want the signal generator to produce.
    '''''
    '''''
    '''''Note&#160;&#160;You must call the niFgen_ConfigureOutputMode function to set the output mode to NIFGEN_VAL_OUTPUT_SEQ before calling this function.
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Sequence_Length">
    '''''
    '''''
    '''''sequenceLength
    '''''ViInt32
    '''''Specifies the number of waveforms in the new arbitrary sequence that you want to create. The value you pass must be between the minimum and maximum sequence lengths that the signal generator allows. You can obtain the minimum and maximum sequence lengths from minimumSequenceLength and maximumSequenceLength in the niFgen_QueryArbSeqCapabilities function.
    '''''
    '''''Default Value: None
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Handles_Array">
    '''''
    '''''
    '''''waveformHandlesArray
    '''''ViInt32[]
    '''''Specifies the array of waveform handles from which you want to create a new arbitrary 
    '''''sequence. The array must have at least as many elements as the value that you specify in 
    '''''sequenceLength. Each waveformHandlesArray element has a 
    '''''corresponding loopCountsArray element that indicates how many times that 
    '''''waveform is repeated. You obtain waveform handles when you create arbitrary waveforms with the niFgen_AllocateWaveform function or one of the following niFgen CreateWaveform functions:
    '''''
    '''''niFgen_CreateWaveformF64
    '''''niFgen_CreateWaveformI16
    '''''niFgen_CreateWaveformFromFileI16
    '''''niFgen_CreateWaveformFromFileF64
    '''''niFgen_CreateWaveformFromFileHWS
    '''''
    '''''Default Value: None
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Loop_Counts_Array">
    '''''
    '''''
    '''''loopCountsArray
    '''''ViInt32[]
    '''''Specifies the array of loop counts you want to use to create a new arbitrary sequence. The array must have at least as many elements as the value that you specify in the sequenceLength parameter. Each loopCountsArray element corresponds to a waveformHandlesArray element and indicates how many times to repeat that waveform. Each element of the loopCountsArray must be less than or equal to the maximum number of loop counts that the signal generator allows. You can obtain the maximum loop count from maximumLoopCount in the niFgen_QueryArbSeqCapabilities function.
    '''''
    '''''Default Value: None
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Sequence_Handle">
    '''''
    '''''
    '''''sequenceHandle
    '''''ViInt32*
    '''''Returns the handle that identifies the new arbitrary sequence.  You can pass this handle to niFgen_ConfigureArbSequence to generate the arbitrary sequence.
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function CreateArbSequence(ByVal Sequence_Length As Integer, ByVal Waveform_Handles_Array() As Integer, ByVal Loop_Counts_Array() As Integer, ByRef Sequence_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CreateArbSequence(Me._handle, Sequence_Length, Waveform_Handles_Array, Loop_Counts_Array, Sequence_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_CreateAdvancedArbSequence
    '''''
    '''''ViStatus niFgen_CreateAdvancedArbSequence&#160;(ViSession&#160;vi, ViInt32&#160;sequenceLength, ViInt32[]&#160;waveformHandlesArray, ViInt32[]&#160;loopCountsArray, 
    '''''ViInt32[]&#160;sampleCountsArray, 
    '''''ViInt32[]&#160;markerLocationArray, 
    '''''ViInt32[]&#160;coercedMarkersArray, 
    '''''ViInt32*&#160;sequenceHandle);
    '''''
    '''''Purpose
    '''''
    '''''
    '''''Creates an arbitrary sequence from an array of waveform handles and an array of corresponding loop counts. An arbitrary sequence consists of multiple waveforms. For each waveform, you specify the number of times the signal generator produces the waveform before proceeding to the next waveform. The number of times to repeat a specific waveform is called the loop count.
    ''''' The function returns a handle that identifies the sequence. You pass this handle to the niFgen_ConfigureArbSequence function to specify what arbitrary sequence you want the signal generator to produce.
    '''''
    '''''The niFgen_CreateAdvancedArbSequence function extends on niFgen_CreateArbSequence by adding the ability to set the number of samples in each sequence step and to set marker locations.
    '''''
    '''''
    '''''
    '''''Note&#160;&#160;You must call the niFgen_ConfigureOutputMode function to set the output mode to NIFGEN_VAL_OUTPUT_SEQ before calling this function.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Sequence_Length">
    '''''
    '''''
    '''''sequenceLength
    '''''ViInt32
    '''''Specifies the number of waveforms in the new arbitrary sequence that you want to create. The value you pass must be between the minimum and maximum sequence lengths that the signal generator allows. You can obtain the minimum and maximum sequence lengths from minimumSequenceLength and maximumSequenceLength in the niFgen_QueryArbSeqCapabilities function.
    '''''
    '''''Default Value: None
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Handles_Array">
    '''''
    '''''
    '''''waveformHandlesArray
    '''''ViInt32[]
    '''''Specifies the array of waveform handles from which you want to create a new arbitrary 
    '''''sequence. The array must have at least as many elements as the value that you specify in 
    '''''sequenceLength. Each waveformHandlesArray element has a 
    '''''corresponding loopCountsArray element that indicates how many times that 
    '''''waveform is repeated. You obtain waveform handles when you create arbitrary waveforms with the niFgen_AllocateWaveform function or one of the following niFgen CreateWaveform functions:
    '''''
    '''''niFgen_CreateWaveformF64
    '''''niFgen_CreateWaveformI16
    '''''niFgen_CreateWaveformFromFileI16
    '''''niFgen_CreateWaveformFromFileF64
    '''''niFgen_CreateWaveformFromFileHWS
    '''''
    '''''Default Value: None
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Loop_Counts_Array">
    '''''
    '''''
    '''''loopCountsArray
    '''''ViInt32[]
    '''''Specifies the array of loop counts you want to use to create a new arbitrary sequence. The array must have at least as many elements as the value that you specify in the sequenceLength parameter. Each loopCountsArray element corresponds to a waveformHandlesArray element and indicates how many times to repeat that waveform. Each element of the loopCountsArray must be less than or equal to the maximum number of loop counts that the signal generator allows. You can obtain the maximum loop count from maximumLoopCount in the niFgen_QueryArbSeqCapabilities function.
    '''''
    '''''Default Value: None
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Sample_Counts_Array">
    '''''
    '''''
    '''''sampleCountsArray
    '''''ViInt32[]
    '''''Specifies the array of sample counts that you want to use to create a new arbitrary sequence.  The array must have at least as many elements as the value you specify in the sequenceLength parameter.  Each sampleCountsArray element corresponds to a waveformHandlesArray element and indicates the subset, in samples, of the given waveform to generate.  Each element of the sampleCountsArray must be larger than the minimum waveform size, a multiple of the waveform quantum and no larger than the number of samples in the corresponding waveform.  You can obtain these values by calling the niFgen_QueryArbWfmCapabilities function. 
    '''''
    '''''Default Value: None
    ''''' 
    '''''</param>
    '''''<param name="Marker_Location_Array">
    '''''
    '''''
    '''''markerLocationArray
    '''''ViInt32[]
    '''''Specifies the array of marker locations to where you want a marker to be generated in the sequence.  The array must have at least as many elements as the value you specify in the sequenceLength parameter.  Each markerLocationArray element corresponds to a waveformHandlesArray element and indicates where in the waveform a marker is to generate.  The marker location must be less than the size of the waveform the marker is in.  The markers are coerced to the nearest marker quantum and the coerced values are returned in the coercedMarkersArray parameter.
    '''''
    '''''If you do not want a marker generated for a particular sequence stage, set the marker to NIFGEN_VAL_NO_MARKER.
    '''''
    '''''Defined Value: NIFGEN_VAL_NO_MARKER
    '''''
    '''''Default Value: None
    ''''' 
    '''''</param>
    '''''<param name="Coerced_Markers_Array">
    '''''
    '''''
    '''''coercedMarkersArray
    '''''ViInt32[]
    '''''Returns an array of all given markers that are coerced (rounded) to the nearest marker quantum. Not all devices coerce markers. 
    '''''Default Value: None
    ''''' 
    '''''</param>
    '''''<param name="Sequence_Handle">
    '''''
    '''''
    '''''sequenceHandle
    '''''ViInt32*
    '''''Returns the handle that identifies the new arbitrary sequence.  You can pass this handle to niFgen_ConfigureArbSequence to generate the arbitrary sequence.
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function CreateAdvancedArbSequence(ByVal Sequence_Length As Integer, ByVal Waveform_Handles_Array() As Integer, ByVal Loop_Counts_Array() As Integer, ByVal Sample_Counts_Array() As Integer, ByVal Marker_Location_Array() As Integer, ByVal Coerced_Markers_Array() As Integer, ByRef Sequence_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CreateAdvancedArbSequence(Me._handle, Sequence_Length, Waveform_Handles_Array, Loop_Counts_Array, Sample_Counts_Array, Marker_Location_Array, Coerced_Markers_Array, Sequence_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureArbSequence
    '''''
    '''''ViStatus niFgen_ConfigureArbSequence&#160;(ViSession&#160;vi, VViConstString channelName,
    '''''ViInt32 sequenceHandle, ViReal64 gain, ViReal64 offset;
    '''''
    '''''
    '''''
    '''''Purpose
    '''''
    '''''Configures the signal generator attributes that affect arbitrary sequence generation. These attributes are the NIFGEN_ATTR_ARB_SEQUENCE_HANDLE, NIFGEN_ATTR_ARB_GAIN, and NIFGEN_ATTR_ARB_OFFSET
    '''''
    '''''
    '''''
    '''''Notes&#160;&#160;The signal generator must not be in the Generating state when you call this function.
    '''''
    '''''You must call the niFgen_ConfigureOutputMode function to set the output mode to NIFGEN_VAL_OUTPUT_SEQ before calling this function.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name from which you want to configure an arbitrary sequence.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Sequence_Handle">
    '''''
    '''''
    '''''sequenceHandle
    '''''ViInt32
    '''''
    '''''Specifies the handle of the arbitrary sequence that you want the signal generator to produce. NI-FGEN sets the NIFGEN_ATTR_ARB_SEQUENCE_HANDLE attribute to this value. You can create an arbitrary sequence using the niFgen_CreateArbSequence function. The niFgen_CreateArbSequence function returns a handle that you use to identify the sequence.
    '''''
    '''''Default Value: None
    '''''
    ''''' 
    '''''
    '''''
    '''''
    '''''</param>
    '''''<param name="Gain">
    '''''
    '''''
    '''''gain
    '''''ViReal64
    '''''Specifies the factor by which the signal generator scales the arbitrary waveform data. When you create arbitrary waveforms, you must first normalize the data points to a range of &#8211;1.00 to +1.00&#160;V.  You can use this parameter to scale the arbitrary waveform to other ranges. NI-FGEN sets the NIFGEN_ATTR_ARB_GAIN attribute to this value.
    '''''
    '''''For example, to configure the output signal to range from &#8211;2.00 to +2.00&#160;V, set the gain to 2.00.
    '''''
    '''''Units: volts
    '''''
    '''''Default Value: None
    ''''' 
    '''''</param>
    '''''<param name="Offset">
    '''''
    '''''
    '''''offset
    '''''ViReal64
    '''''Specifies the value the signal generator adds to the arbitrary waveform data. When you create arbitrary waveforms, you must first normalize the data points to a range of &#8211;1.00 to +1.00&#160;V. You can use this parameter to shift the range of the arbitrary waveform. NI-FGEN sets the NIFGEN_ATTR_ARB_OFFSET attribute to this value.
    '''''
    '''''For example, to configure the output signal to range from 0.00 to 2.00&#160;V instead of &#8211;1.00 to 1.00&#160;V, set the offset to 1.00.
    '''''
    '''''Units: volts
    '''''
    '''''Default Value: None
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureArbSequence(ByVal Channel_Name As String, ByVal Sequence_Handle As Integer, ByVal Gain As Double, ByVal Offset As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureArbSequence(Me._handle, Channel_Name, Sequence_Handle, Gain, Offset)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ClearArbSequence
    '''''
    '''''ViStatus niFgen_ClearArbSequence&#160;(ViSession&#160;vi, ViInt32&#160;sequenceHandle);
    '''''
    '''''Purpose
    '''''
    '''''Removes a previously created arbitrary sequence from the signal generator memory and invalidates the sequence handle.
    '''''
    '''''
    '''''Note&#160;&#160;  The signal generator must not be in the Generating state when you call this function.
    '''''
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Sequence_Handle">
    '''''
    '''''
    '''''sequenceHandle
    '''''ViInt32
    '''''
    '''''
    '''''
    '''''
    '''''Specifies the handle of the arbitrary sequence that you want the signal generator to remove.  You can create an arbitrary sequence using the niFgen_CreateArbSequence function. The niFgen_CreateArbSequence function returns a handle that you use to identify the sequence.
    '''''
    '''''Defined Value:
    '''''NIFGEN_VAL_ALL_SEQUENCES&#8212;Remove all sequences from the signal generator
    '''''
    '''''Default Value: None
    '''''
    ''''' 
    '''''
    '''''
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ClearArbSequence(ByVal Sequence_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ClearArbSequence(Me._handle, Sequence_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ClearArbMemory
    '''''
    '''''ViStatus niFgen_ClearArbMemory&#160;(ViSession&#160;vi);
    '''''
    '''''Purpose
    '''''
    '''''Removes all previously created arbitrary waveforms, sequences, and scripts from the signal generator memory, and invalidates all waveform handles, sequence handles, and waveform names.
    '''''
    '''''
    '''''Note&#160;&#160;  The signal generator must not be in the Generating state when you call this function.
    '''''
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ClearArbMemory() As Integer
        Dim pInvokeResult As Integer = PInvoke.ClearArbMemory(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_AllocateWaveform
    '''''
    '''''ViStatus niFgen_AllocateWaveform&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;waveformSize, ViInt32*&#160;waveformHandle);
    '''''
    '''''Purpose
    '''''
    '''''Specifies the size of a waveform so that it can be allocated in onboard memory before loading the associated data.  Data can then be loaded in smaller chunks with the Write (Binary16)Waveform functions.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to allocate the waveform.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Size">
    '''''
    '''''
    '''''waveformSize
    '''''ViInt32
    '''''Specifies, in samples, the size of the waveform to allocate.
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Handle">
    '''''
    '''''
    '''''waveformHandle
    '''''ViInt32*
    '''''The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function AllocateWaveform(ByVal Channel_Name As String, ByVal Waveform_Size As Integer, ByRef Waveform_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.AllocateWaveform(Me._handle, Channel_Name, Waveform_Size, Waveform_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_SetWaveformNextWritePosition
    '''''
    '''''ViStatus niFgen_SetWaveformNextWritePosition&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;waveformHandle, ViInt32&#160;relativeto, ViInt32&#160;offset);
    '''''
    '''''Purpose
    '''''
    '''''Sets the position in the waveform at which the next waveform data is written. 
    '''''This function allows you to write to arbitrary locations within the waveform. These settings 
    '''''apply only to the next write to the waveform specified by the waveformHandle 
    '''''parameter. Subsequent writes to that waveform begin where the last write left off, unless 
    '''''this function is called again. The waveformHandle passed in must have been created by a call 
    '''''to the niFgen_AllocateWaveform function or one of the following
    '''''niFgen CreateWaveform functions:
    '''''
    '''''
    '''''niFgen_CreateWaveformF64
    '''''niFgen_CreateWaveformI16
    '''''niFgen_CreateWaveformFromFileI16
    '''''niFgen_CreateWaveformFromFileF64
    '''''niFgen_CreateWaveformFromFileHWS
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel on which to the waveform data should be loaded.
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Handle">
    '''''
    '''''
    '''''waveformHandle
    '''''ViInt32
    '''''Specifies the handle of the arbitrary waveform previously allocated with the 
    '''''niFgen_AllocateWaveform function. 
    ''''' 
    '''''</param>
    '''''<param name="relativeTo">
    '''''
    '''''
    '''''relativeTo
    '''''ViInt32
    '''''Specifies the reference position in the waveform. The position and offset together determine where to start loading data into the waveform.
    '''''
    '''''Defined Values
    '''''
    '''''NIFGEN_VAL_WAVEFORM_POSITION_START&#160;(0)  
    '''''Use the start of the waveform as the reference position.
    '''''NIFGEN_VAL_WAVEFORM_POSITION_CURRENT&#160;(1) 
    '''''Use the current position within the waveform as the reference position. 
    ''''' 
    '''''</param>
    '''''<param name="offset">
    '''''
    '''''
    '''''offset
    '''''ViInt32
    '''''Specifies the offset from relativeTo at which to start loading the data into the waveform.
    ''''' </tr></table>
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function SetWaveformNextWritePosition(ByVal Channel_Name As String, ByVal Waveform_Handle As Integer, ByVal relativeTo As Integer, ByVal offset As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.SetWaveformNextWritePosition(Me._handle, Channel_Name, Waveform_Handle, relativeTo, offset)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_WriteWaveform
    '''''
    '''''ViStatus niFgen_WriteWaveform&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;waveformHandle, ViInt32&#160;size, ViReal64[]&#160;data);
    '''''
    '''''Purpose
    '''''
    '''''Writes floating-point data to the waveform in onboard memory. 
    '''''The waveform handle passed in must have been created by a call to the 
    '''''niFgen_AllocateWaveform function or one of the following 
    '''''niFgen CreateWaveform functions:
    '''''niFgen_CreateWaveformF64
    '''''niFgen_CreateWaveformI16
    '''''niFgen_CreateWaveformFromFileI16
    '''''niFgen_CreateWaveformFromFileF64
    '''''niFgen_CreateWaveformFromFileHWS
    '''''The write position and offset can be set by calling the niFgen_SetWaveformNextWritePosition function.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''The channel onto which the waveform data should be loaded. 
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Handle">
    '''''
    '''''
    '''''waveformHandle
    '''''ViInt32
    '''''Specifies the handle of the arbitrary waveform previously allocated with the
    '''''niFgen_AllocateWaveform function. 
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Size">
    '''''
    '''''
    '''''size
    '''''ViInt32
    '''''Specifies the number of samples to load into the waveform.
    '''''
    '''''Default Value: 0
    ''''' 
    '''''
    '''''
    '''''</param>
    '''''<param name="Data">
    '''''
    '''''
    '''''data
    '''''ViInt64[]
    '''''Specifies the array of data to load into the waveform. The array must have at least as many elements as the value in size.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function WriteWaveform(ByVal Channel_Name As String, ByVal Waveform_Handle As Integer, ByVal Size As Integer, ByVal Data() As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.WriteWaveform(Me._handle, Channel_Name, Waveform_Handle, Size, Data)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_WriteWaveformComplexF64
    '''''
    '''''ViStatus niFgen_WriteWaveformComplexF64&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;numberofSamples, niFgen_ComplexF64[]&#160;data, ViInt32&#160;waveformHandle);
    '''''
    '''''Purpose
    '''''
    '''''Writes complex data to the waveform in onboard memory on devices with the NIFGEN_ATTR_OUTPUT_ENABLED attribute set to VI_TRUE and the NIFGEN_ATTR_OSP_DATA_PROCESSING_MODE attribute set to NIFGEN_VAL_OSP_COMPLEX. The waveform handle passed in must have been created by a call to the niFgen_AllocateWaveform function or to one of the following niFgen Create Waveform functions:
    '''''
    '''''niFgen_CreateWaveformF64
    '''''
    '''''niFgen_CreateWaveformI16
    '''''
    ''''' niFgen_CreateWaveformFromFileI16
    '''''
    '''''niFgen_CreateWaveformFromFileF64
    '''''
    '''''niFgen_CreateWaveformFromFileHWS
    '''''
    '''''
    '''''The write position and offset can be set by calling the niFgen_SetWaveformNextWritePosition function.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel onto which the waveform data should be loaded. 
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Number_of_Samples">
    '''''
    '''''
    '''''numberofSamples
    '''''ViInt32
    '''''Specifies the number of samples to load into the waveform.
    '''''
    '''''Default Value: 0
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Data">
    '''''
    '''''
    '''''data
    '''''niFgen_ComplexF64[]
    '''''Specifies the array of data to load into the waveform. You must normalize the data points in the array to be between -1.00 and +1.00. The array must have at least as many elements as the value in the numberOfSamples parameter.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Handle">
    '''''
    '''''
    '''''waveformHandle
    '''''ViInt32
    '''''Specifies the handle of the arbitrary waveform previously allocated with 
    '''''niFgen_AllocateWaveform. 
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function WriteWaveformComplexF64(ByVal Channel_Name As String, ByVal Number_of_Samples As Integer, ByVal Data As Integer, ByVal Waveform_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.WriteWaveformComplexF64(Me._handle, Channel_Name, Number_of_Samples, Data, Waveform_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_WriteBinary16Waveform
    '''''
    '''''ViStatus niFgen_WriteBinary16Waveform&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;waveformHandle, ViInt32&#160;size, ViInt16[]&#160;data);
    '''''
    '''''Purpose
    '''''
    '''''Writes binary data to the waveform in onboard memory. The waveform handle 
    '''''passed in must have been created by a call to the niFgen_AllocateWaveform
    '''''or the niFgen_CreateWaveformI16 function.
    '''''The write position and offset can be set by calling the niFgen_SetWaveformNextWritePosition function.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel on which to the waveform data should be loaded.  
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Handle">
    '''''
    '''''
    '''''waveformHandle
    '''''ViInt32
    '''''Specifies the handle of the arbitrary waveform previously allocated with the 
    '''''niFgen_AllocateWaveform function.  
    ''''' 
    '''''</param>
    '''''<param name="Size">
    '''''
    '''''
    '''''size
    '''''ViInt32
    '''''Specifies the number of samples to load into the waveform.
    '''''
    '''''Default Value: 0
    ''''' 
    '''''
    '''''
    '''''</param>
    '''''<param name="Data">
    '''''
    '''''
    '''''data
    '''''ViInt16 []
    '''''Specifies the array of data to load into the waveform. The array must have at least as many elements as the value in size. The binary data is left-justified.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function WriteBinary16Waveform(ByVal Channel_Name As String, ByVal Waveform_Handle As Integer, ByVal Size As Integer, ByVal Data() As Short) As Integer
        Dim pInvokeResult As Integer = PInvoke.WriteBinary16Waveform(Me._handle, Channel_Name, Waveform_Handle, Size, Data)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_WriteComplexBinary16Waveform
    '''''
    '''''ViStatus niFgen_WriteComplexBinary16Waveform&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;waveformHandle, ViInt32&#160;size, NIComplexI16[]&#160;data);
    '''''
    '''''Purpose
    '''''
    '''''Writes binary data to the waveform in onboard memory. The waveform handle passed in must have been created by a call to the niFgen_AllocateWaveform or the niFgen_CreateWaveformI16 function.
    '''''
    '''''The write position and offset can be set by calling the niFgen_SetWaveformNextWritePosition function.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies channel on which to the waveform data should be loaded.  
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Handle">
    '''''
    '''''
    '''''waveformHandle
    '''''ViInt32
    '''''Specifies the handle of the arbitrary waveform previously allocated with the 
    '''''niFgen_AllocateWaveform function. 
    ''''' 
    '''''</param>
    '''''<param name="Size">
    '''''
    '''''
    '''''size
    '''''ViInt32
    '''''Specifies the number of samples to load into the waveform.
    '''''
    '''''Default Value: 0
    ''''' 
    '''''
    '''''
    '''''</param>
    '''''<param name="Data">
    '''''
    '''''
    '''''data
    '''''NIComplexI16&#160;[]
    '''''Specifies the array of data to load into the waveform. The array must have at least as many elements as the value in size. The binary data is left-justified.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function WriteComplexBinary16Waveform(ByVal Channel_Name As String, ByVal Waveform_Handle As Integer, ByVal Size As Integer, ByVal Data As nicomplexI16) As Integer
        Dim pInvokeResult As Integer = PInvoke.WriteComplexBinary16Waveform(Me._handle, Channel_Name, Waveform_Handle, Size, Data)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureReferenceClock
    '''''
    '''''ViStatus niFgen_ConfigureReferenceClock&#160;(ViSession&#160;vi, ViConstString&#160;referenceClockSource, ViReal64&#160;referenceClockFrequency);
    '''''
    '''''Purpose
    '''''
    '''''Configures the signal generator Reference clock source and frequency. 
    '''''
    '''''The signal generator uses the Reference clock to tune the Sample clock timebase of the signal generator so that the frequency stability and accuracy of the Sample clock timebase matches that of the Reference clock.
    '''''
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Reference_Clock_Source">
    '''''
    '''''
    '''''referenceClockSource
    '''''ViConstString
    '''''Specifies the source for the Reference clock.
    '''''
    '''''
    '''''
    '''''For example, when you set this parameter to &quot;ClkIn,&quot; the signal generator uses the signal it receives at its Clk In front panel connector as the Reference clock. The Reference clock phase-locks with the signal generator Sample clock timebase to allow the frequency stability and accuracy of the sample clock timebase to match that of the Reference clock.
    '''''
    '''''
    '''''
    '''''Note&#160;&#160; The following Defined Values are examples of possible reference clock sources. For a complete list of the reference clock sources available on your device, refer to the Device Routes tab in MAX.
    '''''
    '''''
    '''''
    '''''Defined Values
    '''''
    '''''&quot;None&quot;No Reference clock
    '''''
    '''''&quot;PXI_Clk10&quot;10 MHz PCI backplane reference clock
    '''''
    '''''&quot;ClkIn&quot;Clk In Front panel connector
    '''''
    '''''&quot;OnboardRefClk&quot;
    '''''Onboard reference clock
    '''''
    '''''&quot;RTSI7&quot;RTSI line 7
    '''''
    '''''&quot;RefIn&quot;Ref In front panel connector
    '''''
    '''''
    '''''
    '''''Default Value: &quot;None&quot;
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Reference_Clock_Frequency">
    '''''
    '''''
    '''''referenceClockFrequency
    '''''ViReal64
    '''''The reference clock frequency in hertz.
    '''''Default Value: 10000000
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureReferenceClock(ByVal Reference_Clock_Source As String, ByVal Reference_Clock_Frequency As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureReferenceClock(Me._handle, Reference_Clock_Source, Reference_Clock_Frequency)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureSampleClockSource
    '''''
    '''''ViStatus niFgen_ConfigureSampleClockSource&#160;(ViSession&#160;vi, ViConstString&#160;sampleClockSource);
    '''''
    '''''Purpose
    '''''
    '''''Sets the source of the Sample clock of the signal generator. Samples are generated based on the the Sample clock cycles. The Sample clock source can be internal or external.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Sample_Clock_Source">
    '''''
    '''''
    '''''sampleClockSource
    '''''ViConstString
    '''''Specifies the Sample clock source that you want the signal generator to use. 
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''Note&#160;&#160; The following Defined Values are examples of possible Sample clock sources. For a complete list of the Sample clock sources available on your device, refer to the Device Routes tab in MAX.
    '''''
    '''''
    '''''Defined Values
    '''''
    '''''&quot;OnboardClock&quot;Onboard clock
    '''''
    '''''
    '''''&quot;ClkIn&quot;Clk In front panel connector
    '''''
    '''''&quot;PXI_Star&quot;PXI star trigger line
    '''''
    '''''&quot;PXI_Trig0&quot;
    '''''PXI trigger line 0 or RTSI line 0
    '''''
    '''''&quot;PXI_Trig1&quot;
    '''''PXI trigger line 1 or RTSI line 1
    '''''
    '''''&quot;PXI_Trig2&quot;
    '''''PXI trigger line 2 or RTSI line 2
    '''''
    '''''&quot;PXI_Trig3&quot;
    '''''PXI trigger line 3 or RTSI line 3
    '''''
    '''''&quot;PXI_Trig4&quot;
    '''''PXI trigger line 4 or RTSI line 4
    '''''
    '''''&quot;PXI_Trig5&quot;
    '''''PXI trigger line 5 or RTSI line 5
    '''''
    '''''&quot;PXI_Trig6&quot;
    '''''PXI trigger line 6 or RTSI line 6
    '''''
    '''''&quot;PXI_Trig7&quot;
    '''''PXI trigger line 7 or RTSI line 7
    '''''
    '''''&quot;DDC_ClkIn&quot;
    '''''Sample clock from DDC connector
    '''''
    '''''
    '''''
    '''''Default Value: &quot;OnboardClock&quot;
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureSampleClockSource(ByVal Sample_Clock_Source As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureSampleClockSource(Me._handle, Sample_Clock_Source)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureClockMode
    '''''
    '''''ViStatus niFgen_ConfigureClockMode&#160;(ViSession&#160;vi, ViInt32&#160;clockMode);
    '''''
    '''''Purpose
    '''''
    '''''Selects the clock mode for the signal generator.  
    '''''
    '''''For signal generators that support it, this function allows you to switch the Sample clock to High-Resolution Sampling mode.
    '''''
    '''''When in Divide-Down Sampling mode, you can only set the sample rate to certain frequencies, based on dividing down the update clock. However, in High-Resolution Sampling mode, you can set the sample rate to any value. 
    '''''
    '''''
    '''''Note&#160;&#160;The signal generator must not be in the Generating state when you call this function.
    '''''
    '''''
    '''''Note&#160;&#160;You must call the niFgen_ConfigureOutputMode function to set the output mode to NIFGEN_VAL_OUTPUT_SEQ, NIFGEN_VAL_OUTPUT_ARB, or NIFGEN_VAL_OUTPUT_SCRIPT before calling this function.
    '''''
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Clock_Mode">
    '''''
    '''''
    '''''clockMode
    '''''ViInt32
    '''''Sets the clock mode of the signal generator. 
    '''''
    '''''Defined Values
    '''''
    '''''NIFGEN_VAL_DIVIDE_DOWNDivide down sampling&#8212;Sample rates are generated by dividing the source frequency.
    '''''NIFGEN_VAL_HIGH_RESOLUTIONHigh resolution sampling&#8212;Sample rate is generated by a high resolution clock source.
    '''''NIFGEN_VAL_AUTOMATICAutomatic Selection&#8212;NI-FGEN selects between the divide-down and high-resolution clocking modes.
    '''''
    '''''Default Value: Depends on the device
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureClockMode(ByVal Clock_Mode As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureClockMode(Me._handle, Clock_Mode)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_AdjustSampleClockRelativeDelay
    '''''
    '''''ViStatus niFgen_AdjustSampleClockRelativeDelay&#160;(ViSession&#160;vi, ViReal64&#160;adjustmentTime);
    '''''
    '''''Purpose
    '''''
    '''''Delays (or phase shifts) the Sample clock, which delays the generated signal.  Delaying the Sample clock can be useful when synchronizing the output of multiple modules or when intentionally phase shifting the output relative to a fixed reference, such as the PLL Reference clock.  
    '''''Adjustment time can be positive or negative, but it must be less than or equal to the Sample clock period.  The delay takes effect immediately after this function is called.  To delay an external Sample clock, use the 
    '''''NIFGEN_ATTR_SAMPLE_CLOCK_ABSOLUTE_DELAY attribute.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Adjustment_Time">
    '''''
    '''''
    '''''adjustmentTime
    '''''ViReal64
    '''''Specifies the amount of time to adjust the sample clock delay in seconds.
    '''''
    '''''Default Value: 0
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function AdjustSampleClockRelativeDelay(ByVal Adjustment_Time As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.AdjustSampleClockRelativeDelay(Me._handle, Adjustment_Time)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureDigitalEdgeStartTrigger
    '''''
    '''''ViStatus niFgen_ConfigureDigitalEdgeStartTrigger&#160;(ViSession&#160;vi, ViConstString&#160;source, ViInt32&#160;edge);
    '''''
    '''''Purpose
    '''''
    '''''Configures the Start trigger for digital edge triggering.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Source">
    '''''
    '''''
    '''''source
    '''''ViConstString
    '''''Specifies which trigger source the signal generator uses.
    ''''' 
    '''''</param>
    '''''<param name="Edge">
    '''''
    '''''
    '''''edge
    '''''ViInt32
    '''''Specifies the edge to detect. 
    '''''
    '''''Defined Values
    '''''NIFGEN_VAL_RISING_EDGEOccurs when the signal transitions from low level to high level.
    '''''NIFGEN_VAL_FALLING_EDGEOccurs when the signal transitions from high level to low level.
    '''''Default Value:
    '''''NIFGEN_VAL_RISING_EDGE
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureDigitalEdgeStartTrigger(ByVal Source As String, ByVal Edge As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureDigitalEdgeStartTrigger(Me._handle, Source, Edge)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureSoftwareEdgeStartTrigger
    '''''
    '''''ViStatus niFgen_ConfigureSoftwareEdgeStartTrigger&#160;(ViSession&#160;vi);
    '''''
    '''''Purpose
    '''''
    '''''Configures the Start trigger for software edge triggering.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureSoftwareEdgeStartTrigger() As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureSoftwareEdgeStartTrigger(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_DisableStartTrigger
    '''''
    '''''ViStatus niFgen_DisableStartTrigger&#160;(ViSession&#160;vi);
    '''''
    '''''Purpose
    '''''
    '''''Disables the Start trigger.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function DisableStartTrigger() As Integer
        Dim pInvokeResult As Integer = PInvoke.DisableStartTrigger(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureDigitalEdgeScriptTrigger
    '''''
    '''''ViStatus niFgen_ConfigureDigitalEdgeScriptTrigger&#160;(ViSession&#160;vi, ViConstString&#160;triggerID, ViConstString&#160;source, ViInt32&#160;edge);
    '''''
    '''''Purpose
    '''''
    '''''Configures the specified Script trigger for digital edge triggering.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Trigger_ID">
    '''''
    '''''
    '''''triggerID
    '''''ViConstString
    '''''Specifies the Script trigger used for triggering.
    ''''' 
    '''''</param>
    '''''<param name="Source">
    '''''
    '''''
    '''''source
    '''''ViConstString
    '''''Specifies which trigger source the signal generator uses.
    ''''' 
    '''''</param>
    '''''<param name="Edge">
    '''''
    '''''
    '''''edge
    '''''ViInt32
    '''''Specifies the edge to detect. 
    '''''
    '''''Defined Values
    '''''NIFGEN_VAL_RISING_EDGEOccurs when the signal transitions from low level to high level.
    '''''NIFGEN_VAL_FALLING_EDGEOccurs when the signal transitions from high level to low level.
    '''''Default Value:
    '''''NIFGEN_VAL_RISING_EDGE
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureDigitalEdgeScriptTrigger(ByVal Trigger_ID As String, ByVal Source As String, ByVal Edge As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureDigitalEdgeScriptTrigger(Me._handle, Trigger_ID, Source, Edge)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureDigitalLevelScriptTrigger
    '''''
    '''''ViStatus niFgen_ConfigureDigitalLevelScriptTrigger&#160;(ViSession&#160;vi, ViConstString&#160;triggerID, ViConstString&#160;source, ViInt32&#160;triggerWhen);
    '''''
    '''''Purpose
    '''''
    '''''Configures the specified Script trigger for digital level triggering.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Trigger_ID">
    '''''
    '''''
    '''''triggerID
    '''''ViConstString
    '''''Specifies the Script trigger used for triggering.
    ''''' 
    '''''</param>
    '''''<param name="Source">
    '''''
    '''''
    '''''source
    '''''ViConstString
    '''''Specifies which trigger source the signal generator uses.
    ''''' 
    '''''</param>
    '''''<param name="Trigger_When">
    '''''
    '''''
    '''''triggerWhen
    '''''ViInt32
    '''''Configures the specified Script trigger for digital level triggering.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureDigitalLevelScriptTrigger(ByVal Trigger_ID As String, ByVal Source As String, ByVal Trigger_When As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureDigitalLevelScriptTrigger(Me._handle, Trigger_ID, Source, Trigger_When)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureSoftwareEdgeScriptTrigger
    '''''
    '''''ViStatus niFgen_ConfigureSoftwareEdgeScriptTrigger&#160;(ViSession&#160;vi, ViConstString&#160;triggerID);
    '''''
    '''''Purpose
    '''''
    '''''Configures the specified Script trigger for software edge triggering.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Trigger_ID">
    '''''
    '''''
    '''''triggerID
    '''''ViConstString
    '''''Specifies the Script trigger used for triggering.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureSoftwareEdgeScriptTrigger(ByVal Trigger_ID As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureSoftwareEdgeScriptTrigger(Me._handle, Trigger_ID)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_DisableScriptTrigger
    '''''
    '''''ViStatus niFgen_DisableScriptTrigger&#160;(ViSession&#160;vi, ViConstString&#160;triggerID);
    '''''
    '''''Purpose
    '''''
    '''''Disables the specified Script trigger.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Trigger_ID">
    '''''
    '''''
    '''''triggerID
    '''''ViConstString
    '''''Specifies the Script trigger used for triggering.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function DisableScriptTrigger(ByVal Trigger_ID As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.DisableScriptTrigger(Me._handle, Trigger_ID)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureTriggerMode
    '''''
    '''''ViStatus niFgen_ConfigureTriggerMode&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;triggerMode);
    '''''
    '''''Purpose
    '''''
    '''''Sets the trigger mode for the signal generator.
    '''''
    '''''Supported trigger modes are Single Trigger, Continuous Trigger, Stepped Trigger, and Burst Trigger. Refer to Devices?<your device>?Triggering?Trigger Modes in the NI Signal Generators Help for descriptions of the signal generator's specific behavior for supported trigger modes.
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to configure the trigger mode.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Trigger_Mode">
    '''''
    '''''
    '''''triggerMode
    '''''ViInt32
    '''''Sets the trigger mode.
    '''''
    '''''Defined Values
    '''''
    '''''NIFGEN_VAL_SINGLE
    '''''The waveform that you describe in the sequence list generates only once by going through the entire staging list. Only one trigger is required to start the waveform generation. You can use single trigger mode with the output mode in any mode.  After a trigger is received, the waveform generation starts from the first stage and continues through to the last stage.
    '''''
    '''''NIFGEN_VAL_CONTINUOUS&#160;
    '''''The waveform that you describe in the staging list generates infinitely by repeatedly cycling through the staging list. After a trigger is received, the waveform generation starts from the first stage and continues through to the last stage. After the last stage is completed, the waveform generation loops back to the start of the first stage and continues until it is stopped. Only one trigger is required to start the waveform generation.
    '''''
    '''''NIFGEN_VAL_STEPPED
    '''''After a start trigger is received, the waveform described by the first stage generates. Then, the device waits for the next trigger signal. On the next trigger, the waveform described by the second stage generates, and so on. Once the staging list is exhausted, the waveform generation returns to the first stage and continues to repeat the cycle.
    '''''
    '''''NIFGEN_VAL_BURST
    '''''&#160;&#160;After a start trigger is received, the waveform described by the first stage generates until another trigger is received. At the next trigger, the buffer of the previous stage completes, and then the waveform described by the second stage generates. Once the staging list is exhausted, the waveform generation returns to the first stage and continues to repeat the cycle.  In Frequency List mode, the duration instruction is ignored, and the trigger switches the frequency to the next frequency in the list.
    '''''
    '''''
    '''''Default Value: NIFGEN_VAL_CONTINUOUS
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureTriggerMode(ByVal Channel_Name As String, ByVal Trigger_Mode As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureTriggerMode(Me._handle, Channel_Name, Trigger_Mode)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_SendSoftwareEdgeTrigger
    '''''
    '''''ViStatus niFgen_SendSoftwareEdgeTrigger&#160;(ViSession&#160;vi, viInt32&#160;trigger, viConstString&#160;triggerID);
    '''''
    '''''Purpose
    '''''
    '''''Sends a software edge to the specified trigger.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Trigger">
    '''''
    '''''
    '''''trigger
    '''''ViInt32
    '''''Specifies the type of trigger to send.
    '''''Defined Values
    '''''
    '''''NIFGEN_VAL_START_TRIGGERTransitions the device from an Idle state to a Generation state where the device can respond to sample clocks.
    '''''NIFGEN_VAL_SCRIPT_TRIGGERAllows you to create sophisticated generation operations that are determined by the generation script.
    '''''
    '''''Default Value: NIFGEN_VAL_START_TRIGGER
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Trigger_ID">
    '''''
    '''''
    '''''triggerID
    '''''ViConstString
    '''''Identifies the specific trigger to be used.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function SendSoftwareEdgeTrigger(ByVal Trigger As Integer, ByVal Trigger_ID As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.SendSoftwareEdgeTrigger(Me._handle, Trigger, Trigger_ID)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureSynchronization
    '''''
    '''''ViStatus niFgen_ConfigureSynchronization&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;synchronizationSource);
    '''''
    '''''Purpose
    '''''
    '''''Sets the signal generator to receive a synchronization signal to synchronize two or more NI&#160;5401/5411/5431 signal generators. One signal generator should route a SYNC signal to a RTSI line by calling the niFgen_ExportSignal function (use the niFgen_RouteSignalOut function for the NI 5404), and other signal generators should receive the signal by calling the niFgen_ConfigureSynchronization function.
    '''''
    '''''
    '''''Note&#160;&#160;  The signal generator must not be in the Generating state when you call this function.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to configure the synchronization signal.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Synchronization_Source">
    '''''
    '''''
    '''''synchronizationSource
    '''''ViInt32
    '''''Specify the source of the synchronization signal you want to use. 
    '''''
    '''''Defined Values
    '''''
    '''''NIFGEN_VAL_NONE&#160;&#160;
    '''''No synchronization source
    '''''
    '''''NIFGEN_VAL_RTSI_0&#160;&#160;
    '''''RTSI 0 or PXI_Trig 0
    '''''
    '''''NIFGEN_VAL_RTSI_1&#160;&#160;
    '''''RTSI 1 or PXI_Trig 1
    '''''
    '''''NIFGEN_VAL_RTSI_2&#160;&#160;
    '''''RTSI 2 or PXI_Trig 2
    '''''
    '''''NIFGEN_VAL_RTSI_3&#160;&#160;
    '''''RTSI 3 or PXI_Trig 3
    '''''
    '''''NIFGEN_VAL_RTSI_4&#160;&#160;
    '''''RTSI 4 or PXI_Trig 4
    '''''
    '''''NIFGEN_VAL_RTSI_5&#160;&#160;
    '''''RTSI 5 or PXI_Trig 5
    '''''
    '''''NIFGEN_VAL_RTSI_6&#160;&#160;
    '''''RTSI 6 or PXI_Trig 6
    '''''
    '''''NIFGEN_VAL_TTL0&#160;&#160;
    '''''TTL 0
    '''''
    '''''NIFGEN_VAL_TTL1&#160;&#160;
    '''''TTL 1
    '''''
    '''''NIFGEN_VAL_TTL2&#160;&#160;
    '''''TTL 2
    '''''
    '''''NIFGEN_VAL_TTL3&#160;&#160;
    '''''TTL 3
    '''''
    '''''NIFGEN_VAL_TTL4&#160;&#160;
    '''''TTL 4
    '''''
    '''''NIFGEN_VAL_TTL5&#160;&#160;
    '''''TTL 5
    '''''
    '''''NIFGEN_VAL_TTL6&#160;&#160;
    '''''TTL 6
    '''''
    '''''Default Value: NIFGEN_VAL_NONE
    ''''' </tr></table>
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureSynchronization(ByVal Channel_Name As String, ByVal Synchronization_Source As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureSynchronization(Me._handle, Channel_Name, Synchronization_Source)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ExportSignal
    '''''
    '''''ViStatus&#160;niFgen_ExportSignal&#160;(ViSession&#160;vi, ViInt32&#160;signal, ViConstString&#160;signalIdentifier, ViConstString&#160;outputTerminal);
    '''''
    '''''Purpose
    '''''
    '''''Exports various signals, clocks, and events from the signal generator to the RTSI lines, front panel, or other external terminals.  
    '''''
    '''''Notes&#160;&#160;The signal generator must not be in the Generating state when you call this function.
    '''''You can clear a previously routed signal by exporting the signal to &quot;&quot; (empty string).
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Signal">
    '''''
    '''''
    '''''signal
    '''''ViInt32
    '''''Specifies the source of the signal to route.
    '''''
    '''''Defined Values
    '''''
    '''''
    '''''
    '''''NIFGEN_VAL_ONBOARD_REFERENCE_CLOCKThe onboard 10 MHz synchronization clock (PCI only).
    '''''
    '''''NIFGEN_VAL_SYNC_OUTThe SYNC OUT signal that normally is generated on the SYNC OUT front panel connector.
    '''''
    '''''NIFGEN_VAL_START_TRIGGERStart trigger.
    '''''
    '''''
    '''''NIFGEN_VAL_MARKER_EVENTMarker event.
    '''''
    '''''
    '''''NIFGEN_VAL_SAMPLE_CLOCK_TIMEBASEThe clock from which the sample clock is derived.
    '''''
    '''''NIFGEN_VAL_SYNCHRONIZATIONA synchronization strobe used to guarantee absolute synchronization between two or more signal generators. (NI 5404, 5411, 5431 only)
    '''''
    '''''NIFGEN_VAL_SAMPLE_CLOCKSample clock 
    '''''
    '''''NIFGEN_VAL_REFERENCE_CLOCKPLL Reference clock
    '''''
    '''''NIFGEN_VAL_SCRIPT_TRIGGERScript trigger
    '''''
    '''''NIFGEN_VAL_READY_FOR_START_EVENTReady For Start event
    '''''
    '''''NIFGEN_VAL_STARTED_EVENTStarted event
    '''''
    '''''NIFGEN_VAL_DONE_EVENTDone event
    '''''
    '''''NIFGEN_VAL_DATA_MARKER_EVENTData Marker event
    '''''
    '''''
    '''''
    '''''</param>
    '''''<param name="Signal_Identifier">
    '''''
    '''''
    '''''signalIdentifier
    '''''ViConstString
    '''''Specifies which instance of the selected signal to export.
    '''''
    '''''
    '''''
    '''''
    '''''Defined Values
    '''''
    '''''&quot;&quot; (empty string)Default (for non instance-based signals)
    '''''
    '''''
    '''''&quot;ScriptTrigger0&quot;Script trigger 0
    '''''
    '''''&quot;ScriptTrigger1&quot;Script trigger 1
    '''''
    '''''&quot;ScriptTrigger2&quot;Script trigger 2
    '''''
    '''''&quot;ScriptTrigger3&quot;Script trigger 3
    '''''
    '''''&quot;Marker0&quot;
    '''''Marker 0
    '''''
    '''''&quot;Marker1&quot;
    '''''Marker 1
    '''''
    '''''&quot;Marker2&quot;
    '''''Marker 2
    '''''
    '''''&quot;Marker3&quot;
    '''''Marker 3
    '''''
    '''''&quot;DataMarker0&quot;
    '''''Data Marker 0*
    '''''
    '''''&quot;DataMarker1&quot;
    '''''Data Marker 1*
    '''''
    '''''&quot;DataMarker2&quot;
    '''''Data Marker 2*
    '''''
    '''''&quot;DataMarker3&quot;
    '''''Data Marker 3*
    '''''
    '''''* These Data Marker values apply only to single-channel devices or to multichannel devices that are configured for single-channel operation. When using a device that is configured for multichannel operation, specify the channel number along with the signal identifier. For example, to export Data Marker 0 on channel 1 of a device configured for multichannel operation, use the value "1/ DataMarker0." If you do not specify a channel when using a device configured for multichannel generation, DataMarker0  generates on all channels.
    '''''
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Output_Terminal">
    '''''
    '''''
    '''''outputTerminal
    '''''ViConstString
    '''''Specifies the output terminal to export the signal.
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''Note&#160;&#160; The following Defined Values are examples of possible output terminals. For a complete list of the output terminals available on your device, refer to the Device Routes tab in MAX.
    '''''
    '''''
    '''''
    '''''Defined Values
    '''''
    '''''&quot;&quot; (empty string)Do not export signal
    '''''
    '''''
    '''''&quot;PFI0&quot;PFI line 0
    '''''
    '''''&quot;PFI1&quot;PFI line 1
    '''''
    '''''&quot;PFI4&quot;PFI line 4
    '''''
    '''''&quot;PFI5&quot;PFI line 5
    '''''
    '''''&quot;PXI_Trig0&quot;
    '''''PXI or RTSI line 0
    '''''
    '''''&quot;PXI_Trig1&quot;
    '''''PXI or RTSI line 1
    '''''
    '''''&quot;PXI_Trig2&quot;
    '''''PXI or RTSI line 2
    '''''
    '''''&quot;PXI_Trig3&quot;
    '''''PXI or RTSI line 3
    '''''
    '''''&quot;PXI_Trig4&quot;
    '''''PXI or RTSI line 4
    '''''
    '''''&quot;PXI_Trig5&quot;
    '''''PXI or RTSI line 5
    '''''
    '''''&quot;PXI_Trig6&quot;
    '''''PXI or RTSI line 6
    '''''
    '''''&quot;PXI_Trig7&quot;
    '''''PXI or RTSI line 7
    '''''
    '''''&quot;DDC_ClkOut&quot;
    '''''Clock out from DDC connector
    '''''
    '''''&quot;PXI_Star&quot;PXI star trigger line
    '''''
    '''''
    '''''
    '''''
    ''''' 
    '''''
    '''''
    '''''</td>
    ''''' </tr></table></body>
    '''''</html>
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ExportSignal(ByVal Signal As Integer, ByVal Signal_Identifier As String, ByVal Output_Terminal As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.ExportSignal(Me._handle, Signal, Signal_Identifier, Output_Terminal)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_RouteSignalOut
    '''''
    '''''ViStatus niFgen_RouteSignalOut&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;routeSignalFrom, ViInt32&#160;routeSignalTo);
    '''''
    '''''Purpose
    '''''
    '''''Routes various signals in the signal generator to the RTSI lines and front 
    '''''panel terminals. 
    '''''
    '''''
    '''''Notes&#160;&#160;The signal generator must not be in the Generating state when you call this function.
    '''''
    '''''You can clear a previously routed signal by routing NIFGEN_VAL_NONE to the destination terminal.
    '''''
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to route a signal.
    '''''
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Route_Signal_From">
    '''''
    '''''
    '''''routeSignalFrom
    '''''ViInt32
    '''''Various signals can be routed out the RTSI lines.  
    '''''
    '''''Defined Values
    '''''
    '''''NIFGEN_VAL_NONE
    '''''Route nothing to the RTSI line. Clears the line.
    '''''
    '''''NIFGEN_VAL_MARKER
    '''''Marker event
    '''''
    '''''NIFGEN_VAL_SYNC_OUT
    '''''The SYNC signal that normally appears on the SYNC OUT front panel connector.
    '''''
    '''''NIFGEN_VAL_OUT_START_TRIGGER
    '''''The trigger generated at the start of the sequence. Call the niFgen_ConfigureTriggerSource function to receive this trigger.
    '''''
    '''''NIFGEN_VAL_BOARD_CLOCK
    '''''The signal generator board clock, which is 20&#160;MHz for the NI&#160;PCI-5401/5411/5431. The NI&#160;PXI-5404 has a 20&#160;MHz board clock, and the NI&#160;PXI-5421 has integer divisors of 100&#160;MHz. The NI&#160;PXI-5401/5411/5431 does not support routing a Board Clock to RTSI lines or front panel connectors.
    '''''
    '''''NIFGEN_VAL_SYNCHRONIZATION
    '''''A synchronization strobe used to guarantee absolute synchronization between two or more signal generators. Call the niFgen_ConfigureSynchronization function to receive the strobe.
    '''''
    '''''NIFGEN_VAL_SOFTWARE_TRIG
    '''''Software trigger
    '''''
    '''''NIFGEN_VAL_OUT_UPDATE
    '''''&#8212;
    '''''
    '''''NIFGEN_VAL_REF_OUT
    '''''Reference clock out front panel connector
    '''''
    '''''NIFGEN_VAL_PXI_CLK10
    '''''PXI 10&#160;MHz backplane reference clock
    '''''
    '''''NIFGEN_VAL_PXI_STAR
    '''''PXI star trigger line
    '''''
    '''''NIFGEN_VAL_PFI_0
    '''''PFI 0
    '''''
    '''''NIFGEN_VAL_RTSI_0
    '''''RTSI 0 or PXI_Trig 0
    '''''
    '''''NIFGEN_VAL_RTSI_1
    '''''RTSI 1 or PXI_Trig 1
    '''''
    '''''NIFGEN_VAL_RTSI_2
    '''''RTSI 2 or PXI_Trig 2
    '''''
    '''''NIFGEN_VAL_RTSI_3
    '''''RTSI 3 or PXI_Trig 3
    '''''
    '''''NIFGEN_VAL_RTSI_4
    '''''RTSI 4 or PXI_Trig 4
    '''''
    '''''NIFGEN_VAL_RTSI_5
    '''''RTSI 5 or PXI_Trig 5
    '''''
    '''''NIFGEN_VAL_RTSI_6
    '''''RTSI 6 or PXI_Trig 6
    '''''
    '''''NIFGEN_VAL_RTSI_7
    '''''RTSI 7 or PXI_Trig 7
    '''''
    '''''NIFGEN_VAL_REF_CLOCK_RTSI_CLOCK
    '''''RTSI clock
    '''''
    '''''NIFGEN_VAL_ONBOARD_REFERENCE_CLOCK
    '''''Onboard Reference clock
    '''''
    '''''NIFGEN_VAL_UPDATE_CLOCK
    '''''Sample clock
    '''''
    '''''NIFGEN_VAL_PLL_REF_SOURCE
    '''''PLL reference clock
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Route_Signal_To">
    '''''
    '''''
    '''''routeSignalTo
    '''''ViInt32
    '''''The possible RTSI lines to which you can route a signal.
    '''''
    '''''Defined Values
    '''''
    '''''NIFGEN_VAL_RTSI_0
    '''''RTSI 0 or PXI_Trig 0
    '''''
    '''''NIFGEN_VAL_RTSI_1
    '''''RTSI 1 or PXI_Trig 1
    '''''
    '''''NIFGEN_VAL_RTSI_2
    '''''RTSI 2 or PXI_Trig 2
    '''''
    '''''NIFGEN_VAL_RTSI_3
    '''''RTSI 3 or PXI_Trig 3
    '''''
    '''''NIFGEN_VAL_RTSI_4
    '''''RTSI 4 or PXI_Trig 4
    '''''
    '''''NIFGEN_VAL_RTSI_5
    '''''RTSI 5 or PXI_Trig 5
    '''''
    '''''NIFGEN_VAL_RTSI_6
    '''''RTSI 6 or PXI_Trig 6
    '''''
    '''''NIFGEN_VAL_RTSI_7
    '''''RTSI 7 or PXI_Trig 7
    '''''
    '''''NIFGEN_VAL_REF_CLOCK_RTSI_CLOCK
    '''''RTSI clock
    '''''
    '''''NIFGEN_VAL_REF_OUT
    '''''Reference clock out front panel connector
    '''''
    '''''NIFGEN_VAL_PFI_0
    '''''PFI 0
    '''''
    '''''NIFGEN_VAL_PFI_1
    '''''PFI 1
    '''''
    '''''NIFGEN_VAL_PFI_4
    '''''PFI 4
    '''''
    '''''NIFGEN_VAL_PFI_5
    '''''PFI 5
    ''''' 
    '''''NIFGEN_VAL_PXI_STAR
    '''''PXI star trigger line
    '''''
    '''''NIFGEN_VAL_PXI_CLK10
    '''''PXI 10&#160;MHz backplane reference clock
    '''''
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function RouteSignalOut(ByVal Channel_Name As String, ByVal Route_Signal_From As Integer, ByVal Route_Signal_To As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.RouteSignalOut(Me._handle, Channel_Name, Route_Signal_From, Route_Signal_To)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_AllocateNamedWaveform
    '''''
    '''''ViStatus niFgen_AllocateNamedWaveform&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViConstString&#160;waveformName, ViInt32&#160;waveformSize);
    '''''
    '''''Purpose
    '''''
    '''''Specifies the size of a named waveform up front so that it can be allocated in onboard memory before loading the associated data. Data can then be loaded in smaller blocks with the niFgen Write (Binary16) Waveform functions.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to allocate the named waveform.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Name">
    '''''
    '''''
    '''''waveformName
    '''''ViConstString
    '''''Specifies the name to associate with the allocated waveform.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Size">
    '''''
    '''''
    '''''waveformSize
    '''''ViInt32
    '''''Specifies the size of the waveform to allocate in samples.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function AllocateNamedWaveform(ByVal Channel_Name As String, ByVal Waveform_Name As String, ByVal Waveform_Size As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.AllocateNamedWaveform(Me._handle, Channel_Name, Waveform_Name, Waveform_Size)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_SetNamedWaveformNextWritePosition
    '''''
    '''''ViStatus niFgen_SetNamedWaveformNextWritePosition&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViConstString&#160;waveformName, ViInt32&#160;relativeto, ViInt32&#160;offset);
    '''''
    '''''Purpose
    '''''
    '''''Sets the position in the waveform to which data is written at the next write. This function allows you to write to arbitrary locations within the waveform. These settings apply only to the next write to the waveform specified by the waveformHandle parameter. Subsequent writes to that waveform begin where the last write left off, unless this function is called again. The waveformHandle passed in must have been created with a call to one of the following functions:
    '''''
    ''''' niFgen_AllocateWaveform
    ''''' niFgen_CreateWaveformF64
    '''''
    '''''niFgen_CreateWaveformI16
    '''''
    ''''' niFgen_CreateWaveformFromFileI16
    '''''
    ''''' niFgen_CreateWaveformFromFileF64
    '''''
    ''''' niFgen_CreateWaveformFromFileHWS
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel onto which the waveform data should be loaded.
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Name">
    '''''
    '''''
    '''''waveformName
    '''''ViConstString
    '''''Specifies the name to associate with the allocated waveform.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="relativeTo">
    '''''
    '''''
    '''''relativeTo
    '''''ViInt32
    '''''Specifies the reference position in the waveform. The position and offset together determine where to start loading data into the waveform.
    '''''
    '''''Defined Values
    '''''
    '''''NIFGEN_VAL_WAVEFORM_POSITION_START&#160;(0)  
    '''''Use the start of the waveform as the reference position.
    '''''NIFGEN_VAL_WAVEFORM_POSITION_CURRENT&#160;(1) 
    '''''Use the current position within the waveform as the reference position. 
    ''''' 
    '''''</param>
    '''''<param name="offset">
    '''''html>
    '''''
    '''''
    '''''offset
    '''''ViInt32
    '''''Specifies the offset from the relativeTo parameter at which to start loading the data into the waveform.
    ''''' 
    '''''</html>
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function SetNamedWaveformNextWritePosition(ByVal Channel_Name As String, ByVal Waveform_Name As String, ByVal relativeTo As Integer, ByVal offset As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.SetNamedWaveformNextWritePosition(Me._handle, Channel_Name, Waveform_Name, relativeTo, offset)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_WriteNamedWaveformF64
    '''''
    '''''ViStatus niFgen_WriteNamedWaveformF64&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViConstString&#160;waveformName, ViInt32&#160;size, ViReal64[]&#160;data);
    '''''
    '''''Purpose
    '''''
    '''''Writes floating-point data to the waveform in onboard memory.  The waveform handle passed in must have been created by a call to the niFgen_AllocateWaveform function or to one of the following niFgen Create Waveform functions:
    '''''
    ''''' niFgen_CreateWaveformF64
    '''''
    ''''' niFgen_CreateWaveformI16
    '''''
    ''''' niFgen_CreateWaveformFromFileI16
    '''''
    ''''' niFgen_CreateWaveformFromFileF64
    '''''
    ''''' niFgen_CreateWaveformFromFileHWS
    '''''
    '''''The write position and offset can be set by calling niFgen_SetWaveformNextWritePosition.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel onto which the waveform data should be loaded.  
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Name">
    '''''
    '''''
    '''''waveformName
    '''''ViConstString
    '''''Specifies the name to associate with the allocated waveform.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Size">
    '''''
    '''''
    '''''size
    '''''ViInt32
    '''''Specifies the number of samples to load into the waveform.
    '''''
    '''''Default Value: 0
    ''''' 
    '''''
    '''''
    '''''</param>
    '''''<param name="Data">
    '''''
    '''''
    '''''data
    '''''ViReal64 []
    '''''Specifies the array of data to load into the waveform. The array must have at least as many elements as the value in size.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function WriteNamedWaveformF64(ByVal Channel_Name As String, ByVal Waveform_Name As String, ByVal Size As Integer, ByVal Data() As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.WriteNamedWaveformF64(Me._handle, Channel_Name, Waveform_Name, Size, Data)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_WriteNamedWaveformI16
    '''''
    '''''ViStatus niFgen_WriteNamedWaveformI16&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViConstString&#160;waveformName, ViInt32&#160;size, ViInt16[]&#160;data);
    '''''
    '''''Purpose
    '''''
    '''''Writes binary data to the named waveform in onboard memory.  The waveform handle passed in must have been created by a call to the niFgen_AllocateWaveform function or to one of the following niFgen Create Waveform functions:
    '''''
    ''''' niFgen_CreateWaveformF64
    '''''
    ''''' niFgen_CreateWaveformI16
    '''''
    ''''' niFgen_CreateWaveformFromFileI16
    '''''
    ''''' niFgen_CreateWaveformFromFileF64
    '''''
    ''''' niFgen_CreateWaveformFromFileHWS
    '''''
    '''''The write position and offset can be set by calling the niFgen_SetWaveformNextWritePosition function.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel onto which the waveform data should be loaded.  
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Name">
    '''''
    '''''
    '''''waveformName
    '''''ViConstString
    '''''Specifies the name to associate with the allocated waveform.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Size">
    '''''
    '''''
    '''''size
    '''''ViInt32
    '''''Specifies the number of samples to load into the waveform.
    '''''
    '''''Default Value: 0
    ''''' 
    '''''
    '''''
    '''''</param>
    '''''<param name="Data">
    '''''
    '''''
    '''''data
    '''''ViInt16 []
    '''''Specifies the array of data to load into the waveform. The array must have at least as many elements as the value in size.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function WriteNamedWaveformI16(ByVal Channel_Name As String, ByVal Waveform_Name As String, ByVal Size As Integer, ByVal Data() As Short) As Integer
        Dim pInvokeResult As Integer = PInvoke.WriteNamedWaveformI16(Me._handle, Channel_Name, Waveform_Name, Size, Data)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_WriteNamedWaveformComplexF64
    '''''
    '''''ViStatus niFgen_WriteNamedWaveformComplexF64&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViConstString&#160;waveformName, ViInt32&#160;size, NIComplexNumber[]&#160;data);
    '''''
    '''''Purpose
    '''''
    '''''Writes complex floating&#8211;point data to the named waveform in onboard memory on devices with the OSP Enabled property set to VI_TRUE and the Data Processing Mode property set to Complex.  The waveform handle passed in must have been created by a call to the niFgen_AllocateWaveform function or to one of the following niFgen Create Waveform functions:
    '''''
    ''''' niFgen_CreateWaveformF64
    '''''
    ''''' niFgen_CreateWaveformI16
    '''''
    ''''' niFgen_CreateWaveformFromFileI16
    '''''
    ''''' niFgen_CreateWaveformFromFileF64
    '''''
    ''''' niFgen_CreateWaveformFromFileHWS
    '''''
    '''''The write position and offset can be set by calling the niFgen_SetWaveformNextWritePosition function.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel onto which the waveform data should be loaded.  
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Name">
    '''''
    '''''
    '''''waveformName
    '''''ViConstString
    '''''Specifies the name to associate with the allocated waveform.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Size">
    '''''
    '''''
    '''''size
    '''''ViInt32
    '''''Specifies the number of samples to load into the waveform.
    '''''
    '''''Default Value: 0
    ''''' 
    '''''
    '''''
    '''''</param>
    '''''<param name="Data">
    '''''
    '''''
    '''''data
    '''''NIComplexNumber []
    '''''Specifies the array of data to load into the waveform. The array must have at least as many elements as the value in size.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function WriteNamedWaveformComplexF64(ByVal Channel_Name As String, ByVal Waveform_Name As String, ByVal Size As Integer, ByVal Data As nicomplexnumber) As Integer
        Dim pInvokeResult As Integer = PInvoke.WriteNamedWaveformComplexF64(Me._handle, Channel_Name, Waveform_Name, Size, Data)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_WriteNamedComplexWaveformI16
    '''''
    '''''ViStatus niFgen_WriteNamedComplexWaveformI16&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViConstString&#160;waveformName, ViInt32&#160;size, NIComplexI16[]&#160;data);
    '''''
    '''''Purpose
    '''''
    '''''Writes complex binary data to the named waveform in onboard memory on devices with the OSP Enabled property set to VI_TRUE and the Data Processing Mode property set to Complex.   The waveform handle passed in must have been created by a call to the niFgen_AllocateWaveform function or to one of the following niFgen Create Waveform functions:
    '''''
    ''''' niFgen_CreateWaveformF64
    '''''
    ''''' niFgen_CreateWaveformI16
    '''''
    ''''' niFgen_CreateWaveformFromFileI16
    '''''
    ''''' niFgen_CreateWaveformFromFileF64
    '''''
    ''''' niFgen_CreateWaveformFromFileHWS
    '''''
    '''''The write position and offset can be set by calling the niFgen_SetWaveformNextWritePositionfunction.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel onto which the waveform data should be loaded.  
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Name">
    '''''
    '''''
    '''''waveformName
    '''''ViConstString
    '''''Specifies the name to associate with the allocated waveform.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Size">
    '''''
    '''''
    '''''size
    '''''ViInt32
    '''''Specifies the number of samples to load into the waveform.
    '''''
    '''''Default Value: 0
    ''''' 
    '''''
    '''''
    '''''</param>
    '''''<param name="Data">
    '''''
    '''''
    '''''data
    '''''NIComplexI16 []
    '''''Specifies the array of data to load into the waveform. The array must have at least as many elements as the value in size.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function WriteNamedWaveformComplexI16(ByVal Channel_Name As String, ByVal Waveform_Name As String, ByVal Size As Integer, ByVal Data As nicomplexI16) As Integer
        Dim pInvokeResult As Integer = PInvoke.WriteNamedWaveformComplexI16(Me._handle, Channel_Name, Waveform_Name, Size, Data)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_DeleteNamedWaveform
    '''''
    '''''ViStatus niFgen_DeleteNamedWaveform&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViConstString&#160;waveformName);
    '''''
    '''''Purpose
    '''''
    '''''Removes a previously created arbitrary waveform from the signal generator memory and invalidates the waveform handle.
    '''''
    '''''
    '''''Note&#160;&#160;The signal generator must not be in the Generating state when you call this function.
    '''''
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel onto which the named waveform is loaded.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Name">
    '''''
    '''''
    '''''waveformName
    '''''ViConstString
    '''''Specifies the name to associate with the allocated waveform.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function DeleteNamedWaveform(ByVal Channel_Name As String, ByVal Waveform_Name As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.DeleteNamedWaveform(Me._handle, Channel_Name, Waveform_Name)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_WriteScript
    '''''
    '''''ViStatus niFgen_WriteScript&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViConstString&#160;script);
    '''''
    '''''Purpose
    '''''
    '''''Writes a string containing one or more scripts that govern the generation of waveforms.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel on which the script is loaded. 
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Script">
    '''''
    '''''
    '''''script
    '''''ViConstString
    '''''Contains the text of the script you want to use for your generation operation.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function WriteScript(ByVal Channel_Name As String, ByVal Script As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.WriteScript(Me._handle, Channel_Name, Script)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_DeleteScript
    '''''
    '''''ViStatus niFgen_DeleteScript&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViConstString&#160;scriptName);
    '''''
    '''''Purpose
    '''''
    '''''Deletes the specified script from onboard memory.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel onto which the script is loaded.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Script_Name">
    '''''
    '''''
    '''''scriptName
    '''''ViConstString
    '''''Specifies the name of the script you want to delete. The script name appears in the text of the script following the script keyword.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function DeleteScript(ByVal Channel_Name As String, ByVal Script_Name As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.DeleteScript(Me._handle, Channel_Name, Script_Name)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ConfigureCustomFIRFilterCoefficients
    '''''
    '''''ViStatus niFgen_ConfigureCustomFIRFilterCoefficients&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;numberofCoefficients, ViReal64[]&#160;coefficientsArray);
    '''''
    '''''Purpose
    '''''
    '''''Sets the FIR filter coefficients used by the NI 5441 onboard signal processing block. The values are coerced to the closest settings achievable by the signal generator.
    '''''
    '''''Refer to  Devices&raquo;&lt;your device&gt;&raquo;Theory of Operation&raquo;Onboard Signal Processing&raquo;Components&raquo;FIR Filter for more information about FIR filter coefficients.
    '''''
    '''''
    '''''Note&#160;&#160;The signal generator must not be in the Generating state when you call this function.
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to configure the operation mode.
    '''''
    '''''Defined Value: &quot;0&quot;
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Number_of_Coefficients">
    '''''
    '''''
    '''''numberofCoefficients
    '''''ViInt32
    '''''Specifies the number of coefficients. The NI 5441 requires 95.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Coefficients_Array">
    '''''
    '''''
    '''''coefficientsArray
    '''''ViReal64[]
    '''''Specifies the array of data the onboard signal processor uses for the FIR filter coefficients. For the NI 5441, provide a symmetric array of 95 coefficients to this parameter. The array must have at least as many elements as the value that you specify in the numberOfCoefficients parameter in the niFgen_ConfigureCustomFIRFilterCoefficients VI.
    '''''
    '''''The coefficients should range between -1.00 and +1.00.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureCustomFIRFilterCoefficients(ByVal Channel_Name As String, ByVal Number_of_Coefficients As Integer, ByVal Coefficients_Array() As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureCustomFIRFilterCoefficients(Me._handle, Channel_Name, Number_of_Coefficients, Coefficients_Array)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_GetFIRFilterCoefficients
    '''''
    '''''ViStatus niFgen_GetFIRFilterCoefficients&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;arraySize, ViReal64[]&#160;coefficientsArray, ViInt32*&#160;numberofCoefficientsRead);
    '''''
    '''''Purpose
    '''''
    '''''
    '''''Returns the FIR filter coefficients used by the onboard signal processing block. These coefficients are determined by NI-FGEN and based on the FIR filter type and corresponding attribute (Alpha, Passband, BT) unless you are using the custom filter. If you are using a custom filter, the coefficients returned are those set with the niFgen_ConfigureCustomFIRFilterCoefficients  function coerced to the quantized values used by the device.
    '''''
    '''''The coefficients are between &#8211;1.00 and +1.00.
    '''''
    '''''
    '''''
    '''''
    '''''To use this function, first call an instance of the niFgen_GetFIRFilterCoefficients function with the coefficientsArray parameter set to VI_NULL. Calling the function in this state returns the current size of the coefficientsArray as the value of the numberOfCoefficientsRead parameter. Create an array of this size, and call the niFgen_GetFIRFilterCoefficients function a second time, passing the new array as the coefficientsArray parameter and the size as the arraySize parameter.  This second function call populate the array with the FIR filter coefficients. 
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''Refer to  Devices&raquo;&lt;your device&gt;&raquo;Theory of Operation&raquo;Onboard Signal Processing&raquo;Components&raquo;FIR Filter for more information about FIR filter coefficients.
    '''''
    '''''
    '''''
    '''''Default Value: None
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to configure the operation mode.
    '''''
    '''''Defined Value: &quot;0&quot;
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Array_Size">
    '''''
    '''''
    '''''arraySize
    '''''ViInt32
    '''''Specifies the size of the coefficient array
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Coefficients_Array">
    '''''
    '''''
    '''''coefficientsArray
    '''''ViReal64[]
    '''''Specifies the array of data the onboard signal processor uses for the FIR filter coefficients. For the NI 5441, provide a symmetric array of 95 coefficients to this parameter. The array must have at least as many elements as the value that you specify in the numberOfCoefficients parameter in the niFgen_ConfigureCustomFIRFilterCoefficients VI.
    '''''
    '''''The coefficients should range between -1.00 and +1.00.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Number_of_Coefficients_Read">
    '''''
    '''''
    '''''numberofCoefficientsRead
    '''''ViInt32[]
    '''''Specifies the array of data containing the number of coefficients you want to read.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function GetFIRFilterCoefficients(ByVal Channel_Name As String, ByVal Array_Size As Integer, ByVal Coefficients_Array() As Double, ByVal Number_of_Coefficients_Read() As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetFIRFilterCoefficients(Me._handle, Channel_Name, Array_Size, Coefficients_Array, Number_of_Coefficients_Read)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_InitiateGeneration
    '''''
    '''''ViStatus niFgen_InitiateGeneration&#160;(ViSession&#160;vi);
    '''''
    '''''Purpose
    '''''
    '''''Initiates signal generation.  If you want to abort signal generation, call the niFgen_AbortGeneration function. Once the signal generation is aborted, you can call the niFgen_InitiateGeneration function to cause the signal generator to produce a signal again.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function InitiateGeneration() As Integer
        Dim pInvokeResult As Integer = PInvoke.InitiateGeneration(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_AbortGeneration
    '''''
    '''''ViStatus niFgen_AbortGeneration&#160;(ViSession&#160;vi);
    '''''
    '''''Purpose
    '''''
    '''''Aborts any previously initiated signal generation. If you want to abort signal generation, call this function. Call the 
    '''''niFgen_InitiateGeneration function to cause the signal generator to produce a signal again.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function AbortGeneration() As Integer
        Dim pInvokeResult As Integer = PInvoke.AbortGeneration(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_GetHardwareState
    '''''
    '''''ViStatus niFgen_GetHardwareState&#160;(ViSession&#160;vi, ViInt32*&#160;state);
    '''''
    '''''Purpose
    '''''
    '''''Returns the current hardware state of the device and, if the device is in the hardware error state, the current hardware error.  
    '''''
    '''''
    '''''Note&#160;&#160;  Hardware states do not necessarily correspond to NI-FGEN states.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="state">
    '''''
    '''''
    '''''state
    '''''ViInt32*
    '''''Returns the Hardware state of the signal generator.Defined Values
    '''''
    '''''NIFGEN_VAL_IDLE
    '''''The device is in the Idle state.
    '''''
    '''''NIFGEN_VAL_WAITING_FOR_START_TRIGGER
    '''''The device is waiting for Start trigger.
    '''''
    '''''NIFGEN_VAL_RUNNING
    '''''The device is in the Running state.
    '''''
    '''''NIFGEN_VAL_DONE
    '''''The generation has completed successfully.
    '''''
    '''''NIFGEN_VAL_HARDWARE_ERROR
    '''''There is a hardware error.
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function GetHardwareState(ByRef state As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetHardwareState(Me._handle, state)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_WaitUntilDone
    '''''
    '''''ViStatus niFgen_WaitUntilDone&#160;(ViSession&#160;vi, ViInt32&#160;maxtime);
    '''''
    '''''Purpose
    '''''
    '''''Waits until the device is done generating or until the maximum time has expired.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="maxTime">
    '''''
    '''''
    '''''maxTime
    '''''ViInt32
    '''''The timeout value (in milliseconds).
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function WaitUntilDone(ByVal maxTime As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.WaitUntilDone(Me._handle, maxTime)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_IsDone
    '''''
    '''''ViStatus niFgen_IsDone&#160;(ViSession&#160;vi, ViBoolean*&#160;done);
    '''''
    '''''Purpose
    '''''
    '''''Determines whether the current generation is complete.  This function sets the done parameter to VI_TRUE if the session is in the Idle or Committed states.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Done">
    '''''
    '''''
    '''''done
    '''''ViBoolean*
    '''''Returns information about the completion of waveform generation.
    '''''
    '''''Defined Values
    '''''
    '''''VI_TRUEGeneration is complete.
    '''''VI_FALSEGeneration is not complete.
    ''''' 
    '''''
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function IsDone(ByRef Done As Boolean) As Integer
        Dim DoneAsUShort As UShort
        Dim pInvokeResult As Integer = PInvoke.IsDone(Me._handle, DoneAsUShort)
        Done = System.Convert.ToBoolean(DoneAsUShort)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ResetWithDefaults
    '''''
    '''''ViStatus niFgen_ResetWithDefaults&#160;(ViSession&#160;vi);
    '''''
    '''''Purpose
    '''''
    '''''Resets the instrument and reapplies initial user&#8211;specified settings from the logical name that was used to initialize the session.  If the session was created without a logical name, this function is equivalent to the niFgen_reset function.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ResetWithDefaults() As Integer
        Dim pInvokeResult As Integer = PInvoke.ResetWithDefaults(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ResetDevice
    '''''
    '''''ViStatus niFgen_ResetDevice&#160;(ViSession&#160;vi);
    '''''
    '''''Purpose
    '''''
    '''''Performs a hard reset on the device.  Generation is stopped, all routes are released, external bidirectional terminals are tristated, FPGAs are reset, hardware is configured to its default state, and all session attributes are reset to their default states.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ResetDevice() As Integer
        Dim pInvokeResult As Integer = PInvoke.ResetDevice(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_GetChannelName
    '''''
    '''''ViStatus&#160;niFgen_GetChannelName&#160;(ViSession&#160;vi, ViInt32&#160;index, ViInt32&#160;buffersize, ViChar[]&#160;channelName);
    '''''
    '''''Purpose
    '''''
    '''''The function returns the channel string that is in the channel table at an index you specify.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Index">
    '''''
    '''''
    '''''index
    '''''ViInt32
    '''''Specifies a 1-based index into the channel table.
    ''''' 
    '''''</param>
    '''''<param name="BufferSize">
    '''''
    '''''
    '''''bufferSize
    '''''ViInt32
    '''''Specifies the size of the buffer for the channel string.
    ''''' 
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Returns the channel string that is in the channel table at the index you specify.
    '''''
    '''''Do not modify the contents of the channel string.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function GetChannelName(ByVal Index As Integer, ByVal BufferSize As Integer, ByVal Channel_Name As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetChannelName(Me._handle, Index, BufferSize, Channel_Name)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_Disable
    '''''
    '''''ViStatus niFgen_Disable&#160;(ViSession&#160;vi);
    '''''
    '''''Purpose
    '''''
    '''''Places the instrument in a quiescent state where it has minimal or no impact on the system to which it is connected.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function Disable() As Integer
        Dim pInvokeResult As Integer = PInvoke.Disable(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_self_test
    '''''
    '''''ViStatus niFgen_self_test&#160;(ViSession&#160;vi, ViInt16*&#160;selfTestResult, ViChar[]&#160;selfTestMessage);
    '''''
    '''''Purpose
    '''''
    '''''Runs the instrument self-test routine and returns the test result(s).
    '''''
    '''''
    '''''Note&#160;&#160;When used on some signal generators, the device is reset after the niFgen_self_test function runs. If you use the niFgen_self_test function, your device may not be in its previously configured state after the function runs. 
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Self_Test_Result">
    '''''
    '''''
    '''''selfTestResult
    '''''ViInt16
    '''''Contains the value returned from the instrument self-test.  Zero means success. 
    '''''
    '''''
    '''''
    '''''Self-Test Code    
    '''''Description
    '''''
    '''''0              
    '''''Passed self-test
    '''''
    '''''1              
    '''''Self-test failed
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Self_Test_Message">
    '''''
    '''''
    '''''selfTestMessage
    '''''ViChar[]
    '''''Returns the self-test response string from the instrument. 
    '''''
    '''''You must pass a ViChar array with at least 256 bytes.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function self_test(ByRef Self_Test_Result As Short, ByVal Self_Test_Message As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.self_test(Me._handle, Self_Test_Result, Self_Test_Message)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_revision_query
    '''''
    '''''ViStatus niFgen_revision_query&#160;(ViSession&#160;vi, ViChar[]&#160;instrumentDriverRevision, ViChar[]&#160;firmwareRevision);
    '''''
    '''''Purpose
    '''''
    '''''Returns the revision numbers of the NI-FGEN and instrument firmware.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Instrument_Driver_Revision">
    '''''
    '''''
    '''''instrumentDriverRevision
    '''''ViChar[]
    '''''Returns the NI-FGEN software revision numbers in the form of a string.
    '''''
    '''''You must pass a ViChar array with at least 256 bytes.
    ''''' 
    '''''</param>
    '''''<param name="Firmware_Revision">
    '''''
    '''''
    '''''firmwareRevision
    '''''ViChar[]
    '''''Returns the instrument firmware revision numbers in the form of a string.
    '''''
    '''''You must pass a ViChar array with at least 256 bytes.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function revision_query(ByVal Instrument_Driver_Revision As System.Text.StringBuilder, ByVal Firmware_Revision As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.revision_query(Me._handle, Instrument_Driver_Revision, Firmware_Revision)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_GetNextCoercionRecord
    '''''
    '''''ViStatus niFgen_GetNextCoercionRecord&#160;(ViSession&#160;vi, ViInt32&#160;bufferSize, ViChar[]&#160;coercionRecord);
    '''''
    '''''Purpose
    '''''
    '''''Returns the coercion information associated with the IVI session.  This function retrieves and clears the oldest instance in which the NI-FGEN coerced a value you specified to another value.
    '''''
    '''''If you set the NIFGEN_ATTR_RECORD_COERCIONS attribute to VI_TRUE, NI-FGEN keeps a list of all coercions it makes on ViInt32 or ViReal64 values that you pass to NI-FGEN functions.  You use this function to retrieve information from that list.
    '''''
    '''''If the next coercion record string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies bufferSize &#8211; 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size you must pass to get the entire value.  For example, if the value is &quot;123456&quot; and bufferSize is 4, the function places &quot;123&quot; into the buffer and returns 7.
    '''''
    '''''If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
    '''''
    '''''If you pass 0, you can pass VI_NULL for the coercionRecord buffer parameter.
    '''''
    '''''The function returns an empty string in the coercionRecord parameter if no coercion records remain for the session.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Buffer_Size">
    '''''
    '''''
    '''''bufferSize
    '''''ViInt32
    '''''Specifies the number of bytes in the ViChar array you specify for the coercionRecord parameter.
    '''''
    '''''If the next coercion record string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies bufferSize &#8211; 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size that you must pass to get the entire value.  For example, if the value is &quot;123456&quot; and the buffer size is 4, the function places &quot;123&quot; into the buffer and returns 7.
    '''''
    '''''If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
    '''''
    '''''If you pass 0, you can pass VI_NULL for the coercionRecord buffer parameter.
    '''''
    '''''Default Value:  None
    ''''' 
    '''''</param>
    '''''<param name="Coercion_Record">
    '''''
    '''''
    '''''coercionRecord
    '''''ViChar[]
    '''''Returns the next coercion record for the IVI session.  If there are no coercion records, the function returns an empty string.
    '''''
    '''''The buffer must contain at least as many elements as the value you specify with the bufferSize parameter.  If the next coercion record string, including the terminating NUL byte, contains more bytes than you indicate with the bufferSize parameter, the function copies bufferSize &#8211; 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size that you must pass to get the entire value.  For example, if the value is &quot;123456&quot; and bufferSize is 4, the function places &quot;123&quot; into the buffer and returns 7.
    '''''
    '''''This parameter returns an empty string if no coercion records remain for the session.
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call   niFgen_error_message. To obtain additional information about the error condition, call   niFgen_GetError. To clear the error information from NI-FGEN, call   niFgen_ClearError. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function GetNextCoercionRecord(ByVal Buffer_Size As Integer, ByVal Coercion_Record As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetNextCoercionRecord(Me._handle, Buffer_Size, Coercion_Record)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_error_query
    '''''
    '''''ViStatus niFgen_error_query&#160;(ViSession&#160;vi, ViInt32*&#160;errorCode, ViChar[]&#160;errorMessage);
    '''''
    '''''Purpose
    '''''
    '''''Reads an error code and a message from the instrument error queue.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Error_Code">
    '''''
    '''''
    '''''errorCode
    '''''ViInt32*
    '''''Returns the error code read from the instrument error queue.
    ''''' 
    '''''</param>
    '''''<param name="Error_Message">
    '''''
    '''''
    '''''errorMessage
    '''''ViChar[]
    '''''Returns the error message string read from the instrument error message queue.
    '''''
    '''''You must pass a ViChar array with at least 256 bytes.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function error_query(ByRef Error_Code As Integer, ByVal Error_Message As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.error_query(Me._handle, Error_Code, Error_Message)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ErrorHandler
    '''''
    '''''ViStatus niFgen_ErrorHandler&#160;(ViSession&#160;vi, ViStatus&#160;errorCode, ViChar[]&#160;errorMessage);
    '''''
    '''''Purpose
    '''''
    '''''Converts a status code returned by an NI-FGEN function into a user-readable string and returns any error elaborations.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitWithOptions functions and identifies a
    '''''            particular instrument session.  
    '''''You can pass VI_NULL for this parameter.  Passing VI_NULL is useful when one of the initialize functions fail.
    '''''
    '''''Default Value:  VI_NULL
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Error_Code">
    '''''
    '''''
    '''''errorCode
    '''''ViStatus
    '''''Specifies the status parameter that is returned from any of the NI-FGEN functions.
    '''''
    '''''Default Value:  0  (VI_SUCCESS)
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Error_Message">
    '''''
    '''''
    '''''errorMessage
    '''''ViChar[]
    '''''Returns the error message string read from the instrument error message queue.
    '''''
    '''''You must pass a ViChar array with at least 256 bytes.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ErrorHandler(ByVal Error_Code As Integer, ByVal Error_Message As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.ErrorHandler(Me._handle, Error_Code, Error_Message)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_GetNextInterchangeWarning
    '''''
    '''''ViStatus niFgen_GetNextInterchangeWarning&#160;(ViSession&#160;vi, ViInt32&#160;bufferSize, ViChar[]&#160;interchangeWarning);
    '''''
    '''''Purpose
    '''''
    '''''Returns the interchangeability warnings associated with the IVI session. It retrieves and clears the oldest instance in which the class driver recorded an interchangeability warning.  Interchangeability warnings indicate that using your application with a different instrument might cause different behavior. Use this function to retrieve interchangeability warnings.
    '''''
    '''''NI-FGEN performs interchangeability checking when the NIFGEN_ATTR_INTERCHANGE_CHECK attribute is set to VI_TRUE.
    '''''
    '''''The function returns an empty string in the interchangeWarning parameter if no interchangeability warnings remain for the session.
    '''''
    '''''In general, NI-FGEN generates interchangeability warnings when an attribute that affects the behavior of the instrument is in a state that you did not specify.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Buffer_Size">
    '''''
    '''''
    '''''bufferSize
    '''''ViInt32
    '''''Specifies the number of bytes in the ViChar array you specify for the interchangeWarning parameter.
    '''''
    '''''If the next interchangeability warning string, including the terminating NUL byte, contains more bytes than you indicate in this parameter, the function copies bufferSize &#8211; 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size that you must pass to get the entire value. For example, if the value is &quot;123456&quot; and bufferSize is 4, the function places &quot;123&quot; into the buffer and returns 7.
    '''''
    '''''If you pass a negative number, the function copies the value to the buffer regardless of the number of bytes in the value.
    '''''
    '''''If you pass 0, you can pass VI_NULL for the interchangeWarning buffer parameter.
    '''''
    '''''Default Value:  None
    '''''
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Interchange_Warning">
    '''''
    '''''
    '''''interchangeWarning
    '''''ViChar[]
    '''''Returns the next interchange warning for the IVI session. If there are no interchange warnings, the function returns an empty string.
    '''''
    '''''The buffer must contain at least as many elements as the value you specify with the bufferSize parameter. If the next interchangeability warning string, including the terminating NUL byte, contains more bytes than you indicate with the bufferSize parameter, the function copies bufferSize &#8211; 1 bytes into the buffer, places an ASCII NUL byte at the end of the buffer, and returns the buffer size that you must pass to get the entire value.  For example, if the value is &quot;123456&quot; and bufferSize is 4, the function places &quot;123&quot; into the buffer and returns 7.
    '''''
    '''''This parameter returns an empty string if no interchangeability warnings remain for the session.
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call   niFgen_error_message. To obtain additional information about the error condition, call   niFgen_GetError. To clear the error information from NI-FGEN, call   niFgen_ClearError. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function GetNextInterchangeWarning(ByVal Buffer_Size As Integer, ByVal Interchange_Warning As System.Text.StringBuilder) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetNextInterchangeWarning(Me._handle, Buffer_Size, Interchange_Warning)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ClearInterchangeWarnings
    '''''
    '''''ViStatus niFgen_ClearInterchangeWarnings&#160;(ViSession&#160;vi);
    '''''
    '''''Purpose
    '''''
    '''''Clears the list of current interchange warnings.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ClearInterchangeWarnings() As Integer
        Dim pInvokeResult As Integer = PInvoke.ClearInterchangeWarnings(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ResetInterchangeCheck
    '''''
    '''''ViStatus niFgen_ResetInterchangeCheck&#160;(ViSession&#160;vi);
    '''''
    '''''Purpose
    '''''
    '''''When developing a complex test system that consists of multiple test modules, it is generally a good idea to design the test modules so that they can run in any order.  To do so requires ensuring that each test module completely configures the state of each instrument it uses.  If a particular test module does not completely configure the state of an instrument, the state of the instrument depends on the configuration from a previously executed test module.  If you execute the test modules in a different order, the behavior of the instrument and therefore the entire test module is likely to change.  This change in behavior is generally instrument specific and represents an interchangeability problem.
    '''''
    '''''You can use this function to test for such cases.  After you call this function, the interchangeability checking algorithms in the specific driver ignore all previous configuration operations.  By calling this function at the beginning of a test module, you can determine whether the test module has dependencies on the operation of previously executed test modules.
    '''''
    '''''This function does not clear the interchangeability warnings from the list of previously recorded interchangeability warnings.  If you want to guarantee that the niFgen_GetNextInterchangeWarning function only returns those interchangeability warnings that are generated after calling this function, you must clear the list of interchangeability warnings.  You can clear the interchangeability warnings list by repeatedly calling the niFgen_GetNextInterchangeWarning function until no more interchangeability warnings are returned.  If you are not interested in the content of those warnings, you can call the  niFgen_ClearInterchangeWarnings function.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ResetInterchangeCheck() As Integer
        Dim pInvokeResult As Integer = PInvoke.ResetInterchangeCheck(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_CloseExtCal
    '''''
    '''''ViStatus niFgen_CloseExtCal&#160;(ViSession&#160;vi, ViInt32&#160;action);
    '''''
    '''''Purpose
    '''''
    '''''Closes an NI-FGEN external calibration session and, if specified, stores the new calibration constants and calibration data, such as time and temperature, in the onboard EEPROM.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Action">
    '''''
    '''''
    '''''action
    '''''ViInt32
    '''''Specifies he action to perform upon closing. 
    '''''
    '''''Defined Values
    '''''
    '''''NIFGEN_VAL_EXT_CAL_ABORT
    '''''No changes are made to the calibration constants and data in the EEPROM.
    '''''
    '''''NIFGEN_VAL_EXT_CAL_COMMIT
    '''''The new calibration constants and data determined during the external calibration session are stored in the onboard EEPROM.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function CloseExtCal(ByVal Action As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CloseExtCal(Me._handle, Action)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_SelfCal
    '''''
    '''''ViStatus niFgen_SelfCal&#160;(ViSession&#160;vi);
    '''''
    '''''Purpose
    '''''
    '''''Performs a full internal (self-) calibration on the device.  If the calibration is successful, new calibration data and constants are stored in the onboard EEPROM.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function SelfCal() As Integer
        Dim pInvokeResult As Integer = PInvoke.SelfCal(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_InitializeAnalogOutputCalibration
    '''''
    '''''ViStatus niFgen_InitializeAnalogOutputCalibration&#160;(ViSession&#160;vi);
    '''''
    '''''Purpose
    '''''
    '''''This function sets up the device to start the analog output calibration.
    '''''
    '''''The session handle should be the handle returned by niFgen_InitExtCal.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function InitializeAnalogOutputCalibration() As Integer
        Dim pInvokeResult As Integer = PInvoke.InitializeAnalogOutputCalibration(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_WriteBinary16AnalogStaticValue
    '''''
    '''''ViStatus niFgen_WriteBinary16AnalogStaticValue &#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt16&#160;value);
    '''''
    '''''Purpose
    '''''
    '''''Writes a 16-bit value to the DAC, which can be generated as a DC voltage. This function writes to the DAC only within an external calibration session.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to write the value.  
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Value">
    '''''
    '''''
    '''''value
    '''''ViInt16
    '''''Specifies the value to write.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function WriteBinary16AnalogStaticValue(ByVal Channel_Name As String, ByVal Value As Short) As Integer
        Dim pInvokeResult As Integer = PInvoke.WriteBinary16AnalogStaticValue(Me._handle, Channel_Name, Value)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_CalAdjustMainPathPreAmpOffset
    '''''
    '''''ViStatus niFgen_CalAdjustMainPathPreAmpOffset&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;configuration, ViInt32[]&#160;gainDACValues, ViInt32[]&#160;offsetDACValues, ViReal64[]&#160;measuredOutputs);
    '''''
    '''''Purpose
    '''''
    '''''Calculates calibration constants pertaining to the preamplifier offset of the main analog path. During external calibration, you can put the device in different configurations; program different gain, offset, and main DAC values; and take measurements of the resulting output voltage. Pass the configuration data, as well as the measurements, to this function to allow NI-FGEN to calculate the appropriate calibration constants and store them in the onboard EEPROM when the calibration session is committed.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the name of the channel being calibrated.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Configuration">
    '''''
    '''''
    '''''configuration
    '''''ViInt32
    '''''Specifies the preamplifier stage configuration.
    ''''' 
    '''''</param>
    '''''<param name="Gain_DAC_Values">
    '''''
    '''''
    '''''gainDACValues
    '''''ViInt32[]
    '''''Specifies an array of the values programmed to the gain calibration DAC during this calibration stage.
    ''''' 
    '''''</param>
    '''''<param name="Offset_DAC_Values">
    '''''
    '''''
    '''''offsetDACValues
    '''''ViInt32[]
    '''''Specifies an array of the values programmed to the offset calibration DAC during this calibration stage.
    ''''' 
    '''''</param>
    '''''<param name="Measured_Outputs">
    '''''
    '''''
    '''''measuredOutputs
    '''''ViReal64[]
    '''''Specifies an array of the analog output voltages measured during this calibration stage.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function CalAdjustMainPathPreAmpOffset(ByVal Channel_Name As String, ByVal Configuration As Integer, ByVal Gain_DAC_Values() As Integer, ByVal Offset_DAC_Values() As Integer, ByVal Measured_Outputs() As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.CalAdjustMainPathPreAmpOffset(Me._handle, Channel_Name, Configuration, Gain_DAC_Values, Offset_DAC_Values, Measured_Outputs)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_CalAdjustMainPathPreAmpGain
    '''''
    '''''ViStatus niFgen_CalAdjustMainPathPreAmpGain&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;configuration, ViInt32[]&#160;mainDACValues, ViInt32[]&#160;gainDACValues, ViInt32[]&#160;offsetDACValues, ViReal64[]&#160;measuredOutputs);
    '''''
    '''''Purpose
    '''''
    '''''Calculates calibration constants pertaining to the preamplifier gain of the main analog path. During external calibration, you can put the device in different configurations; program different gain, offset, and main DAC values; and take measurements of the resulting output voltage. Pass the configuration data, as well as the measurements to this function to allow NI-FGEN to calculate the appropriate calibration constants and store them in the onboard EEPROM when the calibration session is committed.
    '''''
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the name of the channel being calibrated.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Configuration">
    '''''
    '''''
    '''''configuration
    '''''ViInt32
    '''''Specifies the preamplifier stage configuration.
    ''''' 
    '''''</param>
    '''''<param name="Main_DAC_Values">
    '''''
    '''''
    '''''mainDACValues
    '''''ViInt32[]
    '''''Specifies an array of the values programmed to the main output DAC during this calibration stage.
    ''''' 
    '''''</param>
    '''''<param name="Gain_DAC_Values">
    '''''
    '''''
    '''''gainDACValues
    '''''ViInt32[]
    '''''Specifies an array of the values programmed to the gain calibration DAC during this calibration stage.
    ''''' 
    '''''</param>
    '''''<param name="Offset_DAC_Values">
    '''''
    '''''
    '''''offsetDACValues
    '''''ViInt32[]
    '''''Specifies an array of the values programmed to the offset calibration DAC during this calibration stage.
    ''''' 
    '''''</param>
    '''''<param name="Measured_Outputs">
    '''''
    '''''
    '''''measuredOutputs
    '''''ViReal64[]
    '''''Specifies an array of the analog output voltages measured during this calibration stage.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function CalAdjustMainPathPreAmpGain(ByVal Channel_Name As String, ByVal Configuration As Integer, ByVal Main_DAC_Values() As Integer, ByVal Gain_DAC_Values() As Integer, ByVal Offset_DAC_Values() As Integer, ByVal Measured_Outputs() As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.CalAdjustMainPathPreAmpGain(Me._handle, Channel_Name, Configuration, Main_DAC_Values, Gain_DAC_Values, Offset_DAC_Values, Measured_Outputs)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_CalAdjustMainPathPostAmpGainAndOffset
    '''''
    '''''ViStatus niFgen_CalAdjustMainPathPostAmpGainAndOffset&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;configuration, ViInt32[]&#160;mainDACValues, ViInt32[]&#160;gainDACValues, ViInt32[]&#160;offsetDACValues, ViReal64[]&#160;measuredOutputs);
    '''''
    '''''Purpose
    '''''
    '''''Calculates calibration constants pertaining to the postamplifier gain and offset of the main analog path. During external calibration, you can put the device in different configurations; program different gain, offset, and main DAC values; and take measurements of the resulting output voltage.  Pass the configuration data, as well as the measurements to this function to allow NI-FGEN to calculate the appropriate calibration constants and store them in the onboard EEPROM when the calibration session is committed.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the name of the channel being calibrated.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Configuration">
    '''''
    '''''
    '''''configuration
    '''''ViInt32
    '''''Specifies the postamplifier stage configuration.
    ''''' 
    '''''</param>
    '''''<param name="Main_DAC_Values">
    '''''
    '''''
    '''''mainDACValues
    '''''ViInt32[]
    '''''Specifies an array of the values programmed to the main output DAC during this calibration stage.
    ''''' 
    '''''</param>
    '''''<param name="Gain_DAC_Values">
    '''''
    '''''
    '''''gainDACValues
    '''''ViInt32[]
    '''''Specifies an array of the values programmed to the gain calibration DAC during this calibration stage.
    ''''' 
    '''''</param>
    '''''<param name="Offset_DAC_Values">
    '''''
    '''''
    '''''offsetDACValues
    '''''ViInt32[]
    '''''Specifies an array of the values programmed to the offset calibration DAC during this calibration stage.
    ''''' 
    '''''</param>
    '''''<param name="Measured_Outputs">
    '''''
    '''''
    '''''measuredOutputs
    '''''ViReal64[]
    '''''Specifies an array of the analog output voltages measured during this calibration stage.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function CalAdjustMainPathPostAmpGainAndOffset(ByVal Channel_Name As String, ByVal Configuration As Integer, ByVal Main_DAC_Values() As Integer, ByVal Gain_DAC_Values() As Integer, ByVal Offset_DAC_Values() As Integer, ByVal Measured_Outputs() As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.CalAdjustMainPathPostAmpGainAndOffset(Me._handle, Channel_Name, Configuration, Main_DAC_Values, Gain_DAC_Values, Offset_DAC_Values, Measured_Outputs)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_CalAdjustDirectPathGain
    '''''
    '''''ViStatus niFgen_CalAdjustDirectPathGain&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32[]&#160;mainDACValues, ViInt32[]&#160;gainDACValues, ViReal64[]&#160;measuredOutputs);
    '''''
    '''''Purpose
    '''''
    '''''Calculates calibration constants pertaining to the gain of the direct analog path. During external calibration, you can put the device in different configurations; program different gain and main DAC values; and take measurements of the resulting output voltage. Pass the configuration data, as well as the measurements, to this function to allow NI-FGEN to calculate the appropriate calibration constants and store them in the onboard EEPROM when the calibration session is committed.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the name of the channel being calibrated.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Main_DAC_Values">
    '''''
    '''''
    '''''mainDACValues
    '''''ViInt32[]
    '''''Specifies an array of the values programmed to the main output DAC during this calibration stage.
    ''''' 
    '''''</param>
    '''''<param name="Gain_DAC_Values">
    '''''
    '''''
    '''''gainDACValues
    '''''ViInt32[]
    '''''Specifies an array of the values programmed to the gain calibration DAC during this calibration stage.
    ''''' 
    '''''</param>
    '''''<param name="Measured_Outputs">
    '''''
    '''''
    '''''measuredOutputs
    '''''ViReal64[]
    '''''Specifies an array of the analog output voltages measured during this calibration stage.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function CalAdjustDirectPathGain(ByVal Channel_Name As String, ByVal Main_DAC_Values() As Integer, ByVal Gain_DAC_Values() As Integer, ByVal Measured_Outputs() As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.CalAdjustDirectPathGain(Me._handle, Channel_Name, Main_DAC_Values, Gain_DAC_Values, Measured_Outputs)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_CalAdjustMainPathOutputImpedance
    '''''
    '''''ViStatus niFgen_CalAdjustMainPathOutputImpedance&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;configuration, ViReal64&#160;loadImpedance, ViReal64&#160;measuredSourceVoltage, ViReal64&#160;measuredVoltageAcrossLoad);
    '''''
    '''''Purpose
    '''''
    '''''Calculates calibration constants pertaining to main analog path output impedance.  During external calibration, you can put the device in different configurations and take measurements of the resulting output voltage across different loads.  Pass the configuration data, as well as the measurements, to this function to allow NI-FGEN to calculate the appropriate calibration constants and store them in the onboard EEPROM when the calibration session is committed.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the name of the channel being calibrated.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Configuration">
    '''''
    '''''
    '''''configuration
    '''''ViInt32
    '''''Specifies the main path output impedance configuration.
    ''''' 
    '''''</param>
    '''''<param name="Load_Impedance">
    '''''
    '''''
    '''''loadImpedance
    '''''ViReal64
    '''''Specifies the impedance of the load across which the measurement passed in as measuredVoltageAcrossLoad is taken.
    ''''' 
    '''''</param>
    '''''<param name="Measured_Source_Voltage">
    '''''
    '''''
    '''''measuredSourceVoltage
    '''''ViReal64
    '''''Specifies the analog output voltage measured across a very high-impedance load.
    ''''' 
    '''''</param>
    '''''<param name="Measured_Voltage_Across_Load">
    '''''
    '''''
    '''''measuredVoltageAcrossLoad
    '''''ViReal64
    '''''Specifies the analog output voltage measured across the load impedance specified in the loadImpedance parameter.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function CalAdjustMainPathOutputImpedance(ByVal Channel_Name As String, ByVal Configuration As Integer, ByVal Load_Impedance As Double, ByVal Measured_Source_Voltage As Double, ByVal Measured_Voltage_Across_Load As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.CalAdjustMainPathOutputImpedance(Me._handle, Channel_Name, Configuration, Load_Impedance, Measured_Source_Voltage, Measured_Voltage_Across_Load)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_CalAdjustDirectPathOutputImpedance
    '''''
    '''''ViStatus niFgen_CalAdjustDirectPathOutputImpedance&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;configuration, ViReal64&#160;loadImpedance, ViReal64&#160;measuredSourceVoltage, ViReal64&#160;measuredVoltageAcrossLoad);
    '''''
    '''''Purpose
    '''''
    '''''Calculates calibration constants pertaining to direct analog path output impedance. During external calibration, you can put the device in different configurations and take measurements of the resulting output voltage across different loads. Pass the configuration data, as well as the measurements, to this function to allow NI-FGEN to calculate the appropriate calibration constants and store them in the onboard EEPROM when the calibration session is committed.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the name of the channel being calibrated.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Configuration">
    '''''
    '''''
    '''''configuration
    '''''ViInt32
    '''''Specifies the direct path output impedance configuration.
    ''''' 
    '''''</param>
    '''''<param name="Load_Impedance">
    '''''
    '''''
    '''''loadImpedance
    '''''ViReal64
    '''''Specifies the impedance of the load across which the measurement passed in as measuredVoltageAcrossLoad is taken.
    ''''' 
    '''''</param>
    '''''<param name="Measured_Source_Voltage">
    '''''
    '''''
    '''''measuredSourceVoltage
    '''''ViReal64
    '''''Specifies the analog output voltage measured across a very high-impedance load.
    ''''' 
    '''''</param>
    '''''<param name="Measured_Voltage_Across_Load">
    '''''
    '''''
    '''''measuredVoltageAcrossLoad
    '''''ViReal64
    '''''Specifies the analog output voltage measured across the load impedance specified in the loadImpedance parameter.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function CalAdjustDirectPathOutputImpedance(ByVal Channel_Name As String, ByVal Configuration As Integer, ByVal Load_Impedance As Double, ByVal Measured_Source_Voltage As Double, ByVal Measured_Voltage_Across_Load As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.CalAdjustDirectPathOutputImpedance(Me._handle, Channel_Name, Configuration, Load_Impedance, Measured_Source_Voltage, Measured_Voltage_Across_Load)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_InitializeOscillatorFrequencyCalibration
    '''''
    '''''ViStatus niFgen_InitializeOscillatorFrequencyCalibration&#160;(ViSession&#160;vi);
    '''''
    '''''Purpose
    '''''
    '''''Sets up the device to start the VCXO calibration.
    '''''
    '''''The session handle should be the handle returned by the niFgen_InitExtCal function.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function InitializeOscillatorFrequencyCalibration() As Integer
        Dim pInvokeResult As Integer = PInvoke.InitializeOscillatorFrequencyCalibration(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_CalAdjustOscillatorFrequency
    '''''
    '''''ViStatus niFgen_CalAdjustOscillatorFrequency&#160;(ViSession&#160;vi, ViReal64&#160;desiredFrequency, ViReal64&#160;measuredFrequency);
    '''''
    '''''Purpose
    '''''
    '''''Calculates calibration constants pertaining to the VCXO.  During external calibration, you can generate sine waves and take measurements of the resulting output frequency.  Pass the desired and measured frequencies to this function to allow NI-FGEN to calculate the appropriate calibration constants and store them in the onboard EEPROM when the calibration session is committed.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Desired_Frequency">
    '''''
    '''''
    '''''desiredFrequency
    '''''ViReal64
    '''''Specifies the expected frequency of the output waveform.
    ''''' 
    '''''</param>
    '''''<param name="Measured_Frequency">
    '''''
    '''''
    '''''measuredFrequency
    '''''ViReal64
    '''''Specifies the actual (measured) frequency of the output waveform.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function CalAdjustOscillatorFrequency(ByVal Desired_Frequency As Double, ByVal Measured_Frequency As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.CalAdjustOscillatorFrequency(Me._handle, Desired_Frequency, Measured_Frequency)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_InitializeCalADCCalibration
    '''''
    '''''ViStatus niFgen_InitializeCalADCCalibration&#160;(ViSession&#160;vi);
    '''''
    '''''Purpose
    '''''
    '''''Initializes an external calibration session for ADC calibration.  For the NI 5421/5422/5441, calibration ADC calibration involves characterizing the gain and offset of the onboard calibration ADC.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function InitializeCalADCCalibration() As Integer
        Dim pInvokeResult As Integer = PInvoke.InitializeCalADCCalibration(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_CalAdjustCalADC
    '''''
    '''''ViStatus niFgen_calAdjustCalADC&#160;(ViSession&#160;vi, ViReal64[]&#160;voltagesMeasuredExternally, ViReal64[]&#160;voltagesMeasuredWithCalADC);
    '''''
    '''''Purpose
    '''''
    '''''Calculates calibration constants pertaining to the gain and offset of the onboard calibration ADC.  During external calibration, you can generate voltages and measure them both externally and with the calibration ADC.  Pass the measured voltages to this function to allow NI-FGEN to calculate the appropriate calibration constants and store them in the onboard EEPROM when the calibration session is committed.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Voltages_Measured_Externally">
    '''''
    '''''
    '''''voltagesMeasuredExternally
    '''''ViReal64[]
    '''''Specifies an array of analog output voltages measured with an external instrument.
    ''''' 
    '''''</param>
    '''''<param name="Voltages_Measured_With_CalADC">
    '''''
    '''''
    '''''voltagesMeasuredWithCalADC
    '''''ViReal64[]
    '''''Specifies an array of analog output voltages measured with the onboard calibration ADC.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function CalAdjustCalADC(ByVal Voltages_Measured_Externally() As Double, ByVal Voltages_Measured_With_CalADC() As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.CalAdjustCalADC(Me._handle, Voltages_Measured_Externally, Voltages_Measured_With_CalADC)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ReadCalADC
    '''''
    '''''ViStatus niFgen_ReadCalADC&#160;(ViSession&#160;vi, ViInt32&#160;numberofReadstoAverage, ViBoolean&#160;returnCalibratedValue, ViReal64*&#160;calADCValue);
    '''''
    '''''Purpose
    '''''
    '''''Takes one or more voltage measurements from the onboard calibration ADC and returns the value or the average value. The signal that the ADC actually measures can be specified using the NIFGEN_ATTR_CAL_ADC_INPUT attribute. The ADC has some inherent gain and offset. These values can be determined during an external calibration session and stored in the calibration EEPROM.
    '''''
    '''''If the returnCalibratedValue parameter is VI_TRUE, NI-FGEN adjusts the value that is returned to account for the gain and offset of the ADC. Otherwise, the raw voltage value reported by the ADC is returned.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Number_of_Reads_to_Average">
    '''''
    '''''
    '''''numberofReadstoAverage
    '''''ViInt32
    '''''Specifies the number of measurements to be taken and averaged to determine the return value.
    ''''' 
    '''''</param>
    '''''<param name="Return_Calibrated_Value">
    '''''
    '''''
    '''''returnCalibratedValue
    '''''ViBoolean
    '''''Specifies whether the voltage returned from the ADC should be adjusted to account for the gain and offset of the ADC.
    ''''' 
    '''''</param>
    '''''<param name="Cal_ADC_Value">
    '''''
    '''''
    '''''calADCValue
    '''''ViReal64*
    '''''Specifies the average of the voltage measurements taken from the onboard calibration ADC.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ReadCalADC(ByVal Number_of_Reads_to_Average As Integer, ByVal Return_Calibrated_Value As Boolean, ByRef Cal_ADC_Value As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ReadCalADC(Me._handle, Number_of_Reads_to_Average, System.Convert.ToUInt16(Return_Calibrated_Value), Cal_ADC_Value)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_InitializeFlatnessCalibration
    '''''
    '''''ViStatus niFgen_InitializeFlatnessCalibration&#160;(ViSession&#160;vi);
    '''''
    '''''Purpose
    '''''
    '''''Initializes an external calibration session to calibrate flatness.
    '''''
    '''''The session handle should be the handle returned by the niFgen_InitExtCal function.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the  niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function InitializeFlatnessCalibration() As Integer
        Dim pInvokeResult As Integer = PInvoke.InitializeFlatnessCalibration(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_CalAdjustFlatness
    '''''
    '''''ViStatus niFgen_CalAdjustFlatness&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;configuration, ViReal64&#160;requestedAmplitude, ViReal64[]&#160;frequencies, ViReal64[]&#160;measuredAmplitudes, ViInt32&#160;numberOfMeasurements);
    '''''
    '''''Purpose
    '''''
    '''''Calculates calibration constants pertaining to the VCXO.  During external calibration, you can generate sine waves and take measurements of the resulting output frequency.  The desired and measured frequencies are passed to this function so that NI-FGEN can calculate the appropriate calibration constants and, when the calibration session is committed, store them in the onboard EEPROM.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the name of the channel being calibrated.
    '''''
    '''''
    '''''Default Value: &quot;0&quot;
    ''''' 
    '''''</param>
    '''''<param name="Configuration">
    '''''
    '''''
    '''''configuration
    '''''ViInt32
    '''''Specifies the main path configuration.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Requested_Amplitude">
    '''''
    '''''
    '''''requestedAmplitude
    '''''ViReal64
    '''''Specifies the desired amplitude of the output waveform.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Frequencies">
    '''''
    '''''
    '''''frequencies
    '''''ViReal64[]
    '''''Specifies the frequencies of the output waveform.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Measured_Amplitudes">
    '''''
    '''''
    '''''measuredAmplitudes
    '''''ViReal64[]
    '''''Specifies the actual (measured) amplitudes of the output waveform.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Number_Of_Measurements">
    '''''
    '''''
    '''''numberofMeasurements
    '''''ViInt32
    '''''Specifies the number of measurements to take.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function CalAdjustFlatness(ByVal Channel_Name As String, ByVal Configuration As Integer, ByVal Requested_Amplitude As Double, ByVal Frequencies() As Double, ByVal Measured_Amplitudes() As Double, ByVal Number_Of_Measurements As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CalAdjustFlatness(Me._handle, Channel_Name, Configuration, Requested_Amplitude, Frequencies, Measured_Amplitudes, Number_Of_Measurements)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_GetSelfCalSupported
    '''''
    '''''ViStatus niFgen_GetSelfCalSupported&#160;(ViSession&#160;vi, ViBoolean*&#160;selfCalSupported);
    '''''
    '''''Purpose
    '''''
    '''''Returns whether the device supports self&#8211;calibration.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitWithOptions  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Self_Cal_Supported">
    '''''
    '''''
    '''''selfCalSupported
    '''''ViBoolean*
    '''''Returns whether the device supports self-calibration. 
    '''''
    '''''Defined Values
    '''''VI_TRUE Self&#8211;calibration is supported.  VI_FALSESelf&#8211;calibration is not supported.
    ''''' 
    '''''</td>
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function GetSelfCalSupported(ByRef Self_Cal_Supported As Boolean) As Integer
        Dim Self_Cal_SupportedAsUShort As UShort
        Dim pInvokeResult As Integer = PInvoke.GetSelfCalSupported(Me._handle, Self_Cal_SupportedAsUShort)
        Self_Cal_Supported = System.Convert.ToBoolean(Self_Cal_SupportedAsUShort)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_GetSelfCalLastDateAndTime
    '''''
    '''''ViStatus niFgen_GetSelfCalLastDateAndTime &#160;(ViSession&#160;vi, ViInt32*&#160;year, ViInt32*&#160;month, ViInt32*&#160;day, ViInt32*&#160;hour, ViInt32*&#160;minute);
    '''''
    '''''Purpose
    '''''
    '''''Returns the date and time of the last successful self-calibration.  The time returned is 24-hour (military) local time; for example, if the device was calibrated at 2:30 PM, this function returns 14 for the hours parameter and 30 for the minutes parameter.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Year">
    '''''
    '''''
    '''''year
    '''''ViInt32*
    '''''Specifies the year of the last successful calibration.
    ''''' 
    '''''</param>
    '''''<param name="Month">
    '''''
    '''''
    '''''month
    '''''ViInt32*
    '''''Specifies the month of the last successful calibration.
    ''''' 
    '''''</param>
    '''''<param name="Day">
    '''''
    '''''
    '''''day
    '''''ViInt32*
    '''''Specifies the day of the last successful calibration.
    ''''' 
    '''''</param>
    '''''<param name="Hour">
    '''''
    '''''
    '''''hour
    '''''ViInt32*
    '''''Specifies the hour of the last successful calibration.
    ''''' 
    '''''</param>
    '''''<param name="Minute">
    '''''
    '''''
    '''''minute
    '''''ViInt32*
    '''''Specifies the minute of the last successful calibration.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function GetSelfCalLastDateAndTime(ByRef Year As Integer, ByRef Month As Integer, ByRef Day As Integer, ByRef Hour As Integer, ByRef Minute As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetSelfCalLastDateAndTime(Me._handle, Year, Month, Day, Hour, Minute)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_GetExtCalLastDateAndTime
    '''''
    '''''ViStatus niFgen_GetExtCalLastDateAndTime&#160;(ViSession&#160;vi, ViInt32*&#160;year, ViInt32*&#160;month, ViInt32*&#160;day, ViInt32*&#160;hour, ViInt32*&#160;minute);
    '''''
    '''''Purpose
    '''''
    '''''Returns the date and time of the last successful external calibration.  The time returned is 24-hour (military) local time; for example, if the device was calibrated at 2:30 PM, this function returns 14 for the hours parameter and 30 for the minutes parameter.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Year">
    '''''
    '''''
    '''''year
    '''''ViInt32*
    '''''Specifies the year of the last successful calibration.
    ''''' 
    '''''</param>
    '''''<param name="Month">
    '''''
    '''''
    '''''month
    '''''ViInt32*
    '''''Specifies the month of the last successful calibration.
    ''''' 
    '''''</param>
    '''''<param name="Day">
    '''''
    '''''
    '''''day
    '''''ViInt32*
    '''''Specifies the day of the last successful calibration.
    ''''' 
    '''''</param>
    '''''<param name="Hour">
    '''''
    '''''
    '''''hour
    '''''ViInt32*
    '''''Specifies the hour of the last successful calibration.
    ''''' 
    '''''</param>
    '''''<param name="Minute">
    '''''
    '''''
    '''''minute
    '''''ViInt32*
    '''''Specifies the minute of the last successful calibration.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function GetExtCalLastDateAndTime(ByRef Year As Integer, ByRef Month As Integer, ByRef Day As Integer, ByRef Hour As Integer, ByRef Minute As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetExtCalLastDateAndTime(Me._handle, Year, Month, Day, Hour, Minute)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_GetSelfCalLastTemp
    '''''
    '''''ViStatus niFgen_GetSelfCalLastTemp&#160;(ViSession&#160;vi, ViReal64*&#160;temperature);
    '''''
    '''''Purpose
    '''''
    '''''Returns the temperature at the last successful self-calibration.  The temperature is returned in degrees Celsius.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Temperature">
    '''''
    '''''
    '''''temperature
    '''''ViReal64*
    '''''Specifies the temperature at the last successful calibration.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function GetSelfCalLastTemp(ByRef Temperature As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetSelfCalLastTemp(Me._handle, Temperature)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_GetExtCalLastTemp
    '''''
    '''''ViStatus niFgen_GetExtCalLastTemp&#160;(ViSession&#160;vi, ViReal64*&#160;temperature);
    '''''
    '''''Purpose
    '''''
    '''''Returns the temperature at the last successful external calibration.  The temperature is returned in degrees Celsius.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Temperature">
    '''''
    '''''
    '''''temperature
    '''''ViReal64*
    '''''Specifies the temperature at the last successful calibration.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function GetExtCalLastTemp(ByRef Temperature As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetExtCalLastTemp(Me._handle, Temperature)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_GetExtCalRecommendedInterval
    '''''
    '''''ViStatus niFgen_GetExtCalRecommendedInterval&#160;(ViSession&#160;vi, ViInt32*&#160;months);
    '''''
    '''''Purpose
    '''''
    '''''Returns the recommended interval between external calibrations in months.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Months">
    '''''
    '''''
    '''''months
    '''''ViInt32*
    '''''Specifies the recommended interval between external calibrations in months.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function GetExtCalRecommendedInterval(ByRef Months As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetExtCalRecommendedInterval(Me._handle, Months)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ChangeExtCalPassword
    '''''
    '''''ViStatus niFgen_ChangeExtCalPassword&#160;(ViSession&#160;vi, ViConstString&#160;oldPassword, ViConstString&#160;newPassword);
    '''''
    '''''Purpose
    '''''
    '''''Changes the password that is required to initialize an external calibration session.  The password may be up to four characters long.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Old_Password">
    '''''
    '''''
    '''''oldPassword
    '''''ViConstString
    '''''Specifies the old (current) external calibration password.
    ''''' 
    '''''</param>
    '''''<param name="New_Password">
    '''''
    '''''
    '''''newPassword
    '''''ViConstString
    '''''Specifies the new (desired) external calibration password.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ChangeExtCalPassword(ByVal Old_Password As String, ByVal New_Password As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.ChangeExtCalPassword(Me._handle, Old_Password, New_Password)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_SetCalUserDefinedInfo
    '''''
    '''''ViStatus niFgen_SetCalUserDefinedInfo&#160;(ViSession&#160;vi, ViConstString&#160;info);
    '''''
    '''''Purpose
    '''''
    '''''Stores user-defined information in the onboard EEPROM.  Call the niFgen_GetCalUserDefinedInfoMaxSize function to determine the number of characters that can be stored.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Info">
    '''''
    '''''
    '''''info
    '''''ViConstString
    '''''Specifies the information string that should be stored in the EEPROM.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function SetCalUserDefinedInfo(ByVal Info As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.SetCalUserDefinedInfo(Me._handle, Info)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_GetCalUserDefinedInfo
    '''''
    '''''ViStatus niFgen_GetCalUserDefinedInfo&#160;(ViSession&#160;vi, ViString&#160;info);
    '''''
    '''''Purpose
    '''''
    '''''Retrieves user-defined information from the onboard EEPROM.  Call the niFgen_GetCalUserDefinedInfoMaxSize  function to determine the number of characters that can be retrieved.  The buffer you provide should be the size of the maximum number of characters stored plus one termination character.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Info">
    '''''
    '''''
    '''''info
    '''''ViString
    '''''Specifies a string into which the user information is copied.  This parameter must point to a character buffer large enough to hold the information string.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function GetCalUserDefinedInfo(ByVal Info As String) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetCalUserDefinedInfo(Me._handle, Info)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_GetCalUserDefinedInfoMaxSize
    '''''
    '''''ViStatus niFgen_GetCalUserDefinedInfoMaxSize&#160;(ViSession&#160;vi, ViInt32*&#160;infoSize);
    '''''
    '''''Purpose
    '''''
    '''''Returns the maximum number of characters (excluding the termination character) of user-defined information that can be stored in the onboard EEPROM.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Info_Size">
    '''''
    '''''
    '''''infoSize
    '''''ViInt32*
    '''''Specifies the maximum number of characters of user defined info that can be stored in the onboard EEPROM.
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function GetCalUserDefinedInfoMaxSize(ByRef Info_Size As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.GetCalUserDefinedInfoMaxSize(Me._handle, Info_Size)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_ReadCurrentTemperature
    '''''
    '''''ViStatus niFgen_ReadCurrentTemperature&#160;(ViSession&#160;vi, ViReal64*&#160;temperature);
    '''''
    '''''Purpose
    '''''
    '''''Reads the current onboard temperature of the device. The temperature is returned in degrees Celsius.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_init or the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Temperature">
    '''''
    '''''
    '''''Temperature
    '''''ViReal64*
    '''''Returns the current temperature read from onboard temperature sensors (degrees Celsius).
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ReadCurrentTemperature(ByRef Temperature As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ReadCurrentTemperature(Me._handle, Temperature)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''niFgen_RestoreLastExtCalConstants
    '''''
    '''''ViStatus niFgen_RestoreLastExtCalConstants&#160;(ViSession&#160;vi);
    '''''
    '''''Purpose
    '''''
    '''''Overwrites the current calibration constants with those from the last successful external calibration. This action effectively undoes any self-calibrations performed since the last time an external calibration was performed. This function should be used if a self-calibration produced invalid calibration constants.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the niFgen_InitExtCal  function and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function RestoreLastExtCalConstants() As Integer
        Dim pInvokeResult As Integer = PInvoke.RestoreLastExtCalConstants(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''[OBSOLETE] niFgen_ConfigureTriggerSource
    '''''
    '''''ViStatus niFgen_ConfigureTriggerSource&#160;(ViSession&#160;vi, ViConstString&#160;channelName, ViInt32&#160;triggerSource);
    '''''
    '''''Purpose
    '''''
    '''''Configures the trigger source. The signal generator responds to a trigger depending on the operation mode in which the signal generator is operating.
    '''''
    '''''
    '''''Note&#160;&#160; The signal generator must not be in the Generating state when you call this function.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Channel_Name">
    '''''
    '''''
    '''''channelName
    '''''ViConstString
    '''''Specifies the channel name for which you want to configure the trigger source.
    '''''
    '''''Defined Value:&quot;0&quot;
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Trigger_Source">
    '''''
    '''''
    '''''triggerSource
    '''''ViInt32
    '''''Controls which trigger source the signal generator uses.
    '''''
    '''''Defined Values
    '''''
    '''''NIFGEN_VAL_IMMEDIATE
    '''''Immediate
    '''''
    '''''NIFGEN_VAL_EXTERNAL
    '''''External (maps to PFI 0)
    '''''
    '''''NIFGEN_VAL_SOFTWARE_TRIG
    '''''Software trigger
    '''''
    '''''NIFGEN_VAL_PXI_STAR
    '''''PXI star
    '''''
    '''''NIFGEN_VAL_RTSI_0
    '''''RTSI 0 or PXI_Trig 0
    '''''
    '''''NIFGEN_VAL_RTSI_1
    '''''RTSI 1 or PXI_Trig 1
    '''''
    '''''NIFGEN_VAL_RTSI_2
    '''''RTSI 2 or PXI_Trig 2
    '''''
    '''''NIFGEN_VAL_RTSI_3
    '''''RTSI 3 or PXI_Trig 3
    '''''
    '''''NIFGEN_VAL_RTSI_4
    '''''RTSI 4 or PXI_Trig 4
    '''''
    '''''NIFGEN_VAL_RTSI_5
    '''''RTSI 5 or PXI_Trig 5
    '''''
    '''''NIFGEN_VAL_RTSI_6
    '''''RTSI 6 or PXI_Trig 6
    '''''
    '''''NIFGEN_VAL_RTSI_7
    '''''RTSI 7 or PXI_Trig 7
    '''''
    '''''NIFGEN_VAL_TTL0
    '''''TTL 0
    '''''
    '''''NIFGEN_VAL_TTL1
    '''''TTL 1
    '''''
    '''''NIFGEN_VAL_TTL2
    '''''TTL 2
    '''''
    '''''NIFGEN_VAL_TTL3
    '''''TTL 3
    '''''
    '''''NIFGEN_VAL_TTL4
    '''''TTL 4
    '''''
    '''''NIFGEN_VAL_TTL5
    '''''TTL 5
    '''''
    '''''NIFGEN_VAL_TTL6
    '''''TTL 6
    '''''
    '''''NIFGEN_VAL_PFI_0
    '''''PFI 0
    '''''
    '''''NIFGEN_VAL_PFI_1
    '''''PFI 1
    '''''
    '''''NIFGEN_VAL_PFI_2
    '''''PFI 2
    '''''
    '''''NIFGEN_VAL_PFI_3
    '''''PFI 3
    '''''
    '''''Default Value: NIFGEN_VAL_IMMEDIATE
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureTriggerSource(ByVal Channel_Name As String, ByVal Trigger_Source As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureTriggerSource(Me._handle, Channel_Name, Trigger_Source)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''[OBSOLETE] niFgen_CreateArbWaveform
    '''''
    '''''ViStatus niFgen_CreateArbWaveform&#160;(ViSession&#160;vi, ViInt32&#160;waveformSize, ViReal64[]&#160;waveformDataArray, ViInt32*&#160;waveformHandle);
    '''''
    '''''Purpose
    '''''
    '''''[OBSOLETE] This function is obsolete.  Use the niFgen_CreateWaveformF64, niFgen_CreateWaveformI16, or niFgen_CreateWaveformComplexF64 function instead of this function.
    '''''
    '''''Creates an arbitrary waveform and returns a handle that identifies that waveform. You can pass this handle to the niFgen_ConfigureArbWaveform function to produce that waveform. You can also use the handles this function returns to specify a sequence of arbitrary waveforms with the niFgen_CreateArbSequence function.
    '''''
    '''''
    '''''Note&#160;&#160;You must set the output mode to NIFGEN_VAL_OUTPUT_ARB before calling this function.
    '''''
    '''''
    '''''Note&#160;&#160;You must scale the data between &#8211;1.00 and +1.00. Use the arbGain parameter to generate different output voltages.
    '''''
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Waveform_Size">
    '''''
    '''''
    '''''waveformSize
    '''''ViInt32
    '''''Specifies the size of the arbitrary waveform that you want created.
    '''''
    '''''The size must meet the following restrictions:
    '''''
    '''''
    '''''
    '''''The size must be less than or equal to the maximum waveform size that the device allows.
    '''''The size must be greater than or equal to the minimum waveform size that the device allows.
    '''''The size must be an integer multiple of the device waveform quantum.
    '''''
    '''''
    '''''
    '''''You can obtain these values from the maximumWaveformSize, minimumWaveformSize, and waveformQuantum parameters in the niFgen_QueryArbWfmCapabilities function.
    '''''
    '''''Default Value: None
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Data_Array">
    '''''
    '''''
    '''''waveformDataArray
    '''''ViReal64[]
    '''''Specifies the array of data you want to use for the new arbitrary waveform. The array must have at least as many elements as the value that you specify in waveformSize.
    '''''
    '''''You must normalize the data points in the array to be between &#8211;1.00 and +1.00.
    '''''
    '''''Default Value: None
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Handle">
    '''''
    '''''
    '''''waveformHandle
    '''''ViInt32*
    '''''The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function CreateArbWaveform(ByVal Waveform_Size As Integer, ByVal Waveform_Data_Array() As Double, ByRef Waveform_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CreateArbWaveform(Me._handle, Waveform_Size, Waveform_Data_Array, Waveform_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''[OBSOLETE] niFgen_CreateBinary16ArbWaveform
    '''''
    '''''ViStatus niFgen_CreateBinary16ArbWaveform&#160;(ViSession&#160;vi, ViInt32&#160;waveformSize, ViInt16[]&#160;waveformDataArray, ViInt32*&#160;waveformHandle);
    '''''
    '''''Purpose
    '''''
    '''''[OBSOLETE] This function is obsolete.  Use the niFgen_CreateWaveformI16 function instead of this function.
    '''''
    '''''Creates an arbitrary waveform from binary data and returns a handle that identifies that waveform. You can pass this handle to the niFgen_ConfigureArbWaveform function to produce that waveform. You can also use the handles this function returns to specify a sequence of arbitrary waveforms with the niFgen_CreateArbSequence function.
    '''''
    '''''
    '''''Note&#160;&#160;You must set the output mode to NIFGEN_VAL_OUTPUT_ARB or NIFGEN_VAL_OUTPUT_SEQ before calling this function.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Waveform_Size">
    '''''
    '''''
    '''''waveformSize
    '''''ViInt32
    '''''Specifies the size of the arbitrary waveform that you want created.
    '''''
    '''''The size must meet the following restrictions:
    '''''
    ''''' The size must be less than or equal to the maximum waveform size that the device allows.
    ''''' The size must be greater than or equal to the minimum waveform size that the device allows.
    ''''' The size must be an integer multiple of the device waveform quantum.
    '''''
    '''''
    '''''
    '''''You can obtain these values from the maximumWaveformSize, minimumWaveformSize, and waveformQuantum parameters in niFgen_QueryArbWfmCapabilities.
    '''''
    '''''Default Value: None
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Data_Array">
    '''''
    '''''
    '''''waveformDataArray
    '''''ViReal64[]
    '''''Specifies the array of data you want to use for the new arbitrary waveform. The array must have at least as many elements as the value that you specify in waveformSize.
    '''''
    '''''You must normalize the data points in the array to be between &#8211;1.00 and +1.00.
    '''''
    '''''Default Value: None
    ''''' 
    '''''</param>
    '''''<param name="Waveform_Handle">
    '''''
    '''''
    '''''waveformHandle
    '''''ViInt32*
    '''''The handle that identifies the new waveform.  This handle is used later when referring to this waveform.
    '''''
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function CreateBinary16ArbWaveform(ByVal Waveform_Size As Integer, ByVal Waveform_Data_Array() As Short, ByRef Waveform_Handle As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.CreateBinary16ArbWaveform(Me._handle, Waveform_Size, Waveform_Data_Array, Waveform_Handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''[OBSOLETE] niFgen_ConfigureRefClockSource
    '''''
    '''''ViStatus niFgen_ConfigureRefClockSource&#160;(ViSession&#160;vi, ViInt32&#160;referenceClockSource);
    '''''
    '''''Purpose
    '''''
    '''''Configures the signal generator reference clock source. The signal generator uses the reference clock to derive frequencies and sample rates when generating waveforms.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Reference_Clock_Source">
    '''''
    '''''
    '''''referenceClockSource
    '''''ViInt32
    '''''Specifies the reference clock source that you want the signal generator to use. NI-FGEN sets the NIFGEN_ATTR_REF_CLOCK_SOURCE attribute to this value.
    '''''
    '''''The signal generator derives the frequencies and sample rates that it uses to generate waveforms from the source you specify.
    '''''
    '''''For example, when you set this parameter to NIFGEN_VAL_REF_CLOCK_EXTERNAL, the signal generator uses the signal it receives at its external clock terminal as the reference clock.
    '''''
    '''''Defined Values
    '''''
    '''''NIFGEN_VAL_REF_CLOCK_INTERNAL
    '''''Internal clock source
    '''''
    '''''NIFGEN_VAL_REF_CLOCK_EXTERNAL
    '''''External clock source
    '''''
    '''''NIFGEN_VAL_REF_CLOCK_RTSI_CLOCK
    '''''RTSI clock
    '''''
    '''''NIFGEN_VAL_REF_CLOCK_TTL7
    '''''TTL 7
    '''''
    '''''NIFGEN_VAL_PXI_CLK10
    '''''PXI 10&#160;MHz clock
    '''''
    '''''NIFGEN_VAL_REF_IN
    '''''External clock source
    '''''
    '''''NIFGEN_VAL_RTSI_0
    '''''RTSI 0
    '''''
    '''''NIFGEN_VAL_RTSI_1
    '''''RTSI 1
    '''''
    '''''NIFGEN_VAL_RTSI_2
    '''''RTSI 2
    '''''
    '''''NIFGEN_VAL_RTSI_3
    '''''RTSI 3
    '''''
    '''''NIFGEN_VAL_RTSI_4
    '''''RTSI 4
    '''''
    '''''NIFGEN_VAL_RTSI_5
    '''''RTSI 5
    '''''
    '''''NIFGEN_VAL_RTSI_6
    '''''RTSI 6
    '''''
    '''''NIFGEN_VAL_RTSI_7
    '''''RTSI 7
    '''''
    '''''NIFGEN_VAL_CLK_IN
    '''''CLK IN front panel connector
    '''''
    '''''Default Value: NIFGEN_VAL_REF_CLOCK_INTERNAL
    ''''' </tr></table>
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureRefClockSource(ByVal Reference_Clock_Source As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureRefClockSource(Me._handle, Reference_Clock_Source)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''[OBSOLETE] niFgen_ConfigureRefClockFrequency
    '''''
    '''''ViStatus niFgen_ConfigureRefClockFrequency&#160;(ViSession&#160;vi, ViReal64&#160;referenceClockFrequency);
    '''''
    '''''Purpose
    '''''
    '''''Configures the signal generator reference clock frequency.  The signal generator uses the reference clock to derive frequencies and sample rates when generating waveforms.
    '''''
    '''''
    '''''Note&#160;&#160;  The signal generator must not be in the Generating state when you call this function.
    '''''
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Reference_Clock_Frequency">
    '''''
    '''''
    '''''referenceClockFrequency
    '''''ViReal64
    '''''The reference clock frequency in Hz.
    '''''
    '''''Default Value: 10000000
    '''''
    ''''' 
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureRefClockFrequency(ByVal Reference_Clock_Frequency As Double) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureRefClockFrequency(Me._handle, Reference_Clock_Frequency)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''[OBSOLETE] niFgen_ConfigureUpdateClockSource
    '''''
    '''''ViStatus niFgen_ConfigureUpdateClockSource&#160;(ViSession&#160;vi, ViInt32&#160;updateClockSource);
    '''''
    '''''Purpose
    '''''
    '''''Sets the source of the update clock of the signal generator.  The source can be internal or external.
    '''''
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<param name="Update_Clock_Source">
    '''''
    '''''
    '''''updateClockSource
    '''''ViInt32
    '''''Specifies the update clock source.
    '''''
    '''''Defined Values
    '''''
    '''''NIFGEN_VAL_INTERNAL
    '''''Internal clock source
    '''''
    '''''NIFGEN_VAL_EXTERNAL
    '''''External clock source
    '''''
    '''''NIFGEN_VAL_PXI_STAR
    '''''PXI star
    '''''
    '''''NIFGEN_VAL_RTSI_0
    '''''RTSI 0 or PXI_Trig 0
    '''''
    '''''NIFGEN_VAL_RTSI_1
    '''''RTSI 1 or PXI_Trig 1
    '''''
    '''''NIFGEN_VAL_RTSI_2
    '''''RTSI 2 or PXI_Trig 2
    '''''
    '''''NIFGEN_VAL_RTSI_3
    '''''RTSI 3 or PXI_Trig 3
    '''''
    '''''NIFGEN_VAL_RTSI_4
    '''''RTSI 4 or PXI_Trig 4
    '''''
    '''''NIFGEN_VAL_RTSI_5
    '''''RTSI 5 or PXI_Trig 5
    '''''
    '''''NIFGEN_VAL_RTSI_6
    '''''RTSI 6 or PXI_Trig 6
    '''''
    '''''NIFGEN_VAL_RTSI_7
    '''''RTSI 7 or PXI_Trig 7
    '''''
    '''''NIFGEN_VAL_CLK_IN
    '''''CLK IN front panel connector
    '''''
    '''''NIFGEN_VAL_DDC_CLK_IN
    '''''Digital Data &amp; Control clock in
    '''''
    '''''Default Value: NIFGEN_VAL_INTERNAL
    ''''' </tr></table>
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function ConfigureUpdateClockSource(ByVal Update_Clock_Source As Integer) As Integer
        Dim pInvokeResult As Integer = PInvoke.ConfigureUpdateClockSource(Me._handle, Update_Clock_Source)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    '''''<summary>
    '''''
    '''''
    '''''
    '''''[OBSOLETE] niFgen_SendSoftwareTrigger
    '''''
    '''''ViStatus niFgen_SendSoftwareTrigger&#160;(ViSession&#160;vi);
    '''''
    '''''Purpose
    '''''
    '''''Sends a command to trigger the signal generator. 
    '''''
    '''''
    '''''Note&#160;&#160;This function can act as an override for an external edge trigger. However, the NI&#160;5401/5411/5431 
    '''''do not support overriding an external digital edge trigger.
    '''''
    '''''</summary>
    '''''<param name="vi">
    '''''
    '''''
    '''''vi
    '''''ViSession
    '''''Identifies your instrument session. vi is obtained from the 
    '''''   niFgen_init or the niFgen_InitWithOptions functions and identifies a particular instrument session.
    ''''' 
    '''''
    '''''</param>
    '''''<returns>
    '''''
    '''''
    '''''Status
    '''''ViStatus
    '''''Returns the status code of this operation. The status code  either indicates success or describes an error or warning condition. You can examine the status code from each call to an NI-FGEN function to determine if an error occurred.
    '''''
    '''''To obtain a text description of the status code, call  the  niFgen_error_message function. To obtain additional information about the error condition, call the niFgen_GetError function. To clear the error information from NI-FGEN, call the  niFgen_ClearError function. 
    '''''
    '''''
    ''''' 
    '''''
    '''''The general meaning of the status code is as follows:
    ''''' 
    '''''
    '''''
    '''''
    '''''Value
    '''''Meaning
    '''''0
    '''''Success
    '''''Positive Values
    '''''Warnings
    '''''Negative Values
    '''''Errors
    '''''
    '''''
    '''''
    '''''
    '''''
    '''''</returns>
    Public Function SendSoftwareTrigger() As Integer
        Dim pInvokeResult As Integer = PInvoke.SendSoftwareTrigger(Me._handle)
        PInvoke.TestForError(Me._handle, pInvokeResult)
        Return pInvokeResult
    End Function
    
    Public Overloads Sub Dispose() Implements System.IDisposable.Dispose
        Me.Dispose(true)
        System.GC.SuppressFinalize(Me)
    End Sub
    
    Private Overloads Sub Dispose(ByVal disposing As Boolean)
        If (Me._disposed = false) Then
            PInvoke.close(Me._handle)
            Me._handle = System.IntPtr.Zero
        End If
        Me._disposed = true
    End Sub
    
    Protected Overrides Sub Finalize()
        Me.Dispose(false)
    End Sub
    
    Public Overloads Sub SetInt32(ByVal propertyId As niFgenProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Integer)
        PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViInt32(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), val))
    End Sub
    
    Public Overloads Sub SetInt32(ByVal propertyId As niFgenProperties, ByVal val As Integer)
        Me.SetInt32(propertyId, "", val)
    End Sub
    
    Public Overloads Function GetInt32(ByVal propertyId As niFgenProperties, ByVal repeatedCapabilityOrChannel As String) As Integer
        Dim val As Integer
        PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViInt32(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), val))
        Return val
    End Function
    
    Public Overloads Function GetInt32(ByVal propertyId As niFgenProperties) As Integer
        Return Me.GetInt32(propertyId, "")
    End Function
    
    Public Overloads Sub SetDouble(ByVal propertyId As niFgenProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Double)
        PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViReal64(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), val))
    End Sub
    
    Public Overloads Sub SetDouble(ByVal propertyId As niFgenProperties, ByVal val As Double)
        Me.SetDouble(propertyId, "", val)
    End Sub
    
    Public Overloads Function GetDouble(ByVal propertyId As niFgenProperties, ByVal repeatedCapabilityOrChannel As String) As Double
        Dim val As Double
        PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViReal64(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), val))
        Return val
    End Function
    
    Public Overloads Function GetDouble(ByVal propertyId As niFgenProperties) As Double
        Return Me.GetDouble(propertyId, "")
    End Function
    
    Public Overloads Sub SetBoolean(ByVal propertyId As niFgenProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As Boolean)
        PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViBoolean(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), System.Convert.ToUInt16(val)))
    End Sub
    
    Public Overloads Sub SetBoolean(ByVal propertyId As niFgenProperties, ByVal val As Boolean)
        Me.SetBoolean(propertyId, "", val)
    End Sub
    
    Public Overloads Function GetBoolean(ByVal propertyId As niFgenProperties, ByVal repeatedCapabilityOrChannel As String) As Boolean
        Dim val As UShort
        PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViBoolean(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), val))
        Return System.Convert.ToBoolean(val)
    End Function
    
    Public Overloads Function GetBoolean(ByVal propertyId As niFgenProperties) As Boolean
        Return Me.GetBoolean(propertyId, "")
    End Function
    
    Public Overloads Sub SetString(ByVal propertyId As niFgenProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As String)
        PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), val))
    End Sub
    
    Public Overloads Sub SetString(ByVal propertyId As niFgenProperties, ByVal val As String)
        Me.SetString(propertyId, "", val)
    End Sub
    
    Public Overloads Function GetString(ByVal propertyId As niFgenProperties, ByVal repeatedCapabilityOrChannel As String) As String
        Dim newVal As System.Text.StringBuilder = New System.Text.StringBuilder(512)
        Dim size As Integer = PInvoke.GetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), 512, newVal)
        If (size < 0) Then
            PInvoke.ThrowError(Me._handle, size)
        Else
            If (size > 0) Then
                newVal.Capacity = size
                PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViString(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), size, newVal))
            End If
        End If
        Return newVal.ToString
    End Function
    
    Public Overloads Function GetString(ByVal propertyId As niFgenProperties) As String
        Return Me.GetString(propertyId, "")
    End Function
    
    Public Overloads Sub SetSession(ByVal propertyId As niFgenProperties, ByVal repeatedCapabilityOrChannel As String, ByVal val As System.IntPtr)
        PInvoke.TestForError(Me._handle, PInvoke.SetAttributeViSession(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), val))
    End Sub
    
    Public Overloads Sub SetSession(ByVal propertyId As niFgenProperties, ByVal val As System.IntPtr)
        Me.SetSession(propertyId, "", val)
    End Sub
    
    Public Overloads Function GetSession(ByVal propertyId As niFgenProperties, ByVal repeatedCapabilityOrChannel As String) As System.IntPtr
        Dim val As System.IntPtr
        PInvoke.TestForError(Me._handle, PInvoke.GetAttributeViSession(Me._handle, repeatedCapabilityOrChannel, CType(propertyId,Integer), val))
        Return val
    End Function
    
    Public Overloads Function GetSession(ByVal propertyId As niFgenProperties) As System.IntPtr
        Return Me.GetSession(propertyId, "")
    End Function
    
    Private Class PInvoke
        
<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_init", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function init (ByVal Resource_Name As String, ByVal ID_Query As UShort, ByVal Reset_Device As UShort, ByRef vi As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_InitWithOptions", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function InitWithOptions (ByVal Resource_Name As String, ByVal ID_Query As UShort, ByVal Reset_Device As UShort, ByVal Option_String As String, ByRef vi As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_InitExtCal", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function InitExtCal (ByVal Resource_Name As String, ByVal Password As String, ByRef vi As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_Commit", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function Commit (ByVal vi As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_reset", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function reset (ByVal vi As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureOperationMode", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureOperationMode (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Operation_Mode As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureOutputMode", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureOutputMode (ByVal vi As System.IntPtr, ByVal Output_Mode As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureChannels", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureChannels (ByVal vi As System.IntPtr, ByVal Channels As String) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureOutputEnabled", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureOutputEnabled (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Enabled As UShort) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureOutputImpedance", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureOutputImpedance (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Impedance As Double) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_EnableAnalogFilter", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function EnableAnalogFilter (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Filter_Correction_Frequency As Double) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_DisableAnalogFilter", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function DisableAnalogFilter (ByVal vi As System.IntPtr, ByVal Channel_Name As String) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_EnableDigitalFilter", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function EnableDigitalFilter (ByVal vi As System.IntPtr, ByVal Channel_Name As String) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_DisableDigitalFilter", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function DisableDigitalFilter (ByVal vi As System.IntPtr, ByVal Channel_Name As String) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_EnableDigitalPatterning", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function EnableDigitalPatterning (ByVal vi As System.IntPtr, ByVal Channel_Name As String) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_DisableDigitalPatterning", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function DisableDigitalPatterning (ByVal vi As System.IntPtr, ByVal Channel_Name As String) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureStandardWaveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureStandardWaveform (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform As Integer, ByVal Amplitude As Double, ByVal DC_Offset As Double, ByVal Frequency As Double, ByVal Start_Phase As Double) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_DefineUserStandardWaveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function DefineUserStandardWaveform (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Size As Integer, ByVal Waveform_Data_Array As Double()) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ClearUserStandardWaveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ClearUserStandardWaveform (ByVal vi As System.IntPtr, ByVal Channel_Name As String) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureFrequency", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureFrequency (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Frequency As Double) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureAmplitude", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureAmplitude (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Amplitude As Double) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_CreateFreqList", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CreateFreqList (ByVal vi As System.IntPtr, ByVal Waveform As Integer, ByVal Frequency_List_Length As Integer, ByVal Frequency_Array As Double(), ByVal Duration_Array As Double(), ByRef Frequency_List_Handle As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureFreqList", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureFreqList (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Frequency_List_Handle As Integer, ByVal Amplitude As Double, ByVal DC_Offset As Double, ByVal Start_Phase As Double) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ClearFreqList", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ClearFreqList (ByVal vi As System.IntPtr, ByVal Frequency_List_Handle As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_QueryFreqListCapabilities", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function QueryFreqListCapabilities (ByVal vi As System.IntPtr, ByRef Maximum_Number_Of_Freq_Lists As Integer, ByRef Minimum_Frequency_List_Length As Integer, ByRef Maximum_Frequency_List_Length As Integer, ByRef Minimum_Frequency_List_Duration As Double, ByRef Maximum_Frequency_List_Duration As Double, ByRef Frequency_List_Duration_Quantum As Double) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureGain", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureGain (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Gain As Double) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureSampleRate", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureSampleRate (ByVal vi As System.IntPtr, ByVal Sample_Rate As Double) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_QueryArbWfmCapabilities", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function QueryArbWfmCapabilities (ByVal vi As System.IntPtr, ByRef Maximum_Number_of_Waveforms As Integer, ByRef Waveform_Quantum As Integer, ByRef Minimum_Waveform_Size As Integer, ByRef Maximum_Waveform_Size As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_CreateWaveformF64", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CreateWaveformF64 (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Size As Integer, ByVal Waveform_Data_Array As Double(), ByRef Waveform_Handle As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_CreateWaveformI16", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CreateWaveformI16 (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Size As Integer, ByVal Waveform_Data_Array As Short(), ByRef Waveform_Handle As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_CreateWaveformComplexF64", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CreateWaveformComplexF64 (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Number_of_Samples As Integer, ByVal Waveform_Data_Array As Integer, ByRef Waveform_Handle As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_CreateWaveformFromFileI16", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CreateWaveformFromFileI16 (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal FileName As String, ByVal Byte_Order As Integer, ByRef Waveform_Handle As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_CreateWaveformFromFileF64", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CreateWaveformFromFileF64 (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal FileName As String, ByVal Byte_Order As Integer, ByRef Waveform_Handle As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_CreateWaveformFromFileHWS", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CreateWaveformFromFileHWS (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal FileName As String, ByVal Use_Rate_From_Waveform As UShort, ByVal Use_Gain___Offset_From_Waveform As UShort, ByRef Waveform_Handle As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureArbWaveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureArbWaveform (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Handle As Integer, ByVal Gain As Double, ByVal Offset As Double) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ClearArbWaveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ClearArbWaveform (ByVal vi As System.IntPtr, ByVal Waveform_Handle As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_QueryArbSeqCapabilities", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function QueryArbSeqCapabilities (ByVal vi As System.IntPtr, ByRef Maximum_Number_of_Sequences As Integer, ByRef Minimum_Sequence_Length As Integer, ByRef Maximum_Sequence_Length As Integer, ByRef Maximum_Loop_Count As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_CreateArbSequence", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CreateArbSequence (ByVal vi As System.IntPtr, ByVal Sequence_Length As Integer, ByVal Waveform_Handles_Array As Integer(), ByVal Loop_Counts_Array As Integer(), ByRef Sequence_Handle As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_CreateAdvancedArbSequence", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CreateAdvancedArbSequence (ByVal vi As System.IntPtr, ByVal Sequence_Length As Integer, ByVal Waveform_Handles_Array As Integer(), ByVal Loop_Counts_Array As Integer(), ByVal Sample_Counts_Array As Integer(), ByVal Marker_Location_Array As Integer(), <[In], Out> Coerced_Markers_Array As Integer(), ByRef Sequence_Handle As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureArbSequence", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureArbSequence (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Sequence_Handle As Integer, ByVal Gain As Double, ByVal Offset As Double) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ClearArbSequence", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ClearArbSequence (ByVal vi As System.IntPtr, ByVal Sequence_Handle As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ClearArbMemory", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ClearArbMemory (ByVal vi As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_AllocateWaveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function AllocateWaveform (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Size As Integer, ByRef Waveform_Handle As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_SetWaveformNextWritePosition", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SetWaveformNextWritePosition (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Handle As Integer, ByVal relativeTo As Integer, ByVal offset As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_WriteWaveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function WriteWaveform (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Handle As Integer, ByVal Size As Integer, ByVal Data As Double()) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_WriteWaveformComplexF64", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function WriteWaveformComplexF64 (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Number_of_Samples As Integer, ByVal Data As Integer, ByVal Waveform_Handle As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_WriteBinary16Waveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function WriteBinary16Waveform (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Handle As Integer, ByVal Size As Integer, ByVal Data As Short()) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_WriteComplexBinary16Waveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function WriteComplexBinary16Waveform (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Handle As Integer, ByVal Size As Integer, ByVal Data As nicomplexI16) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureReferenceClock", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureReferenceClock (ByVal vi As System.IntPtr, ByVal Reference_Clock_Source As String, ByVal Reference_Clock_Frequency As Double) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureSampleClockSource", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureSampleClockSource (ByVal vi As System.IntPtr, ByVal Sample_Clock_Source As String) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureClockMode", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureClockMode (ByVal vi As System.IntPtr, ByVal Clock_Mode As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_AdjustSampleClockRelativeDelay", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function AdjustSampleClockRelativeDelay (ByVal vi As System.IntPtr, ByVal Adjustment_Time As Double) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureDigitalEdgeStartTrigger", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureDigitalEdgeStartTrigger (ByVal vi As System.IntPtr, ByVal Source As String, ByVal Edge As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureSoftwareEdgeStartTrigger", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureSoftwareEdgeStartTrigger (ByVal vi As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_DisableStartTrigger", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function DisableStartTrigger (ByVal vi As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureDigitalEdgeScriptTrigger", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureDigitalEdgeScriptTrigger (ByVal vi As System.IntPtr, ByVal Trigger_ID As String, ByVal Source As String, ByVal Edge As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureDigitalLevelScriptTrigger", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureDigitalLevelScriptTrigger (ByVal vi As System.IntPtr, ByVal Trigger_ID As String, ByVal Source As String, ByVal Trigger_When As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureSoftwareEdgeScriptTrigger", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureSoftwareEdgeScriptTrigger (ByVal vi As System.IntPtr, ByVal Trigger_ID As String) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_DisableScriptTrigger", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function DisableScriptTrigger (ByVal vi As System.IntPtr, ByVal Trigger_ID As String) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureTriggerMode", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureTriggerMode (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Trigger_Mode As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_SendSoftwareEdgeTrigger", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SendSoftwareEdgeTrigger (ByVal vi As System.IntPtr, ByVal Trigger As Integer, ByVal Trigger_ID As String) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureSynchronization", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureSynchronization (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Synchronization_Source As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ExportSignal", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ExportSignal (ByVal vi As System.IntPtr, ByVal Signal As Integer, ByVal Signal_Identifier As String, ByVal Output_Terminal As String) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_RouteSignalOut", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function RouteSignalOut (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Route_Signal_From As Integer, ByVal Route_Signal_To As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_AllocateNamedWaveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function AllocateNamedWaveform (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Name As String, ByVal Waveform_Size As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_SetNamedWaveformNextWritePosition", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SetNamedWaveformNextWritePosition (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Name As String, ByVal relativeTo As Integer, ByVal offset As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_WriteNamedWaveformF64", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function WriteNamedWaveformF64 (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Name As String, ByVal Size As Integer, ByVal Data As Double()) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_WriteNamedWaveformI16", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function WriteNamedWaveformI16 (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Name As String, ByVal Size As Integer, ByVal Data As Short()) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_WriteNamedWaveformComplexF64", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function WriteNamedWaveformComplexF64 (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Name As String, ByVal Size As Integer, ByVal Data As nicomplexnumber) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_WriteNamedWaveformComplexI16", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function WriteNamedWaveformComplexI16 (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Name As String, ByVal Size As Integer, ByVal Data As nicomplexI16) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_DeleteNamedWaveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function DeleteNamedWaveform (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Waveform_Name As String) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_WriteScript", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function WriteScript (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Script As String) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_DeleteScript", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function DeleteScript (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Script_Name As String) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureCustomFIRFilterCoefficients", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureCustomFIRFilterCoefficients (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Number_of_Coefficients As Integer, ByVal Coefficients_Array As Double()) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_GetFIRFilterCoefficients", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetFIRFilterCoefficients (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Array_Size As Integer, ByVal Coefficients_Array As Double(), ByVal Number_of_Coefficients_Read As Integer()) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_InitiateGeneration", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function InitiateGeneration (ByVal vi As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_AbortGeneration", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function AbortGeneration (ByVal vi As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_GetHardwareState", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetHardwareState (ByVal vi As System.IntPtr, ByRef state As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_WaitUntilDone", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function WaitUntilDone (ByVal vi As System.IntPtr, ByVal maxTime As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_IsDone", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function IsDone (ByVal vi As System.IntPtr, ByRef Done As UShort) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ResetWithDefaults", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ResetWithDefaults (ByVal vi As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ResetDevice", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ResetDevice (ByVal vi As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_GetChannelName", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetChannelName (ByVal vi As System.IntPtr, ByVal Index As Integer, ByVal BufferSize As Integer, ByVal Channel_Name As System.Text.StringBuilder) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_Disable", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function Disable (ByVal vi As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_self_test", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function self_test (ByVal vi As System.IntPtr, ByRef Self_Test_Result As Short, ByVal Self_Test_Message As System.Text.StringBuilder) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_revision_query", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function revision_query (ByVal vi As System.IntPtr, ByVal Instrument_Driver_Revision As System.Text.StringBuilder, ByVal Firmware_Revision As System.Text.StringBuilder) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_GetNextCoercionRecord", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetNextCoercionRecord (ByVal vi As System.IntPtr, ByVal Buffer_Size As Integer, ByVal Coercion_Record As System.Text.StringBuilder) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_error_query", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function error_query (ByVal vi As System.IntPtr, ByRef Error_Code As Integer, ByVal Error_Message As System.Text.StringBuilder) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ErrorHandler", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ErrorHandler (ByVal vi As System.IntPtr, ByVal Error_Code As Integer, ByVal Error_Message As System.Text.StringBuilder) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_GetNextInterchangeWarning", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetNextInterchangeWarning (ByVal vi As System.IntPtr, ByVal Buffer_Size As Integer, ByVal Interchange_Warning As System.Text.StringBuilder) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ClearInterchangeWarnings", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ClearInterchangeWarnings (ByVal vi As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ResetInterchangeCheck", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ResetInterchangeCheck (ByVal vi As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_CloseExtCal", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CloseExtCal (ByVal vi As System.IntPtr, ByVal Action As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_SelfCal", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SelfCal (ByVal vi As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_InitializeAnalogOutputCalibration", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function InitializeAnalogOutputCalibration (ByVal vi As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_WriteBinary16AnalogStaticValue", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function WriteBinary16AnalogStaticValue (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Value As Short) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_CalAdjustMainPathPreAmpOffset", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CalAdjustMainPathPreAmpOffset (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Configuration As Integer, ByVal Gain_DAC_Values As Integer(), ByVal Offset_DAC_Values As Integer(), ByVal Measured_Outputs As Double()) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_CalAdjustMainPathPreAmpGain", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CalAdjustMainPathPreAmpGain (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Configuration As Integer, ByVal Main_DAC_Values As Integer(), ByVal Gain_DAC_Values As Integer(), ByVal Offset_DAC_Values As Integer(), ByVal Measured_Outputs As Double()) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_CalAdjustMainPathPostAmpGainAndOffset", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CalAdjustMainPathPostAmpGainAndOffset (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Configuration As Integer, ByVal Main_DAC_Values As Integer(), ByVal Gain_DAC_Values As Integer(), ByVal Offset_DAC_Values As Integer(), ByVal Measured_Outputs As Double()) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_CalAdjustDirectPathGain", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CalAdjustDirectPathGain (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Main_DAC_Values As Integer(), ByVal Gain_DAC_Values As Integer(), ByVal Measured_Outputs As Double()) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_CalAdjustMainPathOutputImpedance", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CalAdjustMainPathOutputImpedance (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Configuration As Integer, ByVal Load_Impedance As Double, ByVal Measured_Source_Voltage As Double, ByVal Measured_Voltage_Across_Load As Double) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_CalAdjustDirectPathOutputImpedance", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CalAdjustDirectPathOutputImpedance (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Configuration As Integer, ByVal Load_Impedance As Double, ByVal Measured_Source_Voltage As Double, ByVal Measured_Voltage_Across_Load As Double) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_InitializeOscillatorFrequencyCalibration", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function InitializeOscillatorFrequencyCalibration (ByVal vi As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_CalAdjustOscillatorFrequency", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CalAdjustOscillatorFrequency (ByVal vi As System.IntPtr, ByVal Desired_Frequency As Double, ByVal Measured_Frequency As Double) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_InitializeCalADCCalibration", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function InitializeCalADCCalibration (ByVal vi As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_CalAdjustCalADC", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CalAdjustCalADC (ByVal vi As System.IntPtr, ByVal Voltages_Measured_Externally As Double(), ByVal Voltages_Measured_With_CalADC As Double()) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ReadCalADC", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ReadCalADC (ByVal vi As System.IntPtr, ByVal Number_of_Reads_to_Average As Integer, ByVal Return_Calibrated_Value As UShort, ByRef Cal_ADC_Value As Double) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_InitializeFlatnessCalibration", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function InitializeFlatnessCalibration (ByVal vi As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_CalAdjustFlatness", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CalAdjustFlatness (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Configuration As Integer, ByVal Requested_Amplitude As Double, ByVal Frequencies As Double(), ByVal Measured_Amplitudes As Double(), ByVal Number_Of_Measurements As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_GetSelfCalSupported", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetSelfCalSupported (ByVal vi As System.IntPtr, ByRef Self_Cal_Supported As UShort) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_GetSelfCalLastDateAndTime", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetSelfCalLastDateAndTime (ByVal vi As System.IntPtr, ByRef Year As Integer, ByRef Month As Integer, ByRef Day As Integer, ByRef Hour As Integer, ByRef Minute As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_GetExtCalLastDateAndTime", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetExtCalLastDateAndTime (ByVal vi As System.IntPtr, ByRef Year As Integer, ByRef Month As Integer, ByRef Day As Integer, ByRef Hour As Integer, ByRef Minute As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_GetSelfCalLastTemp", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetSelfCalLastTemp (ByVal vi As System.IntPtr, ByRef Temperature As Double) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_GetExtCalLastTemp", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetExtCalLastTemp (ByVal vi As System.IntPtr, ByRef Temperature As Double) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_GetExtCalRecommendedInterval", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetExtCalRecommendedInterval (ByVal vi As System.IntPtr, ByRef Months As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ChangeExtCalPassword", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ChangeExtCalPassword (ByVal vi As System.IntPtr, ByVal Old_Password As String, ByVal New_Password As String) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_SetCalUserDefinedInfo", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SetCalUserDefinedInfo (ByVal vi As System.IntPtr, ByVal Info As String) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_GetCalUserDefinedInfo", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetCalUserDefinedInfo (ByVal vi As System.IntPtr, ByVal Info As String) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_GetCalUserDefinedInfoMaxSize", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetCalUserDefinedInfoMaxSize (ByVal vi As System.IntPtr, ByRef Info_Size As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ReadCurrentTemperature", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ReadCurrentTemperature (ByVal vi As System.IntPtr, ByRef Temperature As Double) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_RestoreLastExtCalConstants", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function RestoreLastExtCalConstants (ByVal vi As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureTriggerSource", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureTriggerSource (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Trigger_Source As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_CreateArbWaveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CreateArbWaveform (ByVal vi As System.IntPtr, ByVal Waveform_Size As Integer, ByVal Waveform_Data_Array As Double(), ByRef Waveform_Handle As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_CreateBinary16ArbWaveform", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function CreateBinary16ArbWaveform (ByVal vi As System.IntPtr, ByVal Waveform_Size As Integer, ByVal Waveform_Data_Array As Short(), ByRef Waveform_Handle As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureRefClockSource", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureRefClockSource (ByVal vi As System.IntPtr, ByVal Reference_Clock_Source As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureRefClockFrequency", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureRefClockFrequency (ByVal vi As System.IntPtr, ByVal Reference_Clock_Frequency As Double) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_ConfigureUpdateClockSource", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function ConfigureUpdateClockSource (ByVal vi As System.IntPtr, ByVal Update_Clock_Source As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_SendSoftwareTrigger", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SendSoftwareTrigger (ByVal vi As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_close", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function close (ByVal vi As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_error_message", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function error_message (ByVal vi As System.IntPtr, ByVal Error_Code As Integer, ByVal Error_Message_2 As System.Text.StringBuilder) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_GetAttributeViInt32", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetAttributeViInt32 (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_GetAttributeViReal64", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetAttributeViReal64 (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As Double) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_GetAttributeViString", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetAttributeViString (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Array_Size As Integer, ByVal Attribute_Value As System.Text.StringBuilder) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_GetAttributeViBoolean", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetAttributeViBoolean (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As UShort) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_GetAttributeViSession", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetAttributeViSession (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByRef Attribute_Value As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_SetAttributeViInt32", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SetAttributeViInt32 (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As Integer) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_SetAttributeViReal64", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SetAttributeViReal64 (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As Double) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_SetAttributeViString", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SetAttributeViString (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As String) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_SetAttributeViBoolean", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SetAttributeViBoolean (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As UShort) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_SetAttributeViSession", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function SetAttributeViSession (ByVal vi As System.IntPtr, ByVal Channel_Name As String, ByVal Attribute_ID As Integer, ByVal Attribute_Value As System.IntPtr) As Integer
End Function

<DllImport ("niFgen_32.dll", EntryPoint:="niFgen_GetError", CallingConvention:=CallingConvention.StdCall)> _
Public Shared Function GetError (ByVal vi As System.IntPtr, ByRef Error_Code As Integer, ByVal Error_Description_Buffer_Size As Integer, ByVal Error_Description As System.Text.StringBuilder) As Integer
End Function

        
        Public Shared Function TestForError(ByVal handle As System.IntPtr, ByVal status As Integer) As Integer
            If (status < 0) Then
                PInvoke.ThrowError(handle, status)
            End If
            Return status
        End Function
        
        Public Shared Function ThrowError(ByVal handle As System.IntPtr, ByVal code As Integer) As Integer
            Dim status As Integer
            Dim size As Integer = PInvoke.GetError(handle, status, 0, Nothing)
            Dim msg As System.Text.StringBuilder = New System.Text.StringBuilder
            If (size >= 0) Then
                msg.Capacity = size
                PInvoke.GetError(handle, status, size, msg)
            End If
            Throw New System.Runtime.InteropServices.ExternalException(msg.ToString, code)
        End Function
    End Class
End Class

Public Class niFgenConstants
    
    Public Const OperateContinuous As Integer = 0
    
    Public Const OutputFunc As Integer = 0
    
    Public Const OutputFreqList As Integer = 101
    
    Public Const OutputArb As Integer = 1
    
    Public Const OutputSeq As Integer = 2
    
    Public Const OutputScript As Integer = 102
    
    Public Const WfmSine As Integer = 1
    
    Public Const WfmSquare As Integer = 2
    
    Public Const WfmTriangle As Integer = 3
    
    Public Const WfmRampUp As Integer = 4
    
    Public Const WfmRampDown As Integer = 5
    
    Public Const WfmDc As Integer = 6
    
    Public Const WfmUser As Integer = 102
    
    Public Const LittleEndian As Integer = 0
    
    Public Const BigEndian As Integer = 1
    
    Public Const WaveformPositionStart As Integer = 0
    
    Public Const WaveformPositionCurrent As Integer = 1
    
    Public Const DivideDown As Integer = 1
    
    Public Const HighResolution As Integer = 0
    
    Public Const Automatic As Integer = 2
    
    Public Const RisingEdge As Integer = 101
    
    Public Const FallingEdge As Integer = 102
    
    Public Const ActiveHigh As Integer = 101
    
    Public Const ActiveLow As Integer = 102
    
    Public Const [Single] As Integer = 1
    
    Public Const Continuous As Integer = 2
    
    Public Const Stepped As Integer = 3
    
    Public Const Burst As Integer = 4
    
    Public Const StartTrigger As Integer = 1004
    
    Public Const ScriptTrigger As Integer = 103
    
    Public Const None As Integer = 1000
    
    Public Const Ttl0 As Integer = 111
    
    Public Const Ttl1 As Integer = 112
    
    Public Const Ttl2 As Integer = 113
    
    Public Const Ttl3 As Integer = 114
    
    Public Const Ttl4 As Integer = 115
    
    Public Const Ttl5 As Integer = 116
    
    Public Const Ttl6 As Integer = 117
    
    Public Const Rtsi0 As Integer = 141
    
    Public Const Rtsi1 As Integer = 142
    
    Public Const Rtsi2 As Integer = 143
    
    Public Const Rtsi3 As Integer = 144
    
    Public Const Rtsi4 As Integer = 145
    
    Public Const Rtsi5 As Integer = 146
    
    Public Const Rtsi6 As Integer = 147
    
    Public Const SampleClock As Integer = 101
    
    Public Const ReferenceClock As Integer = 102
    
    Public Const OnboardReferenceClock As Integer = 1019
    
    Public Const SyncOut As Integer = 1002
    
    Public Const MarkerEvent As Integer = 1001
    
    Public Const DataMarkerEvent As Integer = 108
    
    Public Const ReadyForStartEvent As Integer = 105
    
    Public Const StartedEvent As Integer = 106
    
    Public Const DoneEvent As Integer = 107
    
    Public Const Synchronization As Integer = 1007
    
    Public Const Marker As Integer = 1001
    
    Public Const PllRefSource As Integer = 1003
    
    Public Const UpdateClock As Integer = 1017
    
    Public Const OutStartTrigger As Integer = 1004
    
    Public Const BoardClock As Integer = 1006
    
    Public Const SoftwareTrig As Integer = 2
    
    Public Const RefOut As Integer = 1008
    
    Public Const PxiClk10 As Integer = 1201
    
    Public Const Pfi0 As Integer = 1011
    
    Public Const Rtsi7 As Integer = 1010
    
    Public Const RefClockRtsiClock As Integer = 101
    
    Public Const ClockOut As Integer = 1009
    
    Public Const PxiStar As Integer = 131
    
    Public Const ExtCalAbort As Integer = 0
    
    Public Const ExtCalCommit As Integer = 1
    
    Public Const CalConfigMainPathFilterOff0db As Integer = 0
    
    Public Const CalConfigMainPathFilterOff3db As Integer = 1
    
    Public Const CalConfigMainPathFilterOff6db As Integer = 2
    
    Public Const CalConfigMainPathFilterOff9db As Integer = 3
    
    Public Const CalConfigMainPathFilterOff12db As Integer = 4
    
    Public Const CalConfigMainPathFilterOn0db As Integer = 5
    
    Public Const CalConfigMainPathFilterOn3db As Integer = 6
    
    Public Const CalConfigMainPathFilterOn6db As Integer = 7
    
    Public Const CalConfigMainPathFilterOn9db As Integer = 8
    
    Public Const CalConfigMainPathFilterOn12db As Integer = 9
    
    Public Const CalConfigMainPathLowGain0db As Integer = 0
    
    Public Const CalConfigMainPathLowGain12db As Integer = 1
    
    Public Const CalConfigMainPathLowGain24db As Integer = 2
    
    Public Const CalConfigMainPathLowGain36db As Integer = 3
    
    Public Const CalConfigMainPathHighGain0db As Integer = 4
    
    Public Const CalConfigMainPathHighGain12db As Integer = 5
    
    Public Const CalConfigMainPathHighGain24db As Integer = 6
    
    Public Const CalConfigMainPathHighGain36db As Integer = 7
    
    Public Const CalConfigMainPathLowGain0db50ohms As Integer = 0
    
    Public Const CalConfigMainPathLowGain0db75ohms As Integer = 1
    
    Public Const CalConfigMainPathLowGain12db50ohms As Integer = 2
    
    Public Const CalConfigMainPathLowGain12db75ohms As Integer = 3
    
    Public Const CalConfigMainPathLowGain24db50ohms As Integer = 4
    
    Public Const CalConfigMainPathLowGain24db75ohms As Integer = 5
    
    Public Const CalConfigMainPathLowGain36db50ohms As Integer = 6
    
    Public Const CalConfigMainPathLowGain36db75ohms As Integer = 7
    
    Public Const CalConfigMainPathHighGain0db50ohms As Integer = 8
    
    Public Const CalConfigMainPathHighGain0db75ohms As Integer = 9
    
    Public Const CalConfigMainPathHighGain12db50ohms As Integer = 10
    
    Public Const CalConfigMainPathHighGain12db75ohms As Integer = 11
    
    Public Const CalConfigMainPathHighGain24db50ohms As Integer = 12
    
    Public Const CalConfigMainPathHighGain24db75ohms As Integer = 13
    
    Public Const CalConfigMainPathHighGain36db50ohms As Integer = 14
    
    Public Const CalConfigMainPathHighGain36db75ohms As Integer = 15
    
    Public Const CalConfigDirectPath50ohms As Integer = 0
    
    Public Const CalConfigDirectPath75ohms As Integer = 1
    
    Public Const CalConfigLowGainPathPreAmp0db As Integer = 0
    
    Public Const CalConfigLowGainPathPreAmp3db As Integer = 1
    
    Public Const CalConfigLowGainPathPreAmp6db As Integer = 2
    
    Public Const CalConfigLowGainPathPreAmp9db As Integer = 3
    
    Public Const CalConfigLowGainPathPreAmp12db As Integer = 4
    
    Public Const CalConfigHighGainPathPreAmp0db As Integer = 5
    
    Public Const CalConfigHighGainPathPreAmp3db As Integer = 6
    
    Public Const CalConfigHighGainPathPreAmp6db As Integer = 7
    
    Public Const CalConfigHighGainPathPreAmp9db As Integer = 8
    
    Public Const CalConfigHighGainPathPreAmp12db As Integer = 9
    
    Public Const External As Integer = 1
    
    Public Const Immediate As Integer = 0
    
    Public Const Pfi1 As Integer = 1012
    
    Public Const Pfi2 As Integer = 1013
    
    Public Const Pfi3 As Integer = 1014
    
    Public Const Ttl7 As Integer = 118
    
    Public Const RefClockInternal As Integer = 0
    
    Public Const RefClockExternal As Integer = 1
    
    Public Const RefClockTtl7 As Integer = 118
    
    Public Const RefIn As Integer = 1200
    
    Public Const ClkIn As Integer = 1202
    
    Public Const DdcClkIn As Integer = 1203
    
    Public Const Internal As Integer = 0
    
    Public Const MainAnalogPath As Integer = 0
    
    Public Const DirectAnalogPath As Integer = 1
    
    Public Const FixedLowGainAnalogPath As Integer = 2
    
    Public Const FixedHighGainAnalogPath As Integer = 3
    
    Public Const _50Ohms As Double = 50
    
    Public Const _75Ohms As Double = 75
    
    Public Const SingleEnded As Integer = 300
    
    Public Const Differential As Integer = 301
    
    Public Const HoldLastValue As Integer = 400
    
    Public Const JumpToValue As Integer = 401
    
    Public Const OspReal As Integer = 0
    
    Public Const OspComplex As Integer = 1
    
    Public Const OspIf As Integer = 0
    
    Public Const OspBaseband As Integer = 1
    
    Public Const OspFlat As Integer = 0
    
    Public Const OspRaisedCosine As Integer = 1
    
    Public Const OspRootRaisedCosine As Integer = 2
    
    Public Const OspGaussian As Integer = 3
    
    Public Const OspCustom As Integer = 4
    
    Public Const ErrorReportingError As Integer = 0
    
    Public Const ErrorReportingDisabled As Integer = 2
    
    Public Const OspOverflowNone As Integer = 0
    
    Public Const OspOverflowPreFilterGainI As Integer = 1
    
    Public Const OspOverflowPreFilterGainQ As Integer = 2
    
    Public Const OspOverflowPreFilterOffsetI As Integer = 4
    
    Public Const OspOverflowPreFilterOffsetQ As Integer = 8
    
    Public Const OspOverflowFirFilterI As Integer = 16
    
    Public Const OspOverflowFirFilterQ As Integer = 32
    
    Public Const OspOverflowCicFilterI As Integer = 64
    
    Public Const OspOverflowCicFilterQ As Integer = 128
    
    Public Const OspOverflowComplexData As Integer = 256
    
    Public Const WfmNoise As Integer = 101
    
    Public Const Pulse As Integer = 101
    
    Public Const Level As Integer = 102
    
    Public Const SampleClockPeriods As Integer = 101
    
    Public Const Seconds As Integer = 102
    
    Public Const High As Integer = 101
    
    Public Const Low As Integer = 102
    
    Public Const TrigNone As Integer = 101
    
    Public Const DigitalEdge As Integer = 102
    
    Public Const SoftwareEdge As Integer = 104
    
    Public Const DigitalLevel As Integer = 103
    
    Public Const BusInvalid As Integer = 0
    
    Public Const BusAt As Integer = 1
    
    Public Const BusPci As Integer = 2
    
    Public Const BusPxi As Integer = 3
    
    Public Const BusVxi As Integer = 4
    
    Public Const BusPcmcia As Integer = 5
    
    Public Const AnalogOutput As Integer = 0
    
    Public Const InternalVoltageReference As Integer = 1
    
    Public Const Ground As Integer = 2
    
    Public Const AnalogOutputDifferential As Integer = 3
    
    Public Const AnalogOutputPlus As Integer = 4
    
    Public Const AnalogOutputMinus As Integer = 5
    
    Public Const AnalogOutputIdle As Integer = 6
    
    Public Const PalB As Integer = 0
    
    Public Const PalD As Integer = 1
    
    Public Const PalG As Integer = 2
    
    Public Const PalH As Integer = 3
    
    Public Const PalI As Integer = 4
    
    Public Const PalM As Integer = 5
    
    Public Const PalN As Integer = 6
    
    Public Const NtscM As Integer = 7
End Class

Public Enum niFgenProperties
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    OutputMode = 1250001
    
    '''''<summary>
    '''''System.Boolean
    '''''</summary>
    OutputEnabled = 1250003
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    DigitalGain = 1150254
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    AnalogPath = 1150222
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    LoadImpedance = 1150220
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    OutputImpedance = 1250004
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    TerminalConfiguration = 1150365
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    CommonModeOffset = 1150366
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    ChannelDelay = 1150369
    
    '''''<summary>
    '''''System.Boolean
    '''''</summary>
    AnalogFilterEnabled = 1150103
    
    '''''<summary>
    '''''System.Boolean
    '''''</summary>
    DigitalFilterEnabled = 1150102
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    DigitalFilterInterpolationFactor = 1150218
    
    '''''<summary>
    '''''System.Boolean
    '''''</summary>
    FlatnessCorrectionEnabled = 1150323
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    AnalogDataMask = 1150234
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    AnalogStaticValue = 1150235
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    DigitalDataMask = 1150236
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    DigitalStaticValue = 1150237
    
    '''''<summary>
    '''''System.Boolean
    '''''</summary>
    DigitalPatternEnabled = 1150101
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    IdleBehavior = 1150377
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    IdleValue = 1150378
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    WaitBehavior = 1150379
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    WaitValue = 1150380
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    ArbGain = 1250202
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    ArbOffset = 1250203
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    ArbWaveformHandle = 1250201
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    ArbMarkerPosition = 1150327
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    ArbRepeatCount = 1150328
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    ArbSequenceHandle = 1250211
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    MaxNumSequences = 1250212
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    MaxSequenceLength = 1250214
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    MinSequenceLength = 1250213
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    MaxLoopCount = 1250215
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    ScriptToGenerate = 1150270
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    WaveformQuantum = 1250206
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    MaxNumWaveforms = 1250205
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    MinWaveformSize = 1250207
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    MaxWaveformSize = 1250208
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    DataTransferBlockSize = 1150241
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    FileTransferBlockSize = 1150240
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    DataTransferMaximumBandwidth = 1150373
    
    '''''<summary>
    '''''System.Boolean
    '''''</summary>
    DirectDmaEnabled = 1150244
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    DirectDmaWindowAddress = 1150274
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    DirectDmaWindowSize = 1150245
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    StreamingWaveformName = 1150326
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    StreamingWaveformHandle = 1150324
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    StreamingSpaceAvailableInWaveform = 1150325
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    DataTransferMaximumInFlightReads = 1150375
    
    '''''<summary>
    '''''System.Boolean
    '''''</summary>
    PciDmaOptimizationsEnabled = 1150362
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    DataTransferPreferredPacketSize = 1150374
    
    '''''<summary>
    '''''System.Boolean
    '''''</summary>
    OspEnabled = 1150246
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    OspIqRate = 1150248
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    OspDataProcessingMode = 1150247
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    OspMode = 1150370
    
    '''''<summary>
    '''''System.Boolean
    '''''</summary>
    OspCarrierEnabled = 1150249
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    OspCarrierFrequency = 1150250
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    OspFrequencyShift = 1150371
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    OspFirFilterType = 1150253
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    OspFirFilterFlatPassband = 1150261
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    OspFirFilterRaisedCosineAlpha = 1150260
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    OspFirFilterRootRaisedCosineAlpha = 1150259
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    OspFirFilterGaussianBt = 1150262
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    OspCarrierPhaseI = 1150251
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    OspCarrierPhaseQ = 1150252
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    OspPreFilterGainI = 1150264
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    OspPreFilterGainQ = 1150265
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    OspPreFilterOffsetI = 1150266
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    OspPreFilterOffsetQ = 1150267
    
    '''''<summary>
    '''''System.Boolean
    '''''</summary>
    OspFirFilterEnabled = 1150255
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    OspFirFilterInterpolation = 1150256
    
    '''''<summary>
    '''''System.Boolean
    '''''</summary>
    OspCicFilterEnabled = 1150257
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    OspCicFilterGain = 1150263
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    OspCicFilterInterpolation = 1150258
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    OspOverflowErrorReporting = 1150268
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    OspOverflowStatus = 1150269
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    FuncWaveform = 1250101
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    FuncAmplitude = 1250102
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    FuncDcOffset = 1250103
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    FuncStartPhase = 1250105
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    FuncDutyCycleHigh = 1250106
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    SyncDutyCycleHigh = 1150105
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    SyncOutOutputTerminal = 1150330
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    FuncFrequency = 1250104
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    FuncBufferSize = 1150238
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    FuncMaxBufferSize = 1150239
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    FreqListHandle = 1150208
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    MaxNumFreqLists = 1150209
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    MaxFreqListLength = 1150211
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    MinFreqListLength = 1150210
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    FreqListDurationQuantum = 1150214
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    MaxFreqListDuration = 1150213
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    MinFreqListDuration = 1150212
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    RefClockFrequency = 1150107
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    ReferenceClockSource = 1150113
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    ExportedReferenceClockOutputTerminal = 1150321
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    ExportedOnboardReferenceClockOutputTerminal = 1150322
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    ArbSampleRate = 1250204
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    ClockMode = 1150110
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    SampleClockSource = 1150112
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    ExportedSampleClockOutputTerminal = 1150320
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    ExportedSampleClockDivisor = 1150219
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    SampleClockTimebaseSource = 1150367
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    SampleClockTimebaseRate = 1150368
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    ExportedSampleClockTimebaseOutputTerminal = 1150329
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    ExportedSampleClockTimebaseDivisor = 1150230
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    ExternalSampleClockMultiplier = 1150376
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    SampleClockAbsoluteDelay = 1150231
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    ExternalClockDelayBinaryValue = 1150233
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    OscillatorPhaseDacValue = 1150232
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    MarkerEventOutputTerminal = 1150312
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    MarkerEventOutputBehavior = 1150342
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    MarkerEventPulsePolarity = 1150313
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    MarkerEventPulseWidthUnits = 1150341
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    MarkerEventPulseWidth = 1150340
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    MarkerEventToggleInitialState = 1150343
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    MarkerEventDelayUnits = 1150355
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    MarkerEventDelay = 1150354
    
    '''''<summary>
    '''''System.Boolean
    '''''</summary>
    MarkerEventLatchedStatus = 1150350
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    AllMarkerEventsLatchedStatus = 1150349
    
    '''''<summary>
    '''''System.Boolean
    '''''</summary>
    MarkerEventLiveStatus = 1150345
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    AllMarkerEventsLiveStatus = 1150344
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    DataMarkerEventOutputTerminal = 1150339
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    DataMarkerEventDataBitNumber = 1150337
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    DataMarkerEventLevelPolarity = 1150338
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    ReadyForStartEventOutputTerminal = 1150310
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    ReadyForStartEventLevelActiveLevel = 1150311
    
    '''''<summary>
    '''''System.Boolean
    '''''</summary>
    ReadyForStartEventLiveStatus = 1150348
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    StartedEventOutputTerminal = 1150314
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    StartedEventOutputBehavior = 1150331
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    StartedEventPulsePolarity = 1150318
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    StartedEventPulseWidthUnits = 1150333
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    StartedEventPulseWidth = 1150335
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    StartedEventLevelActiveLevel = 1150316
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    StartedEventDelay = 1150356
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    StartedEventDelayUnits = 1150357
    
    '''''<summary>
    '''''System.Boolean
    '''''</summary>
    StartedEventLatchedStatus = 1150352
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    DoneEventOutputTerminal = 1150315
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    DoneEventOutputBehavior = 1150332
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    DoneEventPulsePolarity = 1150319
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    DoneEventPulseWidthUnits = 1150334
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    DoneEventPulseWidth = 1150336
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    DoneEventLevelActiveLevel = 1150317
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    DoneEventDelay = 1150358
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    DoneEventDelayUnits = 1150359
    
    '''''<summary>
    '''''System.Boolean
    '''''</summary>
    DoneEventLatchedStatus = 1150351
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    TriggerMode = 1150108
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    StartTriggerType = 1150280
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    ExportedStartTriggerOutputTerminal = 1150283
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    DigitalEdgeStartTriggerSource = 1150281
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    DigitalEdgeStartTriggerEdge = 1150282
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    ScriptTriggerType = 1150290
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    ExportedScriptTriggerOutputTerminal = 1150295
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    DigitalEdgeScriptTriggerSource = 1150291
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    DigitalEdgeScriptTriggerEdge = 1150292
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    DigitalLevelScriptTriggerSource = 1150293
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    DigitalLevelScriptTriggerActiveLevel = 1150294
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    BusType = 1150215
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    MemorySize = 1150242
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    SerialNumber = 1150243
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    MarkerEventsCount = 1150271
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    DataMarkerEventsCount = 1150273
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    ScriptTriggersCount = 1150272
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    CalAdcInput = 1150227
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    GainDacValue = 1150223
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    OffsetDacValue = 1150224
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    OscillatorFreqDacValue = 1150225
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    PreAmplifierAttenuation = 1150228
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    PostAmplifierAttenuation = 1150229
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    DriverSetup = 1050007
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    LogicalName = 1050305
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    IoResourceDescriptor = 1050304
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    ChannelCount = 1050203
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    GroupCapabilities = 1050401
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    SupportedInstrumentModels = 1050327
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    SpecificDriverClassSpecMajorVersion = 1050515
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    SpecificDriverClassSpecMinorVersion = 1050516
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    SpecificDriverDescription = 1050514
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    SpecificDriverPrefix = 1050302
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    SpecificDriverVendor = 1050513
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    SpecificDriverRevision = 1050551
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    IdQueryResponse = 1150001
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    InstrumentFirmwareRevision = 1050510
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    InstrumentManufacturer = 1050511
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    InstrumentModel = 1050512
    
    '''''<summary>
    '''''System.Boolean
    '''''</summary>
    Cache = 1050004
    
    '''''<summary>
    '''''System.Boolean
    '''''</summary>
    InterchangeCheck = 1050021
    
    '''''<summary>
    '''''System.Boolean
    '''''</summary>
    QueryInstrumentStatus = 1050003
    
    '''''<summary>
    '''''System.Boolean
    '''''</summary>
    RangeCheck = 1050002
    
    '''''<summary>
    '''''System.Boolean
    '''''</summary>
    RecordCoercions = 1050006
    
    '''''<summary>
    '''''System.Boolean
    '''''</summary>
    Simulate = 1050005
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    FilterCorrectionFrequency = 1150104
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    TriggerSource = 1250302
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    Synchronization = 1150111
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    VideoWaveformType = 1150216
    
    '''''<summary>
    '''''System.String
    '''''</summary>
    ErrorElaboration = 1050103
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    PrimaryError = 1050101
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    SecondaryError = 1050102
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    OperationMode = 1250005
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    RefClockSource = 1250002
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    UpdateClockSource = 1150106
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    CycleCount = 1250350
    
    '''''<summary>
    '''''System.IntPtr
    '''''</summary>
    IoSession = 1050322
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    NumChannels = 1050203
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    BurstCount = 1250350
    
    '''''<summary>
    '''''System.Double
    '''''</summary>
    ActualArbSampleRate = 1150109
    
    '''''<summary>
    '''''System.Int32
    '''''</summary>
    DaqmxTask = 1150221
    End Enum
End Namespace

